// python wrapper for vtkMRMLCommandLineModuleNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkMRMLCommandLineModuleNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLCommandLineModuleNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLCommandLineModuleNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLNode_ClassNew
extern "C" { PyObject *PyvtkMRMLNode_ClassNew(); }
#define DECLARED_PyvtkMRMLNode_ClassNew
#endif

static const char *PyvtkMRMLCommandLineModuleNode_Doc =
  "vtkMRMLCommandLineModuleNode - MRML node for representing the\nparameters allowing to run a command line interface module (CLI).\n\n"
  "Superclass: vtkMRMLNode\n\n"
  "The CLI parameters are defined with SetModuleDescription(). The\n"
  "parameters can be changed with SetParameterAsXXX(). It is possible to\n"
  "automatically run the CLI each time the parameters are changed, see\n"
  "SetAutoRun().\n\n";

static PyTypeObject PyvtkMRMLCommandLineModuleNode_CLINodeEvent_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLCLI.vtkMRMLCommandLineModuleNode.CLINodeEvent", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkMRMLCommandLineModuleNode_CLINodeEvent_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkMRMLCommandLineModuleNode_CLINodeEvent_Type, static_cast<int>(val));
}

static PyTypeObject PyvtkMRMLCommandLineModuleNode_AutoRunMode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLCLI.vtkMRMLCommandLineModuleNode.AutoRunMode", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkMRMLCommandLineModuleNode_AutoRunMode_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkMRMLCommandLineModuleNode_AutoRunMode_Type, static_cast<int>(val));
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLCommandLineModuleNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLCommandLineModuleNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLCommandLineModuleNode *tempr = vtkMRMLCommandLineModuleNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLCommandLineModuleNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLCommandLineModuleNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLCommandLineModuleNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLCommandLineModuleNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLCommandLineModuleNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_CopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->CopyContent(temp0, temp1);
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::CopyContent(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_HasCopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasCopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasCopyContent() :
      op->vtkMRMLCommandLineModuleNode::HasCopyContent());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLCommandLineModuleNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetModuleDescriptionAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModuleDescriptionAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetModuleDescriptionAsString() :
      op->vtkMRMLCommandLineModuleNode::GetModuleDescriptionAsString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  int temp0;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->SetStatus(temp0, temp1);
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::SetStatus(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetStatus() :
      op->vtkMRMLCommandLineModuleNode::GetStatus());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetStatusString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStatusString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetStatusString() :
      op->vtkMRMLCommandLineModuleNode::GetStatusString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetOutputText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  std::string temp0;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->SetOutputText(temp0, temp1);
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::SetOutputText(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetOutputText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetOutputText() :
      op->vtkMRMLCommandLineModuleNode::GetOutputText());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetErrorText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetErrorText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  std::string temp0;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->SetErrorText(temp0, temp1);
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::SetErrorText(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetErrorText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetErrorText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetErrorText() :
      op->vtkMRMLCommandLineModuleNode::GetErrorText());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_IsBusy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsBusy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsBusy() :
      op->vtkMRMLCommandLineModuleNode::IsBusy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetProgress(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProgress");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetProgress() :
      op->vtkMRMLCommandLineModuleNode::GetProgress());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_Cancel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Cancel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Cancel();
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::Cancel();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetAutoRun(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoRun");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoRun(temp0);
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::SetAutoRun(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetAutoRun(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoRun");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetAutoRun() :
      op->vtkMRMLCommandLineModuleNode::GetAutoRun());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetAutoRunMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoRunMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoRunMode(temp0);
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::SetAutoRunMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetAutoRunMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoRunMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAutoRunMode() :
      op->vtkMRMLCommandLineModuleNode::GetAutoRunMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetAutoRunDelay(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoRunDelay");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoRunDelay(temp0);
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::SetAutoRunDelay(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetAutoRunDelay(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoRunDelay");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetAutoRunDelay() :
      op->vtkMRMLCommandLineModuleNode::GetAutoRunDelay());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetLastRunTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastRunTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetLastRunTime() :
      op->vtkMRMLCommandLineModuleNode::GetLastRunTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetParameterMTime() :
      op->vtkMRMLCommandLineModuleNode::GetParameterMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetInputMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInputMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetInputMTime() :
      op->vtkMRMLCommandLineModuleNode::GetInputMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_ReadParameterFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReadParameterFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->ReadParameterFile(temp0) :
      op->vtkMRMLCommandLineModuleNode::ReadParameterFile(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_WriteParameterFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteParameterFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  std::string temp0;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    bool tempr = (ap.IsBound() ?
      op->WriteParameterFile(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::WriteParameterFile(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetParameterAsNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParameterAsNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  vtkMRMLNode *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMRMLNode"))
  {
    bool tempr = (ap.IsBound() ?
      op->SetParameterAsNode(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::SetParameterAsNode(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetParameterAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParameterAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->SetParameterAsString(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::SetParameterAsString(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetParameterAsInt(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParameterAsInt");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->SetParameterAsInt(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::SetParameterAsInt(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetParameterAsBool(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParameterAsBool");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->SetParameterAsBool(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::SetParameterAsBool(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetParameterAsDouble(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParameterAsDouble");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->SetParameterAsDouble(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::SetParameterAsDouble(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetParameterAsFloat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParameterAsFloat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  float temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->SetParameterAsFloat(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::SetParameterAsFloat(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterAsString(temp0) :
      op->vtkMRMLCommandLineModuleNode::GetParameterAsString(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_SetModuleDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetModuleDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetModuleDescription(temp0);
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::SetModuleDescription(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetModuleVersion(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModuleVersion");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetModuleVersion() :
      op->vtkMRMLCommandLineModuleNode::GetModuleVersion());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetModuleTitle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModuleTitle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetModuleTitle() :
      op->vtkMRMLCommandLineModuleNode::GetModuleTitle());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetModuleTarget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModuleTarget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetModuleTarget() :
      op->vtkMRMLCommandLineModuleNode::GetModuleTarget());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetModuleType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModuleType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetModuleType() :
      op->vtkMRMLCommandLineModuleNode::GetModuleType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_IsValidGroupId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsValidGroupId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsValidGroupId(temp0) :
      op->vtkMRMLCommandLineModuleNode::IsValidGroupId(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_IsValidParamId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsValidParamId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->IsValidParamId(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::IsValidParamId(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetNumberOfParameterGroups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfParameterGroups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetNumberOfParameterGroups() :
      op->vtkMRMLCommandLineModuleNode::GetNumberOfParameterGroups());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetNumberOfParametersInGroup(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfParametersInGroup");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetNumberOfParametersInGroup(temp0) :
      op->vtkMRMLCommandLineModuleNode::GetNumberOfParametersInGroup(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterGroupLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterGroupLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterGroupLabel(temp0) :
      op->vtkMRMLCommandLineModuleNode::GetParameterGroupLabel(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterGroupDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterGroupDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterGroupDescription(temp0) :
      op->vtkMRMLCommandLineModuleNode::GetParameterGroupDescription(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterGroupAdvanced(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterGroupAdvanced");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterGroupAdvanced(temp0) :
      op->vtkMRMLCommandLineModuleNode::GetParameterGroupAdvanced(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterTag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterTag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterTag(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterTag(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterType(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterType(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterArgType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterArgType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterArgType(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterArgType(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterName(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterName(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterLongFlag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterLongFlag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterLongFlag(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterLongFlag(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterLabel(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterLabel(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterConstraints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterConstraints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterConstraints(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterConstraints(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterMaximum(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterMaximum");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterMaximum(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterMaximum(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterMinimum(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterMinimum");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterMinimum(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterMinimum(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterDescription(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterDescription(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterChannel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterChannel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterChannel(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterChannel(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterIndex(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterIndex(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterDefault(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterDefault");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterDefault(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterDefault(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterValue(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterValue(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterFlag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterFlag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterFlag(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterFlag(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterMultiple(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterMultiple");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterMultiple(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterMultiple(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterFileExtensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterFileExtensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterFileExtensions(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterFileExtensions(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetParameterCoordinateSystem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameterCoordinateSystem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  unsigned int temp0;
  unsigned int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetParameterCoordinateSystem(temp0, temp1) :
      op->vtkMRMLCommandLineModuleNode::GetParameterCoordinateSystem(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_IsInputDefaultValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsInputDefaultValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsInputDefaultValue(temp0) :
      op->vtkMRMLCommandLineModuleNode::IsInputDefaultValue(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetNumberOfRegisteredModules(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfRegisteredModules");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    int tempr = vtkMRMLCommandLineModuleNode::GetNumberOfRegisteredModules();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_GetRegisteredModuleNameByIndex(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetRegisteredModuleNameByIndex");

  int temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = vtkMRMLCommandLineModuleNode::GetRegisteredModuleNameByIndex(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_HasRegisteredModule(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "HasRegisteredModule");

  std::string temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = vtkMRMLCommandLineModuleNode::HasRegisteredModule(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCommandLineModuleNode_Modified(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Modified");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCommandLineModuleNode *op = static_cast<vtkMRMLCommandLineModuleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Modified();
    }
    else
    {
      op->vtkMRMLCommandLineModuleNode::Modified();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLCommandLineModuleNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLCommandLineModuleNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLCommandLineModuleNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLCommandLineModuleNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLCommandLineModuleNode\nC++: static vtkMRMLCommandLineModuleNode *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLCommandLineModuleNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLCommandLineModuleNode\nC++: vtkMRMLCommandLineModuleNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLCommandLineModuleNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLCommandLineModuleNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"CreateNodeInstance", PyvtkMRMLCommandLineModuleNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\nCreate instance of the default node. Like New only virtual.\n\note Subclasses should implement this method\n"},
  {"CopyContent", PyvtkMRMLCommandLineModuleNode_CopyContent, METH_VARARGS,
   "V.CopyContent(vtkMRMLNode, bool)\nC++: void CopyContent(vtkMRMLNode *node, bool deepCopy=true)\n    override;\n\nCopy node content (excludes basic data, such as name and node\nreferences).\n\\sa vtkMRMLNode::CopyContent\n"},
  {"HasCopyContent", PyvtkMRMLCommandLineModuleNode_HasCopyContent, METH_VARARGS,
   "V.HasCopyContent() -> bool\nC++: bool HasCopyContent() override;\n\nReturns true if the class supports deep and shallow copying node\n    content.\n"},
  {"GetNodeTagName", PyvtkMRMLCommandLineModuleNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"GetModuleDescriptionAsString", PyvtkMRMLCommandLineModuleNode_GetModuleDescriptionAsString, METH_VARARGS,
   "V.GetModuleDescriptionAsString() -> string\nC++: std::string GetModuleDescriptionAsString()\n\n"},
  {"SetStatus", PyvtkMRMLCommandLineModuleNode_SetStatus, METH_VARARGS,
   "V.SetStatus(int, bool)\nC++: void SetStatus(int status, bool modify=true)\n\nSet the status of the node (Idle, Scheduled, Running, Completed).\n The \"modify\" parameter indicates whether the object can be\nmodified by the call. Having modify = false is used when a\nseparate thread updates the node status but does not want to\ninvoke modified events because it would refresh the GUI from the\nthread. Do not call manually, only the logic should change the\nstatus of the node.\n\\sa GetStatus(), GetStatusString(), IsBusy(), Cancel()\n"},
  {"GetStatus", PyvtkMRMLCommandLineModuleNode_GetStatus, METH_VARARGS,
   "V.GetStatus() -> int\nC++: int GetStatus()\n\n\\sa SetStatus(), GetStatusString(), IsBusy()\n"},
  {"GetStatusString", PyvtkMRMLCommandLineModuleNode_GetStatusString, METH_VARARGS,
   "V.GetStatusString() -> string\nC++: const char *GetStatusString()\n\nReturn current status as a string for display.\n\\sa GetStatus(), IsBusy()\n"},
  {"SetOutputText", PyvtkMRMLCommandLineModuleNode_SetOutputText, METH_VARARGS,
   "V.SetOutputText(string, bool)\nC++: void SetOutputText(const std::string &text, bool modify=true)\n\nSet output messages generated during latest execution.\n"},
  {"GetOutputText", PyvtkMRMLCommandLineModuleNode_GetOutputText, METH_VARARGS,
   "V.GetOutputText() -> string\nC++: const std::string GetOutputText()\n\nSet output messages generated during latest execution.\n"},
  {"SetErrorText", PyvtkMRMLCommandLineModuleNode_SetErrorText, METH_VARARGS,
   "V.SetErrorText(string, bool)\nC++: void SetErrorText(const std::string &text, bool modify=true)\n\nSet error messages generated during latest execution.\n"},
  {"GetErrorText", PyvtkMRMLCommandLineModuleNode_GetErrorText, METH_VARARGS,
   "V.GetErrorText() -> string\nC++: const std::string GetErrorText()\n\nGet error messages generated during latest execution.\n"},
  {"IsBusy", PyvtkMRMLCommandLineModuleNode_IsBusy, METH_VARARGS,
   "V.IsBusy() -> bool\nC++: bool IsBusy()\n\nReturn true if the module is in a busy state: Scheduled, Running,\nCancelling, Completing.\n\\sa SetStatus(), GetStatus(), BusyMask, Cancel()\n"},
  {"GetProgress", PyvtkMRMLCommandLineModuleNode_GetProgress, METH_VARARGS,
   "V.GetProgress() -> int\nC++: int GetProgress()\n\n"},
  {"Cancel", PyvtkMRMLCommandLineModuleNode_Cancel, METH_VARARGS,
   "V.Cancel()\nC++: void Cancel()\n\nSet a request to stop the processing of the CLI. Do nothing if\nthe module is not \"busy\".\n\\sa IsBusy(), Cancelling, Cancelled\n"},
  {"SetAutoRun", PyvtkMRMLCommandLineModuleNode_SetAutoRun, METH_VARARGS,
   "V.SetAutoRun(bool)\nC++: void SetAutoRun(bool enable)\n\nEnable/Disable the AutoRun for the CLI node. The behavior is\nensured by the CLI logic. AutoRun is disabled (false) by default.\n\\sa GetAutoRun(), AutoRunMode, SetAutoRunDelay()\n"},
  {"GetAutoRun", PyvtkMRMLCommandLineModuleNode_GetAutoRun, METH_VARARGS,
   "V.GetAutoRun() -> bool\nC++: bool GetAutoRun()\n\nReturn true if the AutoRun is enabled, false otherwise.\n\\sa SetAutoRun(), AutoRunMode, GetAutoRunDelay()\n"},
  {"SetAutoRunMode", PyvtkMRMLCommandLineModuleNode_SetAutoRunMode, METH_VARARGS,
   "V.SetAutoRunMode(int)\nC++: void SetAutoRunMode(int autoRunMode)\n\nSet the auto running flags for the node. The behavior is ensured\nby the CLI logic. AutoRun is not enabled untilSetAutoRun(true) is\ncalled.AutoRunWhenParameterChanged | AutoRunCancelsRunningProcess\nby default.\n\\sa AutoRunMode, GetAutoRunMode(), SetAutoRun(),\n    SetAutoRunDelay()\n"},
  {"GetAutoRunMode", PyvtkMRMLCommandLineModuleNode_GetAutoRunMode, METH_VARARGS,
   "V.GetAutoRunMode() -> int\nC++: int GetAutoRunMode()\n\nReturn the AutoRun mode flags.\n\\sa AutoRunMode, SetAutoRunMode(), GetAutoRun(),\n    GetAutoRunDelay()\n"},
  {"SetAutoRunDelay", PyvtkMRMLCommandLineModuleNode_SetAutoRunDelay, METH_VARARGS,
   "V.SetAutoRunDelay(int)\nC++: void SetAutoRunDelay(unsigned int delayInMs)\n\nSet the number of msecs to wait before automatically running the\nmodule. 1000msecs by default.\n\\sa GetAutoRunDelay(), SetAutoRun(), SetAutoRunMode()\n"},
  {"GetAutoRunDelay", PyvtkMRMLCommandLineModuleNode_GetAutoRunDelay, METH_VARARGS,
   "V.GetAutoRunDelay() -> int\nC++: unsigned int GetAutoRunDelay()\n\nReturn the number of msecs to wait before automatically running\nthe module.\n\\sa SetAutoRunDelay(), GetAutoRun(), GetAutoRunMode()\n"},
  {"GetLastRunTime", PyvtkMRMLCommandLineModuleNode_GetLastRunTime, METH_VARARGS,
   "V.GetLastRunTime() -> int\nC++: vtkMTimeType GetLastRunTime()\n\nReturn the last time the module was ran.\n\\sa GetParameterMTime(), GetInputMTime(), GetMTime()\n"},
  {"GetParameterMTime", PyvtkMRMLCommandLineModuleNode_GetParameterMTime, METH_VARARGS,
   "V.GetParameterMTime() -> int\nC++: vtkMTimeType GetParameterMTime()\n\nReturn the last time a parameter was modified\n\\sa GetInputMTime(), GetMTime()\n"},
  {"GetInputMTime", PyvtkMRMLCommandLineModuleNode_GetInputMTime, METH_VARARGS,
   "V.GetInputMTime() -> int\nC++: vtkMTimeType GetInputMTime()\n\nReturn the last time an input parameter was modified.\n\\sa GetParameterMTime(), GetMTime()\n"},
  {"ReadParameterFile", PyvtkMRMLCommandLineModuleNode_ReadParameterFile, METH_VARARGS,
   "V.ReadParameterFile(string) -> bool\nC++: bool ReadParameterFile(const std::string &filename)\n\nRead a parameter file. This will set any parameters that\nparameters in this ModuleDescription.\n"},
  {"WriteParameterFile", PyvtkMRMLCommandLineModuleNode_WriteParameterFile, METH_VARARGS,
   "V.WriteParameterFile(string, bool) -> bool\nC++: bool WriteParameterFile(const std::string &filename,\n    bool withHandlesToBulkParameters=true)\n\nWrite a parameter file. This will output any parameters that\nparameters in this ModuleDescription.\n\"withHandlesToBulkParameters\" allows to control whether all\nparameters are written or just the parameters with simple IO\nmechanisms.\n"},
  {"SetParameterAsNode", PyvtkMRMLCommandLineModuleNode_SetParameterAsNode, METH_VARARGS,
   "V.SetParameterAsNode(string, vtkMRMLNode) -> bool\nC++: bool SetParameterAsNode(const char *name, vtkMRMLNode *value)\n\nSet the parameter name to the node value. If the parameter is not\nin the output channel, InputParameterModifiedEvent is invoked\nanytime the node is modified (ModifiedEvent is invoked).\n\\sa SetParameterAsString(), SetParameterAsBool(),\n    SetParameterAsDouble(),\nSetParameterAsFloat(), SetParameterAsInt()\n"},
  {"SetParameterAsString", PyvtkMRMLCommandLineModuleNode_SetParameterAsString, METH_VARARGS,
   "V.SetParameterAsString(string, string) -> bool\nC++: bool SetParameterAsString(const char *name,\n    const std::string &value)\n\nSet the parameter name to the string value.\n\\sa SetParameterAsInt(), SetParameterAsBool(),\n    SetParameterAsDouble(),\nSetParameterAsFloat(), SetParameterAsNode()\n"},
  {"SetParameterAsInt", PyvtkMRMLCommandLineModuleNode_SetParameterAsInt, METH_VARARGS,
   "V.SetParameterAsInt(string, int) -> bool\nC++: bool SetParameterAsInt(const char *name, int value)\n\nSet the parameter name to the int value.\n\\sa SetParameterAsString(), SetParameterAsBool(),\n    SetParameterAsDouble(),\nSetParameterAsFloat(), SetParameterAsNode()\n"},
  {"SetParameterAsBool", PyvtkMRMLCommandLineModuleNode_SetParameterAsBool, METH_VARARGS,
   "V.SetParameterAsBool(string, bool) -> bool\nC++: bool SetParameterAsBool(const char *name, bool value)\n\nSet the parameter name to the bool value.\n\\sa SetParameterAsString(), SetParameterAsInt(),\n    SetParameterAsDouble(),\nSetParameterAsFloat(), SetParameterAsNode()\n"},
  {"SetParameterAsDouble", PyvtkMRMLCommandLineModuleNode_SetParameterAsDouble, METH_VARARGS,
   "V.SetParameterAsDouble(string, float) -> bool\nC++: bool SetParameterAsDouble(const char *name, double value)\n\nSet the parameter name to the double value.\n\\sa SetParameterAsString(), SetParameterAsInt(),\n    SetParameterAsBool(),\nSetParameterAsFloat(), SetParameterAsNode()\n"},
  {"SetParameterAsFloat", PyvtkMRMLCommandLineModuleNode_SetParameterAsFloat, METH_VARARGS,
   "V.SetParameterAsFloat(string, float) -> bool\nC++: bool SetParameterAsFloat(const char *name, float value)\n\nSet the parameter name to the float value.\n\\sa SetParameterAsString(), SetParameterAsInt(),\n    SetParameterAsDouble(),\nSetParameterAsBool(), SetParameterAsNode()\n"},
  {"GetParameterAsString", PyvtkMRMLCommandLineModuleNode_GetParameterAsString, METH_VARARGS,
   "V.GetParameterAsString(string) -> string\nC++: std::string GetParameterAsString(const char *name)\n\n"},
  {"SetModuleDescription", PyvtkMRMLCommandLineModuleNode_SetModuleDescription, METH_VARARGS,
   "V.SetModuleDescription(string)\nC++: void SetModuleDescription(const char *name)\n\n"},
  {"GetModuleVersion", PyvtkMRMLCommandLineModuleNode_GetModuleVersion, METH_VARARGS,
   "V.GetModuleVersion() -> string\nC++: std::string GetModuleVersion()\n\n"},
  {"GetModuleTitle", PyvtkMRMLCommandLineModuleNode_GetModuleTitle, METH_VARARGS,
   "V.GetModuleTitle() -> string\nC++: std::string GetModuleTitle()\n\n"},
  {"GetModuleTarget", PyvtkMRMLCommandLineModuleNode_GetModuleTarget, METH_VARARGS,
   "V.GetModuleTarget() -> string\nC++: std::string GetModuleTarget()\n\n"},
  {"GetModuleType", PyvtkMRMLCommandLineModuleNode_GetModuleType, METH_VARARGS,
   "V.GetModuleType() -> string\nC++: std::string GetModuleType()\n\n"},
  {"IsValidGroupId", PyvtkMRMLCommandLineModuleNode_IsValidGroupId, METH_VARARGS,
   "V.IsValidGroupId(int) -> bool\nC++: bool IsValidGroupId(unsigned int group)\n\n"},
  {"IsValidParamId", PyvtkMRMLCommandLineModuleNode_IsValidParamId, METH_VARARGS,
   "V.IsValidParamId(int, int) -> bool\nC++: bool IsValidParamId(unsigned int group, unsigned int param)\n\n"},
  {"GetNumberOfParameterGroups", PyvtkMRMLCommandLineModuleNode_GetNumberOfParameterGroups, METH_VARARGS,
   "V.GetNumberOfParameterGroups() -> int\nC++: unsigned int GetNumberOfParameterGroups()\n\n"},
  {"GetNumberOfParametersInGroup", PyvtkMRMLCommandLineModuleNode_GetNumberOfParametersInGroup, METH_VARARGS,
   "V.GetNumberOfParametersInGroup(int) -> int\nC++: unsigned int GetNumberOfParametersInGroup(unsigned int group)\n\n"},
  {"GetParameterGroupLabel", PyvtkMRMLCommandLineModuleNode_GetParameterGroupLabel, METH_VARARGS,
   "V.GetParameterGroupLabel(int) -> string\nC++: std::string GetParameterGroupLabel(unsigned int group)\n\n"},
  {"GetParameterGroupDescription", PyvtkMRMLCommandLineModuleNode_GetParameterGroupDescription, METH_VARARGS,
   "V.GetParameterGroupDescription(int) -> string\nC++: std::string GetParameterGroupDescription(unsigned int group)\n\n"},
  {"GetParameterGroupAdvanced", PyvtkMRMLCommandLineModuleNode_GetParameterGroupAdvanced, METH_VARARGS,
   "V.GetParameterGroupAdvanced(int) -> string\nC++: std::string GetParameterGroupAdvanced(unsigned int group)\n\n"},
  {"GetParameterTag", PyvtkMRMLCommandLineModuleNode_GetParameterTag, METH_VARARGS,
   "V.GetParameterTag(int, int) -> string\nC++: std::string GetParameterTag(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterType", PyvtkMRMLCommandLineModuleNode_GetParameterType, METH_VARARGS,
   "V.GetParameterType(int, int) -> string\nC++: std::string GetParameterType(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterArgType", PyvtkMRMLCommandLineModuleNode_GetParameterArgType, METH_VARARGS,
   "V.GetParameterArgType(int, int) -> string\nC++: std::string GetParameterArgType(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterName", PyvtkMRMLCommandLineModuleNode_GetParameterName, METH_VARARGS,
   "V.GetParameterName(int, int) -> string\nC++: std::string GetParameterName(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterLongFlag", PyvtkMRMLCommandLineModuleNode_GetParameterLongFlag, METH_VARARGS,
   "V.GetParameterLongFlag(int, int) -> string\nC++: std::string GetParameterLongFlag(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterLabel", PyvtkMRMLCommandLineModuleNode_GetParameterLabel, METH_VARARGS,
   "V.GetParameterLabel(int, int) -> string\nC++: std::string GetParameterLabel(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterConstraints", PyvtkMRMLCommandLineModuleNode_GetParameterConstraints, METH_VARARGS,
   "V.GetParameterConstraints(int, int) -> string\nC++: std::string GetParameterConstraints(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterMaximum", PyvtkMRMLCommandLineModuleNode_GetParameterMaximum, METH_VARARGS,
   "V.GetParameterMaximum(int, int) -> string\nC++: std::string GetParameterMaximum(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterMinimum", PyvtkMRMLCommandLineModuleNode_GetParameterMinimum, METH_VARARGS,
   "V.GetParameterMinimum(int, int) -> string\nC++: std::string GetParameterMinimum(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterDescription", PyvtkMRMLCommandLineModuleNode_GetParameterDescription, METH_VARARGS,
   "V.GetParameterDescription(int, int) -> string\nC++: std::string GetParameterDescription(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterChannel", PyvtkMRMLCommandLineModuleNode_GetParameterChannel, METH_VARARGS,
   "V.GetParameterChannel(int, int) -> string\nC++: std::string GetParameterChannel(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterIndex", PyvtkMRMLCommandLineModuleNode_GetParameterIndex, METH_VARARGS,
   "V.GetParameterIndex(int, int) -> string\nC++: std::string GetParameterIndex(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterDefault", PyvtkMRMLCommandLineModuleNode_GetParameterDefault, METH_VARARGS,
   "V.GetParameterDefault(int, int) -> string\nC++: std::string GetParameterDefault(unsigned int group,\n    unsigned int param)\n\n\\deprecated Consider using GetParameterValue()\n"},
  {"GetParameterValue", PyvtkMRMLCommandLineModuleNode_GetParameterValue, METH_VARARGS,
   "V.GetParameterValue(int, int) -> string\nC++: std::string GetParameterValue(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterFlag", PyvtkMRMLCommandLineModuleNode_GetParameterFlag, METH_VARARGS,
   "V.GetParameterFlag(int, int) -> string\nC++: std::string GetParameterFlag(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterMultiple", PyvtkMRMLCommandLineModuleNode_GetParameterMultiple, METH_VARARGS,
   "V.GetParameterMultiple(int, int) -> string\nC++: std::string GetParameterMultiple(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterFileExtensions", PyvtkMRMLCommandLineModuleNode_GetParameterFileExtensions, METH_VARARGS,
   "V.GetParameterFileExtensions(int, int) -> string\nC++: std::string GetParameterFileExtensions(unsigned int group,\n    unsigned int param)\n\n"},
  {"GetParameterCoordinateSystem", PyvtkMRMLCommandLineModuleNode_GetParameterCoordinateSystem, METH_VARARGS,
   "V.GetParameterCoordinateSystem(int, int) -> string\nC++: std::string GetParameterCoordinateSystem(unsigned int group,\n    unsigned int param)\n\n"},
  {"IsInputDefaultValue", PyvtkMRMLCommandLineModuleNode_IsInputDefaultValue, METH_VARARGS,
   "V.IsInputDefaultValue(string) -> bool\nC++: bool IsInputDefaultValue(const std::string &value)\n\nReturns true if the value is a default value for a parameter that\nis not an output parameter.\n\\sa SetAutoRun\n"},
  {"GetNumberOfRegisteredModules", PyvtkMRMLCommandLineModuleNode_GetNumberOfRegisteredModules, METH_VARARGS,
   "V.GetNumberOfRegisteredModules() -> int\nC++: static int GetNumberOfRegisteredModules()\n\nMethods to manage the master list of module description\nprototypes\n"},
  {"GetRegisteredModuleNameByIndex", PyvtkMRMLCommandLineModuleNode_GetRegisteredModuleNameByIndex, METH_VARARGS,
   "V.GetRegisteredModuleNameByIndex(int) -> string\nC++: static const char *GetRegisteredModuleNameByIndex(int idx)\n\n"},
  {"HasRegisteredModule", PyvtkMRMLCommandLineModuleNode_HasRegisteredModule, METH_VARARGS,
   "V.HasRegisteredModule(string) -> bool\nC++: static bool HasRegisteredModule(const std::string &name)\n\n"},
  {"Modified", PyvtkMRMLCommandLineModuleNode_Modified, METH_VARARGS,
   "V.Modified()\nC++: void Modified() override;\n\nReimplemented for internal reasons.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLCommandLineModuleNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLCLI.vtkMRMLCommandLineModuleNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLCommandLineModuleNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLCommandLineModuleNode_StaticNew()
{
  return vtkMRMLCommandLineModuleNode::New();
}

PyObject *PyvtkMRMLCommandLineModuleNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLCommandLineModuleNode_Type, PyvtkMRMLCommandLineModuleNode_Methods,
    "vtkMRMLCommandLineModuleNode",
 &PyvtkMRMLCommandLineModuleNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkMRMLNode");

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkMRMLCommandLineModuleNode_CLINodeEvent_Type);
  PyVTKEnum_Add(&PyvtkMRMLCommandLineModuleNode_CLINodeEvent_Type, "vtkMRMLCommandLineModuleNode.CLINodeEvent");

  o = (PyObject *)&PyvtkMRMLCommandLineModuleNode_CLINodeEvent_Type;
  if (PyDict_SetItemString(d, "CLINodeEvent", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkMRMLCommandLineModuleNode_AutoRunMode_Type);
  PyVTKEnum_Add(&PyvtkMRMLCommandLineModuleNode_AutoRunMode_Type, "vtkMRMLCommandLineModuleNode.AutoRunMode");

  o = (PyObject *)&PyvtkMRMLCommandLineModuleNode_AutoRunMode_Type;
  if (PyDict_SetItemString(d, "AutoRunMode", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 4; c++)
  {
    typedef vtkMRMLCommandLineModuleNode::CLINodeEvent cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[4] = {
        { "ParameterChangedEvent", vtkMRMLCommandLineModuleNode::ParameterChangedEvent },
        { "InputParameterEvent", vtkMRMLCommandLineModuleNode::InputParameterEvent },
        { "AutoRunEvent", vtkMRMLCommandLineModuleNode::AutoRunEvent },
        { "StatusModifiedEvent", vtkMRMLCommandLineModuleNode::StatusModifiedEvent },
      };

    o = PyvtkMRMLCommandLineModuleNode_CLINodeEvent_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 10; c++)
  {
    static const struct { const char *name; int value; }
      constants[10] = {
        { "Idle", vtkMRMLCommandLineModuleNode::Idle },
        { "Scheduled", vtkMRMLCommandLineModuleNode::Scheduled },
        { "Running", vtkMRMLCommandLineModuleNode::Running },
        { "Cancelling", vtkMRMLCommandLineModuleNode::Cancelling },
        { "Cancelled", vtkMRMLCommandLineModuleNode::Cancelled },
        { "Completing", vtkMRMLCommandLineModuleNode::Completing },
        { "Completed", vtkMRMLCommandLineModuleNode::Completed },
        { "ErrorsMask", vtkMRMLCommandLineModuleNode::ErrorsMask },
        { "CompletedWithErrors", vtkMRMLCommandLineModuleNode::CompletedWithErrors },
        { "BusyMask", vtkMRMLCommandLineModuleNode::BusyMask },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 6; c++)
  {
    typedef vtkMRMLCommandLineModuleNode::AutoRunMode cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[6] = {
        { "AutoRunCancelsRunningProcess", vtkMRMLCommandLineModuleNode::AutoRunCancelsRunningProcess },
        { "AutoRunOnChangedParameter", vtkMRMLCommandLineModuleNode::AutoRunOnChangedParameter },
        { "AutoRunOnModifiedInputEvent", vtkMRMLCommandLineModuleNode::AutoRunOnModifiedInputEvent },
        { "AutoRunOnOtherInputEvents", vtkMRMLCommandLineModuleNode::AutoRunOnOtherInputEvents },
        { "AutoRunOnAnyInputEvent", vtkMRMLCommandLineModuleNode::AutoRunOnAnyInputEvent },
        { "AutoRunEnabledMask", vtkMRMLCommandLineModuleNode::AutoRunEnabledMask },
      };

    o = PyvtkMRMLCommandLineModuleNode_AutoRunMode_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLCommandLineModuleNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLCommandLineModuleNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLCommandLineModuleNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

