// python wrapper for vtkMRMLClipModelsNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMRMLClipModelsNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLClipModelsNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLClipModelsNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLNode_ClassNew
extern "C" { PyObject *PyvtkMRMLNode_ClassNew(); }
#define DECLARED_PyvtkMRMLNode_ClassNew
#endif

static const char *PyvtkMRMLClipModelsNode_Doc =
  "vtkMRMLClipModelsNode - MRML node to represent three clipping planes.\n\n"
  "Superclass: vtkMRMLNode\n\n"
  "The vtkMRMLClipModelsNode MRML node stores the direction of clipping\n"
  "for each of the three clipping planes. It also stores the type of\n"
  "combined clipping operation as either an intersection or union.\n\n";


static PyObject *
PyvtkMRMLClipModelsNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLClipModelsNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLClipModelsNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLClipModelsNode *tempr = vtkMRMLClipModelsNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLClipModelsNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLClipModelsNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLClipModelsNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLClipModelsNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLClipModelsNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_CopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->CopyContent(temp0, temp1);
    }
    else
    {
      op->vtkMRMLClipModelsNode::CopyContent(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_HasCopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasCopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasCopyContent() :
      op->vtkMRMLClipModelsNode::HasCopyContent());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLClipModelsNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_GetClipType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClipType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetClipType() :
      op->vtkMRMLClipModelsNode::GetClipType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_SetClipType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetClipType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetClipType(temp0);
    }
    else
    {
      op->vtkMRMLClipModelsNode::SetClipType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_GetRedSliceClipState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRedSliceClipState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRedSliceClipState() :
      op->vtkMRMLClipModelsNode::GetRedSliceClipState());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_SetRedSliceClipState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRedSliceClipState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRedSliceClipState(temp0);
    }
    else
    {
      op->vtkMRMLClipModelsNode::SetRedSliceClipState(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_GetYellowSliceClipState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetYellowSliceClipState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetYellowSliceClipState() :
      op->vtkMRMLClipModelsNode::GetYellowSliceClipState());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_SetYellowSliceClipState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetYellowSliceClipState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetYellowSliceClipState(temp0);
    }
    else
    {
      op->vtkMRMLClipModelsNode::SetYellowSliceClipState(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_GetGreenSliceClipState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGreenSliceClipState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetGreenSliceClipState() :
      op->vtkMRMLClipModelsNode::GetGreenSliceClipState());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_SetGreenSliceClipState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGreenSliceClipState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLClipModelsNode *op = static_cast<vtkMRMLClipModelsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGreenSliceClipState(temp0);
    }
    else
    {
      op->vtkMRMLClipModelsNode::SetGreenSliceClipState(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLClipModelsNode_GetClippingMethodFromString(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetClippingMethodFromString");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLClipModelsNode::GetClippingMethodFromString(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLClipModelsNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLClipModelsNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLClipModelsNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLClipModelsNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLClipModelsNode\nC++: static vtkMRMLClipModelsNode *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLClipModelsNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLClipModelsNode\nC++: vtkMRMLClipModelsNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLClipModelsNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLClipModelsNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"CreateNodeInstance", PyvtkMRMLClipModelsNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\nMRMLNode methods\n"},
  {"CopyContent", PyvtkMRMLClipModelsNode_CopyContent, METH_VARARGS,
   "V.CopyContent(vtkMRMLNode, bool)\nC++: void CopyContent(vtkMRMLNode *node, bool deepCopy=true)\n    override;\n\nCopy node content (excludes basic data, such as name and node\nreferences).\n\\sa vtkMRMLNode::CopyContent\n"},
  {"HasCopyContent", PyvtkMRMLClipModelsNode_HasCopyContent, METH_VARARGS,
   "V.HasCopyContent() -> bool\nC++: bool HasCopyContent() override;\n\nReturns true if the class supports deep and shallow copying node\n    content.\n"},
  {"GetNodeTagName", PyvtkMRMLClipModelsNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"GetClipType", PyvtkMRMLClipModelsNode_GetClipType, METH_VARARGS,
   "V.GetClipType() -> int\nC++: virtual int GetClipType()\n\nIndicates the type of clipping \"Intersection\" or \"Union\"\n"},
  {"SetClipType", PyvtkMRMLClipModelsNode_SetClipType, METH_VARARGS,
   "V.SetClipType(int)\nC++: virtual void SetClipType(int _arg)\n\n"},
  {"GetRedSliceClipState", PyvtkMRMLClipModelsNode_GetRedSliceClipState, METH_VARARGS,
   "V.GetRedSliceClipState() -> int\nC++: virtual int GetRedSliceClipState()\n\nIndicates if the Red slice clipping is Off, Positive space, or\nNegative space\n"},
  {"SetRedSliceClipState", PyvtkMRMLClipModelsNode_SetRedSliceClipState, METH_VARARGS,
   "V.SetRedSliceClipState(int)\nC++: virtual void SetRedSliceClipState(int _arg)\n\n"},
  {"GetYellowSliceClipState", PyvtkMRMLClipModelsNode_GetYellowSliceClipState, METH_VARARGS,
   "V.GetYellowSliceClipState() -> int\nC++: virtual int GetYellowSliceClipState()\n\nIndicates if the Yellow slice clipping is Off, Positive space, or\nNegative space\n"},
  {"SetYellowSliceClipState", PyvtkMRMLClipModelsNode_SetYellowSliceClipState, METH_VARARGS,
   "V.SetYellowSliceClipState(int)\nC++: virtual void SetYellowSliceClipState(int _arg)\n\n"},
  {"GetGreenSliceClipState", PyvtkMRMLClipModelsNode_GetGreenSliceClipState, METH_VARARGS,
   "V.GetGreenSliceClipState() -> int\nC++: virtual int GetGreenSliceClipState()\n\nIndicates if the Green slice clipping is Off, Positive space, or\nNegative space\n"},
  {"SetGreenSliceClipState", PyvtkMRMLClipModelsNode_SetGreenSliceClipState, METH_VARARGS,
   "V.SetGreenSliceClipState(int)\nC++: virtual void SetGreenSliceClipState(int _arg)\n\n"},
  {"GetClippingMethodFromString", PyvtkMRMLClipModelsNode_GetClippingMethodFromString, METH_VARARGS,
   "V.GetClippingMethodFromString(string) -> int\nC++: static int GetClippingMethodFromString(const char *name)\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLClipModelsNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLCore.vtkMRMLClipModelsNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLClipModelsNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLClipModelsNode_StaticNew()
{
  return vtkMRMLClipModelsNode::New();
}

PyObject *PyvtkMRMLClipModelsNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLClipModelsNode_Type, PyvtkMRMLClipModelsNode_Methods,
    "vtkMRMLClipModelsNode",
 &PyvtkMRMLClipModelsNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMRMLNode_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 8; c++)
  {
    static const struct { const char *name; int value; }
      constants[8] = {
        { "ClipIntersection", vtkMRMLClipModelsNode::ClipIntersection },
        { "ClipUnion", vtkMRMLClipModelsNode::ClipUnion },
        { "ClipOff", vtkMRMLClipModelsNode::ClipOff },
        { "ClipPositiveSpace", vtkMRMLClipModelsNode::ClipPositiveSpace },
        { "ClipNegativeSpace", vtkMRMLClipModelsNode::ClipNegativeSpace },
        { "Straight", vtkMRMLClipModelsNode::Straight },
        { "WholeCells", vtkMRMLClipModelsNode::WholeCells },
        { "WholeCellsWithBoundary", vtkMRMLClipModelsNode::WholeCellsWithBoundary },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLClipModelsNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLClipModelsNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLClipModelsNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

