// python wrapper for vtkMRMLCrosshairNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMRMLCrosshairNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLCrosshairNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLCrosshairNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLNode_ClassNew
extern "C" { PyObject *PyvtkMRMLNode_ClassNew(); }
#define DECLARED_PyvtkMRMLNode_ClassNew
#endif

static const char *PyvtkMRMLCrosshairNode_Doc =
  "vtkMRMLCrosshairNode - MRML node for storing a crosshair through RAS\nspace\n\n"
  "Superclass: vtkMRMLNode\n\n"
  "This node stores the information about a crosshair (position, style,\n"
  "attributes)\n\n";


static PyObject *
PyvtkMRMLCrosshairNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLCrosshairNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLCrosshairNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLCrosshairNode *tempr = vtkMRMLCrosshairNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLCrosshairNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLCrosshairNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLCrosshairNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLCrosshairNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLCrosshairNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_CopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->CopyContent(temp0, temp1);
    }
    else
    {
      op->vtkMRMLCrosshairNode::CopyContent(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_HasCopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasCopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasCopyContent() :
      op->vtkMRMLCrosshairNode::HasCopyContent());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLCrosshairNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetCrosshairMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCrosshairMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCrosshairMode() :
      op->vtkMRMLCrosshairNode::GetCrosshairMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCrosshairMode(temp0);
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetCrosshairBehavior(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCrosshairBehavior");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCrosshairBehavior() :
      op->vtkMRMLCrosshairNode::GetCrosshairBehavior());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairBehavior(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairBehavior");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCrosshairBehavior(temp0);
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairBehavior(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairThickness(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairThickness");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCrosshairThickness(temp0);
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairThickness(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetCrosshairThicknessMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCrosshairThicknessMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCrosshairThicknessMinValue() :
      op->vtkMRMLCrosshairNode::GetCrosshairThicknessMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetCrosshairThicknessMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCrosshairThicknessMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCrosshairThicknessMaxValue() :
      op->vtkMRMLCrosshairNode::GetCrosshairThicknessMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetCrosshairThickness(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCrosshairThickness");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCrosshairThickness() :
      op->vtkMRMLCrosshairNode::GetCrosshairThickness());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairToFine(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairToFine");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetCrosshairToFine();
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairToFine();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairToMedium(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairToMedium");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetCrosshairToMedium();
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairToMedium();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairToThick(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairToThick");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetCrosshairToThick();
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairToThick();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCursorPositionRAS(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCursorPositionRAS");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetCursorPositionRAS(temp0);
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCursorPositionRAS(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCursorPositionXYZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCursorPositionXYZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  vtkMRMLSliceNode *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetVTKObject(temp1, "vtkMRMLSliceNode"))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetCursorPositionXYZ(temp0, temp1);
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCursorPositionXYZ(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCursorPositionInvalid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCursorPositionInvalid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetCursorPositionInvalid();
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCursorPositionInvalid();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetCursorPositionRAS(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCursorPositionRAS");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    bool tempr = (ap.IsBound() ?
      op->GetCursorPositionRAS(temp0) :
      op->vtkMRMLCrosshairNode::GetCursorPositionRAS(temp0));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetCursorPositionXYZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCursorPositionXYZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    vtkMRMLSliceNode *tempr = (ap.IsBound() ?
      op->GetCursorPositionXYZ(temp0) :
      op->vtkMRMLCrosshairNode::GetCursorPositionXYZ(temp0));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairRAS_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairRAS");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetCrosshairRAS(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairRAS(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairRAS_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairRAS");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetCrosshairRAS(temp0);
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairRAS(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairRAS_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairRAS");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetCrosshairRAS(temp0, temp1);
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairRAS(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairRAS(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkMRMLCrosshairNode_SetCrosshairRAS_s1(self, args);
    case 1:
      return PyvtkMRMLCrosshairNode_SetCrosshairRAS_s2(self, args);
    case 2:
      return PyvtkMRMLCrosshairNode_SetCrosshairRAS_s3(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetCrosshairRAS");
  return nullptr;
}



static PyObject *
PyvtkMRMLCrosshairNode_GetCrosshairRAS(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCrosshairRAS");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetCrosshairRAS() :
      op->vtkMRMLCrosshairNode::GetCrosshairRAS());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetLightBoxPane(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLightBoxPane");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLightBoxPane() :
      op->vtkMRMLCrosshairNode::GetLightBoxPane());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_SetCrosshairName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCrosshairName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCrosshairName(temp0);
    }
    else
    {
      op->vtkMRMLCrosshairNode::SetCrosshairName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLCrosshairNode_GetCrosshairName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCrosshairName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLCrosshairNode *op = static_cast<vtkMRMLCrosshairNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetCrosshairName() :
      op->vtkMRMLCrosshairNode::GetCrosshairName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLCrosshairNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLCrosshairNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLCrosshairNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLCrosshairNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLCrosshairNode\nC++: static vtkMRMLCrosshairNode *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLCrosshairNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLCrosshairNode\nC++: vtkMRMLCrosshairNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLCrosshairNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLCrosshairNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"CreateNodeInstance", PyvtkMRMLCrosshairNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\nCreate instance of the default node. Like New only virtual.\n\note Subclasses should implement this method\n"},
  {"CopyContent", PyvtkMRMLCrosshairNode_CopyContent, METH_VARARGS,
   "V.CopyContent(vtkMRMLNode, bool)\nC++: void CopyContent(vtkMRMLNode *node, bool deepCopy=true)\n    override;\n\nCopy node content (excludes basic data, such as name and node\nreferences).\n\\sa vtkMRMLNode::CopyContent\n"},
  {"HasCopyContent", PyvtkMRMLCrosshairNode_HasCopyContent, METH_VARARGS,
   "V.HasCopyContent() -> bool\nC++: bool HasCopyContent() override;\n\nReturns true if the class supports deep and shallow copying node\n    content.\n"},
  {"GetNodeTagName", PyvtkMRMLCrosshairNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"GetCrosshairMode", PyvtkMRMLCrosshairNode_GetCrosshairMode, METH_VARARGS,
   "V.GetCrosshairMode() -> int\nC++: virtual int GetCrosshairMode()\n\nconfigures the crosshair appearance and behavior\n"},
  {"SetCrosshairMode", PyvtkMRMLCrosshairNode_SetCrosshairMode, METH_VARARGS,
   "V.SetCrosshairMode(int)\nC++: virtual void SetCrosshairMode(int _arg)\n\n"},
  {"GetCrosshairBehavior", PyvtkMRMLCrosshairNode_GetCrosshairBehavior, METH_VARARGS,
   "V.GetCrosshairBehavior() -> int\nC++: virtual int GetCrosshairBehavior()\n\n"},
  {"SetCrosshairBehavior", PyvtkMRMLCrosshairNode_SetCrosshairBehavior, METH_VARARGS,
   "V.SetCrosshairBehavior(int)\nC++: virtual void SetCrosshairBehavior(int _arg)\n\n"},
  {"SetCrosshairThickness", PyvtkMRMLCrosshairNode_SetCrosshairThickness, METH_VARARGS,
   "V.SetCrosshairThickness(int)\nC++: virtual void SetCrosshairThickness(int _arg)\n\n"},
  {"GetCrosshairThicknessMinValue", PyvtkMRMLCrosshairNode_GetCrosshairThicknessMinValue, METH_VARARGS,
   "V.GetCrosshairThicknessMinValue() -> int\nC++: virtual int GetCrosshairThicknessMinValue()\n\n"},
  {"GetCrosshairThicknessMaxValue", PyvtkMRMLCrosshairNode_GetCrosshairThicknessMaxValue, METH_VARARGS,
   "V.GetCrosshairThicknessMaxValue() -> int\nC++: virtual int GetCrosshairThicknessMaxValue()\n\n"},
  {"GetCrosshairThickness", PyvtkMRMLCrosshairNode_GetCrosshairThickness, METH_VARARGS,
   "V.GetCrosshairThickness() -> int\nC++: virtual int GetCrosshairThickness()\n\n"},
  {"SetCrosshairToFine", PyvtkMRMLCrosshairNode_SetCrosshairToFine, METH_VARARGS,
   "V.SetCrosshairToFine()\nC++: void SetCrosshairToFine()\n\n"},
  {"SetCrosshairToMedium", PyvtkMRMLCrosshairNode_SetCrosshairToMedium, METH_VARARGS,
   "V.SetCrosshairToMedium()\nC++: void SetCrosshairToMedium()\n\n"},
  {"SetCrosshairToThick", PyvtkMRMLCrosshairNode_SetCrosshairToThick, METH_VARARGS,
   "V.SetCrosshairToThick()\nC++: void SetCrosshairToThick()\n\n"},
  {"SetCursorPositionRAS", PyvtkMRMLCrosshairNode_SetCursorPositionRAS, METH_VARARGS,
   "V.SetCursorPositionRAS([float, float, float])\nC++: void SetCursorPositionRAS(double ras[3])\n\nSet cursor position in 3D. This should be called whenever the\ncursor is moved by using a 3D positioning device (that does not\nhave an associated slice viewer). GetCursorPositionXYZ returns\nwith nullptr if SetCursorPositionRAS is used for setting the\ncursor position, so if slice position is available then\nSetCursorPositionXYZ method should be used instead (it sets both\nXYZ and RAS position, too).\n"},
  {"SetCursorPositionXYZ", PyvtkMRMLCrosshairNode_SetCursorPositionXYZ, METH_VARARGS,
   "V.SetCursorPositionXYZ([float, float, float], vtkMRMLSliceNode)\nC++: void SetCursorPositionXYZ(double xyz[3],\n    vtkMRMLSliceNode *sliceNode)\n\nSet cursor position in a 2D slice view. The method also computes\nthe RAS position. This method should be called whenever the mouse\nmoves in a slice viewer.\n"},
  {"SetCursorPositionInvalid", PyvtkMRMLCrosshairNode_SetCursorPositionInvalid, METH_VARARGS,
   "V.SetCursorPositionInvalid()\nC++: void SetCursorPositionInvalid()\n\nInvalidates the cursor position. This should be called whenever\nthe mouse moves out of a view.\n"},
  {"GetCursorPositionRAS", PyvtkMRMLCrosshairNode_GetCursorPositionRAS, METH_VARARGS,
   "V.GetCursorPositionRAS([float, float, float]) -> bool\nC++: bool GetCursorPositionRAS(double ras[3])\n\nGet the position of the cursor in the current view in RAS\ncoordinate system. Returns false if the cursor position is\nunknown. This is typically called by other classes to get the\ncurrent cursor position after receiving\nCursorPositionModifiedEvent event.\n"},
  {"GetCursorPositionXYZ", PyvtkMRMLCrosshairNode_GetCursorPositionXYZ, METH_VARARGS,
   "V.GetCursorPositionXYZ([float, float, float]) -> vtkMRMLSliceNode\nC++: vtkMRMLSliceNode *GetCursorPositionXYZ(double xyz[3])\n\nGet the position of the cursor in the current view in XYZ\ncoordinate system. Returns nullptr if the cursor is not in a\nslice viewer. This is typically called by other classes to get\nthe current cursor position after receiving\nCursorPositionModifiedEvent event.\n"},
  {"SetCrosshairRAS", PyvtkMRMLCrosshairNode_SetCrosshairRAS, METH_VARARGS,
   "V.SetCrosshairRAS(float, float, float)\nC++: virtual void SetCrosshairRAS(double _arg1, double _arg2,\n    double _arg3)\nV.SetCrosshairRAS((float, float, float))\nC++: virtual void SetCrosshairRAS(const double _arg[3])\nV.SetCrosshairRAS([float, float, float], int)\nC++: void SetCrosshairRAS(double ras[3], int id)\n\nSet crosshair position\n"},
  {"GetCrosshairRAS", PyvtkMRMLCrosshairNode_GetCrosshairRAS, METH_VARARGS,
   "V.GetCrosshairRAS() -> (float, float, float)\nC++: virtual double *GetCrosshairRAS()\n\n"},
  {"GetLightBoxPane", PyvtkMRMLCrosshairNode_GetLightBoxPane, METH_VARARGS,
   "V.GetLightBoxPane() -> int\nC++: virtual int GetLightBoxPane()\n\nGet the pane of the lightbox that was last cached\n"},
  {"SetCrosshairName", PyvtkMRMLCrosshairNode_SetCrosshairName, METH_VARARGS,
   "V.SetCrosshairName(string)\nC++: void SetCrosshairName(const char *name)\n\nName of the layout\n"},
  {"GetCrosshairName", PyvtkMRMLCrosshairNode_GetCrosshairName, METH_VARARGS,
   "V.GetCrosshairName() -> string\nC++: char *GetCrosshairName()\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLCrosshairNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLCore.vtkMRMLCrosshairNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLCrosshairNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLCrosshairNode_StaticNew()
{
  return vtkMRMLCrosshairNode::New();
}

PyObject *PyvtkMRMLCrosshairNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLCrosshairNode_Type, PyvtkMRMLCrosshairNode_Methods,
    "vtkMRMLCrosshairNode",
 &PyvtkMRMLCrosshairNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMRMLNode_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 16; c++)
  {
    static const struct { const char *name; int value; }
      constants[16] = {
        { "CursorPositionModifiedEvent", vtkMRMLCrosshairNode::CursorPositionModifiedEvent },
        { "NoCrosshair", vtkMRMLCrosshairNode::NoCrosshair },
        { "ShowBasic", vtkMRMLCrosshairNode::ShowBasic },
        { "ShowIntersection", vtkMRMLCrosshairNode::ShowIntersection },
        { "ShowHashmarks", vtkMRMLCrosshairNode::ShowHashmarks },
        { "ShowAll", vtkMRMLCrosshairNode::ShowAll },
        { "ShowSmallBasic", vtkMRMLCrosshairNode::ShowSmallBasic },
        { "ShowSmallIntersection", vtkMRMLCrosshairNode::ShowSmallIntersection },
        { "Fine", vtkMRMLCrosshairNode::Fine },
        { "Medium", vtkMRMLCrosshairNode::Medium },
        { "Thick", vtkMRMLCrosshairNode::Thick },
        { "NoAction", vtkMRMLCrosshairNode::NoAction },
        { "OffsetJumpSlice", vtkMRMLCrosshairNode::OffsetJumpSlice },
        { "CenteredJumpSlice", vtkMRMLCrosshairNode::CenteredJumpSlice },
        { "Normal", vtkMRMLCrosshairNode::Normal },
        { "JumpSlice", vtkMRMLCrosshairNode::JumpSlice },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLCrosshairNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLCrosshairNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLCrosshairNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

