// python wrapper for vtkMRMLDoubleArrayNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMRMLDoubleArrayNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLDoubleArrayNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLDoubleArrayNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLStorableNode_ClassNew
extern "C" { PyObject *PyvtkMRMLStorableNode_ClassNew(); }
#define DECLARED_PyvtkMRMLStorableNode_ClassNew
#endif

static const char *PyvtkMRMLDoubleArrayNode_Doc =
  "vtkMRMLDoubleArrayNode - no description provided.\n\n"
  "Superclass: vtkMRMLStorableNode\n\n"
;


static PyObject *
PyvtkMRMLDoubleArrayNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLDoubleArrayNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLDoubleArrayNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLDoubleArrayNode *tempr = vtkMRMLDoubleArrayNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLDoubleArrayNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLDoubleArrayNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLDoubleArrayNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLDoubleArrayNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLDoubleArrayNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_CopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->CopyContent(temp0, temp1);
    }
    else
    {
      op->vtkMRMLDoubleArrayNode::CopyContent(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_HasCopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasCopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasCopyContent() :
      op->vtkMRMLDoubleArrayNode::HasCopyContent());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLDoubleArrayNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_ProcessMRMLEvents(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProcessMRMLEvents");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  vtkObject *temp0 = nullptr;
  unsigned long temp1;
  void  *temp2 = nullptr;
  Py_buffer pbuf2 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkObject") &&
      ap.GetValue(temp1) &&
      ap.GetBuffer(temp2, &pbuf2))
  {
    if (ap.IsBound())
    {
      op->ProcessMRMLEvents(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLDoubleArrayNode::ProcessMRMLEvents(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf2.obj != 0)
  {
    PyBuffer_Release(&pbuf2);
  }
#endif
  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_SetArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  vtkDoubleArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDoubleArray"))
  {
    if (ap.IsBound())
    {
      op->SetArray(temp0);
    }
    else
    {
      op->vtkMRMLDoubleArrayNode::SetArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDoubleArray *tempr = (ap.IsBound() ?
      op->GetArray() :
      op->vtkMRMLDoubleArrayNode::GetArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_SetSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  unsigned int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSize(temp0);
    }
    else
    {
      op->vtkMRMLDoubleArrayNode::SetSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetSize() :
      op->vtkMRMLDoubleArrayNode::GetSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetYAxisValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetYAxisValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  double temp0;
  int temp1 = vtkMRMLDoubleArrayNode::INTERP_LINEAR;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    double tempr = (ap.IsBound() ?
      op->GetYAxisValue(temp0, temp1) :
      op->vtkMRMLDoubleArrayNode::GetYAxisValue(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_SetValues(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetValues");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  int temp0;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    int tempr = (ap.IsBound() ?
      op->SetValues(temp0, temp1) :
      op->vtkMRMLDoubleArrayNode::SetValues(temp0, temp1));

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_SetValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  int temp0;
  int temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->SetValue(temp0, temp1, temp2) :
      op->vtkMRMLDoubleArrayNode::SetValue(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_SetXYValue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetXYValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  int temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->SetXYValue(temp0, temp1, temp2) :
      op->vtkMRMLDoubleArrayNode::SetXYValue(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLDoubleArrayNode_SetXYValue_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetXYValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  int temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    int tempr = (ap.IsBound() ?
      op->SetXYValue(temp0, temp1, temp2, temp3) :
      op->vtkMRMLDoubleArrayNode::SetXYValue(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLDoubleArrayNode_SetXYValue(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkMRMLDoubleArrayNode_SetXYValue_s1(self, args);
    case 4:
      return PyvtkMRMLDoubleArrayNode_SetXYValue_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetXYValue");
  return nullptr;
}



static PyObject *
PyvtkMRMLDoubleArrayNode_GetValues(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValues");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  int temp0;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    int tempr = (ap.IsBound() ?
      op->GetValues(temp0, temp1) :
      op->vtkMRMLDoubleArrayNode::GetValues(temp0, temp1));

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    double tempr = (ap.IsBound() ?
      op->GetValue(temp0, temp1, temp2) :
      op->vtkMRMLDoubleArrayNode::GetValue(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(2, temp2);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetXYValue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetXYValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  int temp0;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<double> store2(2*size2);
  double *temp2 = store2.Data();
  double *save2 = (size2 == 0 ? nullptr : temp2 + size2);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2))
  {
    vtkPythonArgs::Save(temp1, save1, size1);
    vtkPythonArgs::Save(temp2, save2, size2);

    int tempr = (ap.IsBound() ?
      op->GetXYValue(temp0, temp1, temp2) :
      op->vtkMRMLDoubleArrayNode::GetXYValue(temp0, temp1, temp2));

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (vtkPythonArgs::HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLDoubleArrayNode_GetXYValue_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetXYValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  int temp0;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<double> store2(2*size2);
  double *temp2 = store2.Data();
  double *save2 = (size2 == 0 ? nullptr : temp2 + size2);
  size_t size3 = ap.GetArgSize(3);
  vtkPythonArgs::Array<double> store3(2*size3);
  double *temp3 = store3.Data();
  double *save3 = (size3 == 0 ? nullptr : temp3 + size3);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2) &&
      ap.GetArray(temp3, size3))
  {
    vtkPythonArgs::Save(temp1, save1, size1);
    vtkPythonArgs::Save(temp2, save2, size2);
    vtkPythonArgs::Save(temp3, save3, size3);

    int tempr = (ap.IsBound() ?
      op->GetXYValue(temp0, temp1, temp2, temp3) :
      op->vtkMRMLDoubleArrayNode::GetXYValue(temp0, temp1, temp2, temp3));

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (vtkPythonArgs::HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (vtkPythonArgs::HasChanged(temp3, save3, size3) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(3, temp3, size3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLDoubleArrayNode_GetXYValue(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkMRMLDoubleArrayNode_GetXYValue_s1(self, args);
    case 4:
      return PyvtkMRMLDoubleArrayNode_GetXYValue_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetXYValue");
  return nullptr;
}



static PyObject *
PyvtkMRMLDoubleArrayNode_AddValues(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddValues");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    int tempr = (ap.IsBound() ?
      op->AddValues(temp0) :
      op->vtkMRMLDoubleArrayNode::AddValues(temp0));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_AddValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  int temp0;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->AddValue(temp0, temp1) :
      op->vtkMRMLDoubleArrayNode::AddValue(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_AddXYValue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddXYValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  double temp0;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->AddXYValue(temp0, temp1) :
      op->vtkMRMLDoubleArrayNode::AddXYValue(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLDoubleArrayNode_AddXYValue_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddXYValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->AddXYValue(temp0, temp1, temp2) :
      op->vtkMRMLDoubleArrayNode::AddXYValue(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLDoubleArrayNode_AddXYValue(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkMRMLDoubleArrayNode_AddXYValue_s1(self, args);
    case 3:
      return PyvtkMRMLDoubleArrayNode_AddXYValue_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "AddXYValue");
  return nullptr;
}



static PyObject *
PyvtkMRMLDoubleArrayNode_GetRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  int temp2 = 1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    vtkPythonArgs::Save(temp0, save0, size0);
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetRange(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLDoubleArrayNode::GetRange(temp0, temp1, temp2);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetXRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetXRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetXRange(temp0);
    }
    else
    {
      op->vtkMRMLDoubleArrayNode::GetXRange(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetYRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetYRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  int temp1 = 1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetArray(temp0, size0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetYRange(temp0, temp1);
    }
    else
    {
      op->vtkMRMLDoubleArrayNode::GetYRange(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_SetLabels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  std::vector<std::string> temp0(ap.GetArgSize(0));
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0.data(), temp0.size()))
  {
    if (ap.IsBound())
    {
      op->SetLabels(temp0);
    }
    else
    {
      op->vtkMRMLDoubleArrayNode::SetLabels(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_GetLabels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const std::vector<std::string> *tempr = (ap.IsBound() ?
      &op->GetLabels() :
      &op->vtkMRMLDoubleArrayNode::GetLabels());

    if (!ap.ErrorOccurred())
    {
      if (tempr->size() == 0)
      {
        result = PyTuple_New(0);
      }
      else
      {
        result = ap.BuildTuple(tempr->data(), tempr->size());
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLDoubleArrayNode_CreateDefaultStorageNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultStorageNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLDoubleArrayNode *op = static_cast<vtkMRMLDoubleArrayNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLStorageNode *tempr = (ap.IsBound() ?
      op->CreateDefaultStorageNode() :
      op->vtkMRMLDoubleArrayNode::CreateDefaultStorageNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLDoubleArrayNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLDoubleArrayNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLDoubleArrayNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLDoubleArrayNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLDoubleArrayNode\nC++: static vtkMRMLDoubleArrayNode *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLDoubleArrayNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLDoubleArrayNode\nC++: vtkMRMLDoubleArrayNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLDoubleArrayNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLDoubleArrayNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"CreateNodeInstance", PyvtkMRMLDoubleArrayNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\nMRMLNode methods\n"},
  {"CopyContent", PyvtkMRMLDoubleArrayNode_CopyContent, METH_VARARGS,
   "V.CopyContent(vtkMRMLNode, bool)\nC++: void CopyContent(vtkMRMLNode *node, bool deepCopy=true)\n    override;\n\nCopy node content (excludes basic data, such as name and node\nreferences).\n\\sa vtkMRMLNode::CopyContent\n"},
  {"HasCopyContent", PyvtkMRMLDoubleArrayNode_HasCopyContent, METH_VARARGS,
   "V.HasCopyContent() -> bool\nC++: bool HasCopyContent() override;\n\nReturns true if the class supports deep and shallow copying node\n    content.\n"},
  {"GetNodeTagName", PyvtkMRMLDoubleArrayNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"ProcessMRMLEvents", PyvtkMRMLDoubleArrayNode_ProcessMRMLEvents, METH_VARARGS,
   "V.ProcessMRMLEvents(vtkObject, int, void)\nC++: void ProcessMRMLEvents(vtkObject *caller,\n    unsigned long event, void *callData) override;\n\nMethod to propagate events generated in mrml\n"},
  {"SetArray", PyvtkMRMLDoubleArrayNode_SetArray, METH_VARARGS,
   "V.SetArray(vtkDoubleArray)\nC++: virtual void SetArray(vtkDoubleArray *)\n\nGet and Set Macros\n"},
  {"GetArray", PyvtkMRMLDoubleArrayNode_GetArray, METH_VARARGS,
   "V.GetArray() -> vtkDoubleArray\nC++: virtual vtkDoubleArray *GetArray()\n\n"},
  {"SetSize", PyvtkMRMLDoubleArrayNode_SetSize, METH_VARARGS,
   "V.SetSize(int)\nC++: void SetSize(unsigned int n)\n\nAccess methods\n\nSet / change the size of value data (number of points in time\ndimension)\n"},
  {"GetSize", PyvtkMRMLDoubleArrayNode_GetSize, METH_VARARGS,
   "V.GetSize() -> int\nC++: unsigned int GetSize()\n\nGet the size of value data (number of points in time dimension)\n"},
  {"GetYAxisValue", PyvtkMRMLDoubleArrayNode_GetYAxisValue, METH_VARARGS,
   "V.GetYAxisValue(float, int) -> float\nC++: double GetYAxisValue(double x, int interp=INTERP_LINEAR)\n\nGet Y value by X. If X is between two data points, it\ninterpolates the value by using the method specified by 'interp'.\nNOTE: TO BE IMPLEMENTED.\n"},
  {"SetValues", PyvtkMRMLDoubleArrayNode_SetValues, METH_VARARGS,
   "V.SetValues(int, [float, ...]) -> int\nC++: int SetValues(int index, double *values)\n\n\\bug Fix function GetXYAxisValue(int index, double* x, double*\ny); Get X and Y values at the data point specified by 'index' int\nGetXYAxisValue(int index, double* x, double* y);\\bug Fix function\nGetXYAxisValue(int index, double* x, double* y, double*  yerr);\nGet X and Y values with error (or standard deviation) of Y, at\nthe data point specified by 'index' int GetXYAxisValue(int index,\ndouble* x, double* y, double*  yerr);\n\nSet values at the data point specified by 'index'\n"},
  {"SetValue", PyvtkMRMLDoubleArrayNode_SetValue, METH_VARARGS,
   "V.SetValue(int, int, float) -> int\nC++: int SetValue(int index, int component, double value)\n\nSet value at the data point specified by 'index' at the given\n'component'\n"},
  {"SetXYValue", PyvtkMRMLDoubleArrayNode_SetXYValue, METH_VARARGS,
   "V.SetXYValue(int, float, float) -> int\nC++: int SetXYValue(int index, double x, double y)\nV.SetXYValue(int, float, float, float) -> int\nC++: int SetXYValue(int index, double x, double y, double yerr)\n\nSet X and Y values at the data point specified by 'index'\n"},
  {"GetValues", PyvtkMRMLDoubleArrayNode_GetValues, METH_VARARGS,
   "V.GetValues(int, [float, ...]) -> int\nC++: int GetValues(int index, double *values)\n\nGet values at the data point specified by 'index'\n"},
  {"GetValue", PyvtkMRMLDoubleArrayNode_GetValue, METH_VARARGS,
   "V.GetValue(int, int, int) -> float\nC++: double GetValue(int index, int component, int &success)\n\nGet value at the data point specified by 'index' at the given\n'component'\n"},
  {"GetXYValue", PyvtkMRMLDoubleArrayNode_GetXYValue, METH_VARARGS,
   "V.GetXYValue(int, [float, ...], [float, ...]) -> int\nC++: int GetXYValue(int index, double *x, double *y)\nV.GetXYValue(int, [float, ...], [float, ...], [float, ...]) -> int\nC++: int GetXYValue(int index, double *x, double *y, double *yerr)\n\nGet X and Y values at the data point specified by 'index'\n"},
  {"AddValues", PyvtkMRMLDoubleArrayNode_AddValues, METH_VARARGS,
   "V.AddValues([float, ...]) -> int\nC++: int AddValues(double *values)\n\nAdd values at the end of the array\n"},
  {"AddValue", PyvtkMRMLDoubleArrayNode_AddValue, METH_VARARGS,
   "V.AddValue(int, float) -> int\nC++: int AddValue(int component, double value)\n\nAdd value at the end of the array at the given 'component'\n"},
  {"AddXYValue", PyvtkMRMLDoubleArrayNode_AddXYValue, METH_VARARGS,
   "V.AddXYValue(float, float) -> int\nC++: int AddXYValue(double x, double y)\nV.AddXYValue(float, float, float) -> int\nC++: int AddXYValue(double x, double y, double yerr)\n\nAdd a set of X and Y values at the end of the array\n"},
  {"GetRange", PyvtkMRMLDoubleArrayNode_GetRange, METH_VARARGS,
   "V.GetRange([float, ...], [float, ...], int)\nC++: void GetRange(double *rangeX, double *rangeY,\n    int fIncludeError=1)\n\nSearch min and maximum value of X and Y in the array. The result\nis stored in 'range'. (range[0]: minimum value, range[1]: maximum\nvalue) if fIncludeError=1 is specified, the range takes account\nof errors.\n"},
  {"GetXRange", PyvtkMRMLDoubleArrayNode_GetXRange, METH_VARARGS,
   "V.GetXRange([float, ...])\nC++: void GetXRange(double *range)\n\nSearch min and maximum value of X in the array. The result is\nstored in 'range'. (range[0]: minimum value, range[1]: maximum\nvalue)\n"},
  {"GetYRange", PyvtkMRMLDoubleArrayNode_GetYRange, METH_VARARGS,
   "V.GetYRange([float, ...], int)\nC++: void GetYRange(double *range, int fIncludeError=1)\n\nSearch min and maximum value of Y in the array. The result is\nstored in 'range'. (range[0]: minimum value, range[1]: maximum\nvalue) if fIncludeError=1 is specified, the range takes account\nof errors.\n"},
  {"SetLabels", PyvtkMRMLDoubleArrayNode_SetLabels, METH_VARARGS,
   "V.SetLabels(Stvector_ISt6stringE)\nC++: void SetLabels(const LabelsVectorType &labels)\n\nSet labels void SetLabel(std::vector< std::string > labels);\n"},
  {"GetLabels", PyvtkMRMLDoubleArrayNode_GetLabels, METH_VARARGS,
   "V.GetLabels() -> Stvector_ISt6stringE\nC++: const LabelsVectorType &GetLabels()\n\nGet labels\n"},
  {"CreateDefaultStorageNode", PyvtkMRMLDoubleArrayNode_CreateDefaultStorageNode, METH_VARARGS,
   "V.CreateDefaultStorageNode() -> vtkMRMLStorageNode\nC++: vtkMRMLStorageNode *CreateDefaultStorageNode() override;\n\nCreate default storage node or nullptr if does not have one\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLDoubleArrayNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLCore.vtkMRMLDoubleArrayNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLDoubleArrayNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLDoubleArrayNode_StaticNew()
{
  return vtkMRMLDoubleArrayNode::New();
}

PyObject *PyvtkMRMLDoubleArrayNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLDoubleArrayNode_Type, PyvtkMRMLDoubleArrayNode_Methods,
    "vtkMRMLDoubleArrayNode",
 &PyvtkMRMLDoubleArrayNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMRMLStorableNode_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  o = PyInt_FromLong(vtkMRMLDoubleArrayNode::INTERP_LINEAR);
  if (o)
  {
    PyDict_SetItemString(d, "INTERP_LINEAR", o);
    Py_DECREF(o);
  }
  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLDoubleArrayNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLDoubleArrayNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLDoubleArrayNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

