// python wrapper for vtkMRMLFiducialListNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkMRMLFiducialListNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLFiducialListNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLFiducialListNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLTransformableNode_ClassNew
extern "C" { PyObject *PyvtkMRMLTransformableNode_ClassNew(); }
#define DECLARED_PyvtkMRMLTransformableNode_ClassNew
#endif

static const char *PyvtkMRMLFiducialListNode_Doc =
  "vtkMRMLFiducialListNode - MRML node to represent a list of points in\n3D.\n\n"
  "Superclass: vtkMRMLTransformableNode\n\n"
  "\\deprecated Used for backward compatibility for Slicer3 fiducial\n"
  "lists, please use the Annotation Module MRML nodes\n"
  "\\sa vtkMRMLAnnotationNode, vtkMRMLAnnotationFiducialNode\n\n"
  "Fiducial list nodes describe a list of points in 3d space.  They\n"
  "indicate how to render it (color, opacity, etc).\n\n";

static PyTypeObject PyvtkMRMLFiducialListNode_GlyphShapes_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLCore.vtkMRMLFiducialListNode.GlyphShapes", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkMRMLFiducialListNode_GlyphShapes_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkMRMLFiducialListNode_GlyphShapes_Type, static_cast<int>(val));
}

static PyTypeObject PyvtkMRMLFiducialListNode_NumberingSchemes_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLCore.vtkMRMLFiducialListNode.NumberingSchemes", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkMRMLFiducialListNode_NumberingSchemes_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkMRMLFiducialListNode_NumberingSchemes_Type, static_cast<int>(val));
}


static PyObject *
PyvtkMRMLFiducialListNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLFiducialListNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLFiducialListNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLFiducialListNode *tempr = vtkMRMLFiducialListNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLFiducialListNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLFiducialListNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLFiducialListNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLFiducialListNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLFiducialListNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_Copy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Copy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode"))
  {
    if (ap.IsBound())
    {
      op->Copy(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::Copy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLFiducialListNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_UpdateScene(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateScene");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  vtkMRMLScene *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLScene"))
  {
    if (ap.IsBound())
    {
      op->UpdateScene(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::UpdateScene(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_UpdateReferences(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateReferences");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateReferences();
    }
    else
    {
      op->vtkMRMLFiducialListNode::UpdateReferences();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetSymbolScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSymbolScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSymbolScale(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetSymbolScale(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetSymbolScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSymbolScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSymbolScale() :
      op->vtkMRMLFiducialListNode::GetSymbolScale());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetVisibility(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetVisibility() :
      op->vtkMRMLFiducialListNode::GetVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetTextScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTextScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTextScale(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetTextScale(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetTextScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTextScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTextScale() :
      op->vtkMRMLFiducialListNode::GetTextScale());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetColor_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetColor(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetColor(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_SetColor_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetColor(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetColor(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_SetColor(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkMRMLFiducialListNode_SetColor_s1(self, args);
    case 1:
      return PyvtkMRMLFiducialListNode_SetColor_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetColor");
  return nullptr;
}



static PyObject *
PyvtkMRMLFiducialListNode_GetColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetColor() :
      op->vtkMRMLFiducialListNode::GetColor());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetSelectedColor_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSelectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetSelectedColor(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetSelectedColor(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_SetSelectedColor_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSelectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetSelectedColor(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetSelectedColor(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_SetSelectedColor(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkMRMLFiducialListNode_SetSelectedColor_s1(self, args);
    case 1:
      return PyvtkMRMLFiducialListNode_SetSelectedColor_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetSelectedColor");
  return nullptr;
}



static PyObject *
PyvtkMRMLFiducialListNode_GetSelectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSelectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetSelectedColor() :
      op->vtkMRMLFiducialListNode::GetSelectedColor());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNumberOfFiducials(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfFiducials");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfFiducials() :
      op->vtkMRMLFiducialListNode::GetNumberOfFiducials());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNthFiducialXYZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialXYZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  float temp1;
  float temp2;
  float temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    int tempr = (ap.IsBound() ?
      op->SetNthFiducialXYZ(temp0, temp1, temp2, temp3) :
      op->vtkMRMLFiducialListNode::SetNthFiducialXYZ(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNthFiducialOrientation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialOrientation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  float temp1;
  float temp2;
  float temp3;
  float temp4;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4))
  {
    int tempr = (ap.IsBound() ?
      op->SetNthFiducialOrientation(temp0, temp1, temp2, temp3, temp4) :
      op->vtkMRMLFiducialListNode::SetNthFiducialOrientation(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNthFiducialLabelText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialLabelText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->SetNthFiducialLabelText(temp0, temp1) :
      op->vtkMRMLFiducialListNode::SetNthFiducialLabelText(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNthFiducialSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->SetNthFiducialSelected(temp0, temp1) :
      op->vtkMRMLFiducialListNode::SetNthFiducialSelected(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNthFiducialSelectedNoModified(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialSelectedNoModified");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->SetNthFiducialSelectedNoModified(temp0, temp1) :
      op->vtkMRMLFiducialListNode::SetNthFiducialSelectedNoModified(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNthFiducialVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->SetNthFiducialVisibility(temp0, temp1) :
      op->vtkMRMLFiducialListNode::SetNthFiducialVisibility(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNthFiducialVisibilityNoModified(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialVisibilityNoModified");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->SetNthFiducialVisibilityNoModified(temp0, temp1) :
      op->vtkMRMLFiducialListNode::SetNthFiducialVisibilityNoModified(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNthFiducialID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->SetNthFiducialID(temp0, temp1) :
      op->vtkMRMLFiducialListNode::SetNthFiducialID(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNthFiducialXYZWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialXYZWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  float temp1;
  float temp2;
  float temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    int tempr = (ap.IsBound() ?
      op->SetNthFiducialXYZWorld(temp0, temp1, temp2, temp3) :
      op->vtkMRMLFiducialListNode::SetNthFiducialXYZWorld(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetFiducialXYZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFiducialXYZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  std::string temp0;
  float temp1;
  float temp2;
  float temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    int tempr = (ap.IsBound() ?
      op->SetFiducialXYZ(temp0, temp1, temp2, temp3) :
      op->vtkMRMLFiducialListNode::SetFiducialXYZ(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetFiducialIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFiducialIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFiducialIndex(temp0) :
      op->vtkMRMLFiducialListNode::GetFiducialIndex(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetAllFiducialsSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAllFiducialsSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->SetAllFiducialsSelected(temp0) :
      op->vtkMRMLFiducialListNode::SetAllFiducialsSelected(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetAllFiducialsVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAllFiducialsVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->SetAllFiducialsVisibility(temp0) :
      op->vtkMRMLFiducialListNode::SetAllFiducialsVisibility(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNthFiducialXYZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialXYZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetNthFiducialXYZ(temp0) :
      op->vtkMRMLFiducialListNode::GetNthFiducialXYZ(temp0));

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNthFiducialXYZWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialXYZWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    int tempr = (ap.IsBound() ?
      op->GetNthFiducialXYZWorld(temp0, temp1) :
      op->vtkMRMLFiducialListNode::GetNthFiducialXYZWorld(temp0, temp1));

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNthFiducialOrientation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialOrientation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  size_t sizer = 4;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetNthFiducialOrientation(temp0) :
      op->vtkMRMLFiducialListNode::GetNthFiducialOrientation(temp0));

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNthFiducialLabelText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialLabelText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNthFiducialLabelText(temp0) :
      op->vtkMRMLFiducialListNode::GetNthFiducialLabelText(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNthFiducialSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNthFiducialSelected(temp0) :
      op->vtkMRMLFiducialListNode::GetNthFiducialSelected(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNthFiducialVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNthFiducialVisibility(temp0) :
      op->vtkMRMLFiducialListNode::GetNthFiducialVisibility(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNthFiducialID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNthFiducialID(temp0) :
      op->vtkMRMLFiducialListNode::GetNthFiducialID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_AddFiducial(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddFiducial");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->AddFiducial() :
      op->vtkMRMLFiducialListNode::AddFiducial());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_AddFiducialWithXYZ(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddFiducialWithXYZ");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  float temp0;
  float temp1;
  float temp2;
  int temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    int tempr = (ap.IsBound() ?
      op->AddFiducialWithXYZ(temp0, temp1, temp2, temp3) :
      op->vtkMRMLFiducialListNode::AddFiducialWithXYZ(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_AddFiducialWithLabelXYZSelectedVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddFiducialWithLabelXYZSelectedVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  const char *temp0 = nullptr;
  float temp1;
  float temp2;
  float temp3;
  int temp4;
  int temp5;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5))
  {
    int tempr = (ap.IsBound() ?
      op->AddFiducialWithLabelXYZSelectedVisibility(temp0, temp1, temp2, temp3, temp4, temp5) :
      op->vtkMRMLFiducialListNode::AddFiducialWithLabelXYZSelectedVisibility(temp0, temp1, temp2, temp3, temp4, temp5));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_RemoveFiducial_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveFiducial");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  vtkMRMLFiducial *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLFiducial"))
  {
    if (ap.IsBound())
    {
      op->RemoveFiducial(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::RemoveFiducial(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_RemoveFiducial_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveFiducial");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RemoveFiducial(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::RemoveFiducial(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLFiducialListNode_RemoveFiducial_Methods[] = {
  {nullptr, PyvtkMRMLFiducialListNode_RemoveFiducial_s1, METH_VARARGS,
   "@V *vtkMRMLFiducial"},
  {nullptr, PyvtkMRMLFiducialListNode_RemoveFiducial_s2, METH_VARARGS,
   "@i"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkMRMLFiducialListNode_RemoveFiducial(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkMRMLFiducialListNode_RemoveFiducial_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "RemoveFiducial");
  return nullptr;
}



static PyObject *
PyvtkMRMLFiducialListNode_RemoveAllFiducials(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllFiducials");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllFiducials();
    }
    else
    {
      op->vtkMRMLFiducialListNode::RemoveAllFiducials();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_IsFiducialPresent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsFiducialPresent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  vtkMRMLFiducial *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLFiducial"))
  {
    int tempr = (ap.IsBound() ?
      op->IsFiducialPresent(temp0) :
      op->vtkMRMLFiducialListNode::IsFiducialPresent(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_ProcessMRMLEvents(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProcessMRMLEvents");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  vtkObject *temp0 = nullptr;
  unsigned long temp1;
  void  *temp2 = nullptr;
  Py_buffer pbuf2 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkObject") &&
      ap.GetValue(temp1) &&
      ap.GetBuffer(temp2, &pbuf2))
  {
    if (ap.IsBound())
    {
      op->ProcessMRMLEvents(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLFiducialListNode::ProcessMRMLEvents(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf2.obj != 0)
  {
    PyBuffer_Release(&pbuf2);
  }
#endif
  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetOpacity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOpacity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOpacity(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetOpacity(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetOpacity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOpacity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetOpacity() :
      op->vtkMRMLFiducialListNode::GetOpacity());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetAmbient(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAmbient");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAmbient(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetAmbient(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetAmbient(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAmbient");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetAmbient() :
      op->vtkMRMLFiducialListNode::GetAmbient());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetDiffuse(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDiffuse");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDiffuse(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetDiffuse(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetDiffuse(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDiffuse");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetDiffuse() :
      op->vtkMRMLFiducialListNode::GetDiffuse());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetSpecular(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSpecular");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSpecular(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetSpecular(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetSpecular(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSpecular");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSpecular() :
      op->vtkMRMLFiducialListNode::GetSpecular());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetPower(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPower");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPower(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetPower(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetPower(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPower");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetPower() :
      op->vtkMRMLFiducialListNode::GetPower());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLocked(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetLocked(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLocked() :
      op->vtkMRMLFiducialListNode::GetLocked());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetMinimumGlyphType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinimumGlyphType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMinimumGlyphType() :
      op->vtkMRMLFiducialListNode::GetMinimumGlyphType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetMaximumGlyphType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumGlyphType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaximumGlyphType() :
      op->vtkMRMLFiducialListNode::GetMaximumGlyphType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetGlyphType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphType(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetGlyphType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetGlyphType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlyphType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetGlyphType() :
      op->vtkMRMLFiducialListNode::GetGlyphType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GlyphTypeIs3D_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GlyphTypeIs3D");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GlyphTypeIs3D(temp0) :
      op->vtkMRMLFiducialListNode::GlyphTypeIs3D(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_GlyphTypeIs3D_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GlyphTypeIs3D");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GlyphTypeIs3D() :
      op->vtkMRMLFiducialListNode::GlyphTypeIs3D());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_GlyphTypeIs3D(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkMRMLFiducialListNode_GlyphTypeIs3D_s1(self, args);
    case 0:
      return PyvtkMRMLFiducialListNode_GlyphTypeIs3D_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GlyphTypeIs3D");
  return nullptr;
}



static PyObject *
PyvtkMRMLFiducialListNode_GetGlyphTypeAsString_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlyphTypeAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetGlyphTypeAsString() :
      op->vtkMRMLFiducialListNode::GetGlyphTypeAsString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_GetGlyphTypeAsString_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlyphTypeAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetGlyphTypeAsString(temp0) :
      op->vtkMRMLFiducialListNode::GetGlyphTypeAsString(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_GetGlyphTypeAsString(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkMRMLFiducialListNode_GetGlyphTypeAsString_s1(self, args);
    case 1:
      return PyvtkMRMLFiducialListNode_GetGlyphTypeAsString_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetGlyphTypeAsString");
  return nullptr;
}



static PyObject *
PyvtkMRMLFiducialListNode_SetGlyphTypeFromString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphTypeFromString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphTypeFromString(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetGlyphTypeFromString(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_CanApplyNonLinearTransforms(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CanApplyNonLinearTransforms");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->CanApplyNonLinearTransforms() :
      op->vtkMRMLFiducialListNode::CanApplyNonLinearTransforms());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_ApplyTransform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ApplyTransform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  vtkAbstractTransform *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAbstractTransform"))
  {
    if (ap.IsBound())
    {
      op->ApplyTransform(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::ApplyTransform(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_CreateDefaultStorageNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultStorageNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLStorageNode *tempr = (ap.IsBound() ?
      op->CreateDefaultStorageNode() :
      op->vtkMRMLFiducialListNode::CreateDefaultStorageNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_MoveFiducialUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MoveFiducialUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->MoveFiducialUp(temp0) :
      op->vtkMRMLFiducialListNode::MoveFiducialUp(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_MoveFiducialDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MoveFiducialDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->MoveFiducialDown(temp0) :
      op->vtkMRMLFiducialListNode::MoveFiducialDown(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_RenumberFiducials(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RenumberFiducials");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    if (ap.IsBound())
    {
      op->RenumberFiducials(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::RenumberFiducials(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_RenameFiducials(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RenameFiducials");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RenameFiducials(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::RenameFiducials(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetNumberingScheme(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberingScheme");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberingScheme(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetNumberingScheme(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNumberingScheme(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberingScheme");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberingScheme() :
      op->vtkMRMLFiducialListNode::GetNumberingScheme());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_GetNumberingSchemeAsString_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberingSchemeAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNumberingSchemeAsString() :
      op->vtkMRMLFiducialListNode::GetNumberingSchemeAsString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_GetNumberingSchemeAsString_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberingSchemeAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNumberingSchemeAsString(temp0) :
      op->vtkMRMLFiducialListNode::GetNumberingSchemeAsString(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLFiducialListNode_GetNumberingSchemeAsString(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkMRMLFiducialListNode_GetNumberingSchemeAsString_s1(self, args);
    case 1:
      return PyvtkMRMLFiducialListNode_GetNumberingSchemeAsString_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetNumberingSchemeAsString");
  return nullptr;
}



static PyObject *
PyvtkMRMLFiducialListNode_SetNumberingSchemeFromString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberingSchemeFromString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberingSchemeFromString(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetNumberingSchemeFromString(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLFiducialListNode_SetFiducialLabelTextFromID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFiducialLabelTextFromID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLFiducialListNode *op = static_cast<vtkMRMLFiducialListNode *>(vp);

  vtkMRMLFiducial *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLFiducial"))
  {
    if (ap.IsBound())
    {
      op->SetFiducialLabelTextFromID(temp0);
    }
    else
    {
      op->vtkMRMLFiducialListNode::SetFiducialLabelTextFromID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLFiducialListNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLFiducialListNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLFiducialListNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLFiducialListNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLFiducialListNode\nC++: static vtkMRMLFiducialListNode *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLFiducialListNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLFiducialListNode\nC++: vtkMRMLFiducialListNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLFiducialListNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLFiducialListNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"CreateNodeInstance", PyvtkMRMLFiducialListNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\n------------------------------------------------------------------\n    -------- MRMLNode methods\n------------------------------------------------------------------\n    --------\n"},
  {"Copy", PyvtkMRMLFiducialListNode_Copy, METH_VARARGS,
   "V.Copy(vtkMRMLNode)\nC++: void Copy(vtkMRMLNode *node) override;\n\nCopy the node's attributes to this object\n"},
  {"GetNodeTagName", PyvtkMRMLFiducialListNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"UpdateScene", PyvtkMRMLFiducialListNode_UpdateScene, METH_VARARGS,
   "V.UpdateScene(vtkMRMLScene)\nC++: void UpdateScene(vtkMRMLScene *scene) override;\n\n\n"},
  {"UpdateReferences", PyvtkMRMLFiducialListNode_UpdateReferences, METH_VARARGS,
   "V.UpdateReferences()\nC++: void UpdateReferences() override;\n\nupdate display node ids\n"},
  {"SetSymbolScale", PyvtkMRMLFiducialListNode_SetSymbolScale, METH_VARARGS,
   "V.SetSymbolScale(float)\nC++: void SetSymbolScale(double scale)\n\nGet/Set for Symbol scale\n vtkSetMacro(SymbolScale,double);\n"},
  {"GetSymbolScale", PyvtkMRMLFiducialListNode_GetSymbolScale, METH_VARARGS,
   "V.GetSymbolScale() -> float\nC++: virtual double GetSymbolScale()\n\n"},
  {"SetVisibility", PyvtkMRMLFiducialListNode_SetVisibility, METH_VARARGS,
   "V.SetVisibility(int)\nC++: void SetVisibility(int visible)\n\nGet/Set for list visibility vtkSetMacro(Visibility,int);\n"},
  {"GetVisibility", PyvtkMRMLFiducialListNode_GetVisibility, METH_VARARGS,
   "V.GetVisibility() -> int\nC++: virtual int GetVisibility()\n\n"},
  {"SetTextScale", PyvtkMRMLFiducialListNode_SetTextScale, METH_VARARGS,
   "V.SetTextScale(float)\nC++: void SetTextScale(double scale)\n\nGet/Set for Text scale vtkSetMacro(TextScale,double);\n"},
  {"GetTextScale", PyvtkMRMLFiducialListNode_GetTextScale, METH_VARARGS,
   "V.GetTextScale() -> float\nC++: virtual double GetTextScale()\n\n"},
  {"SetColor", PyvtkMRMLFiducialListNode_SetColor, METH_VARARGS,
   "V.SetColor(float, float, float)\nC++: void SetColor(double r, double g, double b)\nV.SetColor([float, float, float])\nC++: void SetColor(double c[3])\n\nGet/Set for Glyph and Text color\nvtkSetVector3Macro(Color,double);\n"},
  {"GetColor", PyvtkMRMLFiducialListNode_GetColor, METH_VARARGS,
   "V.GetColor() -> (float, float, float)\nC++: virtual double *GetColor()\n\n"},
  {"SetSelectedColor", PyvtkMRMLFiducialListNode_SetSelectedColor, METH_VARARGS,
   "V.SetSelectedColor(float, float, float)\nC++: void SetSelectedColor(double r, double g, double b)\nV.SetSelectedColor([float, float, float])\nC++: void SetSelectedColor(double c[3])\n\nGet/Set for colour for when a fiducial is selected\n"},
  {"GetSelectedColor", PyvtkMRMLFiducialListNode_GetSelectedColor, METH_VARARGS,
   "V.GetSelectedColor() -> (float, float, float)\nC++: virtual double *GetSelectedColor()\n\n"},
  {"GetNumberOfFiducials", PyvtkMRMLFiducialListNode_GetNumberOfFiducials, METH_VARARGS,
   "V.GetNumberOfFiducials() -> int\nC++: int GetNumberOfFiducials()\n\nGet the number of fiducials in the list\n"},
  {"SetNthFiducialXYZ", PyvtkMRMLFiducialListNode_SetNthFiducialXYZ, METH_VARARGS,
   "V.SetNthFiducialXYZ(int, float, float, float) -> int\nC++: int SetNthFiducialXYZ(int n, float x, float y, float z)\n\nRestrict access to the fiducial points, pass in a value via the\nlist so that the appropriate events can be invoked. Returns 0 on\nsuccess\n"},
  {"SetNthFiducialOrientation", PyvtkMRMLFiducialListNode_SetNthFiducialOrientation, METH_VARARGS,
   "V.SetNthFiducialOrientation(int, float, float, float, float)\n    -> int\nC++: int SetNthFiducialOrientation(int n, float w, float x,\n    float y, float z)\n\n"},
  {"SetNthFiducialLabelText", PyvtkMRMLFiducialListNode_SetNthFiducialLabelText, METH_VARARGS,
   "V.SetNthFiducialLabelText(int, string) -> int\nC++: int SetNthFiducialLabelText(int n, const char *text)\n\n"},
  {"SetNthFiducialSelected", PyvtkMRMLFiducialListNode_SetNthFiducialSelected, METH_VARARGS,
   "V.SetNthFiducialSelected(int, int) -> int\nC++: int SetNthFiducialSelected(int n, int flag)\n\n"},
  {"SetNthFiducialSelectedNoModified", PyvtkMRMLFiducialListNode_SetNthFiducialSelectedNoModified, METH_VARARGS,
   "V.SetNthFiducialSelectedNoModified(int, int) -> int\nC++: int SetNthFiducialSelectedNoModified(int n, int flag)\n\n"},
  {"SetNthFiducialVisibility", PyvtkMRMLFiducialListNode_SetNthFiducialVisibility, METH_VARARGS,
   "V.SetNthFiducialVisibility(int, int) -> int\nC++: int SetNthFiducialVisibility(int n, int flag)\n\n"},
  {"SetNthFiducialVisibilityNoModified", PyvtkMRMLFiducialListNode_SetNthFiducialVisibilityNoModified, METH_VARARGS,
   "V.SetNthFiducialVisibilityNoModified(int, int) -> int\nC++: int SetNthFiducialVisibilityNoModified(int n, int flag)\n\n"},
  {"SetNthFiducialID", PyvtkMRMLFiducialListNode_SetNthFiducialID, METH_VARARGS,
   "V.SetNthFiducialID(int, string) -> int\nC++: int SetNthFiducialID(int n, const char *id)\n\n"},
  {"SetNthFiducialXYZWorld", PyvtkMRMLFiducialListNode_SetNthFiducialXYZWorld, METH_VARARGS,
   "V.SetNthFiducialXYZWorld(int, float, float, float) -> int\nC++: int SetNthFiducialXYZWorld(int n, float x, float y, float z)\n\nSet the nth fiducial to xyz transformed by the inverse of the\ntransform to world for the list. Calls SetNthFiducialXYZ after\ntransforming the passed in coordinates and returns the result of\nthat call.\n"},
  {"SetFiducialXYZ", PyvtkMRMLFiducialListNode_SetFiducialXYZ, METH_VARARGS,
   "V.SetFiducialXYZ(string, float, float, float) -> int\nC++: int SetFiducialXYZ(std::string fiducialID, float x, float y,\n    float z)\n\nRestrict access to the fiducial points, access the fiducial by id\n(used by the vtkSlicerFiducialListWidget). Returns 0 on success.\n"},
  {"GetFiducialIndex", PyvtkMRMLFiducialListNode_GetFiducialIndex, METH_VARARGS,
   "V.GetFiducialIndex(string) -> int\nC++: int GetFiducialIndex(std::string fiducialID)\n\nLook through the list of fiducials for fiducialID and return the\ncurrent zero based index. Useful when delete fiducials from the\nlist, as the index will change. Returns -1 if none found.\n"},
  {"SetAllFiducialsSelected", PyvtkMRMLFiducialListNode_SetAllFiducialsSelected, METH_VARARGS,
   "V.SetAllFiducialsSelected(int) -> int\nC++: int SetAllFiducialsSelected(int flag)\n\nSet all fiducials selected state to flag\n"},
  {"SetAllFiducialsVisibility", PyvtkMRMLFiducialListNode_SetAllFiducialsVisibility, METH_VARARGS,
   "V.SetAllFiducialsVisibility(int) -> int\nC++: int SetAllFiducialsVisibility(int flag)\n\nSet all fiducials visible state to flag\n"},
  {"GetNthFiducialXYZ", PyvtkMRMLFiducialListNode_GetNthFiducialXYZ, METH_VARARGS,
   "V.GetNthFiducialXYZ(int) -> (float, float, float)\nC++: float *GetNthFiducialXYZ(int n)\n\nGet the elements of the fiducial points Return a three element\nfloat holding the position\n"},
  {"GetNthFiducialXYZWorld", PyvtkMRMLFiducialListNode_GetNthFiducialXYZWorld, METH_VARARGS,
   "V.GetNthFiducialXYZWorld(int, [float, ...]) -> int\nC++: int GetNthFiducialXYZWorld(int n, double *worldxyz)\n\nReturn a three element double giving the world position (any\nparent transform on the list applied to the return of\nGetNthFiducialXYZ. worldxyz is a 4 item array, xyzw returns 0 on\nfailure, 1 on success.\n"},
  {"GetNthFiducialOrientation", PyvtkMRMLFiducialListNode_GetNthFiducialOrientation, METH_VARARGS,
   "V.GetNthFiducialOrientation(int) -> (float, float, float, float)\nC++: float *GetNthFiducialOrientation(int n)\n\nget the orientation of the nth fiducial\n"},
  {"GetNthFiducialLabelText", PyvtkMRMLFiducialListNode_GetNthFiducialLabelText, METH_VARARGS,
   "V.GetNthFiducialLabelText(int) -> string\nC++: const char *GetNthFiducialLabelText(int n)\n\nget the label text of the nth fiducial\n"},
  {"GetNthFiducialSelected", PyvtkMRMLFiducialListNode_GetNthFiducialSelected, METH_VARARGS,
   "V.GetNthFiducialSelected(int) -> int\nC++: int GetNthFiducialSelected(int n)\n\nget the selected state on the nth fiducial\n"},
  {"GetNthFiducialVisibility", PyvtkMRMLFiducialListNode_GetNthFiducialVisibility, METH_VARARGS,
   "V.GetNthFiducialVisibility(int) -> int\nC++: int GetNthFiducialVisibility(int n)\n\nget the visible state on the nth fiducial\n"},
  {"GetNthFiducialID", PyvtkMRMLFiducialListNode_GetNthFiducialID, METH_VARARGS,
   "V.GetNthFiducialID(int) -> string\nC++: const char *GetNthFiducialID(int n)\n\nget the id of the nth fiducial\n"},
  {"AddFiducial", PyvtkMRMLFiducialListNode_AddFiducial, METH_VARARGS,
   "V.AddFiducial() -> int\nC++: int AddFiducial()\n\nAdd a fiducial point to the list with default values\n"},
  {"AddFiducialWithXYZ", PyvtkMRMLFiducialListNode_AddFiducialWithXYZ, METH_VARARGS,
   "V.AddFiducialWithXYZ(float, float, float, int) -> int\nC++: int AddFiducialWithXYZ(float x, float y, float z,\n    int selected)\n\nAdd a fiducial point to the list x, y, z\n"},
  {"AddFiducialWithLabelXYZSelectedVisibility", PyvtkMRMLFiducialListNode_AddFiducialWithLabelXYZSelectedVisibility, METH_VARARGS,
   "V.AddFiducialWithLabelXYZSelectedVisibility(string, float, float,\n    float, int, int) -> int\nC++: int AddFiducialWithLabelXYZSelectedVisibility(\n    const char *label, float x, float y, float z, int selected,\n    int visibility)\n\nAdd a fiducial point to the list with a label, x,y,z, selected\nflag, visibility\n"},
  {"RemoveFiducial", PyvtkMRMLFiducialListNode_RemoveFiducial, METH_VARARGS,
   "V.RemoveFiducial(vtkMRMLFiducial)\nC++: void RemoveFiducial(vtkMRMLFiducial *o)\nV.RemoveFiducial(int)\nC++: void RemoveFiducial(int i)\n\nremove the passed in fiducial from the list\n"},
  {"RemoveAllFiducials", PyvtkMRMLFiducialListNode_RemoveAllFiducials, METH_VARARGS,
   "V.RemoveAllFiducials()\nC++: void RemoveAllFiducials()\n\nremove all fiducials from the list\n"},
  {"IsFiducialPresent", PyvtkMRMLFiducialListNode_IsFiducialPresent, METH_VARARGS,
   "V.IsFiducialPresent(vtkMRMLFiducial) -> int\nC++: int IsFiducialPresent(vtkMRMLFiducial *o)\n\nis this fiducial on the list?\n"},
  {"ProcessMRMLEvents", PyvtkMRMLFiducialListNode_ProcessMRMLEvents, METH_VARARGS,
   "V.ProcessMRMLEvents(vtkObject, int, void)\nC++: void ProcessMRMLEvents(vtkObject *caller,\n    unsigned long event, void *callData) override;\n\nProcess events from the MRML scene\n"},
  {"SetOpacity", PyvtkMRMLFiducialListNode_SetOpacity, METH_VARARGS,
   "V.SetOpacity(float)\nC++: void SetOpacity(double opacity)\n\nOpacity of the fiducial surface expressed as a number from 0 to 1\n"},
  {"GetOpacity", PyvtkMRMLFiducialListNode_GetOpacity, METH_VARARGS,
   "V.GetOpacity() -> float\nC++: virtual double GetOpacity()\n\n"},
  {"SetAmbient", PyvtkMRMLFiducialListNode_SetAmbient, METH_VARARGS,
   "V.SetAmbient(float)\nC++: void SetAmbient(double val)\n\nAmbient of the fiducial surface expressed as a number from 0 to 1\n"},
  {"GetAmbient", PyvtkMRMLFiducialListNode_GetAmbient, METH_VARARGS,
   "V.GetAmbient() -> float\nC++: virtual double GetAmbient()\n\n"},
  {"SetDiffuse", PyvtkMRMLFiducialListNode_SetDiffuse, METH_VARARGS,
   "V.SetDiffuse(float)\nC++: void SetDiffuse(double val)\n\nDiffuse of the fiducial surface expressed as a number from 0 to 1\n"},
  {"GetDiffuse", PyvtkMRMLFiducialListNode_GetDiffuse, METH_VARARGS,
   "V.GetDiffuse() -> float\nC++: virtual double GetDiffuse()\n\n"},
  {"SetSpecular", PyvtkMRMLFiducialListNode_SetSpecular, METH_VARARGS,
   "V.SetSpecular(float)\nC++: void SetSpecular(double val)\n\nSpecular of the fiducial surface expressed as a number from 0 to\n1\n"},
  {"GetSpecular", PyvtkMRMLFiducialListNode_GetSpecular, METH_VARARGS,
   "V.GetSpecular() -> float\nC++: virtual double GetSpecular()\n\n"},
  {"SetPower", PyvtkMRMLFiducialListNode_SetPower, METH_VARARGS,
   "V.SetPower(float)\nC++: void SetPower(double val)\n\nPower of the fiducial surface expressed as a number from 0 to 1\n"},
  {"GetPower", PyvtkMRMLFiducialListNode_GetPower, METH_VARARGS,
   "V.GetPower() -> float\nC++: virtual double GetPower()\n\n"},
  {"SetLocked", PyvtkMRMLFiducialListNode_SetLocked, METH_VARARGS,
   "V.SetLocked(int)\nC++: void SetLocked(int locked)\n\nWhen fiducial lists are locked, they cannot be manipulated using\nthe interactive widgets\n"},
  {"GetLocked", PyvtkMRMLFiducialListNode_GetLocked, METH_VARARGS,
   "V.GetLocked() -> int\nC++: virtual int GetLocked()\n\n"},
  {"GetMinimumGlyphType", PyvtkMRMLFiducialListNode_GetMinimumGlyphType, METH_VARARGS,
   "V.GetMinimumGlyphType() -> int\nC++: int GetMinimumGlyphType()\n\nReturn the min/max glyph types, for iterating over them in tcl\n"},
  {"GetMaximumGlyphType", PyvtkMRMLFiducialListNode_GetMaximumGlyphType, METH_VARARGS,
   "V.GetMaximumGlyphType() -> int\nC++: int GetMaximumGlyphType()\n\n"},
  {"SetGlyphType", PyvtkMRMLFiducialListNode_SetGlyphType, METH_VARARGS,
   "V.SetGlyphType(int)\nC++: void SetGlyphType(int type)\n\nThe glyph type used to display this fiducial\n"},
  {"GetGlyphType", PyvtkMRMLFiducialListNode_GetGlyphType, METH_VARARGS,
   "V.GetGlyphType() -> int\nC++: virtual int GetGlyphType()\n\n"},
  {"GlyphTypeIs3D", PyvtkMRMLFiducialListNode_GlyphTypeIs3D, METH_VARARGS,
   "V.GlyphTypeIs3D(int) -> int\nC++: int GlyphTypeIs3D(int glyphType)\nV.GlyphTypeIs3D() -> int\nC++: int GlyphTypeIs3D()\n\nReturns 1 if the type is a 3d one, 0 else\n"},
  {"GetGlyphTypeAsString", PyvtkMRMLFiducialListNode_GetGlyphTypeAsString, METH_VARARGS,
   "V.GetGlyphTypeAsString() -> string\nC++: const char *GetGlyphTypeAsString()\nV.GetGlyphTypeAsString(int) -> string\nC++: const char *GetGlyphTypeAsString(int g)\n\nReturn a string representing the glyph type, set it from a string\n"},
  {"SetGlyphTypeFromString", PyvtkMRMLFiducialListNode_SetGlyphTypeFromString, METH_VARARGS,
   "V.SetGlyphTypeFromString(string)\nC++: void SetGlyphTypeFromString(const char *glyphString)\n\n"},
  {"CanApplyNonLinearTransforms", PyvtkMRMLFiducialListNode_CanApplyNonLinearTransforms, METH_VARARGS,
   "V.CanApplyNonLinearTransforms() -> bool\nC++: bool CanApplyNonLinearTransforms() override;\n\ntransform utility functions\n"},
  {"ApplyTransform", PyvtkMRMLFiducialListNode_ApplyTransform, METH_VARARGS,
   "V.ApplyTransform(vtkAbstractTransform)\nC++: void ApplyTransform(vtkAbstractTransform *transform)\n    override;\n\nTransforms the node with the provided non-linear transform.\n\\sa SetAndObserveTransformNodeID, ApplyTransformMatrix,\n    CanApplyNonLinearTransforms\n"},
  {"CreateDefaultStorageNode", PyvtkMRMLFiducialListNode_CreateDefaultStorageNode, METH_VARARGS,
   "V.CreateDefaultStorageNode() -> vtkMRMLStorageNode\nC++: vtkMRMLStorageNode *CreateDefaultStorageNode() override;\n\nCreate default storage node or nullptr if does not have one\n"},
  {"MoveFiducialUp", PyvtkMRMLFiducialListNode_MoveFiducialUp, METH_VARARGS,
   "V.MoveFiducialUp(int) -> int\nC++: int MoveFiducialUp(int fidIndex)\n\nmove a fiducial point in the collection, one up/down returns -1\non failure (current index is out of bounds, the fid is already at\nthe top or bottom of the list), the new fiducial index on success\n"},
  {"MoveFiducialDown", PyvtkMRMLFiducialListNode_MoveFiducialDown, METH_VARARGS,
   "V.MoveFiducialDown(int) -> int\nC++: int MoveFiducialDown(int fidIndex)\n\n"},
  {"RenumberFiducials", PyvtkMRMLFiducialListNode_RenumberFiducials, METH_VARARGS,
   "V.RenumberFiducials(int)\nC++: void RenumberFiducials(int startFrom=0)\n\nRenumber all the fiducials in the active list. It first removes\nany numbers from the ends of the label texts and then appends\nnumbers starting from 0 by default.\n"},
  {"RenameFiducials", PyvtkMRMLFiducialListNode_RenameFiducials, METH_VARARGS,
   "V.RenameFiducials(string)\nC++: void RenameFiducials(const char *newName)\n\nReanme all the fiducials in the active list. It preserves any\nnumbers already on the ends of the labels.\n"},
  {"SetNumberingScheme", PyvtkMRMLFiducialListNode_SetNumberingScheme, METH_VARARGS,
   "V.SetNumberingScheme(int)\nC++: virtual void SetNumberingScheme(int _arg)\n\nFlag determining how to number the next added fiducial\n"},
  {"GetNumberingScheme", PyvtkMRMLFiducialListNode_GetNumberingScheme, METH_VARARGS,
   "V.GetNumberingScheme() -> int\nC++: virtual int GetNumberingScheme()\n\n"},
  {"GetNumberingSchemeAsString", PyvtkMRMLFiducialListNode_GetNumberingSchemeAsString, METH_VARARGS,
   "V.GetNumberingSchemeAsString() -> string\nC++: const char *GetNumberingSchemeAsString()\nV.GetNumberingSchemeAsString(int) -> string\nC++: const char *GetNumberingSchemeAsString(int g)\n\nReturn a string representing the numbering scheme, set it from a\nstring\n"},
  {"SetNumberingSchemeFromString", PyvtkMRMLFiducialListNode_SetNumberingSchemeFromString, METH_VARARGS,
   "V.SetNumberingSchemeFromString(string)\nC++: void SetNumberingSchemeFromString(const char *schemeString)\n\n"},
  {"SetFiducialLabelTextFromID", PyvtkMRMLFiducialListNode_SetFiducialLabelTextFromID, METH_VARARGS,
   "V.SetFiducialLabelTextFromID(vtkMRMLFiducial)\nC++: void SetFiducialLabelTextFromID(vtkMRMLFiducial *fid)\n\nGenerate the label text for a fiducial from it's id. If\nNumberingScheme is UseID, uses the ID (default). If\nNumberingScheme is UseIndex, strips the ID of any trailing\nnumbers and appends the fiducial's index to it. If\nNumberingScheme is UsePrevious, checks the previous fiducial in\nthe list for a trailing number and increments it by 1, and\nappends the new number. If it's the first fiducial, uses 0. If\nthe previous fiducial has no trailing number in it's label text,\nwill use 1.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLFiducialListNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLCore.vtkMRMLFiducialListNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLFiducialListNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLFiducialListNode_StaticNew()
{
  return vtkMRMLFiducialListNode::New();
}

PyObject *PyvtkMRMLFiducialListNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLFiducialListNode_Type, PyvtkMRMLFiducialListNode_Methods,
    "vtkMRMLFiducialListNode",
 &PyvtkMRMLFiducialListNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMRMLTransformableNode_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkMRMLFiducialListNode_GlyphShapes_Type);
  PyVTKEnum_Add(&PyvtkMRMLFiducialListNode_GlyphShapes_Type, "vtkMRMLFiducialListNode.GlyphShapes");

  o = (PyObject *)&PyvtkMRMLFiducialListNode_GlyphShapes_Type;
  if (PyDict_SetItemString(d, "GlyphShapes", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkMRMLFiducialListNode_NumberingSchemes_Type);
  PyVTKEnum_Add(&PyvtkMRMLFiducialListNode_NumberingSchemes_Type, "vtkMRMLFiducialListNode.NumberingSchemes");

  o = (PyObject *)&PyvtkMRMLFiducialListNode_NumberingSchemes_Type;
  if (PyDict_SetItemString(d, "NumberingSchemes", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 4; c++)
  {
    static const struct { const char *name; int value; }
      constants[4] = {
        { "DisplayModifiedEvent", vtkMRMLFiducialListNode::DisplayModifiedEvent },
        { "PolyDataModifiedEvent", vtkMRMLFiducialListNode::PolyDataModifiedEvent },
        { "FiducialModifiedEvent", vtkMRMLFiducialListNode::FiducialModifiedEvent },
        { "FiducialIndexModifiedEvent", vtkMRMLFiducialListNode::FiducialIndexModifiedEvent },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 16; c++)
  {
    typedef vtkMRMLFiducialListNode::GlyphShapes cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[16] = {
        { "GlyphMin", vtkMRMLFiducialListNode::GlyphMin },
        { "Vertex2D", vtkMRMLFiducialListNode::Vertex2D },
        { "Dash2D", vtkMRMLFiducialListNode::Dash2D },
        { "Cross2D", vtkMRMLFiducialListNode::Cross2D },
        { "ThickCross2D", vtkMRMLFiducialListNode::ThickCross2D },
        { "Triangle2D", vtkMRMLFiducialListNode::Triangle2D },
        { "Square2D", vtkMRMLFiducialListNode::Square2D },
        { "Circle2D", vtkMRMLFiducialListNode::Circle2D },
        { "Diamond2D", vtkMRMLFiducialListNode::Diamond2D },
        { "Arrow2D", vtkMRMLFiducialListNode::Arrow2D },
        { "ThickArrow2D", vtkMRMLFiducialListNode::ThickArrow2D },
        { "HookedArrow2D", vtkMRMLFiducialListNode::HookedArrow2D },
        { "StarBurst2D", vtkMRMLFiducialListNode::StarBurst2D },
        { "Sphere3D", vtkMRMLFiducialListNode::Sphere3D },
        { "Diamond3D", vtkMRMLFiducialListNode::Diamond3D },
        { "GlyphMax", vtkMRMLFiducialListNode::GlyphMax },
      };

    o = PyvtkMRMLFiducialListNode_GlyphShapes_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 5; c++)
  {
    typedef vtkMRMLFiducialListNode::NumberingSchemes cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[5] = {
        { "SchemeMin", vtkMRMLFiducialListNode::SchemeMin },
        { "UseID", vtkMRMLFiducialListNode::UseID },
        { "UseIndex", vtkMRMLFiducialListNode::UseIndex },
        { "UsePrevious", vtkMRMLFiducialListNode::UsePrevious },
        { "SchemeMax", vtkMRMLFiducialListNode::SchemeMax },
      };

    o = PyvtkMRMLFiducialListNode_NumberingSchemes_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLFiducialListNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLFiducialListNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLFiducialListNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

