// python wrapper for vtkMRMLApplicationLogic
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkMRMLApplicationLogic.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLApplicationLogic(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLApplicationLogic_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLAbstractLogic_ClassNew
extern "C" { PyObject *PyvtkMRMLAbstractLogic_ClassNew(); }
#define DECLARED_PyvtkMRMLAbstractLogic_ClassNew
#endif

static const char *PyvtkMRMLApplicationLogic_Doc =
  "vtkMRMLApplicationLogic - no description provided.\n\n"
  "Superclass: vtkMRMLAbstractLogic\n\n"
;

static PyTypeObject PyvtkMRMLApplicationLogic_Layers_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLLogic.vtkMRMLApplicationLogic.Layers", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkMRMLApplicationLogic_Layers_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkMRMLApplicationLogic_Layers_Type, static_cast<int>(val));
}

static PyTypeObject PyvtkMRMLApplicationLogic_Events_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLLogic.vtkMRMLApplicationLogic.Events", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkMRMLApplicationLogic_Events_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkMRMLApplicationLogic_Events_Type, static_cast<int>(val));
}


static PyObject *
PyvtkMRMLApplicationLogic_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLApplicationLogic::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLApplicationLogic::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLApplicationLogic *tempr = vtkMRMLApplicationLogic::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLApplicationLogic *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLApplicationLogic::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLApplicationLogic::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLApplicationLogic::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetSelectionNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSelectionNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLSelectionNode *tempr = (ap.IsBound() ?
      op->GetSelectionNode() :
      op->vtkMRMLApplicationLogic::GetSelectionNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetInteractionNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInteractionNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLInteractionNode *tempr = (ap.IsBound() ?
      op->GetInteractionNode() :
      op->vtkMRMLApplicationLogic::GetInteractionNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_SetSliceLogics(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSliceLogics");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  vtkCollection *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCollection"))
  {
    if (ap.IsBound())
    {
      op->SetSliceLogics(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::SetSliceLogics(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetSliceLogics(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceLogics");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkCollection *tempr = (ap.IsBound() ?
      op->GetSliceLogics() :
      op->vtkMRMLApplicationLogic::GetSliceLogics());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetSliceLogic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceLogic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  vtkMRMLSliceNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLSliceNode"))
  {
    vtkMRMLSliceLogic *tempr = (ap.IsBound() ?
      op->GetSliceLogic(temp0) :
      op->vtkMRMLApplicationLogic::GetSliceLogic(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetSliceLogicByLayoutName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceLogicByLayoutName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLSliceLogic *tempr = (ap.IsBound() ?
      op->GetSliceLogicByLayoutName(temp0) :
      op->vtkMRMLApplicationLogic::GetSliceLogicByLayoutName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetSliceLogicByModelDisplayNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceLogicByModelDisplayNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  vtkMRMLModelDisplayNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLModelDisplayNode"))
  {
    vtkMRMLSliceLogic *tempr = (ap.IsBound() ?
      op->GetSliceLogicByModelDisplayNode(temp0) :
      op->vtkMRMLApplicationLogic::GetSliceLogicByModelDisplayNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_SetViewLogics(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetViewLogics");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  vtkCollection *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCollection"))
  {
    if (ap.IsBound())
    {
      op->SetViewLogics(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::SetViewLogics(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetViewLogics(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetViewLogics");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkCollection *tempr = (ap.IsBound() ?
      op->GetViewLogics() :
      op->vtkMRMLApplicationLogic::GetViewLogics());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetViewLogic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetViewLogic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  vtkMRMLViewNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLViewNode"))
  {
    vtkMRMLViewLogic *tempr = (ap.IsBound() ?
      op->GetViewLogic(temp0) :
      op->vtkMRMLApplicationLogic::GetViewLogic(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetViewLogicByLayoutName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetViewLogicByLayoutName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLViewLogic *tempr = (ap.IsBound() ?
      op->GetViewLogicByLayoutName(temp0) :
      op->vtkMRMLApplicationLogic::GetViewLogicByLayoutName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_SetColorLogic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetColorLogic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  vtkMRMLColorLogic *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLColorLogic"))
  {
    if (ap.IsBound())
    {
      op->SetColorLogic(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::SetColorLogic(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetColorLogic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColorLogic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLColorLogic *tempr = (ap.IsBound() ?
      op->GetColorLogic() :
      op->vtkMRMLApplicationLogic::GetColorLogic());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_PropagateVolumeSelection_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PropagateVolumeSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  int temp0 = 1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    if (ap.IsBound())
    {
      op->PropagateVolumeSelection(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::PropagateVolumeSelection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLApplicationLogic_PropagateVolumeSelection_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PropagateVolumeSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->PropagateVolumeSelection(temp0, temp1);
    }
    else
    {
      op->vtkMRMLApplicationLogic::PropagateVolumeSelection(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLApplicationLogic_PropagateVolumeSelection(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
    case 1:
      return PyvtkMRMLApplicationLogic_PropagateVolumeSelection_s1(self, args);
    case 2:
      return PyvtkMRMLApplicationLogic_PropagateVolumeSelection_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "PropagateVolumeSelection");
  return nullptr;
}



static PyObject *
PyvtkMRMLApplicationLogic_PropagateBackgroundVolumeSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PropagateBackgroundVolumeSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  int temp0 = 1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    if (ap.IsBound())
    {
      op->PropagateBackgroundVolumeSelection(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::PropagateBackgroundVolumeSelection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_PropagateForegroundVolumeSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PropagateForegroundVolumeSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  int temp0 = 1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    if (ap.IsBound())
    {
      op->PropagateForegroundVolumeSelection(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::PropagateForegroundVolumeSelection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_PropagateLabelVolumeSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PropagateLabelVolumeSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  int temp0 = 1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    if (ap.IsBound())
    {
      op->PropagateLabelVolumeSelection(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::PropagateLabelVolumeSelection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_FitSliceToAll(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FitSliceToAll");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    if (ap.IsBound())
    {
      op->FitSliceToAll(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::FitSliceToAll(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_PropagateTableSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PropagateTableSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PropagateTableSelection();
    }
    else
    {
      op->vtkMRMLApplicationLogic::PropagateTableSelection();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_PropagatePlotChartSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PropagatePlotChartSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PropagatePlotChartSelection();
    }
    else
    {
      op->vtkMRMLApplicationLogic::PropagatePlotChartSelection();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_Zip(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Zip");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->Zip(temp0, temp1) :
      op->vtkMRMLApplicationLogic::Zip(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_Unzip(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Unzip");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->Unzip(temp0, temp1) :
      op->vtkMRMLApplicationLogic::Unzip(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_PercentEncode(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "PercentEncode");

  std::string temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = vtkMRMLApplicationLogic::PercentEncode(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_SaveSceneToSlicerDataBundleDirectory(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SaveSceneToSlicerDataBundleDirectory");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  vtkImageData *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp1, "vtkImageData")))
  {
    bool tempr = (ap.IsBound() ?
      op->SaveSceneToSlicerDataBundleDirectory(temp0, temp1) :
      op->vtkMRMLApplicationLogic::SaveSceneToSlicerDataBundleDirectory(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_OpenSlicerDataBundle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OpenSlicerDataBundle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->OpenSlicerDataBundle(temp0, temp1) :
      op->vtkMRMLApplicationLogic::OpenSlicerDataBundle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_UnpackSlicerDataBundle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UnpackSlicerDataBundle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = (ap.IsBound() ?
      op->UnpackSlicerDataBundle(temp0, temp1) :
      op->vtkMRMLApplicationLogic::UnpackSlicerDataBundle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_LoadDefaultParameterSets(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "LoadDefaultParameterSets");

  vtkMRMLScene *temp0 = nullptr;
  std::vector<std::string> temp1(ap.GetArgSize(1));
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLScene") &&
      ap.GetArray(temp1.data(), temp1.size()))
  {
    int tempr = vtkMRMLApplicationLogic::LoadDefaultParameterSets(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_CreateUniqueFileName(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "CreateUniqueFileName");

  std::string temp0;
  std::string temp1 = "";
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    std::string tempr = vtkMRMLApplicationLogic::CreateUniqueFileName(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_InvokeEventWithDelay(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InvokeEventWithDelay");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  unsigned int temp0;
  vtkObject *temp1 = nullptr;
  unsigned long temp2 = vtkCommand::ModifiedEvent;
  void  *temp3 = nullptr;
  Py_buffer pbuf3 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 4) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkObject") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)) &&
      (ap.NoArgsLeft() || ap.GetBuffer(temp3, &pbuf3)))
  {
    if (ap.IsBound())
    {
      op->InvokeEventWithDelay(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkMRMLApplicationLogic::InvokeEventWithDelay(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf3.obj != 0)
  {
    PyBuffer_Release(&pbuf3);
  }
#endif
  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetTemporaryPath(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTemporaryPath");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetTemporaryPath() :
      op->vtkMRMLApplicationLogic::GetTemporaryPath());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_SetTemporaryPath(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTemporaryPath");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTemporaryPath(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::SetTemporaryPath(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_SaveSceneScreenshot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SaveSceneScreenshot");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  vtkImageData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SaveSceneScreenshot(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::SaveSceneScreenshot(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_PauseRender(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PauseRender");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PauseRender();
    }
    else
    {
      op->vtkMRMLApplicationLogic::PauseRender();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_ResumeRender(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResumeRender");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ResumeRender();
    }
    else
    {
      op->vtkMRMLApplicationLogic::ResumeRender();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_EditNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EditNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode"))
  {
    if (ap.IsBound())
    {
      op->EditNode(temp0);
    }
    else
    {
      op->vtkMRMLApplicationLogic::EditNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_SetModuleLogic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetModuleLogic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  vtkMRMLAbstractLogic *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMRMLAbstractLogic"))
  {
    if (ap.IsBound())
    {
      op->SetModuleLogic(temp0, temp1);
    }
    else
    {
      op->vtkMRMLApplicationLogic::SetModuleLogic(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLApplicationLogic_GetModuleLogic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModuleLogic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLApplicationLogic *op = static_cast<vtkMRMLApplicationLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLAbstractLogic *tempr = (ap.IsBound() ?
      op->GetModuleLogic(temp0) :
      op->vtkMRMLApplicationLogic::GetModuleLogic(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLApplicationLogic_Methods[] = {
  {"IsTypeOf", PyvtkMRMLApplicationLogic_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLApplicationLogic_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLApplicationLogic_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLApplicationLogic\nC++: static vtkMRMLApplicationLogic *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLApplicationLogic_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLApplicationLogic\nC++: vtkMRMLApplicationLogic *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLApplicationLogic_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLApplicationLogic_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetSelectionNode", PyvtkMRMLApplicationLogic_GetSelectionNode, METH_VARARGS,
   "V.GetSelectionNode() -> vtkMRMLSelectionNode\nC++: vtkMRMLSelectionNode *GetSelectionNode()\n\nGet default Selection node\n"},
  {"GetInteractionNode", PyvtkMRMLApplicationLogic_GetInteractionNode, METH_VARARGS,
   "V.GetInteractionNode() -> vtkMRMLInteractionNode\nC++: vtkMRMLInteractionNode *GetInteractionNode()\n\nGet default Interaction node\n"},
  {"SetSliceLogics", PyvtkMRMLApplicationLogic_SetSliceLogics, METH_VARARGS,
   "V.SetSliceLogics(vtkCollection)\nC++: void SetSliceLogics(vtkCollection *sliceLogics)\n\nAll the slice logics in the application\n"},
  {"GetSliceLogics", PyvtkMRMLApplicationLogic_GetSliceLogics, METH_VARARGS,
   "V.GetSliceLogics() -> vtkCollection\nC++: vtkCollection *GetSliceLogics()\n\n"},
  {"GetSliceLogic", PyvtkMRMLApplicationLogic_GetSliceLogic, METH_VARARGS,
   "V.GetSliceLogic(vtkMRMLSliceNode) -> vtkMRMLSliceLogic\nC++: vtkMRMLSliceLogic *GetSliceLogic(vtkMRMLSliceNode *sliceNode)\n\n"},
  {"GetSliceLogicByLayoutName", PyvtkMRMLApplicationLogic_GetSliceLogicByLayoutName, METH_VARARGS,
   "V.GetSliceLogicByLayoutName(string) -> vtkMRMLSliceLogic\nC++: vtkMRMLSliceLogic *GetSliceLogicByLayoutName(\n    const char *layoutName)\n\n"},
  {"GetSliceLogicByModelDisplayNode", PyvtkMRMLApplicationLogic_GetSliceLogicByModelDisplayNode, METH_VARARGS,
   "V.GetSliceLogicByModelDisplayNode(vtkMRMLModelDisplayNode)\n    -> vtkMRMLSliceLogic\nC++: vtkMRMLSliceLogic *GetSliceLogicByModelDisplayNode(\n    vtkMRMLModelDisplayNode *displayNode)\n\nGet slice logic from slice model display node\n"},
  {"SetViewLogics", PyvtkMRMLApplicationLogic_SetViewLogics, METH_VARARGS,
   "V.SetViewLogics(vtkCollection)\nC++: void SetViewLogics(vtkCollection *viewLogics)\n\nAll the view logics in the application\n"},
  {"GetViewLogics", PyvtkMRMLApplicationLogic_GetViewLogics, METH_VARARGS,
   "V.GetViewLogics() -> vtkCollection\nC++: vtkCollection *GetViewLogics()\n\n"},
  {"GetViewLogic", PyvtkMRMLApplicationLogic_GetViewLogic, METH_VARARGS,
   "V.GetViewLogic(vtkMRMLViewNode) -> vtkMRMLViewLogic\nC++: vtkMRMLViewLogic *GetViewLogic(vtkMRMLViewNode *viewNode)\n\n"},
  {"GetViewLogicByLayoutName", PyvtkMRMLApplicationLogic_GetViewLogicByLayoutName, METH_VARARGS,
   "V.GetViewLogicByLayoutName(string) -> vtkMRMLViewLogic\nC++: vtkMRMLViewLogic *GetViewLogicByLayoutName(\n    const char *layoutName)\n\n"},
  {"SetColorLogic", PyvtkMRMLApplicationLogic_SetColorLogic, METH_VARARGS,
   "V.SetColorLogic(vtkMRMLColorLogic)\nC++: void SetColorLogic(vtkMRMLColorLogic *newColorLogic)\n\nSet/Get color logic. The application typically sets a custom\ncolor logic (i.e. vtkSlicerColorLogic) that contains default\ncolor nodes. By default, a vtkMRMLColorLogic is instantiated.\n"},
  {"GetColorLogic", PyvtkMRMLApplicationLogic_GetColorLogic, METH_VARARGS,
   "V.GetColorLogic() -> vtkMRMLColorLogic\nC++: vtkMRMLColorLogic *GetColorLogic()\n\n"},
  {"PropagateVolumeSelection", PyvtkMRMLApplicationLogic_PropagateVolumeSelection, METH_VARARGS,
   "V.PropagateVolumeSelection(int)\nC++: void PropagateVolumeSelection(int fit=1)\nV.PropagateVolumeSelection(int, int)\nC++: void PropagateVolumeSelection(int layer, int fit)\n\nApply the active volumes in the SelectionNode to the slice\ncomposite nodes Perform the default behavior related to selecting\na volume (in this case, making it the background for all\nSliceCompositeNodes)\n\\sa vtkInternal::PropagateVolumeSelection()\n\\sa FitSliceToAll()\n\\sa vtkMRMLSelectionNode::SetActiveVolumeID()\n\\sa vtkMRMLSelectionNode::SetSecondaryVolumeID()\n\\sa vtkMRMLSelectionNode::SetActiveLabelVolumeID()\n"},
  {"PropagateBackgroundVolumeSelection", PyvtkMRMLApplicationLogic_PropagateBackgroundVolumeSelection, METH_VARARGS,
   "V.PropagateBackgroundVolumeSelection(int)\nC++: void PropagateBackgroundVolumeSelection(int fit=1)\n\nPropagate only active background volume in the SelectionNode to\nslice composite nodes\n\\sa FitSliceToAll()\n\\sa vtkMRMLSelectionNode::SetActiveVolumeID()\n\\sa Layers::BackgroundLayer\n"},
  {"PropagateForegroundVolumeSelection", PyvtkMRMLApplicationLogic_PropagateForegroundVolumeSelection, METH_VARARGS,
   "V.PropagateForegroundVolumeSelection(int)\nC++: void PropagateForegroundVolumeSelection(int fit=1)\n\nPropagate only active foreground volume in the SelectionNode to\nslice composite nodes\n\\sa FitSliceToAll()\n\\sa vtkMRMLSelectionNode::SetSecondaryVolumeID()\n\\sa Layers::ForegroundLayer\n"},
  {"PropagateLabelVolumeSelection", PyvtkMRMLApplicationLogic_PropagateLabelVolumeSelection, METH_VARARGS,
   "V.PropagateLabelVolumeSelection(int)\nC++: void PropagateLabelVolumeSelection(int fit=1)\n\nPropagate only active label volume in the SelectionNode to slice\ncomposite nodes\n\\sa FitSliceToAll()\n\\sa vtkMRMLSelectionNode::SetActiveLabelVolumeID()\n\\sa Layers::LabelLayer\n"},
  {"FitSliceToAll", PyvtkMRMLApplicationLogic_FitSliceToAll, METH_VARARGS,
   "V.FitSliceToAll(bool)\nC++: void FitSliceToAll(\n    bool onlyIfPropagateVolumeSelectionAllowed=false)\n\nFit all the volumes into their views If\nonlyIfPropagateVolumeSelectionAllowed is true then field of view\nwill be reset on only those slices where propagate volume\nselection is allowed\n"},
  {"PropagateTableSelection", PyvtkMRMLApplicationLogic_PropagateTableSelection, METH_VARARGS,
   "V.PropagateTableSelection()\nC++: void PropagateTableSelection()\n\nPropagate selected table in the SelectionNode to table view\nnodes.\n"},
  {"PropagatePlotChartSelection", PyvtkMRMLApplicationLogic_PropagatePlotChartSelection, METH_VARARGS,
   "V.PropagatePlotChartSelection()\nC++: void PropagatePlotChartSelection()\n\nPropagate selected PlotChart in the SelectionNode to Plot view\nnodes.\n"},
  {"Zip", PyvtkMRMLApplicationLogic_Zip, METH_VARARGS,
   "V.Zip(string, string) -> bool\nC++: bool Zip(const char *zipFileName, const char *directoryToZip)\n\nzip the directory into a zip file Returns success or failure.\n"},
  {"Unzip", PyvtkMRMLApplicationLogic_Unzip, METH_VARARGS,
   "V.Unzip(string, string) -> bool\nC++: bool Unzip(const char *zipFileName,\n    const char *destinationDirectory)\n\nunzip the zip file to the current working directory Returns\nsuccess or failure.\n"},
  {"PercentEncode", PyvtkMRMLApplicationLogic_PercentEncode, METH_VARARGS,
   "V.PercentEncode(string) -> string\nC++: static std::string PercentEncode(std::string s)\n\nConvert reserved characters into percent notation to avoid issues\nwith filenames containing things that might be mistaken, for\nexample, for windows drive letters.  Used internally by\nSaveSceneToSlicerDataBundleDirectory. This is not a general\npurpose implementation; it preseves commonly used characters for\nfilenames but avoids known issue like slashes or colons. Ideally\na version from vtksys or similar should be used, but nothing\nseems to be available.\nhttp://en.wikipedia.org/wiki/Percent-encoding See\nhttps://github.com/Slicer/Slicer/issues/2605\n"},
  {"SaveSceneToSlicerDataBundleDirectory", PyvtkMRMLApplicationLogic_SaveSceneToSlicerDataBundleDirectory, METH_VARARGS,
   "V.SaveSceneToSlicerDataBundleDirectory(string, vtkImageData)\n    -> bool\nC++: bool SaveSceneToSlicerDataBundleDirectory(const char *sdbDir,\n     vtkImageData *screenShot=nullptr)\n\nSave the scene into a self contained directory, sdbDir Called by\nthe qSlicerSceneWriter, which can be accessed via\n\\sa qSlicerCoreIOManager::saveScene\nIf screenShot is not null, use it as the screen shot for a scene\nview Returns false if the save failed\n"},
  {"OpenSlicerDataBundle", PyvtkMRMLApplicationLogic_OpenSlicerDataBundle, METH_VARARGS,
   "V.OpenSlicerDataBundle(string, string) -> bool\nC++: bool OpenSlicerDataBundle(const char *sdbFilePath,\n    const char *temporaryDirectory)\n\nOpen the file into a temp directory and load the scene file\ninside.  Note that the first mrml file found in the extracted\ndirectory will be used.\n"},
  {"UnpackSlicerDataBundle", PyvtkMRMLApplicationLogic_UnpackSlicerDataBundle, METH_VARARGS,
   "V.UnpackSlicerDataBundle(string, string) -> string\nC++: std::string UnpackSlicerDataBundle(const char *sdbFilePath,\n    const char *temporaryDirectory)\n\nUnpack the file into a temp directory and return the scene file\ninside.  Note that the first mrml file found in the extracted\ndirectory will be used.\n"},
  {"LoadDefaultParameterSets", PyvtkMRMLApplicationLogic_LoadDefaultParameterSets, METH_VARARGS,
   "V.LoadDefaultParameterSets(vtkMRMLScene, Stvector_ISt6stringE)\n    -> int\nC++: static int LoadDefaultParameterSets(vtkMRMLScene *scene,\n    const std::vector<std::string> &directories)\n\nLoad any default parameter sets into the specified scene Returns\nthe total number of loaded parameter sets\n"},
  {"CreateUniqueFileName", PyvtkMRMLApplicationLogic_CreateUniqueFileName, METH_VARARGS,
   "V.CreateUniqueFileName(string, string) -> string\nC++: static std::string CreateUniqueFileName(\n    const std::string &filename,\n    const std::string &knownExtension=\"\")\n\nCreates a unique (non-existent) file name by adding an index\nafter base file name. knownExtension specifies the extension the\nindex should be inserted before. It is necessary to provide\nextension, because there is no reliable way of correctly\ndetermining extension automatically (for example, file extension\nof some.file.nii.gz could be gz, nii.gz, or file.nii.gz and only\none of them is correct).\n"},
  {"InvokeEventWithDelay", PyvtkMRMLApplicationLogic_InvokeEventWithDelay, METH_VARARGS,
   "V.InvokeEventWithDelay(int, vtkObject, int, void)\nC++: void InvokeEventWithDelay(unsigned int delayInMs,\n    vtkObject *caller,\n    unsigned long eventID=vtkCommand::ModifiedEvent,\n    void *callData=nullptr)\n\nConveniently calls an InvokeEvent on an object with a delay.\n"},
  {"GetTemporaryPath", PyvtkMRMLApplicationLogic_GetTemporaryPath, METH_VARARGS,
   "V.GetTemporaryPath() -> string\nC++: const char *GetTemporaryPath()\n\nReturn the temporary path that was set by the application\n"},
  {"SetTemporaryPath", PyvtkMRMLApplicationLogic_SetTemporaryPath, METH_VARARGS,
   "V.SetTemporaryPath(string)\nC++: void SetTemporaryPath(const char *path)\n\nSet the temporary path the logics can use. The path should be set\nby the application\n"},
  {"SaveSceneScreenshot", PyvtkMRMLApplicationLogic_SaveSceneScreenshot, METH_VARARGS,
   "V.SaveSceneScreenshot(vtkImageData)\nC++: void SaveSceneScreenshot(vtkImageData *screenshot)\n\nSaves the provided image as screenshot of the scene (same\nfilepath as the scene URL but extension is .png instead of\n.mrml). Uses current scene's URL property, so the URL must be\nup-to-date when calling this method.\n"},
  {"PauseRender", PyvtkMRMLApplicationLogic_PauseRender, METH_VARARGS,
   "V.PauseRender()\nC++: virtual void PauseRender()\n\nPauses rendering for all views in the current layout. It should\nbe used in situations where multiple nodes are modified, and it\nis undesirable to display an intermediate state. The caller is\nresponsible for making sure that each PauseRender() is paired\nwith ResumeRender().\n\\sa vtkMRMLApplicationLogic::ResumeRender()\n\\sa qSlicerApplication::setRenderPaused()\n"},
  {"ResumeRender", PyvtkMRMLApplicationLogic_ResumeRender, METH_VARARGS,
   "V.ResumeRender()\nC++: virtual void ResumeRender()\n\nResumes rendering for all views in the current layout.\n\\sa vtkMRMLApplicationLogic::PauseRender()\n\\sa qSlicerApplication::setRenderPaused()\n"},
  {"EditNode", PyvtkMRMLApplicationLogic_EditNode, METH_VARARGS,
   "V.EditNode(vtkMRMLNode)\nC++: virtual void EditNode(vtkMRMLNode *node)\n\nRequests the application to show user interface for editing a\nnode.\n"},
  {"SetModuleLogic", PyvtkMRMLApplicationLogic_SetModuleLogic, METH_VARARGS,
   "V.SetModuleLogic(string, vtkMRMLAbstractLogic)\nC++: void SetModuleLogic(const char *moduleName,\n    vtkMRMLAbstractLogic *moduleLogic)\n\nSets a module with its corresponding logic to the application\nlogic.\n\\param moduleName name of the module.\n\\param moduleLogic pointer to logic to be associated to the\n    module. If this\nparameter is nullptr, then the module logic will be removed from\nthe application logic.\n"},
  {"GetModuleLogic", PyvtkMRMLApplicationLogic_GetModuleLogic, METH_VARARGS,
   "V.GetModuleLogic(string) -> vtkMRMLAbstractLogic\nC++: vtkMRMLAbstractLogic *GetModuleLogic(const char *moduleName)\n\nGets a constant pointer to module logic associated with a given\nmodule\n\\param moduleName name of the module associated to the logic\n\\return constant pointer to vtkMRMLAbstractLogic corresponding to\nthe\nlogic associated to th logic\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLApplicationLogic_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MRMLLogic.vtkMRMLApplicationLogic", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLApplicationLogic_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLApplicationLogic_StaticNew()
{
  return vtkMRMLApplicationLogic::New();
}

PyObject *PyvtkMRMLApplicationLogic_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLApplicationLogic_Type, PyvtkMRMLApplicationLogic_Methods,
    "vtkMRMLApplicationLogic",
 &PyvtkMRMLApplicationLogic_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMRMLAbstractLogic_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkMRMLApplicationLogic_Layers_Type);
  PyVTKEnum_Add(&PyvtkMRMLApplicationLogic_Layers_Type, "vtkMRMLApplicationLogic.Layers");

  o = (PyObject *)&PyvtkMRMLApplicationLogic_Layers_Type;
  if (PyDict_SetItemString(d, "Layers", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkMRMLApplicationLogic_Events_Type);
  PyVTKEnum_Add(&PyvtkMRMLApplicationLogic_Events_Type, "vtkMRMLApplicationLogic.Events");

  o = (PyObject *)&PyvtkMRMLApplicationLogic_Events_Type;
  if (PyDict_SetItemString(d, "Events", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 4; c++)
  {
    typedef vtkMRMLApplicationLogic::Layers cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[4] = {
        { "LabelLayer", vtkMRMLApplicationLogic::LabelLayer },
        { "ForegroundLayer", vtkMRMLApplicationLogic::ForegroundLayer },
        { "BackgroundLayer", vtkMRMLApplicationLogic::BackgroundLayer },
        { "AllLayers", vtkMRMLApplicationLogic::AllLayers },
      };

    o = PyvtkMRMLApplicationLogic_Layers_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 4; c++)
  {
    typedef vtkMRMLApplicationLogic::Events cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[4] = {
        { "RequestInvokeEvent", vtkMRMLApplicationLogic::RequestInvokeEvent },
        { "PauseRenderEvent", vtkMRMLApplicationLogic::PauseRenderEvent },
        { "ResumeRenderEvent", vtkMRMLApplicationLogic::ResumeRenderEvent },
        { "EditNodeEvent", vtkMRMLApplicationLogic::EditNodeEvent },
      };

    o = PyvtkMRMLApplicationLogic_Events_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLApplicationLogic(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLApplicationLogic_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLApplicationLogic", o) != 0)
  {
    Py_DECREF(o);
  }

}

