// python wrapper for vtkITKGrowCutSegmentationImageFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkITKGrowCutSegmentationImageFilter.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkITKGrowCutSegmentationImageFilter(PyObject *dict); }
extern "C" { PyObject *PyvtkITKGrowCutSegmentationImageFilter_ClassNew(); }

#ifndef DECLARED_PyvtkImageAlgorithm_ClassNew
extern "C" { PyObject *PyvtkImageAlgorithm_ClassNew(); }
#define DECLARED_PyvtkImageAlgorithm_ClassNew
#endif

static const char *PyvtkITKGrowCutSegmentationImageFilter_Doc =
  "vtkITKGrowCutSegmentationImageFilter - - Wrapper class around\nitk::GrowCutSegmentationImageFilter\n\n"
  "Superclass: vtkImageAlgorithm\n\n"
  "GrowCutSegmentationImageFilter produces segmentation of regions on an\n"
  "image interactively. It uses the positive and  negative gestures\n"
  "(strokes/ lines/points marked by the user on the region of interest\n"
  "(positive), and outside the object (negative) to automatically\n"
  "generate the segmentation\n\n"
  "Usage: SetInput1 is the input feature/intensity image (required)\n"
  "SetInput2 takes the gesture image (the gestures) image (required)\n"
  "SetInput3 takes the previous segmented image (optional)\n\n"
  "GetOutput produces the output segmented image\n\n"
  "This filter is implemented only for scalar images gray scale images.\n"
  "The current implementation supports n-class segmentation.\n\n";


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkITKGrowCutSegmentationImageFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKGrowCutSegmentationImageFilter *op = static_cast<vtkITKGrowCutSegmentationImageFilter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkITKGrowCutSegmentationImageFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkITKGrowCutSegmentationImageFilter *tempr = vtkITKGrowCutSegmentationImageFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKGrowCutSegmentationImageFilter *op = static_cast<vtkITKGrowCutSegmentationImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkITKGrowCutSegmentationImageFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkITKGrowCutSegmentationImageFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkITKGrowCutSegmentationImageFilter::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKGrowCutSegmentationImageFilter *op = static_cast<vtkITKGrowCutSegmentationImageFilter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkITKGrowCutSegmentationImageFilter::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_SetObjectSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetObjectSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKGrowCutSegmentationImageFilter *op = static_cast<vtkITKGrowCutSegmentationImageFilter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetObjectSize(temp0);
    }
    else
    {
      op->vtkITKGrowCutSegmentationImageFilter::SetObjectSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_GetObjectSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetObjectSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKGrowCutSegmentationImageFilter *op = static_cast<vtkITKGrowCutSegmentationImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetObjectSize() :
      op->vtkITKGrowCutSegmentationImageFilter::GetObjectSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_SetContrastNoiseRatio(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetContrastNoiseRatio");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKGrowCutSegmentationImageFilter *op = static_cast<vtkITKGrowCutSegmentationImageFilter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetContrastNoiseRatio(temp0);
    }
    else
    {
      op->vtkITKGrowCutSegmentationImageFilter::SetContrastNoiseRatio(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_GetContrastNoiseRatio(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetContrastNoiseRatio");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKGrowCutSegmentationImageFilter *op = static_cast<vtkITKGrowCutSegmentationImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetContrastNoiseRatio() :
      op->vtkITKGrowCutSegmentationImageFilter::GetContrastNoiseRatio());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_SetPriorSegmentConfidence(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPriorSegmentConfidence");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKGrowCutSegmentationImageFilter *op = static_cast<vtkITKGrowCutSegmentationImageFilter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPriorSegmentConfidence(temp0);
    }
    else
    {
      op->vtkITKGrowCutSegmentationImageFilter::SetPriorSegmentConfidence(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkITKGrowCutSegmentationImageFilter_GetPriorSegmentConfidence(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPriorSegmentConfidence");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKGrowCutSegmentationImageFilter *op = static_cast<vtkITKGrowCutSegmentationImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetPriorSegmentConfidence() :
      op->vtkITKGrowCutSegmentationImageFilter::GetPriorSegmentConfidence());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkITKGrowCutSegmentationImageFilter_Methods[] = {
  {"IsTypeOf", PyvtkITKGrowCutSegmentationImageFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkITKGrowCutSegmentationImageFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkITKGrowCutSegmentationImageFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkITKGrowCutSegmentationImageFilter\nC++: static vtkITKGrowCutSegmentationImageFilter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkITKGrowCutSegmentationImageFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkITKGrowCutSegmentationImageFilter\nC++: vtkITKGrowCutSegmentationImageFilter *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkITKGrowCutSegmentationImageFilter_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkITKGrowCutSegmentationImageFilter_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetObjectSize", PyvtkITKGrowCutSegmentationImageFilter_SetObjectSize, METH_VARARGS,
   "V.SetObjectSize(float)\nC++: virtual void SetObjectSize(double _arg)\n\nMethods to set/get objectSize\n"},
  {"GetObjectSize", PyvtkITKGrowCutSegmentationImageFilter_GetObjectSize, METH_VARARGS,
   "V.GetObjectSize() -> float\nC++: virtual double GetObjectSize()\n\n"},
  {"SetContrastNoiseRatio", PyvtkITKGrowCutSegmentationImageFilter_SetContrastNoiseRatio, METH_VARARGS,
   "V.SetContrastNoiseRatio(float)\nC++: virtual void SetContrastNoiseRatio(double _arg)\n\nMethods to set/get contrastNoiseRatio\n"},
  {"GetContrastNoiseRatio", PyvtkITKGrowCutSegmentationImageFilter_GetContrastNoiseRatio, METH_VARARGS,
   "V.GetContrastNoiseRatio() -> float\nC++: virtual double GetContrastNoiseRatio()\n\n"},
  {"SetPriorSegmentConfidence", PyvtkITKGrowCutSegmentationImageFilter_SetPriorSegmentConfidence, METH_VARARGS,
   "V.SetPriorSegmentConfidence(float)\nC++: virtual void SetPriorSegmentConfidence(double _arg)\n\nMethods to set/get priorSegmentConfidence\n"},
  {"GetPriorSegmentConfidence", PyvtkITKGrowCutSegmentationImageFilter_GetPriorSegmentConfidence, METH_VARARGS,
   "V.GetPriorSegmentConfidence() -> float\nC++: virtual double GetPriorSegmentConfidence()\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkITKGrowCutSegmentationImageFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkITK.vtkITKGrowCutSegmentationImageFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkITKGrowCutSegmentationImageFilter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkITKGrowCutSegmentationImageFilter_StaticNew()
{
  return vtkITKGrowCutSegmentationImageFilter::New();
}

PyObject *PyvtkITKGrowCutSegmentationImageFilter_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkITKGrowCutSegmentationImageFilter_Type, PyvtkITKGrowCutSegmentationImageFilter_Methods,
    "vtkITKGrowCutSegmentationImageFilter",
 &PyvtkITKGrowCutSegmentationImageFilter_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkImageAlgorithm");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkITKGrowCutSegmentationImageFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkITKGrowCutSegmentationImageFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkITKGrowCutSegmentationImageFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

