// python wrapper for vtkITKNewOtsuThresholdImageFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkITKNewOtsuThresholdImageFilter.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkITKNewOtsuThresholdImageFilter(PyObject *dict); }
extern "C" { PyObject *PyvtkITKNewOtsuThresholdImageFilter_ClassNew(); }

#ifndef DECLARED_PyvtkITKImageToImageFilterSS_ClassNew
extern "C" { PyObject *PyvtkITKImageToImageFilterSS_ClassNew(); }
#define DECLARED_PyvtkITKImageToImageFilterSS_ClassNew
#endif

static const char *PyvtkITKNewOtsuThresholdImageFilter_Doc =
  "vtkITKNewOtsuThresholdImageFilter - Wrapper class around\nitk::NewOtsuThresholdImageFilter.\n\n"
  "Superclass: vtkITKImageToImageFilterSS\n\n"
;


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkITKNewOtsuThresholdImageFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkITKNewOtsuThresholdImageFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkITKNewOtsuThresholdImageFilter *tempr = vtkITKNewOtsuThresholdImageFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkITKNewOtsuThresholdImageFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkITKNewOtsuThresholdImageFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkITKNewOtsuThresholdImageFilter::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkITKNewOtsuThresholdImageFilter::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_SetNumberOfHistogramBins(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfHistogramBins");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  unsigned long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfHistogramBins(temp0);
    }
    else
    {
      op->vtkITKNewOtsuThresholdImageFilter::SetNumberOfHistogramBins(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_GetNumberOfHistogramBins(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfHistogramBins");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetNumberOfHistogramBins() :
      op->vtkITKNewOtsuThresholdImageFilter::GetNumberOfHistogramBins());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_SetOmega(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOmega");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOmega(temp0);
    }
    else
    {
      op->vtkITKNewOtsuThresholdImageFilter::SetOmega(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_GetOmega(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOmega");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetOmega() :
      op->vtkITKNewOtsuThresholdImageFilter::GetOmega());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_SetInsideValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInsideValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  short temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetInsideValue(temp0);
    }
    else
    {
      op->vtkITKNewOtsuThresholdImageFilter::SetInsideValue(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_SetOutsideValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutsideValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  short temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOutsideValue(temp0);
    }
    else
    {
      op->vtkITKNewOtsuThresholdImageFilter::SetOutsideValue(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_GetInsideValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInsideValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    short tempr = (ap.IsBound() ?
      op->GetInsideValue() :
      op->vtkITKNewOtsuThresholdImageFilter::GetInsideValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_GetOutsideValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutsideValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    short tempr = (ap.IsBound() ?
      op->GetOutsideValue() :
      op->vtkITKNewOtsuThresholdImageFilter::GetOutsideValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkITKNewOtsuThresholdImageFilter_GetThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkITKNewOtsuThresholdImageFilter *op = static_cast<vtkITKNewOtsuThresholdImageFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    short tempr = (ap.IsBound() ?
      op->GetThreshold() :
      op->vtkITKNewOtsuThresholdImageFilter::GetThreshold());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkITKNewOtsuThresholdImageFilter_Methods[] = {
  {"IsTypeOf", PyvtkITKNewOtsuThresholdImageFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkITKNewOtsuThresholdImageFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkITKNewOtsuThresholdImageFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkITKNewOtsuThresholdImageFilter\nC++: static vtkITKNewOtsuThresholdImageFilter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkITKNewOtsuThresholdImageFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkITKNewOtsuThresholdImageFilter\nC++: vtkITKNewOtsuThresholdImageFilter *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkITKNewOtsuThresholdImageFilter_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkITKNewOtsuThresholdImageFilter_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetNumberOfHistogramBins", PyvtkITKNewOtsuThresholdImageFilter_SetNumberOfHistogramBins, METH_VARARGS,
   "V.SetNumberOfHistogramBins(int)\nC++: void SetNumberOfHistogramBins(unsigned long value)\n\n"},
  {"GetNumberOfHistogramBins", PyvtkITKNewOtsuThresholdImageFilter_GetNumberOfHistogramBins, METH_VARARGS,
   "V.GetNumberOfHistogramBins() -> int\nC++: unsigned long GetNumberOfHistogramBins()\n\n"},
  {"SetOmega", PyvtkITKNewOtsuThresholdImageFilter_SetOmega, METH_VARARGS,
   "V.SetOmega(float)\nC++: void SetOmega(double value)\n\n"},
  {"GetOmega", PyvtkITKNewOtsuThresholdImageFilter_GetOmega, METH_VARARGS,
   "V.GetOmega() -> float\nC++: double GetOmega()\n\n"},
  {"SetInsideValue", PyvtkITKNewOtsuThresholdImageFilter_SetInsideValue, METH_VARARGS,
   "V.SetInsideValue(int)\nC++: void SetInsideValue(short value)\n\n"},
  {"SetOutsideValue", PyvtkITKNewOtsuThresholdImageFilter_SetOutsideValue, METH_VARARGS,
   "V.SetOutsideValue(int)\nC++: void SetOutsideValue(short value)\n\n"},
  {"GetInsideValue", PyvtkITKNewOtsuThresholdImageFilter_GetInsideValue, METH_VARARGS,
   "V.GetInsideValue() -> int\nC++: short GetInsideValue()\n\n"},
  {"GetOutsideValue", PyvtkITKNewOtsuThresholdImageFilter_GetOutsideValue, METH_VARARGS,
   "V.GetOutsideValue() -> int\nC++: short GetOutsideValue()\n\n"},
  {"GetThreshold", PyvtkITKNewOtsuThresholdImageFilter_GetThreshold, METH_VARARGS,
   "V.GetThreshold() -> int\nC++: short GetThreshold()\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkITKNewOtsuThresholdImageFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkITK.vtkITKNewOtsuThresholdImageFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkITKNewOtsuThresholdImageFilter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkITKNewOtsuThresholdImageFilter_StaticNew()
{
  return vtkITKNewOtsuThresholdImageFilter::New();
}

PyObject *PyvtkITKNewOtsuThresholdImageFilter_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkITKNewOtsuThresholdImageFilter_Type, PyvtkITKNewOtsuThresholdImageFilter_Methods,
    "vtkITKNewOtsuThresholdImageFilter",
 &PyvtkITKNewOtsuThresholdImageFilter_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkITKImageToImageFilterSS_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkITKNewOtsuThresholdImageFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkITKNewOtsuThresholdImageFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkITKNewOtsuThresholdImageFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

