// This file was automatically generated by:
//  /usr/bin/GenerateCLP --logoFiles /usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/ITKLogo.h --InputXML /usr/src/RPM/BUILD/slicer-4.11.20210226/Modules/CLI/CreateDICOMSeries/CreateDICOMSeries.xml --OutputCxx /usr/src/RPM/BUILD/slicer-4.11.20210226/BUILD/Modules/CLI/CreateDICOMSeries/CreateDICOMSeriesCLP.h
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
#include <map>

#include <sstream>
#include <fstream>
#include <stdexcept>

#include "tclap/CmdLine.h"
#include "JsonSerializationUtilities.h"
#include "ModuleProcessInformation.h"

#ifdef _WIN32
#define Module_EXPORT __declspec(dllexport)
#elif defined(MODULE_HIDDEN_VISIBILITY)
#define Module_EXPORT __attribute__((visibility("default")))
#else
#define Module_EXPORT
#endif


extern "C" {
Module_EXPORT char JSONModuleDescription[] =
"{\n"
"	\"Category\" : \"Converters\",\n"
"	\"Contributor\" : \"Bill Lorensen (GE)\",\n"
"	\"Description\" : \"Create a DICOM Series from a Slicer volume. User can specify values for selected DICOM tags in the UI. Given the number of tags DICOM series have, it is impossible to expose all tags in UI. So only important tags can be set by the user.\",\n"
"	\"DocumentationURL\" : \"https://www.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/CreateDICOMSeries\",\n"
"	\"License\" : \"\",\n"
"	\"ParameterGroups\" : \n"
"	[\n"
"		{\n"
"			\"Description\" : \"Input parameters\",\n"
"			\"Label\" : \"Input\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Input volume to be resampled\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"0\",\n"
"					\"Label\" : \"Input Volume\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"inputVolume\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Output parameters\",\n"
"			\"Label\" : \"Output\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The directory to contain the DICOM series.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"DICOM Directory\",\n"
"					\"LongFlag\" : \"dicomDirectory\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"dicomDirectory\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"directory\",\n"
"					\"Value\" : \"./\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The prefix of the DICOM filename.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"DICOM filename prefix\",\n"
"					\"LongFlag\" : \"dicomPrefix\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"dicomPrefix\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"IMG\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The printf-style format to be used when creating the per-slice DICOM filename. The leading % sign can be omitted.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"DICOM file number format\",\n"
"					\"LongFlag\" : \"dicomNumberFormat\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"dicomNumberFormat\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"%04d\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Reverse the slices.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Reverse Slices\",\n"
"					\"LongFlag\" : \"reverseImages\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"reverseImages\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"false\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Compress the output pixel data.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Use Compression\",\n"
"					\"LongFlag\" : \"useCompression\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"useCompression\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"false\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Type for the new output volume.\",\n"
"					\"Elements\" : \n"
"					[\n"
"						\"UnsignedChar\",\n"
"						\"Char\",\n"
"						\"UnsignedChar\",\n"
"						\"Short\",\n"
"						\"UnsignedShort\",\n"
"						\"Int\",\n"
"						\"UnsignedInt\"\n"
"					],\n"
"					\"Flag\" : \"t\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Output Type:\",\n"
"					\"LongFlag\" : \"type\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Type\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string-enumeration\",\n"
"					\"Value\" : \"Short\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Parameters that apply to a patient\",\n"
"			\"Label\" : \"Patient Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The name of the patient (0010,0010)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Patient Name\",\n"
"					\"LongFlag\" : \"patientName\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"patientName\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"Anonymous\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The patient ID (0010,0020). If set to [random] then a random ID will be generated.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Patient ID\",\n"
"					\"LongFlag\" : \"patientID\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"patientID\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"[random]\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Patient birth date (0010,0030) in the format YYYYMMDD.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Patient Birth Date\",\n"
"					\"LongFlag\" : \"patientBirthDate\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"patientBirthDate\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Patient sex (0010,0040). M=male, F=female, O=other, [unknown]=not specified\",\n"
"					\"Elements\" : [ \"[unknown]\", \"M\", \"F\", \"O\" ],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Patient Sex\",\n"
"					\"LongFlag\" : \"patientSex\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"patientSex\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string-enumeration\",\n"
"					\"Value\" : \"[unknown]\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Patient comments (0010,4000)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Patient Comments\",\n"
"					\"LongFlag\" : \"patientComments\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"patientComments\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Parameters that apply to a study\",\n"
"			\"Label\" : \"Study Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The study ID (0020,0010)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Study ID\",\n"
"					\"LongFlag\" : \"studyID\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"studyID\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"[random]\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The date of the study (0008,0020) in the format YYYYMMDD. If set to '[now]' then the current date is used.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Study Date\",\n"
"					\"LongFlag\" : \"studyDate\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"studyDate\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"[now]\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The time of the study (0008,0030) in the format HHMMSS. If set to '[now]' then the current time is used.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Study Time\",\n"
"					\"LongFlag\" : \"studyTime\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"studyTime\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"[now]\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Study comments (0032,4000)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Study Comments\",\n"
"					\"LongFlag\" : \"studyComments\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"studyComments\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Study description (0008,1030)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Study Description\",\n"
"					\"LongFlag\" : \"studyDescription\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"studyDescription\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Modality (0008,0060)\",\n"
"					\"Elements\" : [ \"CT\", \"MR\", \"NM\", \"US\", \"CR\", \"SC\" ],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Modality\",\n"
"					\"LongFlag\" : \"modality\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"modality\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string-enumeration\",\n"
"					\"Value\" : \"CT\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Manufacturer (0008,0070)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Manufacturer\",\n"
"					\"LongFlag\" : \"manufacturer\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"manufacturer\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"3D Slicer\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"model (0008,1090)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Model\",\n"
"					\"LongFlag\" : \"model\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"model\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Parameters that apply to a series\",\n"
"			\"Label\" : \"Series Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The series number (0020,0011)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Series Number\",\n"
"					\"LongFlag\" : \"seriesNumber\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"seriesNumber\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"1\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Series description (0008,103E)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Series Description\",\n"
"					\"LongFlag\" : \"seriesDescription\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"seriesDescription\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The date of the series (0008,0021) in the format YYYYMMDD. If set to '[now]' then the current date is used.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Series Date\",\n"
"					\"LongFlag\" : \"seriesDate\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"seriesDate\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"[now]\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The time of the series (0008,0031) in the format HHMMSS. If set to '[now]' then the current time is used.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Series Time\",\n"
"					\"LongFlag\" : \"seriesTime\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"seriesTime\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"[now]\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Patient position descriptor relative to the equipment.\",\n"
"					\"Elements\" : \n"
"					[\n"
"						\"HFS\",\n"
"						\"HFP\",\n"
"						\"HFDR\",\n"
"						\"HFDL\",\n"
"						\"FFDR\",\n"
"						\"FFDL\",\n"
"						\"FFP\",\n"
"						\"FFS\",\n"
"						\"LFP\",\n"
"						\"LFS\",\n"
"						\"RFP\",\n"
"						\"RFS\",\n"
"						\"AFDR\",\n"
"						\"AFDL\",\n"
"						\"PFDR\",\n"
"						\"PFDL\"\n"
"					],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Patient Position:\",\n"
"					\"LongFlag\" : \"patientPosition\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"patientPosition\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string-enumeration\",\n"
"					\"Value\" : \"HFS\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Parameters that apply to the images and data in each image\",\n"
"			\"Label\" : \"Image Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Window center (0028,1050). Specify a linear conversion from stored pixel values (after Rescale Slope and Intercepthave been applied) to values to be displayed. Window Center contains the input value that is the center of the window. If either window center or width is undefined then the window is set to the full intensity ange of the image.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Window center\",\n"
"					\"LongFlag\" : \"windowCenter\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"windowCenter\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Window width (0028,1051). Specify a linear conversion from stored pixel values (after Rescale Slope and Intercepthave been applied) to values to be displayed. Window Width contains the width of the window. If either window center or width is undefined then the window is set to the full intensity ange of the image.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Window width\",\n"
"					\"LongFlag\" : \"windowWidth\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"windowWidth\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"double\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Rescale intercept (0028,1052). Converts pixel values on disk to pixel values in memory. (Pixel value in memory) = (Pixel value on disk) * rescaleSlope + rescaleIntercept.  Default is 0.0. Data values are converted on write (the data is scaled and shifted so that the slope and interscept will bring it back to the current intensity range).\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Rescale intercept\",\n"
"					\"LongFlag\" : \"rescaleIntercept\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"rescaleIntercept\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"double\",\n"
"					\"Value\" : \"0.0000\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"double\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Rescale slope (0028,1053). Converts pixel values on disk to pixel values in memory. (Pixel value in memory) = (Pixel value on disk) * rescaleSlope + rescaleInterscept.  Default is 1.0. Data values are converted on write (the data is scaled and shifted so that the slope and interscept will bring it back to the current intensity range).\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Rescale slope\",\n"
"					\"LongFlag\" : \"rescaleSlope\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"rescaleSlope\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"double\",\n"
"					\"Value\" : \"1.0000\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Specifies the output units of the rescaled image (0008,1054). Leave it blank to set it automatically (Hounsfield unit for CT, unspecified for others).\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Rescale Type\",\n"
"					\"LongFlag\" : \"rescaleType\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"rescaleType\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The date of the image content (0008,0023) in the format YYYYMMDD. If set to '[now]' then the current date is used.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Content Date\",\n"
"					\"LongFlag\" : \"contentDate\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"contentDate\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"[now]\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The time of the image content (0008,0033) in the format HHMMSS. If set to '[now]' then the current time is used.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Content Time\",\n"
"					\"LongFlag\" : \"contentTime\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"contentTime\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"[now]\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Unique identifiers (UIDs) that allow appending frames to existing studies or series. To generate UIDs automatically, leave all of them blank.\",\n"
"			\"Label\" : \"Unique Identifiers (UIDs)\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The study instance UID (0020,000d). Leave it blank to generate UIDs automatically.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Study Instance UID\",\n"
"					\"LongFlag\" : \"studyInstanceUID\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"studyInstanceUID\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The series instance UID (0020,000e). Leave it blank to generate UIDs automatically.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Series Instance UID\",\n"
"					\"LongFlag\" : \"seriesInstanceUID\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"seriesInstanceUID\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The frame of reference instance UID (0020,0052). Leave it blank to generate UIDs automatically.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Frame of Reference Instance UID\",\n"
"					\"LongFlag\" : \"frameOfReferenceInstanceUID\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"frameOfReferenceInstanceUID\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"\"\n"
"				}\n"
"			]\n"
"		}\n"
"	],\n"
"	\"Title\" : \"Create a DICOM Series\",\n"
"	\"Version\" : \"0.1.0.$Revision$(alpha)\"\n"
"}\n"
"\n"
;
}
#define GENERATE_DESERIALIZATION \
    if (argc >= 2) \
      { \
      for (int arg_idx = 0; arg_idx < argc; ++arg_idx) \
        { \
        if (strcmp(argv[arg_idx],"--deserialize") == 0) \
          { \
          std::ifstream fStream( argv[arg_idx+1] ); \
          if( !fStream.is_open() ) \
            { \
            std::cerr << "Could not open file: " << argv[arg_idx+1] << " for writing." << std::endl; \
            return EXIT_FAILURE; \
            } \
          Json::Value root; \
          Json::Reader reader; \
          reader.parse( fStream, root ); \
          const Json::Value & parameters = root["Parameters"]; \
          if (!parameters["Input"]["inputVolume"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["Input"]["inputVolume"].asString()); \
            } \
          if (!parameters["Output"]["dicomDirectory"].isNull()) \
            { \
            Json::Value param = parameters["Output"]["dicomDirectory"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--dicomDirectory"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--dicomDirectory"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Output"]["dicomPrefix"].isNull()) \
            { \
            Json::Value param = parameters["Output"]["dicomPrefix"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--dicomPrefix"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--dicomPrefix"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Output"]["dicomNumberFormat"].isNull()) \
            { \
            Json::Value param = parameters["Output"]["dicomNumberFormat"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--dicomNumberFormat"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--dicomNumberFormat"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Output"]["reverseImages"].isNull()) \
            { \
            if (parameters["Output"]["reverseImages"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--reverseImages"); \
              } \
            } \
          if (!parameters["Output"]["useCompression"].isNull()) \
            { \
            if (parameters["Output"]["useCompression"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--useCompression"); \
              } \
            } \
          if (!parameters["Output"]["Type"].isNull()) \
            { \
            Json::Value param = parameters["Output"]["Type"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--type"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--type"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Patient Parameters"]["patientName"].isNull()) \
            { \
            Json::Value param = parameters["Patient Parameters"]["patientName"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--patientName"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--patientName"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Patient Parameters"]["patientID"].isNull()) \
            { \
            Json::Value param = parameters["Patient Parameters"]["patientID"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--patientID"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--patientID"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Patient Parameters"]["patientBirthDate"].isNull()) \
            { \
            Json::Value param = parameters["Patient Parameters"]["patientBirthDate"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--patientBirthDate"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--patientBirthDate"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Patient Parameters"]["patientSex"].isNull()) \
            { \
            Json::Value param = parameters["Patient Parameters"]["patientSex"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--patientSex"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--patientSex"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Patient Parameters"]["patientComments"].isNull()) \
            { \
            Json::Value param = parameters["Patient Parameters"]["patientComments"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--patientComments"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--patientComments"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Study Parameters"]["studyID"].isNull()) \
            { \
            Json::Value param = parameters["Study Parameters"]["studyID"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--studyID"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--studyID"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Study Parameters"]["studyDate"].isNull()) \
            { \
            Json::Value param = parameters["Study Parameters"]["studyDate"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--studyDate"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--studyDate"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Study Parameters"]["studyTime"].isNull()) \
            { \
            Json::Value param = parameters["Study Parameters"]["studyTime"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--studyTime"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--studyTime"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Study Parameters"]["studyComments"].isNull()) \
            { \
            Json::Value param = parameters["Study Parameters"]["studyComments"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--studyComments"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--studyComments"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Study Parameters"]["studyDescription"].isNull()) \
            { \
            Json::Value param = parameters["Study Parameters"]["studyDescription"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--studyDescription"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--studyDescription"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Study Parameters"]["modality"].isNull()) \
            { \
            Json::Value param = parameters["Study Parameters"]["modality"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--modality"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--modality"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Study Parameters"]["manufacturer"].isNull()) \
            { \
            Json::Value param = parameters["Study Parameters"]["manufacturer"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--manufacturer"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--manufacturer"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Study Parameters"]["model"].isNull()) \
            { \
            Json::Value param = parameters["Study Parameters"]["model"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--model"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--model"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Series Parameters"]["seriesNumber"].isNull()) \
            { \
            Json::Value param = parameters["Series Parameters"]["seriesNumber"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--seriesNumber"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--seriesNumber"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Series Parameters"]["seriesDescription"].isNull()) \
            { \
            Json::Value param = parameters["Series Parameters"]["seriesDescription"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--seriesDescription"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--seriesDescription"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Series Parameters"]["seriesDate"].isNull()) \
            { \
            Json::Value param = parameters["Series Parameters"]["seriesDate"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--seriesDate"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--seriesDate"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Series Parameters"]["seriesTime"].isNull()) \
            { \
            Json::Value param = parameters["Series Parameters"]["seriesTime"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--seriesTime"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--seriesTime"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Series Parameters"]["patientPosition"].isNull()) \
            { \
            Json::Value param = parameters["Series Parameters"]["patientPosition"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--patientPosition"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--patientPosition"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Image Parameters"]["windowCenter"].isNull()) \
            { \
            Json::Value param = parameters["Image Parameters"]["windowCenter"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--windowCenter"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--windowCenter"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Image Parameters"]["windowWidth"].isNull()) \
            { \
            Json::Value param = parameters["Image Parameters"]["windowWidth"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--windowWidth"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--windowWidth"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Image Parameters"]["rescaleIntercept"].isNull()) \
            { \
            Json::Value param = parameters["Image Parameters"]["rescaleIntercept"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--rescaleIntercept"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--rescaleIntercept"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Image Parameters"]["rescaleSlope"].isNull()) \
            { \
            Json::Value param = parameters["Image Parameters"]["rescaleSlope"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--rescaleSlope"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--rescaleSlope"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Image Parameters"]["rescaleType"].isNull()) \
            { \
            Json::Value param = parameters["Image Parameters"]["rescaleType"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--rescaleType"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--rescaleType"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Image Parameters"]["contentDate"].isNull()) \
            { \
            Json::Value param = parameters["Image Parameters"]["contentDate"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--contentDate"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--contentDate"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Image Parameters"]["contentTime"].isNull()) \
            { \
            Json::Value param = parameters["Image Parameters"]["contentTime"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--contentTime"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--contentTime"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Unique Identifiers (UIDs)"]["studyInstanceUID"].isNull()) \
            { \
            Json::Value param = parameters["Unique Identifiers (UIDs)"]["studyInstanceUID"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--studyInstanceUID"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--studyInstanceUID"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Unique Identifiers (UIDs)"]["seriesInstanceUID"].isNull()) \
            { \
            Json::Value param = parameters["Unique Identifiers (UIDs)"]["seriesInstanceUID"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--seriesInstanceUID"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--seriesInstanceUID"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Unique Identifiers (UIDs)"]["frameOfReferenceInstanceUID"].isNull()) \
            { \
            Json::Value param = parameters["Unique Identifiers (UIDs)"]["frameOfReferenceInstanceUID"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--frameOfReferenceInstanceUID"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--frameOfReferenceInstanceUID"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          } \
        } \
      }
#define GENERATE_SERIALIZATION \
    if( parametersSerializeArg.isSet() ) \
      { \
      Json::Value root; \
      Json::Value & parameters = root["Parameters"]; \
        { \
        Json::Value & parameterGroup = parameters["Input"]; \
        parameterGroup["inputVolume"] = JsonSerialize( inputVolume ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Output"]; \
        parameterGroup["dicomDirectory"] = JsonSerialize( dicomDirectory ); \
        parameterGroup["dicomPrefix"] = JsonSerialize( dicomPrefix ); \
        parameterGroup["dicomNumberFormat"] = JsonSerialize( dicomNumberFormat ); \
        parameterGroup["reverseImages"] = JsonSerialize( reverseImages ); \
        parameterGroup["useCompression"] = JsonSerialize( useCompression ); \
        parameterGroup["Type"] = JsonSerialize( Type ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Patient Parameters"]; \
        parameterGroup["patientName"] = JsonSerialize( patientName ); \
        parameterGroup["patientID"] = JsonSerialize( patientID ); \
        parameterGroup["patientBirthDate"] = JsonSerialize( patientBirthDate ); \
        parameterGroup["patientSex"] = JsonSerialize( patientSex ); \
        parameterGroup["patientComments"] = JsonSerialize( patientComments ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Study Parameters"]; \
        parameterGroup["studyID"] = JsonSerialize( studyID ); \
        parameterGroup["studyDate"] = JsonSerialize( studyDate ); \
        parameterGroup["studyTime"] = JsonSerialize( studyTime ); \
        parameterGroup["studyComments"] = JsonSerialize( studyComments ); \
        parameterGroup["studyDescription"] = JsonSerialize( studyDescription ); \
        parameterGroup["modality"] = JsonSerialize( modality ); \
        parameterGroup["manufacturer"] = JsonSerialize( manufacturer ); \
        parameterGroup["model"] = JsonSerialize( model ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Series Parameters"]; \
        parameterGroup["seriesNumber"] = JsonSerialize( seriesNumber ); \
        parameterGroup["seriesDescription"] = JsonSerialize( seriesDescription ); \
        parameterGroup["seriesDate"] = JsonSerialize( seriesDate ); \
        parameterGroup["seriesTime"] = JsonSerialize( seriesTime ); \
        parameterGroup["patientPosition"] = JsonSerialize( patientPosition ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Image Parameters"]; \
        parameterGroup["windowCenter"] = JsonSerialize( windowCenter ); \
        parameterGroup["windowWidth"] = JsonSerialize( windowWidth ); \
        parameterGroup["rescaleIntercept"] = JsonSerialize( rescaleIntercept ); \
        parameterGroup["rescaleSlope"] = JsonSerialize( rescaleSlope ); \
        parameterGroup["rescaleType"] = JsonSerialize( rescaleType ); \
        parameterGroup["contentDate"] = JsonSerialize( contentDate ); \
        parameterGroup["contentTime"] = JsonSerialize( contentTime ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Unique Identifiers (UIDs)"]; \
        parameterGroup["studyInstanceUID"] = JsonSerialize( studyInstanceUID ); \
        parameterGroup["seriesInstanceUID"] = JsonSerialize( seriesInstanceUID ); \
        parameterGroup["frameOfReferenceInstanceUID"] = JsonSerialize( frameOfReferenceInstanceUID ); \
        } \
      std::ofstream fStream( parametersSerializeArg.getValue().c_str() ); \
      if( !fStream.is_open() ) \
        { \
        std::cerr << "Could not open file: " << parametersSerializeArg.getValue() << " for writing." << std::endl; \
        return EXIT_FAILURE; \
        } \
      Json::StyledStreamWriter writer; \
      writer.write( fStream, root ); \
      fStream.close(); \
      }
#if defined(main) && !defined(REGISTER_TEST)
// If main defined as a preprocessor symbol, redefine it to the expected entry point.
#undef main
#define main ModuleEntryPoint

extern "C" {
  Module_EXPORT char *GetXMLModuleDescription();
  Module_EXPORT int ModuleEntryPoint(int, char*[]);
  Module_EXPORT unsigned char *GetModuleLogo(int *width, int *height, int *pixel_size, unsigned long *bufferLength);
}
#endif

extern "C" {
Module_EXPORT char XMLModuleDescription[] = 
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<executable>\n"
"  <category>Converters</category>\n"
"  <title>Create a DICOM Series</title>\n"
"  <description><![CDATA[Create a DICOM Series from a Slicer volume. User can specify values for selected DICOM tags in the UI. Given the number of tags DICOM series have, it is impossible to expose all tags in UI. So only important tags can be set by the user.]]></description>\n"
"  <version>0.1.0.$Revision$(alpha)</version>\n"
"  <documentation-url>https://www.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/CreateDICOMSeries</documentation-url>\n"
"  <license/>\n"
"  <contributor>Bill Lorensen (GE)</contributor>\n"
"  <acknowledgements><![CDATA[This command module was derived from Insight/Examples (copyright) Insight Software Consortium]]></acknowledgements>\n"
"  <parameters>\n"
"    <label>Input</label>\n"
"    <description><![CDATA[Input parameters]]></description>\n"
"    <image>\n"
"      <name>inputVolume</name>\n"
"      <label>Input Volume</label>\n"
"      <channel>input</channel>\n"
"      <index>0</index>\n"
"      <description><![CDATA[Input volume to be resampled]]></description>\n"
"    </image>\n"
"  </parameters>\n"
"  <parameters>\n"
"    <label>Output</label>\n"
"    <description><![CDATA[Output parameters]]></description>\n"
"    <directory>\n"
"      <label>DICOM Directory</label>\n"
"      <name>dicomDirectory</name>\n"
"      <longflag>--dicomDirectory</longflag>\n"
"      <description><![CDATA[The directory to contain the DICOM series.]]></description>\n"
"      <default>./</default>\n"
"    </directory>\n"
"    <string>\n"
"      <label>DICOM filename prefix</label>\n"
"      <name>dicomPrefix</name>\n"
"      <longflag>--dicomPrefix</longflag>\n"
"      <description><![CDATA[The prefix of the DICOM filename.]]></description>\n"
"      <default>IMG</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>DICOM file number format</label>\n"
"      <name>dicomNumberFormat</name>\n"
"      <longflag>--dicomNumberFormat</longflag>\n"
"      <description><![CDATA[The printf-style format to be used when creating the per-slice DICOM filename. The leading % sign can be omitted.]]></description>\n"
"      <default>%04d</default>\n"
"    </string>\n"
"    <boolean>\n"
"      <label>Reverse Slices</label>\n"
"      <name>reverseImages</name>\n"
"      <longflag>--reverseImages</longflag>\n"
"      <description><![CDATA[Reverse the slices.]]></description>\n"
"      <default>false</default>\n"
"    </boolean>\n"
"    <boolean>\n"
"      <label>Use Compression</label>\n"
"      <name>useCompression</name>\n"
"      <longflag>--useCompression</longflag>\n"
"      <description><![CDATA[Compress the output pixel data.]]></description>\n"
"      <default>false</default>\n"
"    </boolean>\n"
"    <string-enumeration>\n"
"      <label>Filter Settings</label>\n"
"      <name>Type</name>\n"
"      <label>Output Type:</label>\n"
"      <description><![CDATA[Type for the new output volume.]]></description>\n"
"      <longflag>--type</longflag>\n"
"      <flag>--t</flag>\n"
"      <default>Short</default>\n"
"      <element>UnsignedChar</element>\n"
"      <element>Char</element>\n"
"      <element>UnsignedChar</element>\n"
"      <element>Short</element>\n"
"      <element>UnsignedShort</element>\n"
"      <element>Int</element>\n"
"      <element>UnsignedInt</element>\n"
"    </string-enumeration>\n"
"  </parameters>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Patient Parameters</label>\n"
"    <description><![CDATA[Parameters that apply to a patient]]></description>\n"
"    <string>\n"
"      <label>Patient Name</label>\n"
"      <name>patientName</name>\n"
"      <longflag>--patientName</longflag>\n"
"      <description><![CDATA[The name of the patient (0010,0010)]]></description>\n"
"      <default>Anonymous</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Patient ID</label>\n"
"      <name>patientID</name>\n"
"      <longflag>--patientID</longflag>\n"
"      <description><![CDATA[The patient ID (0010,0020). If set to [random] then a random ID will be generated.]]></description>\n"
"      <default>[random]</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Patient Birth Date</label>\n"
"      <name>patientBirthDate</name>\n"
"      <longflag>--patientBirthDate</longflag>\n"
"      <description><![CDATA[Patient birth date (0010,0030) in the format YYYYMMDD.]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"    <string-enumeration>\n"
"      <label>Patient Sex</label>\n"
"      <name>patientSex</name>\n"
"      <longflag>--patientSex</longflag>\n"
"      <description><![CDATA[Patient sex (0010,0040). M=male, F=female, O=other, [unknown]=not specified]]></description>\n"
"      <default>[unknown]</default>\n"
"      <element>[unknown]</element>\n"
"      <element>M</element>\n"
"      <element>F</element>\n"
"      <element>O</element>\n"
"    </string-enumeration>\n"
"    <string>\n"
"      <label>Patient Comments</label>\n"
"      <name>patientComments</name>\n"
"      <longflag>--patientComments</longflag>\n"
"      <description><![CDATA[Patient comments (0010,4000)]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"  </parameters>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Study Parameters</label>\n"
"    <description><![CDATA[Parameters that apply to a study]]></description>\n"
"    <string>\n"
"      <name>studyID</name>\n"
"      <longflag>--studyID</longflag>\n"
"      <description><![CDATA[The study ID (0020,0010)]]></description>\n"
"      <label>Study ID</label>\n"
"      <default>[random]</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Study Date</label>\n"
"      <name>studyDate</name>\n"
"      <longflag>--studyDate</longflag>\n"
"      <description><![CDATA[The date of the study (0008,0020) in the format YYYYMMDD. If set to \"[now]\" then the current date is used.]]></description>\n"
"      <default>[now]</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Study Time</label>\n"
"      <name>studyTime</name>\n"
"      <longflag>--studyTime</longflag>\n"
"      <description><![CDATA[The time of the study (0008,0030) in the format HHMMSS. If set to \"[now]\" then the current time is used.]]></description>\n"
"      <default>[now]</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Study Comments</label>\n"
"      <name>studyComments</name>\n"
"      <longflag>--studyComments</longflag>\n"
"      <description><![CDATA[Study comments (0032,4000)]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Study Description</label>\n"
"      <name>studyDescription</name>\n"
"      <longflag>--studyDescription</longflag>\n"
"      <description><![CDATA[Study description (0008,1030)]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"    <string-enumeration>\n"
"      <label>Modality</label>\n"
"      <name>modality</name>\n"
"      <longflag>--modality</longflag>\n"
"      <description><![CDATA[Modality (0008,0060)]]></description>\n"
"      <element>CT</element>\n"
"      <element>MR</element>\n"
"      <element>NM</element>\n"
"      <element>US</element>\n"
"      <element>CR</element>\n"
"      <element>SC</element>\n"
"      <default>CT</default>\n"
"    </string-enumeration>\n"
"    <string>\n"
"      <label>Manufacturer</label>\n"
"      <name>manufacturer</name>\n"
"      <longflag>--manufacturer</longflag>\n"
"      <description><![CDATA[Manufacturer (0008,0070)]]></description>\n"
"      <default>3D Slicer</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Model</label>\n"
"      <name>model</name>\n"
"      <longflag>--model</longflag>\n"
"      <description><![CDATA[model (0008,1090)]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"  </parameters>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Series Parameters</label>\n"
"    <description><![CDATA[Parameters that apply to a series]]></description>\n"
"    <string>\n"
"      <name>seriesNumber</name>\n"
"      <longflag>--seriesNumber</longflag>\n"
"      <description><![CDATA[The series number (0020,0011)]]></description>\n"
"      <label>Series Number</label>\n"
"      <default>1</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Series Description</label>\n"
"      <name>seriesDescription</name>\n"
"      <longflag>--seriesDescription</longflag>\n"
"      <description><![CDATA[Series description (0008,103E)]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Series Date</label>\n"
"      <name>seriesDate</name>\n"
"      <longflag>--seriesDate</longflag>\n"
"      <description><![CDATA[The date of the series (0008,0021) in the format YYYYMMDD. If set to \"[now]\" then the current date is used.]]></description>\n"
"      <default>[now]</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Series Time</label>\n"
"      <name>seriesTime</name>\n"
"      <longflag>--seriesTime</longflag>\n"
"      <description><![CDATA[The time of the series (0008,0031) in the format HHMMSS. If set to \"[now]\" then the current time is used.]]></description>\n"
"      <default>[now]</default>\n"
"    </string>\n"
"    <string-enumeration>\n"
"      <label>Patient Position:</label>\n"
"      <name>patientPosition</name>\n"
"      <description><![CDATA[Patient position descriptor relative to the equipment.]]></description>\n"
"      <longflag>--patientPosition</longflag>\n"
"      <default>HFS</default>\n"
"      <element>HFS</element>\n"
"      <element>HFP</element>\n"
"      <element>HFDR</element>\n"
"      <element>HFDL</element>\n"
"      <element>FFDR</element>\n"
"      <element>FFDL</element>\n"
"      <element>FFP</element>\n"
"      <element>FFS</element>\n"
"      <element>LFP</element>\n"
"      <element>LFS</element>\n"
"      <element>RFP</element>\n"
"      <element>RFS</element>\n"
"      <element>AFDR</element>\n"
"      <element>AFDL</element>\n"
"      <element>PFDR</element>\n"
"      <element>PFDL</element>\n"
"    </string-enumeration>\n"
"  </parameters>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Image Parameters</label>\n"
"    <description><![CDATA[Parameters that apply to the images and data in each image]]></description>\n"
"    <string>\n"
"      <label>Window center</label>\n"
"      <name>windowCenter</name>\n"
"      <longflag>--windowCenter</longflag>\n"
"      <description><![CDATA[Window center (0028,1050). Specify a linear conversion from stored pixel values (after Rescale Slope and Intercepthave been applied) to values to be displayed. Window Center contains the input value that is the center of the window. If either window center or width is undefined then the window is set to the full intensity ange of the image.]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Window width</label>\n"
"      <name>windowWidth</name>\n"
"      <longflag>--windowWidth</longflag>\n"
"      <description><![CDATA[Window width (0028,1051). Specify a linear conversion from stored pixel values (after Rescale Slope and Intercepthave been applied) to values to be displayed. Window Width contains the width of the window. If either window center or width is undefined then the window is set to the full intensity ange of the image.]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"    <double>\n"
"      <label>Rescale intercept</label>\n"
"      <name>rescaleIntercept</name>\n"
"      <longflag>--rescaleIntercept</longflag>\n"
"      <description><![CDATA[Rescale intercept (0028,1052). Converts pixel values on disk to pixel values in memory. (Pixel value in memory) = (Pixel value on disk) * rescaleSlope + rescaleIntercept.  Default is 0.0. Data values are converted on write (the data is scaled and shifted so that the slope and interscept will bring it back to the current intensity range).]]></description>\n"
"      <default>0.0000</default>\n"
"    </double>\n"
"    <double>\n"
"      <label>Rescale slope</label>\n"
"      <name>rescaleSlope</name>\n"
"      <longflag>--rescaleSlope</longflag>\n"
"      <description><![CDATA[Rescale slope (0028,1053). Converts pixel values on disk to pixel values in memory. (Pixel value in memory) = (Pixel value on disk) * rescaleSlope + rescaleInterscept.  Default is 1.0. Data values are converted on write (the data is scaled and shifted so that the slope and interscept will bring it back to the current intensity range).]]></description>\n"
"      <default>1.0000</default>\n"
"    </double>\n"
"    <string>\n"
"      <label>Rescale Type</label>\n"
"      <name>rescaleType</name>\n"
"      <longflag>--rescaleType</longflag>\n"
"      <description><![CDATA[Specifies the output units of the rescaled image (0008,1054). Leave it blank to set it automatically (Hounsfield unit for CT, unspecified for others).]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Content Date</label>\n"
"      <name>contentDate</name>\n"
"      <longflag>--contentDate</longflag>\n"
"      <description><![CDATA[The date of the image content (0008,0023) in the format YYYYMMDD. If set to \"[now]\" then the current date is used.]]></description>\n"
"      <default>[now]</default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Content Time</label>\n"
"      <name>contentTime</name>\n"
"      <longflag>--contentTime</longflag>\n"
"      <description><![CDATA[The time of the image content (0008,0033) in the format HHMMSS. If set to \"[now]\" then the current time is used.]]></description>\n"
"      <default>[now]</default>\n"
"    </string>\n"
"  </parameters>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Unique Identifiers (UIDs)</label>\n"
"    <description><![CDATA[Unique identifiers (UIDs) that allow appending frames to existing studies or series. To generate UIDs automatically, leave all of them blank.]]></description>\n"
"    <string>\n"
"      <name>studyInstanceUID</name>\n"
"      <longflag>--studyInstanceUID</longflag>\n"
"      <description><![CDATA[The study instance UID (0020,000d). Leave it blank to generate UIDs automatically.]]></description>\n"
"      <label>Study Instance UID</label>\n"
"      <default></default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Series Instance UID</label>\n"
"      <name>seriesInstanceUID</name>\n"
"      <longflag>--seriesInstanceUID</longflag>\n"
"      <description><![CDATA[The series instance UID (0020,000e). Leave it blank to generate UIDs automatically.]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"    <string>\n"
"      <label>Frame of Reference Instance UID</label>\n"
"      <name>frameOfReferenceInstanceUID</name>\n"
"      <longflag>--frameOfReferenceInstanceUID</longflag>\n"
"      <description><![CDATA[The frame of reference instance UID (0020,0052). Leave it blank to generate UIDs automatically.]]></description>\n"
"      <default></default>\n"
"    </string>\n"
"  </parameters>\n"
"</executable>\n"
"\n"
;

#define static Module_EXPORT
#define const
#define image_ITKLogo_width ModuleLogoWidth
#define image_ITKLogo_height ModuleLogoHeight
#define image_ITKLogo_pixel_size ModuleLogoPixelSize
#define image_ITKLogo_length ModuleLogoLength
#define image_ITKLogo ModuleLogoImage
#include "/usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/ITKLogo.h"
#undef static
#undef const
#undef image_ITKLogo_width
#undef image_ITKLogo_height
#undef image_ITKLogo_pixel_size
#undef image_ITKLogo_length
#undef image_ITKLogo
}

void
splitString (const std::string &text,
             const std::string &separators,
             std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  std::string::size_type start = text.find_first_not_of(separators);
  while (start < n)
    {
    std::string::size_type stop = text.find_first_of(separators, start);
    if (stop > n) stop = n;
    words.push_back(text.substr(start, stop - start));
    start = text.find_first_not_of(separators, stop+1);
    }
}

void
splitFilenames (const std::string &text,
                std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  bool quoted;
  std::string comma(",");
  std::string quote("\"");
  std::string::size_type start = text.find_first_not_of(comma);
  while (start < n)
    {
    quoted = false;
    std::string::size_type startq = text.find_first_of(quote, start);
    std::string::size_type stopq = text.find_first_of(quote, startq+1);
    std::string::size_type stop = text.find_first_of(comma, start);
    if (stop > n) stop = n;
    if (startq != std::string::npos && stopq != std::string::npos)
      {
      while (startq < stop && stop < stopq && stop != n)
         {
         quoted = true;
         stop = text.find_first_of(comma, stop+1);
         if (stop > n) stop = n;
         }
      }
    if (!quoted)
      {
      words.push_back(text.substr(start, stop - start));
      }
    else
      {
      words.push_back(text.substr(start+1, stop - start-2));
      }
    start = text.find_first_not_of(comma, stop+1);
    }
}

unsigned char *GetModuleLogo(int *width,
                             int *height,
                             int *pixel_size,
                             unsigned long *length)
{
  *width = ModuleLogoWidth;
  *height = ModuleLogoHeight;
  *pixel_size = ModuleLogoPixelSize;
  *length = ModuleLogoLength;
  return const_cast<unsigned char *>(ModuleLogoImage);
}

char *GetXMLModuleDescription()
{
   return XMLModuleDescription;
}

#define GENERATE_LOGO \
  if (argc >= 2 && (strcmp(argv[1],"--logo") == 0)) \
    { \
    int width, height, pixel_size;     \
    unsigned long length;  \
    unsigned char *logo = GetModuleLogo(&width, &height, &pixel_size, &length);  \
    std::cout << "LOGO" << std::endl;  \
    std::cout << width << std::endl;  \
    std::cout << height << std::endl;  \
    std::cout << pixel_size << std::endl;  \
    std::cout << length << std::endl;  \
    std::cout << logo << std::endl;  \
    return EXIT_SUCCESS;  \
    }
#define GENERATE_XML \
  if (argc >= 2 && (strcmp(argv[1],"--xml") == 0)) \
    { \
    std::cout << GetXMLModuleDescription(); \
    return EXIT_SUCCESS; \
    }
#define GENERATE_DECLARE \
    /* These two vectors are used to store the JSON deserialized value */ \
    /* that are then compiled with the command line. */ \
    std::vector< std::string > deserializedVectorFlaggedArgs; \
    std::vector< std::string > deserializedVectorPositionalArgs; \
    /* This map is used to store the JSON deserialized value of multiple args*/ \
    /* where the key is the argument flag and the value the values of each arg. */ \
    std::map< std::string, std::vector<std::string> > deserializedMultipleArgsMap; \
 \
    /* This vector is used to look up if a flag requires an argument after it. */ \
    /* This is used to differentiate between: */ \
    /* ./myExec --boolFlag /my/first/arg */ \
    /* ./myExec --flag flagArg */ \
    std::vector< std::string > nonbooleanFlags; \
    nonbooleanFlags.push_back("--dicomDirectory"); \
    nonbooleanFlags.push_back("--dicomPrefix"); \
    nonbooleanFlags.push_back("--dicomNumberFormat"); \
    nonbooleanFlags.push_back("-t"); \
    nonbooleanFlags.push_back("--type"); \
    nonbooleanFlags.push_back("--patientName"); \
    nonbooleanFlags.push_back("--patientID"); \
    nonbooleanFlags.push_back("--patientBirthDate"); \
    nonbooleanFlags.push_back("--patientSex"); \
    nonbooleanFlags.push_back("--patientComments"); \
    nonbooleanFlags.push_back("--studyID"); \
    nonbooleanFlags.push_back("--studyDate"); \
    nonbooleanFlags.push_back("--studyTime"); \
    nonbooleanFlags.push_back("--studyComments"); \
    nonbooleanFlags.push_back("--studyDescription"); \
    nonbooleanFlags.push_back("--modality"); \
    nonbooleanFlags.push_back("--manufacturer"); \
    nonbooleanFlags.push_back("--model"); \
    nonbooleanFlags.push_back("--seriesNumber"); \
    nonbooleanFlags.push_back("--seriesDescription"); \
    nonbooleanFlags.push_back("--seriesDate"); \
    nonbooleanFlags.push_back("--seriesTime"); \
    nonbooleanFlags.push_back("--patientPosition"); \
    nonbooleanFlags.push_back("--windowCenter"); \
    nonbooleanFlags.push_back("--windowWidth"); \
    nonbooleanFlags.push_back("--rescaleIntercept"); \
    nonbooleanFlags.push_back("--rescaleSlope"); \
    nonbooleanFlags.push_back("--rescaleType"); \
    nonbooleanFlags.push_back("--contentDate"); \
    nonbooleanFlags.push_back("--contentTime"); \
    nonbooleanFlags.push_back("--studyInstanceUID"); \
    nonbooleanFlags.push_back("--seriesInstanceUID"); \
    nonbooleanFlags.push_back("--frameOfReferenceInstanceUID"); \
    nonbooleanFlags.push_back("--serialize"); \
    nonbooleanFlags.push_back("--deserialize"); \
    nonbooleanFlags.push_back("--processinformationaddress"); \
    nonbooleanFlags.push_back("--returnparameterfile"); \
    /* This map use is twofold: */ \
    /*  - to find whether a flag is multiple */ \
    /*  - to know if we need to reset the multiple arg value because it was */ \
    /*    in the JSON and it's also in the command line. */ \
    std::map<std::string, bool> multipleFlags; \
    std::string inputVolume; \
    std::string dicomDirectory = "./"; \
    std::string dicomPrefix = "IMG"; \
    std::string dicomNumberFormat = "%04d"; \
    bool reverseImages = false; \
    bool useCompression = false; \
    std::string Type = "Short"; \
    std::vector<std::string> TypeAllowed; \
    TypeAllowed.push_back("UnsignedChar");  \
    TypeAllowed.push_back("Char");  \
    TypeAllowed.push_back("UnsignedChar");  \
    TypeAllowed.push_back("Short");  \
    TypeAllowed.push_back("UnsignedShort");  \
    TypeAllowed.push_back("Int");  \
    TypeAllowed.push_back("UnsignedInt");  \
    TCLAP::ValuesConstraint<std::string> TypeAllowedVals (TypeAllowed);  \
    std::string patientName = "Anonymous"; \
    std::string patientID = "[random]"; \
    std::string patientBirthDate; \
    std::string patientSex = "[unknown]"; \
    std::vector<std::string> patientSexAllowed; \
    patientSexAllowed.push_back("[unknown]");  \
    patientSexAllowed.push_back("M");  \
    patientSexAllowed.push_back("F");  \
    patientSexAllowed.push_back("O");  \
    TCLAP::ValuesConstraint<std::string> patientSexAllowedVals (patientSexAllowed);  \
    std::string patientComments; \
    std::string studyID = "[random]"; \
    std::string studyDate = "[now]"; \
    std::string studyTime = "[now]"; \
    std::string studyComments; \
    std::string studyDescription; \
    std::string modality = "CT"; \
    std::vector<std::string> modalityAllowed; \
    modalityAllowed.push_back("CT");  \
    modalityAllowed.push_back("MR");  \
    modalityAllowed.push_back("NM");  \
    modalityAllowed.push_back("US");  \
    modalityAllowed.push_back("CR");  \
    modalityAllowed.push_back("SC");  \
    TCLAP::ValuesConstraint<std::string> modalityAllowedVals (modalityAllowed);  \
    std::string manufacturer = "3D Slicer"; \
    std::string model; \
    std::string seriesNumber = "1"; \
    std::string seriesDescription; \
    std::string seriesDate = "[now]"; \
    std::string seriesTime = "[now]"; \
    std::string patientPosition = "HFS"; \
    std::vector<std::string> patientPositionAllowed; \
    patientPositionAllowed.push_back("HFS");  \
    patientPositionAllowed.push_back("HFP");  \
    patientPositionAllowed.push_back("HFDR");  \
    patientPositionAllowed.push_back("HFDL");  \
    patientPositionAllowed.push_back("FFDR");  \
    patientPositionAllowed.push_back("FFDL");  \
    patientPositionAllowed.push_back("FFP");  \
    patientPositionAllowed.push_back("FFS");  \
    patientPositionAllowed.push_back("LFP");  \
    patientPositionAllowed.push_back("LFS");  \
    patientPositionAllowed.push_back("RFP");  \
    patientPositionAllowed.push_back("RFS");  \
    patientPositionAllowed.push_back("AFDR");  \
    patientPositionAllowed.push_back("AFDL");  \
    patientPositionAllowed.push_back("PFDR");  \
    patientPositionAllowed.push_back("PFDL");  \
    TCLAP::ValuesConstraint<std::string> patientPositionAllowedVals (patientPositionAllowed);  \
    std::string windowCenter; \
    std::string windowWidth; \
    double rescaleIntercept = 0.0000; \
    double rescaleSlope = 1.0000; \
    std::string rescaleType; \
    std::string contentDate = "[now]"; \
    std::string contentTime = "[now]"; \
    std::string studyInstanceUID; \
    std::string seriesInstanceUID; \
    std::string frameOfReferenceInstanceUID; \
    std::string parametersSerialize; \
    std::string parametersDeSerialize; \
    bool echoSwitch = false; \
    bool xmlSwitch = false; \
    std::string processInformationAddressString = "0"; \
    std::string returnParameterFile; \

#define GENERATE_TCLAP_PARSE \
    std::string fullDescription("Description: "); \
    fullDescription += "Create a DICOM Series from a Slicer volume. User can specify values for selected DICOM tags in the UI. Given the number of tags DICOM series have, it is impossible to expose all tags in UI. So only important tags can be set by the user."; \
    if (!std::string("Bill Lorensen (GE)").empty()) \
      { \
      fullDescription += "\nAuthor(s): Bill Lorensen (GE)"; \
      } \
    if (!std::string("This command module was derived from Insight/Examples (copyright) Insight Software Consortium").empty()) \
      { \
      fullDescription += "\nAcknowledgements: This command module was derived from Insight/Examples (copyright) Insight Software Consortium"; \
      } \
    TCLAP::CmdLine commandLine (fullDescription, \
       ' ', \
      "0.1.0.$Revision$(alpha)" ); \
 \
      std::ostringstream msg; \
    msg.str("");msg << "Input volume to be resampled";    TCLAP::UnlabeledValueArg<std::string> inputVolumeArg("inputVolume", msg.str(), 1, inputVolume, "std::string", commandLine); \
 \
    msg.str("");msg << "The directory to contain the DICOM series. (value: " << dicomDirectory << ")"; \
    TCLAP::ValueArg<std::string > dicomDirectoryArg("", "dicomDirectory", msg.str(), 0, dicomDirectory, "std::string", commandLine); \
 \
    msg.str("");msg << "The prefix of the DICOM filename. (value: " << dicomPrefix << ")"; \
    TCLAP::ValueArg<std::string > dicomPrefixArg("", "dicomPrefix", msg.str(), 0, dicomPrefix, "std::string", commandLine); \
 \
    msg.str("");msg << "The printf-style format to be used when creating the per-slice DICOM filename. The leading % sign can be omitted. (value: " << dicomNumberFormat << ")"; \
    TCLAP::ValueArg<std::string > dicomNumberFormatArg("", "dicomNumberFormat", msg.str(), 0, dicomNumberFormat, "std::string", commandLine); \
 \
    msg.str("");msg << "Reverse the slices. (value: " << reverseImages << ")"; \
    TCLAP::SwitchArg reverseImagesArg("", "reverseImages", msg.str(), commandLine, reverseImages); \
 \
    msg.str("");msg << "Compress the output pixel data. (value: " << useCompression << ")"; \
    TCLAP::SwitchArg useCompressionArg("", "useCompression", msg.str(), commandLine, useCompression); \
 \
    msg.str("");msg << "Type for the new output volume. (value: " << Type << ")"; \
    TCLAP::ValueArg<std::string> TypeArg("t", "type", msg.str(), 0, Type, &TypeAllowedVals, commandLine); \
 \
    msg.str("");msg << "The name of the patient (0010,0010) (value: " << patientName << ")"; \
    TCLAP::ValueArg<std::string > patientNameArg("", "patientName", msg.str(), 0, patientName, "std::string", commandLine); \
 \
    msg.str("");msg << "The patient ID (0010,0020). If set to [random] then a random ID will be generated. (value: " << patientID << ")"; \
    TCLAP::ValueArg<std::string > patientIDArg("", "patientID", msg.str(), 0, patientID, "std::string", commandLine); \
 \
    msg.str("");msg << "Patient birth date (0010,0030) in the format YYYYMMDD.";    TCLAP::ValueArg<std::string > patientBirthDateArg("", "patientBirthDate", msg.str(), 0, patientBirthDate, "std::string", commandLine); \
 \
    msg.str("");msg << "Patient sex (0010,0040). M=male, F=female, O=other, [unknown]=not specified (value: " << patientSex << ")"; \
    TCLAP::ValueArg<std::string> patientSexArg("", "patientSex", msg.str(), 0, patientSex, &patientSexAllowedVals, commandLine); \
 \
    msg.str("");msg << "Patient comments (0010,4000)";    TCLAP::ValueArg<std::string > patientCommentsArg("", "patientComments", msg.str(), 0, patientComments, "std::string", commandLine); \
 \
    msg.str("");msg << "The study ID (0020,0010) (value: " << studyID << ")"; \
    TCLAP::ValueArg<std::string > studyIDArg("", "studyID", msg.str(), 0, studyID, "std::string", commandLine); \
 \
    msg.str("");msg << "The date of the study (0008,0020) in the format YYYYMMDD. If set to '[now]' then the current date is used. (value: " << studyDate << ")"; \
    TCLAP::ValueArg<std::string > studyDateArg("", "studyDate", msg.str(), 0, studyDate, "std::string", commandLine); \
 \
    msg.str("");msg << "The time of the study (0008,0030) in the format HHMMSS. If set to '[now]' then the current time is used. (value: " << studyTime << ")"; \
    TCLAP::ValueArg<std::string > studyTimeArg("", "studyTime", msg.str(), 0, studyTime, "std::string", commandLine); \
 \
    msg.str("");msg << "Study comments (0032,4000)";    TCLAP::ValueArg<std::string > studyCommentsArg("", "studyComments", msg.str(), 0, studyComments, "std::string", commandLine); \
 \
    msg.str("");msg << "Study description (0008,1030)";    TCLAP::ValueArg<std::string > studyDescriptionArg("", "studyDescription", msg.str(), 0, studyDescription, "std::string", commandLine); \
 \
    msg.str("");msg << "Modality (0008,0060) (value: " << modality << ")"; \
    TCLAP::ValueArg<std::string> modalityArg("", "modality", msg.str(), 0, modality, &modalityAllowedVals, commandLine); \
 \
    msg.str("");msg << "Manufacturer (0008,0070) (value: " << manufacturer << ")"; \
    TCLAP::ValueArg<std::string > manufacturerArg("", "manufacturer", msg.str(), 0, manufacturer, "std::string", commandLine); \
 \
    msg.str("");msg << "model (0008,1090)";    TCLAP::ValueArg<std::string > modelArg("", "model", msg.str(), 0, model, "std::string", commandLine); \
 \
    msg.str("");msg << "The series number (0020,0011) (value: " << seriesNumber << ")"; \
    TCLAP::ValueArg<std::string > seriesNumberArg("", "seriesNumber", msg.str(), 0, seriesNumber, "std::string", commandLine); \
 \
    msg.str("");msg << "Series description (0008,103E)";    TCLAP::ValueArg<std::string > seriesDescriptionArg("", "seriesDescription", msg.str(), 0, seriesDescription, "std::string", commandLine); \
 \
    msg.str("");msg << "The date of the series (0008,0021) in the format YYYYMMDD. If set to '[now]' then the current date is used. (value: " << seriesDate << ")"; \
    TCLAP::ValueArg<std::string > seriesDateArg("", "seriesDate", msg.str(), 0, seriesDate, "std::string", commandLine); \
 \
    msg.str("");msg << "The time of the series (0008,0031) in the format HHMMSS. If set to '[now]' then the current time is used. (value: " << seriesTime << ")"; \
    TCLAP::ValueArg<std::string > seriesTimeArg("", "seriesTime", msg.str(), 0, seriesTime, "std::string", commandLine); \
 \
    msg.str("");msg << "Patient position descriptor relative to the equipment. (value: " << patientPosition << ")"; \
    TCLAP::ValueArg<std::string> patientPositionArg("", "patientPosition", msg.str(), 0, patientPosition, &patientPositionAllowedVals, commandLine); \
 \
    msg.str("");msg << "Window center (0028,1050). Specify a linear conversion from stored pixel values (after Rescale Slope and Intercepthave been applied) to values to be displayed. Window Center contains the input value that is the center of the window. If either window center or width is undefined then the window is set to the full intensity ange of the image.";    TCLAP::ValueArg<std::string > windowCenterArg("", "windowCenter", msg.str(), 0, windowCenter, "std::string", commandLine); \
 \
    msg.str("");msg << "Window width (0028,1051). Specify a linear conversion from stored pixel values (after Rescale Slope and Intercepthave been applied) to values to be displayed. Window Width contains the width of the window. If either window center or width is undefined then the window is set to the full intensity ange of the image.";    TCLAP::ValueArg<std::string > windowWidthArg("", "windowWidth", msg.str(), 0, windowWidth, "std::string", commandLine); \
 \
    msg.str("");msg << "Rescale intercept (0028,1052). Converts pixel values on disk to pixel values in memory. (Pixel value in memory) = (Pixel value on disk) * rescaleSlope + rescaleIntercept.  Default is 0.0. Data values are converted on write (the data is scaled and shifted so that the slope and interscept will bring it back to the current intensity range). (value: " << rescaleIntercept << ")"; \
    TCLAP::ValueArg<double > rescaleInterceptArg("", "rescaleIntercept", msg.str(), 0, rescaleIntercept, "double", commandLine); \
 \
    msg.str("");msg << "Rescale slope (0028,1053). Converts pixel values on disk to pixel values in memory. (Pixel value in memory) = (Pixel value on disk) * rescaleSlope + rescaleInterscept.  Default is 1.0. Data values are converted on write (the data is scaled and shifted so that the slope and interscept will bring it back to the current intensity range). (value: " << rescaleSlope << ")"; \
    TCLAP::ValueArg<double > rescaleSlopeArg("", "rescaleSlope", msg.str(), 0, rescaleSlope, "double", commandLine); \
 \
    msg.str("");msg << "Specifies the output units of the rescaled image (0008,1054). Leave it blank to set it automatically (Hounsfield unit for CT, unspecified for others).";    TCLAP::ValueArg<std::string > rescaleTypeArg("", "rescaleType", msg.str(), 0, rescaleType, "std::string", commandLine); \
 \
    msg.str("");msg << "The date of the image content (0008,0023) in the format YYYYMMDD. If set to '[now]' then the current date is used. (value: " << contentDate << ")"; \
    TCLAP::ValueArg<std::string > contentDateArg("", "contentDate", msg.str(), 0, contentDate, "std::string", commandLine); \
 \
    msg.str("");msg << "The time of the image content (0008,0033) in the format HHMMSS. If set to '[now]' then the current time is used. (value: " << contentTime << ")"; \
    TCLAP::ValueArg<std::string > contentTimeArg("", "contentTime", msg.str(), 0, contentTime, "std::string", commandLine); \
 \
    msg.str("");msg << "The study instance UID (0020,000d). Leave it blank to generate UIDs automatically.";    TCLAP::ValueArg<std::string > studyInstanceUIDArg("", "studyInstanceUID", msg.str(), 0, studyInstanceUID, "std::string", commandLine); \
 \
    msg.str("");msg << "The series instance UID (0020,000e). Leave it blank to generate UIDs automatically.";    TCLAP::ValueArg<std::string > seriesInstanceUIDArg("", "seriesInstanceUID", msg.str(), 0, seriesInstanceUID, "std::string", commandLine); \
 \
    msg.str("");msg << "The frame of reference instance UID (0020,0052). Leave it blank to generate UIDs automatically.";    TCLAP::ValueArg<std::string > frameOfReferenceInstanceUIDArg("", "frameOfReferenceInstanceUID", msg.str(), 0, frameOfReferenceInstanceUID, "std::string", commandLine); \
 \
    msg.str("");msg << "Store the module's parameters to a file.";    TCLAP::ValueArg<std::string > parametersSerializeArg("", "serialize", msg.str(), 0, parametersSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Restore the module's parameters that were previously archived.";    TCLAP::ValueArg<std::string > parametersDeSerializeArg("", "deserialize", msg.str(), 0, parametersDeSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Echo the command line arguments (value: " << echoSwitch << ")"; \
    TCLAP::SwitchArg echoSwitchArg("", "echo", msg.str(), commandLine, echoSwitch); \
 \
    msg.str("");msg << "Produce xml description of command line arguments (value: " << xmlSwitch << ")"; \
    TCLAP::SwitchArg xmlSwitchArg("", "xml", msg.str(), commandLine, xmlSwitch); \
 \
    msg.str("");msg << "Address of a structure to store process information (progress, abort, etc.). (value: " << processInformationAddressString << ")"; \
    TCLAP::ValueArg<std::string > processInformationAddressStringArg("", "processinformationaddress", msg.str(), 0, processInformationAddressString, "std::string", commandLine); \
 \
    msg.str("");msg << "Filename in which to write simple return parameters (int, float, int-vector, etc.) as opposed to bulk return parameters (image, geometry, transform, measurement, table).";    TCLAP::ValueArg<std::string > returnParameterFileArg("", "returnparameterfile", msg.str(), 0, returnParameterFile, "std::string", commandLine); \
 \
try \
  { \
    /* Build a map of flag aliases to the true flag */ \
    std::map<std::string,std::string> flagAliasMap; \
    std::map<std::string,std::string> deprecatedFlagAliasMap; \
    std::map<std::string,std::string> longFlagAliasMap; \
    std::map<std::string,std::string> deprecatedLongFlagAliasMap; \
 \
    /* Go through argc and consolidate the JSON with the parameters from the command line */ \
    /* In case of conflict, take the command line. */ \
    std::map<std::string,std::string>::iterator ait; \
    std::map<std::string,std::string>::iterator dait; \
    std::vector<std::string>::iterator dvOptionnalArgsIt = deserializedVectorFlaggedArgs.begin(); \
    std::map<std::string, std::vector<std::string> >::iterator dvMultipleArgsIt; \
    size_t noFlagCounter = 0; \
    size_t ac = 1; \
 \
    while (ac < static_cast<size_t>(argc)) \
      { \
      /* short flag case && long flag case */ \
       if ((strlen(argv[ac]) == 2 && argv[ac][0]=='-') \
           || (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]=='-')) \
         { \
         std::string flag = argv[ac]; \
         /* Remap the flag if necessary */ \
         if (strlen(argv[ac]) == 2) \
           { \
           /* Short flag remapping */ \
           ait = flagAliasMap.find(flag); \
           dait = deprecatedFlagAliasMap.find(flag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << flag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         else \
           { \
           /* Long flag remapping */ \
           ait = longFlagAliasMap.find(flag); \
           dait = deprecatedLongFlagAliasMap.find(flag); \
           if (ait != longFlagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedLongFlagAliasMap.end()) \
             { \
             std::cout << "Long flag \"" << flag << "\" is deprecated. Please use long flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         bool isMultiple = multipleFlags.find(flag) != multipleFlags.end(); \
         bool isBoolean = std::find(nonbooleanFlags.begin(), nonbooleanFlags.end(), flag) == nonbooleanFlags.end(); \
         dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), flag); \
         bool isPresentVFA = dvOptionnalArgsIt != deserializedVectorFlaggedArgs.end(); \
         if (isBoolean) \
           { \
           /*Ignore if boolean and already present*/ \
           /*Otherwise add it*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           } \
         else if (isMultiple) \
           { \
           dvMultipleArgsIt = deserializedMultipleArgsMap.find(flag); \
           bool isPresentMA = dvMultipleArgsIt != deserializedMultipleArgsMap.end(); \
           /*Ignore if boolean and already present*/ \
           /*Reset/Add the value if first deserialize or not present*/ \
           if (!isPresentMA || !multipleFlags[flag]) \
             { \
             deserializedMultipleArgsMap[flag] = std::vector<std::string>(); \
             multipleFlags[flag] = true; \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           deserializedMultipleArgsMap[flag].push_back(value); \
           } \
         else \
           { \
           /*Add the flag and if needed*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(value);  \
             } \
           else \
             { \
             *(++dvOptionnalArgsIt) = value; \
             } \
           } \
         } \
       /* short flag case where multiple flags are given at once */ \
       else if (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]!='-') \
         { \
         std::string rflag(argv[ac], 1, std::string::npos); \
         for (std::string::size_type fi=0; fi < rflag.size(); ++fi) \
           { \
           std::string tf(rflag, fi, 1); \
           std::string newFlag ="-"; \
           newFlag += tf; \
           ait = flagAliasMap.find(newFlag); \
           dait = deprecatedFlagAliasMap.find(newFlag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             newFlag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << newFlag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             newFlag = (*dait).second; \
             } \
           dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), newFlag); \
           /*These flags are always boolean, just add it if it's not there already */ \
           if (dvOptionnalArgsIt == deserializedVectorFlaggedArgs.end()) \
             { \
             deserializedVectorFlaggedArgs.push_back(newFlag); \
             } \
           } \
         ++ac; \
         } \
       else \
         { \
         /* Replace if needed, otherwise append.*/ \
         if (noFlagCounter < deserializedVectorPositionalArgs.size()) \
           { \
           deserializedVectorPositionalArgs[noFlagCounter] = argv[ac]; \
           } \
         else \
           { \
           deserializedVectorPositionalArgs.push_back(argv[ac]); \
           } \
         ++ac; \
         ++noFlagCounter; \
         } \
       } \
 \
    /* Put the now compiled arguments in the argvVector */ \
    std::vector<std::string> argvVector; \
    argvVector.push_back(argv[0]); \
    argvVector.insert(argvVector.end(), deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end()); \
    std::map<std::string, std::vector<std::string> >::iterator mavit; \
    for (mavit = deserializedMultipleArgsMap.begin(); mavit != deserializedMultipleArgsMap.end(); ++mavit) \
      { \
      for (size_t i = 0; i < mavit->second.size(); ++i) \
        { \
        argvVector.push_back(mavit->first); \
        argvVector.push_back(mavit->second.at(i)); \
        } \
      } \
    argvVector.insert(argvVector.end(), deserializedVectorPositionalArgs.begin(), deserializedVectorPositionalArgs.end()); \
 \
   /* Remap args to a structure that CmdLine::parse() can understand*/ \
   std::vector<char*> vargs; \
   for (ac = 0; ac < argvVector.size(); ++ac) \
     {  \
     vargs.push_back(const_cast<char *>(argvVector[ac].c_str())); \
     } \
    commandLine.parse ( static_cast<int>(vargs.size()), (char**) &(vargs[0]) ); \
  } \
catch ( TCLAP::ArgException & e ) \
  { \
  std::cerr << "error: " << e.error() << " for arg " << e.argId() << std::endl; \
  return ( EXIT_FAILURE ); \
  }
#define GENERATE_TCLAP_ASSIGNMENT \
      inputVolume = inputVolumeArg.getValue(); \
      dicomDirectory = dicomDirectoryArg.getValue(); \
      dicomPrefix = dicomPrefixArg.getValue(); \
      dicomNumberFormat = dicomNumberFormatArg.getValue(); \
      reverseImages = reverseImagesArg.getValue(); \
      useCompression = useCompressionArg.getValue(); \
      Type = TypeArg.getValue(); \
      patientName = patientNameArg.getValue(); \
      patientID = patientIDArg.getValue(); \
      patientBirthDate = patientBirthDateArg.getValue(); \
      patientSex = patientSexArg.getValue(); \
      patientComments = patientCommentsArg.getValue(); \
      studyID = studyIDArg.getValue(); \
      studyDate = studyDateArg.getValue(); \
      studyTime = studyTimeArg.getValue(); \
      studyComments = studyCommentsArg.getValue(); \
      studyDescription = studyDescriptionArg.getValue(); \
      modality = modalityArg.getValue(); \
      manufacturer = manufacturerArg.getValue(); \
      model = modelArg.getValue(); \
      seriesNumber = seriesNumberArg.getValue(); \
      seriesDescription = seriesDescriptionArg.getValue(); \
      seriesDate = seriesDateArg.getValue(); \
      seriesTime = seriesTimeArg.getValue(); \
      patientPosition = patientPositionArg.getValue(); \
      windowCenter = windowCenterArg.getValue(); \
      windowWidth = windowWidthArg.getValue(); \
      rescaleIntercept = rescaleInterceptArg.getValue(); \
      rescaleSlope = rescaleSlopeArg.getValue(); \
      rescaleType = rescaleTypeArg.getValue(); \
      contentDate = contentDateArg.getValue(); \
      contentTime = contentTimeArg.getValue(); \
      studyInstanceUID = studyInstanceUIDArg.getValue(); \
      seriesInstanceUID = seriesInstanceUIDArg.getValue(); \
      frameOfReferenceInstanceUID = frameOfReferenceInstanceUIDArg.getValue(); \
      parametersSerialize = parametersSerializeArg.getValue(); \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      echoSwitch = echoSwitchArg.getValue(); \
      xmlSwitch = xmlSwitchArg.getValue(); \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      returnParameterFile = returnParameterFileArg.getValue(); \

#define GENERATE_TCLAP GENERATE_TCLAP_PARSE;GENERATE_TCLAP_ASSIGNMENT
#define GENERATE_TCLAP_ASSIGNMENT_IFSET \
    if( inputVolumeArg.isSet() ) \
      { \
      inputVolume = inputVolumeArg.getValue(); \
      } \
    if( dicomDirectoryArg.isSet() ) \
      { \
      dicomDirectory = dicomDirectoryArg.getValue(); \
      } \
    if( dicomPrefixArg.isSet() ) \
      { \
      dicomPrefix = dicomPrefixArg.getValue(); \
      } \
    if( dicomNumberFormatArg.isSet() ) \
      { \
      dicomNumberFormat = dicomNumberFormatArg.getValue(); \
      } \
    if( reverseImagesArg.isSet() ) \
      { \
      reverseImages = reverseImagesArg.getValue(); \
      } \
    if( useCompressionArg.isSet() ) \
      { \
      useCompression = useCompressionArg.getValue(); \
      } \
    if( TypeArg.isSet() ) \
      { \
      Type = TypeArg.getValue(); \
      } \
    if( patientNameArg.isSet() ) \
      { \
      patientName = patientNameArg.getValue(); \
      } \
    if( patientIDArg.isSet() ) \
      { \
      patientID = patientIDArg.getValue(); \
      } \
    if( patientBirthDateArg.isSet() ) \
      { \
      patientBirthDate = patientBirthDateArg.getValue(); \
      } \
    if( patientSexArg.isSet() ) \
      { \
      patientSex = patientSexArg.getValue(); \
      } \
    if( patientCommentsArg.isSet() ) \
      { \
      patientComments = patientCommentsArg.getValue(); \
      } \
    if( studyIDArg.isSet() ) \
      { \
      studyID = studyIDArg.getValue(); \
      } \
    if( studyDateArg.isSet() ) \
      { \
      studyDate = studyDateArg.getValue(); \
      } \
    if( studyTimeArg.isSet() ) \
      { \
      studyTime = studyTimeArg.getValue(); \
      } \
    if( studyCommentsArg.isSet() ) \
      { \
      studyComments = studyCommentsArg.getValue(); \
      } \
    if( studyDescriptionArg.isSet() ) \
      { \
      studyDescription = studyDescriptionArg.getValue(); \
      } \
    if( modalityArg.isSet() ) \
      { \
      modality = modalityArg.getValue(); \
      } \
    if( manufacturerArg.isSet() ) \
      { \
      manufacturer = manufacturerArg.getValue(); \
      } \
    if( modelArg.isSet() ) \
      { \
      model = modelArg.getValue(); \
      } \
    if( seriesNumberArg.isSet() ) \
      { \
      seriesNumber = seriesNumberArg.getValue(); \
      } \
    if( seriesDescriptionArg.isSet() ) \
      { \
      seriesDescription = seriesDescriptionArg.getValue(); \
      } \
    if( seriesDateArg.isSet() ) \
      { \
      seriesDate = seriesDateArg.getValue(); \
      } \
    if( seriesTimeArg.isSet() ) \
      { \
      seriesTime = seriesTimeArg.getValue(); \
      } \
    if( patientPositionArg.isSet() ) \
      { \
      patientPosition = patientPositionArg.getValue(); \
      } \
    if( windowCenterArg.isSet() ) \
      { \
      windowCenter = windowCenterArg.getValue(); \
      } \
    if( windowWidthArg.isSet() ) \
      { \
      windowWidth = windowWidthArg.getValue(); \
      } \
    if( rescaleInterceptArg.isSet() ) \
      { \
      rescaleIntercept = rescaleInterceptArg.getValue(); \
      } \
    if( rescaleSlopeArg.isSet() ) \
      { \
      rescaleSlope = rescaleSlopeArg.getValue(); \
      } \
    if( rescaleTypeArg.isSet() ) \
      { \
      rescaleType = rescaleTypeArg.getValue(); \
      } \
    if( contentDateArg.isSet() ) \
      { \
      contentDate = contentDateArg.getValue(); \
      } \
    if( contentTimeArg.isSet() ) \
      { \
      contentTime = contentTimeArg.getValue(); \
      } \
    if( studyInstanceUIDArg.isSet() ) \
      { \
      studyInstanceUID = studyInstanceUIDArg.getValue(); \
      } \
    if( seriesInstanceUIDArg.isSet() ) \
      { \
      seriesInstanceUID = seriesInstanceUIDArg.getValue(); \
      } \
    if( frameOfReferenceInstanceUIDArg.isSet() ) \
      { \
      frameOfReferenceInstanceUID = frameOfReferenceInstanceUIDArg.getValue(); \
      } \
    if( parametersSerializeArg.isSet() ) \
      { \
      parametersSerialize = parametersSerializeArg.getValue(); \
      } \
    if( parametersDeSerializeArg.isSet() ) \
      { \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      } \
    if( echoSwitchArg.isSet() ) \
      { \
      echoSwitch = echoSwitchArg.getValue(); \
      } \
    if( xmlSwitchArg.isSet() ) \
      { \
      xmlSwitch = xmlSwitchArg.getValue(); \
      } \
    if( processInformationAddressStringArg.isSet() ) \
      { \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      } \
    if( returnParameterFileArg.isSet() ) \
      { \
      returnParameterFile = returnParameterFileArg.getValue(); \
      } \

#define GENERATE_ECHOARGS \
if (echoSwitch) \
{ \
std::cout << "Command Line Arguments" << std::endl; \
std::cout << "    inputVolume: " << inputVolume << std::endl; \
std::cout << "    dicomDirectory: " << dicomDirectory << std::endl; \
std::cout << "    dicomPrefix: " << dicomPrefix << std::endl; \
std::cout << "    dicomNumberFormat: " << dicomNumberFormat << std::endl; \
std::cout << "    reverseImages: " << reverseImages << std::endl; \
std::cout << "    useCompression: " << useCompression << std::endl; \
std::cout << "    Type: " << Type << std::endl; \
std::cout << "    patientName: " << patientName << std::endl; \
std::cout << "    patientID: " << patientID << std::endl; \
std::cout << "    patientBirthDate: " << patientBirthDate << std::endl; \
std::cout << "    patientSex: " << patientSex << std::endl; \
std::cout << "    patientComments: " << patientComments << std::endl; \
std::cout << "    studyID: " << studyID << std::endl; \
std::cout << "    studyDate: " << studyDate << std::endl; \
std::cout << "    studyTime: " << studyTime << std::endl; \
std::cout << "    studyComments: " << studyComments << std::endl; \
std::cout << "    studyDescription: " << studyDescription << std::endl; \
std::cout << "    modality: " << modality << std::endl; \
std::cout << "    manufacturer: " << manufacturer << std::endl; \
std::cout << "    model: " << model << std::endl; \
std::cout << "    seriesNumber: " << seriesNumber << std::endl; \
std::cout << "    seriesDescription: " << seriesDescription << std::endl; \
std::cout << "    seriesDate: " << seriesDate << std::endl; \
std::cout << "    seriesTime: " << seriesTime << std::endl; \
std::cout << "    patientPosition: " << patientPosition << std::endl; \
std::cout << "    windowCenter: " << windowCenter << std::endl; \
std::cout << "    windowWidth: " << windowWidth << std::endl; \
std::cout << "    rescaleIntercept: " << rescaleIntercept << std::endl; \
std::cout << "    rescaleSlope: " << rescaleSlope << std::endl; \
std::cout << "    rescaleType: " << rescaleType << std::endl; \
std::cout << "    contentDate: " << contentDate << std::endl; \
std::cout << "    contentTime: " << contentTime << std::endl; \
std::cout << "    studyInstanceUID: " << studyInstanceUID << std::endl; \
std::cout << "    seriesInstanceUID: " << seriesInstanceUID << std::endl; \
std::cout << "    frameOfReferenceInstanceUID: " << frameOfReferenceInstanceUID << std::endl; \
std::cout << "    parametersSerialize: " << parametersSerialize << std::endl; \
std::cout << "    parametersDeSerialize: " << parametersDeSerialize << std::endl; \
std::cout << "    echoSwitch: " << echoSwitch << std::endl; \
std::cout << "    xmlSwitch: " << xmlSwitch << std::endl; \
std::cout << "    processInformationAddressString: " << processInformationAddressString << std::endl; \
std::cout << "    returnParameterFile: " << returnParameterFile << std::endl; \
}
#define GENERATE_ProcessInformationAddressDecoding \
ModuleProcessInformation *CLPProcessInformation = 0; \
if (processInformationAddressString != "") \
{ \
sscanf(processInformationAddressString.c_str(), "%p", &CLPProcessInformation); \
}
#define PARSE_ARGS GENERATE_LOGO;GENERATE_XML;GENERATE_DECLARE;GENERATE_DESERIALIZATION;GENERATE_TCLAP;GENERATE_ECHOARGS;GENERATE_ProcessInformationAddressDecoding;GENERATE_SERIALIZATION;
