// This file was automatically generated by:
//  /usr/bin/GenerateCLP --logoFiles /usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/NAMICLogo.h --InputXML /usr/src/RPM/BUILD/slicer-4.11.20210226/Modules/CLI/GrayscaleModelMaker/GrayscaleModelMaker.xml --OutputCxx /usr/src/RPM/BUILD/slicer-4.11.20210226/BUILD/Modules/CLI/GrayscaleModelMaker/GrayscaleModelMakerCLP.h
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
#include <map>

#include <sstream>
#include <fstream>
#include <stdexcept>

#include "tclap/CmdLine.h"
#include "JsonSerializationUtilities.h"
#include "ModuleProcessInformation.h"

#ifdef _WIN32
#define Module_EXPORT __declspec(dllexport)
#elif defined(MODULE_HIDDEN_VISIBILITY)
#define Module_EXPORT __attribute__((visibility("default")))
#else
#define Module_EXPORT
#endif


extern "C" {
Module_EXPORT char JSONModuleDescription[] =
"{\n"
"	\"Category\" : \"Surface Models\",\n"
"	\"Contributor\" : \"Nicole Aucoin (SPL, BWH), Bill Lorensen (GE)\",\n"
"	\"Description\" : \"Create 3D surface models from grayscale data. This module uses Marching Cubes to create an isosurface at a given threshold. The resulting surface consists of triangles that separate a volume into regions below and above the threshold. The resulting surface can be smoothed and decimated. This model works on continuous data while the module Model Maker works on labeled (or discrete) data.\",\n"
"	\"DocumentationURL\" : \"http://wiki.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/GrayscaleModelMaker\",\n"
"	\"License\" : \"slicer3\",\n"
"	\"ParameterGroups\" : \n"
"	[\n"
"		{\n"
"			\"Description\" : \"Input/output parameters\",\n"
"			\"Label\" : \"IO\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Volume containing the input grayscale data.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"0\",\n"
"					\"Label\" : \"Input Volume\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"InputVolume\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"output\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Output that contains geometry model.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"1\",\n"
"					\"Label\" : \"Output Geometry\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"OutputGeometry\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"geometry\",\n"
"					\"Value\" : \"\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Parameters used for making models.\",\n"
"			\"Label\" : \"Grayscale Model Maker Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"float\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Grayscale threshold of isosurface. The resulting surface of triangles separates the volume into voxels that lie above (inside) and below (outside) the threshold.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"t\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Threshold\",\n"
"					\"LongFlag\" : \"threshold\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Threshold\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"float\",\n"
"					\"Value\" : \"100.0\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Name to use for this model.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"n\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Model Name\",\n"
"					\"LongFlag\" : \"name\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Name\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"Model\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Number of smoothing iterations. If 0, no smoothing will be done.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Smooth\",\n"
"					\"LongFlag\" : \"smooth\",\n"
"					\"Maximum\" : \"50\",\n"
"					\"Minimum\" : \"0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Smooth\",\n"
"					\"Step\" : \"1\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"15\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"float\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Target reduction during decimation, as a decimal percentage reduction in the number of polygons. If 0, no decimation will be done.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Decimate\",\n"
"					\"LongFlag\" : \"decimate\",\n"
"					\"Maximum\" : \"1.0\",\n"
"					\"Minimum\" : \"0.0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Decimate\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"float\",\n"
"					\"Value\" : \"0.25\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Splitting normals is useful for visualizing sharp features. However it creates holes in surfaces which affect measurements\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Split Normals?\",\n"
"					\"LongFlag\" : \"splitnormals\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"SplitNormals\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"true\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Calculate the point normals? Calculated point normals make the surface appear smooth. Without point normals, the surface will appear faceted.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Compute Point Normals?\",\n"
"					\"LongFlag\" : \"pointnormals\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"PointNormals\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"true\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"\",\n"
"			\"Label\" : \"Advanced\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Turn this flag on to log more details during execution.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"d\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Debug\",\n"
"					\"LongFlag\" : \"debug\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Debug\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"false\"\n"
"				}\n"
"			]\n"
"		}\n"
"	],\n"
"	\"Title\" : \"Grayscale Model Maker\",\n"
"	\"Version\" : \"3.0\"\n"
"}\n"
"\n"
;
}
#define GENERATE_DESERIALIZATION \
    if (argc >= 2) \
      { \
      for (int arg_idx = 0; arg_idx < argc; ++arg_idx) \
        { \
        if (strcmp(argv[arg_idx],"--deserialize") == 0) \
          { \
          std::ifstream fStream( argv[arg_idx+1] ); \
          if( !fStream.is_open() ) \
            { \
            std::cerr << "Could not open file: " << argv[arg_idx+1] << " for writing." << std::endl; \
            return EXIT_FAILURE; \
            } \
          Json::Value root; \
          Json::Reader reader; \
          reader.parse( fStream, root ); \
          const Json::Value & parameters = root["Parameters"]; \
          if (!parameters["IO"]["InputVolume"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["InputVolume"].asString()); \
            } \
          if (!parameters["IO"]["OutputGeometry"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["OutputGeometry"].asString()); \
            } \
          if (!parameters["Grayscale Model Maker Parameters"]["Threshold"].isNull()) \
            { \
            Json::Value param = parameters["Grayscale Model Maker Parameters"]["Threshold"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--threshold"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--threshold"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Grayscale Model Maker Parameters"]["Name"].isNull()) \
            { \
            Json::Value param = parameters["Grayscale Model Maker Parameters"]["Name"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--name"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--name"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Grayscale Model Maker Parameters"]["Smooth"].isNull()) \
            { \
            Json::Value param = parameters["Grayscale Model Maker Parameters"]["Smooth"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--smooth"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--smooth"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Grayscale Model Maker Parameters"]["Decimate"].isNull()) \
            { \
            Json::Value param = parameters["Grayscale Model Maker Parameters"]["Decimate"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--decimate"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--decimate"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Grayscale Model Maker Parameters"]["SplitNormals"].isNull()) \
            { \
            if (parameters["Grayscale Model Maker Parameters"]["SplitNormals"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--splitnormals"); \
              } \
            } \
          if (!parameters["Grayscale Model Maker Parameters"]["PointNormals"].isNull()) \
            { \
            if (parameters["Grayscale Model Maker Parameters"]["PointNormals"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--pointnormals"); \
              } \
            } \
          if (!parameters["Advanced"]["Debug"].isNull()) \
            { \
            if (parameters["Advanced"]["Debug"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--debug"); \
              } \
            } \
          } \
        } \
      }
#define GENERATE_SERIALIZATION \
    if( parametersSerializeArg.isSet() ) \
      { \
      Json::Value root; \
      Json::Value & parameters = root["Parameters"]; \
        { \
        Json::Value & parameterGroup = parameters["IO"]; \
        parameterGroup["InputVolume"] = JsonSerialize( InputVolume ); \
        parameterGroup["OutputGeometry"] = JsonSerialize( OutputGeometry ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Grayscale Model Maker Parameters"]; \
        parameterGroup["Threshold"] = JsonSerialize( Threshold ); \
        parameterGroup["Name"] = JsonSerialize( Name ); \
        parameterGroup["Smooth"] = JsonSerialize( Smooth ); \
        parameterGroup["Decimate"] = JsonSerialize( Decimate ); \
        parameterGroup["SplitNormals"] = JsonSerialize( SplitNormals ); \
        parameterGroup["PointNormals"] = JsonSerialize( PointNormals ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Advanced"]; \
        parameterGroup["Debug"] = JsonSerialize( Debug ); \
        } \
      std::ofstream fStream( parametersSerializeArg.getValue().c_str() ); \
      if( !fStream.is_open() ) \
        { \
        std::cerr << "Could not open file: " << parametersSerializeArg.getValue() << " for writing." << std::endl; \
        return EXIT_FAILURE; \
        } \
      Json::StyledStreamWriter writer; \
      writer.write( fStream, root ); \
      fStream.close(); \
      }
#if defined(main) && !defined(REGISTER_TEST)
// If main defined as a preprocessor symbol, redefine it to the expected entry point.
#undef main
#define main ModuleEntryPoint

extern "C" {
  Module_EXPORT char *GetXMLModuleDescription();
  Module_EXPORT int ModuleEntryPoint(int, char*[]);
  Module_EXPORT unsigned char *GetModuleLogo(int *width, int *height, int *pixel_size, unsigned long *bufferLength);
}
#endif

extern "C" {
Module_EXPORT char XMLModuleDescription[] = 
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<executable>\n"
"  <category>Surface Models</category>\n"
"  <title>Grayscale Model Maker</title>\n"
"  <description><![CDATA[Create 3D surface models from grayscale data. This module uses Marching Cubes to create an isosurface at a given threshold. The resulting surface consists of triangles that separate a volume into regions below and above the threshold. The resulting surface can be smoothed and decimated. This model works on continuous data while the module Model Maker works on labeled (or discrete) data.]]></description>\n"
"  <version>3.0</version>\n"
"  <documentation-url>http://wiki.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/GrayscaleModelMaker</documentation-url>\n"
"  <license>slicer3</license>\n"
"  <contributor>Nicole Aucoin (SPL, BWH), Bill Lorensen (GE)</contributor>\n"
"  <acknowledgements><![CDATA[This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health through the NIH Roadmap for Medical Research, Grant U54 EB005149.]]></acknowledgements>\n"
"  <parameters>\n"
"    <label>IO</label>\n"
"    <description><![CDATA[Input/output parameters]]></description>\n"
"    <image>\n"
"      <name>InputVolume</name>\n"
"      <label>Input Volume</label>\n"
"      <channel>input</channel>\n"
"      <index>0</index>\n"
"      <description><![CDATA[Volume containing the input grayscale data.]]></description>\n"
"    </image>\n"
"    <geometry reference=\"InputVolume\">\n"
"      <name>OutputGeometry</name>\n"
"      <label>Output Geometry</label>\n"
"      <channel>output</channel>\n"
"      <index>1</index>\n"
"      <description><![CDATA[Output that contains geometry model.]]></description>\n"
"    </geometry>\n"
"  </parameters>\n"
"  <parameters>\n"
"    <label>Grayscale Model Maker Parameters</label>\n"
"    <description><![CDATA[Parameters used for making models.]]></description>\n"
"    <float>\n"
"      <name>Threshold</name>\n"
"      <flag>-t</flag>\n"
"      <longflag>--threshold</longflag>\n"
"      <description><![CDATA[Grayscale threshold of isosurface. The resulting surface of triangles separates the volume into voxels that lie above (inside) and below (outside) the threshold.]]></description>\n"
"      <label>Threshold</label>\n"
"      <default>100.0</default>\n"
"    </float>\n"
"    <string>\n"
"      <name>Name</name>\n"
"      <label>Model Name</label>\n"
"      <flag>-n</flag>\n"
"      <longflag>--name</longflag>\n"
"      <description><![CDATA[Name to use for this model.]]></description>\n"
"      <default>Model</default>\n"
"    </string>\n"
"    <integer>\n"
"      <name>Smooth</name>\n"
"      <label>Smooth</label>\n"
"      <longflag>--smooth</longflag>\n"
"      <description><![CDATA[Number of smoothing iterations. If 0, no smoothing will be done.]]></description>\n"
"      <default>15</default>\n"
"      <constraints>\n"
"        <minimum>0</minimum>\n"
"        <maximum>50</maximum>\n"
"        <step>1</step>\n"
"      </constraints>\n"
"    </integer>\n"
"    <float>\n"
"      <name>Decimate</name>\n"
"      <label>Decimate</label>\n"
"      <longflag>--decimate</longflag>\n"
"      <description><![CDATA[Target reduction during decimation, as a decimal percentage reduction in the number of polygons. If 0, no decimation will be done.]]></description>\n"
"      <default>0.25</default>\n"
"      <constraints>\n"
"        <minimum>0.0</minimum>\n"
"        <maximum>1.0</maximum>\n"
"      </constraints>\n"
"    </float>\n"
"    <boolean>\n"
"      <name>SplitNormals</name>\n"
"      <label>Split Normals?</label>\n"
"      <longflag>--splitnormals</longflag>\n"
"      <description><![CDATA[Splitting normals is useful for visualizing sharp features. However it creates holes in surfaces which affect measurements]]></description>\n"
"      <default>true</default>\n"
"    </boolean>\n"
"    <boolean>\n"
"      <name>PointNormals</name>\n"
"      <label>Compute Point Normals?</label>\n"
"      <longflag>--pointnormals</longflag>\n"
"      <description><![CDATA[Calculate the point normals? Calculated point normals make the surface appear smooth. Without point normals, the surface will appear faceted.]]></description>\n"
"      <default>true</default>\n"
"    </boolean>\n"
"  </parameters>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Advanced</label>\n"
"    <boolean>\n"
"      <name>Debug</name>\n"
"      <label>Debug</label>\n"
"      <description><![CDATA[Turn this flag on to log more details during execution.]]></description>\n"
"      <flag>-d</flag>\n"
"      <longflag>--debug</longflag>\n"
"      <default>false</default>\n"
"    </boolean>\n"
"  </parameters>\n"
"</executable>\n"
"\n"
;

#define static Module_EXPORT
#define const
#define image_NAMICLogo_width ModuleLogoWidth
#define image_NAMICLogo_height ModuleLogoHeight
#define image_NAMICLogo_pixel_size ModuleLogoPixelSize
#define image_NAMICLogo_length ModuleLogoLength
#define image_NAMICLogo ModuleLogoImage
#include "/usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/NAMICLogo.h"
#undef static
#undef const
#undef image_NAMICLogo_width
#undef image_NAMICLogo_height
#undef image_NAMICLogo_pixel_size
#undef image_NAMICLogo_length
#undef image_NAMICLogo
}

void
splitString (const std::string &text,
             const std::string &separators,
             std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  std::string::size_type start = text.find_first_not_of(separators);
  while (start < n)
    {
    std::string::size_type stop = text.find_first_of(separators, start);
    if (stop > n) stop = n;
    words.push_back(text.substr(start, stop - start));
    start = text.find_first_not_of(separators, stop+1);
    }
}

void
splitFilenames (const std::string &text,
                std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  bool quoted;
  std::string comma(",");
  std::string quote("\"");
  std::string::size_type start = text.find_first_not_of(comma);
  while (start < n)
    {
    quoted = false;
    std::string::size_type startq = text.find_first_of(quote, start);
    std::string::size_type stopq = text.find_first_of(quote, startq+1);
    std::string::size_type stop = text.find_first_of(comma, start);
    if (stop > n) stop = n;
    if (startq != std::string::npos && stopq != std::string::npos)
      {
      while (startq < stop && stop < stopq && stop != n)
         {
         quoted = true;
         stop = text.find_first_of(comma, stop+1);
         if (stop > n) stop = n;
         }
      }
    if (!quoted)
      {
      words.push_back(text.substr(start, stop - start));
      }
    else
      {
      words.push_back(text.substr(start+1, stop - start-2));
      }
    start = text.find_first_not_of(comma, stop+1);
    }
}

unsigned char *GetModuleLogo(int *width,
                             int *height,
                             int *pixel_size,
                             unsigned long *length)
{
  *width = ModuleLogoWidth;
  *height = ModuleLogoHeight;
  *pixel_size = ModuleLogoPixelSize;
  *length = ModuleLogoLength;
  return const_cast<unsigned char *>(ModuleLogoImage);
}

char *GetXMLModuleDescription()
{
   return XMLModuleDescription;
}

#define GENERATE_LOGO \
  if (argc >= 2 && (strcmp(argv[1],"--logo") == 0)) \
    { \
    int width, height, pixel_size;     \
    unsigned long length;  \
    unsigned char *logo = GetModuleLogo(&width, &height, &pixel_size, &length);  \
    std::cout << "LOGO" << std::endl;  \
    std::cout << width << std::endl;  \
    std::cout << height << std::endl;  \
    std::cout << pixel_size << std::endl;  \
    std::cout << length << std::endl;  \
    std::cout << logo << std::endl;  \
    return EXIT_SUCCESS;  \
    }
#define GENERATE_XML \
  if (argc >= 2 && (strcmp(argv[1],"--xml") == 0)) \
    { \
    std::cout << GetXMLModuleDescription(); \
    return EXIT_SUCCESS; \
    }
#define GENERATE_DECLARE \
    /* These two vectors are used to store the JSON deserialized value */ \
    /* that are then compiled with the command line. */ \
    std::vector< std::string > deserializedVectorFlaggedArgs; \
    std::vector< std::string > deserializedVectorPositionalArgs; \
    /* This map is used to store the JSON deserialized value of multiple args*/ \
    /* where the key is the argument flag and the value the values of each arg. */ \
    std::map< std::string, std::vector<std::string> > deserializedMultipleArgsMap; \
 \
    /* This vector is used to look up if a flag requires an argument after it. */ \
    /* This is used to differentiate between: */ \
    /* ./myExec --boolFlag /my/first/arg */ \
    /* ./myExec --flag flagArg */ \
    std::vector< std::string > nonbooleanFlags; \
    nonbooleanFlags.push_back("-t"); \
    nonbooleanFlags.push_back("--threshold"); \
    nonbooleanFlags.push_back("-n"); \
    nonbooleanFlags.push_back("--name"); \
    nonbooleanFlags.push_back("--smooth"); \
    nonbooleanFlags.push_back("--decimate"); \
    nonbooleanFlags.push_back("--serialize"); \
    nonbooleanFlags.push_back("--deserialize"); \
    nonbooleanFlags.push_back("--processinformationaddress"); \
    nonbooleanFlags.push_back("--returnparameterfile"); \
    /* This map use is twofold: */ \
    /*  - to find whether a flag is multiple */ \
    /*  - to know if we need to reset the multiple arg value because it was */ \
    /*    in the JSON and it's also in the command line. */ \
    std::map<std::string, bool> multipleFlags; \
    std::string InputVolume; \
    std::string OutputGeometry; \
    float Threshold = 100.0; \
    std::string Name = "Model"; \
    int Smooth = 15; \
    float Decimate = 0.25; \
    bool SplitNormals = false; \
    bool PointNormals = false; \
    bool Debug = false; \
    std::string parametersSerialize; \
    std::string parametersDeSerialize; \
    bool echoSwitch = false; \
    bool xmlSwitch = false; \
    std::string processInformationAddressString = "0"; \
    std::string returnParameterFile; \

#define GENERATE_TCLAP_PARSE \
    std::string fullDescription("Description: "); \
    fullDescription += "Create 3D surface models from grayscale data. This module uses Marching Cubes to create an isosurface at a given threshold. The resulting surface consists of triangles that separate a volume into regions below and above the threshold. The resulting surface can be smoothed and decimated. This model works on continuous data while the module Model Maker works on labeled (or discrete) data."; \
    if (!std::string("Nicole Aucoin (SPL, BWH), Bill Lorensen (GE)").empty()) \
      { \
      fullDescription += "\nAuthor(s): Nicole Aucoin (SPL, BWH), Bill Lorensen (GE)"; \
      } \
    if (!std::string("This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health through the NIH Roadmap for Medical Research, Grant U54 EB005149.").empty()) \
      { \
      fullDescription += "\nAcknowledgements: This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health through the NIH Roadmap for Medical Research, Grant U54 EB005149."; \
      } \
    TCLAP::CmdLine commandLine (fullDescription, \
       ' ', \
      "3.0" ); \
 \
      std::ostringstream msg; \
    msg.str("");msg << "Volume containing the input grayscale data.";    TCLAP::UnlabeledValueArg<std::string> InputVolumeArg("InputVolume", msg.str(), 1, InputVolume, "std::string", commandLine); \
 \
    msg.str("");msg << "Output that contains geometry model.";    TCLAP::UnlabeledValueArg<std::string> OutputGeometryArg("OutputGeometry", msg.str(), 1, OutputGeometry, "std::string", commandLine); \
 \
    msg.str("");msg << "Grayscale threshold of isosurface. The resulting surface of triangles separates the volume into voxels that lie above (inside) and below (outside) the threshold. (value: " << Threshold << ")"; \
    TCLAP::ValueArg<float > ThresholdArg("t", "threshold", msg.str(), 0, Threshold, "float", commandLine); \
 \
    msg.str("");msg << "Name to use for this model. (value: " << Name << ")"; \
    TCLAP::ValueArg<std::string > NameArg("n", "name", msg.str(), 0, Name, "std::string", commandLine); \
 \
    msg.str("");msg << "Number of smoothing iterations. If 0, no smoothing will be done. (value: " << Smooth << ")"; \
    TCLAP::ValueArg<int > SmoothArg("", "smooth", msg.str(), 0, Smooth, "int", commandLine); \
 \
    msg.str("");msg << "Target reduction during decimation, as a decimal percentage reduction in the number of polygons. If 0, no decimation will be done. (value: " << Decimate << ")"; \
    TCLAP::ValueArg<float > DecimateArg("", "decimate", msg.str(), 0, Decimate, "float", commandLine); \
 \
    msg.str("");msg << "Splitting normals is useful for visualizing sharp features. However it creates holes in surfaces which affect measurements (value: " << SplitNormals << ")"; \
    TCLAP::SwitchArg SplitNormalsArg("", "splitnormals", msg.str(), commandLine, SplitNormals); \
 \
    msg.str("");msg << "Calculate the point normals? Calculated point normals make the surface appear smooth. Without point normals, the surface will appear faceted. (value: " << PointNormals << ")"; \
    TCLAP::SwitchArg PointNormalsArg("", "pointnormals", msg.str(), commandLine, PointNormals); \
 \
    msg.str("");msg << "Turn this flag on to log more details during execution. (value: " << Debug << ")"; \
    TCLAP::SwitchArg DebugArg("d", "debug", msg.str(), commandLine, Debug); \
 \
    msg.str("");msg << "Store the module's parameters to a file.";    TCLAP::ValueArg<std::string > parametersSerializeArg("", "serialize", msg.str(), 0, parametersSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Restore the module's parameters that were previously archived.";    TCLAP::ValueArg<std::string > parametersDeSerializeArg("", "deserialize", msg.str(), 0, parametersDeSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Echo the command line arguments (value: " << echoSwitch << ")"; \
    TCLAP::SwitchArg echoSwitchArg("", "echo", msg.str(), commandLine, echoSwitch); \
 \
    msg.str("");msg << "Produce xml description of command line arguments (value: " << xmlSwitch << ")"; \
    TCLAP::SwitchArg xmlSwitchArg("", "xml", msg.str(), commandLine, xmlSwitch); \
 \
    msg.str("");msg << "Address of a structure to store process information (progress, abort, etc.). (value: " << processInformationAddressString << ")"; \
    TCLAP::ValueArg<std::string > processInformationAddressStringArg("", "processinformationaddress", msg.str(), 0, processInformationAddressString, "std::string", commandLine); \
 \
    msg.str("");msg << "Filename in which to write simple return parameters (int, float, int-vector, etc.) as opposed to bulk return parameters (image, geometry, transform, measurement, table).";    TCLAP::ValueArg<std::string > returnParameterFileArg("", "returnparameterfile", msg.str(), 0, returnParameterFile, "std::string", commandLine); \
 \
try \
  { \
    /* Build a map of flag aliases to the true flag */ \
    std::map<std::string,std::string> flagAliasMap; \
    std::map<std::string,std::string> deprecatedFlagAliasMap; \
    std::map<std::string,std::string> longFlagAliasMap; \
    std::map<std::string,std::string> deprecatedLongFlagAliasMap; \
 \
    /* Go through argc and consolidate the JSON with the parameters from the command line */ \
    /* In case of conflict, take the command line. */ \
    std::map<std::string,std::string>::iterator ait; \
    std::map<std::string,std::string>::iterator dait; \
    std::vector<std::string>::iterator dvOptionnalArgsIt = deserializedVectorFlaggedArgs.begin(); \
    std::map<std::string, std::vector<std::string> >::iterator dvMultipleArgsIt; \
    size_t noFlagCounter = 0; \
    size_t ac = 1; \
 \
    while (ac < static_cast<size_t>(argc)) \
      { \
      /* short flag case && long flag case */ \
       if ((strlen(argv[ac]) == 2 && argv[ac][0]=='-') \
           || (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]=='-')) \
         { \
         std::string flag = argv[ac]; \
         /* Remap the flag if necessary */ \
         if (strlen(argv[ac]) == 2) \
           { \
           /* Short flag remapping */ \
           ait = flagAliasMap.find(flag); \
           dait = deprecatedFlagAliasMap.find(flag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << flag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         else \
           { \
           /* Long flag remapping */ \
           ait = longFlagAliasMap.find(flag); \
           dait = deprecatedLongFlagAliasMap.find(flag); \
           if (ait != longFlagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedLongFlagAliasMap.end()) \
             { \
             std::cout << "Long flag \"" << flag << "\" is deprecated. Please use long flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         bool isMultiple = multipleFlags.find(flag) != multipleFlags.end(); \
         bool isBoolean = std::find(nonbooleanFlags.begin(), nonbooleanFlags.end(), flag) == nonbooleanFlags.end(); \
         dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), flag); \
         bool isPresentVFA = dvOptionnalArgsIt != deserializedVectorFlaggedArgs.end(); \
         if (isBoolean) \
           { \
           /*Ignore if boolean and already present*/ \
           /*Otherwise add it*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           } \
         else if (isMultiple) \
           { \
           dvMultipleArgsIt = deserializedMultipleArgsMap.find(flag); \
           bool isPresentMA = dvMultipleArgsIt != deserializedMultipleArgsMap.end(); \
           /*Ignore if boolean and already present*/ \
           /*Reset/Add the value if first deserialize or not present*/ \
           if (!isPresentMA || !multipleFlags[flag]) \
             { \
             deserializedMultipleArgsMap[flag] = std::vector<std::string>(); \
             multipleFlags[flag] = true; \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           deserializedMultipleArgsMap[flag].push_back(value); \
           } \
         else \
           { \
           /*Add the flag and if needed*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(value);  \
             } \
           else \
             { \
             *(++dvOptionnalArgsIt) = value; \
             } \
           } \
         } \
       /* short flag case where multiple flags are given at once */ \
       else if (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]!='-') \
         { \
         std::string rflag(argv[ac], 1, std::string::npos); \
         for (std::string::size_type fi=0; fi < rflag.size(); ++fi) \
           { \
           std::string tf(rflag, fi, 1); \
           std::string newFlag ="-"; \
           newFlag += tf; \
           ait = flagAliasMap.find(newFlag); \
           dait = deprecatedFlagAliasMap.find(newFlag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             newFlag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << newFlag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             newFlag = (*dait).second; \
             } \
           dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), newFlag); \
           /*These flags are always boolean, just add it if it's not there already */ \
           if (dvOptionnalArgsIt == deserializedVectorFlaggedArgs.end()) \
             { \
             deserializedVectorFlaggedArgs.push_back(newFlag); \
             } \
           } \
         ++ac; \
         } \
       else \
         { \
         /* Replace if needed, otherwise append.*/ \
         if (noFlagCounter < deserializedVectorPositionalArgs.size()) \
           { \
           deserializedVectorPositionalArgs[noFlagCounter] = argv[ac]; \
           } \
         else \
           { \
           deserializedVectorPositionalArgs.push_back(argv[ac]); \
           } \
         ++ac; \
         ++noFlagCounter; \
         } \
       } \
 \
    /* Put the now compiled arguments in the argvVector */ \
    std::vector<std::string> argvVector; \
    argvVector.push_back(argv[0]); \
    argvVector.insert(argvVector.end(), deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end()); \
    std::map<std::string, std::vector<std::string> >::iterator mavit; \
    for (mavit = deserializedMultipleArgsMap.begin(); mavit != deserializedMultipleArgsMap.end(); ++mavit) \
      { \
      for (size_t i = 0; i < mavit->second.size(); ++i) \
        { \
        argvVector.push_back(mavit->first); \
        argvVector.push_back(mavit->second.at(i)); \
        } \
      } \
    argvVector.insert(argvVector.end(), deserializedVectorPositionalArgs.begin(), deserializedVectorPositionalArgs.end()); \
 \
   /* Remap args to a structure that CmdLine::parse() can understand*/ \
   std::vector<char*> vargs; \
   for (ac = 0; ac < argvVector.size(); ++ac) \
     {  \
     vargs.push_back(const_cast<char *>(argvVector[ac].c_str())); \
     } \
    commandLine.parse ( static_cast<int>(vargs.size()), (char**) &(vargs[0]) ); \
  } \
catch ( TCLAP::ArgException & e ) \
  { \
  std::cerr << "error: " << e.error() << " for arg " << e.argId() << std::endl; \
  return ( EXIT_FAILURE ); \
  }
#define GENERATE_TCLAP_ASSIGNMENT \
      InputVolume = InputVolumeArg.getValue(); \
      OutputGeometry = OutputGeometryArg.getValue(); \
      Threshold = ThresholdArg.getValue(); \
      Name = NameArg.getValue(); \
      Smooth = SmoothArg.getValue(); \
      Decimate = DecimateArg.getValue(); \
      SplitNormals = SplitNormalsArg.getValue(); \
      PointNormals = PointNormalsArg.getValue(); \
      Debug = DebugArg.getValue(); \
      parametersSerialize = parametersSerializeArg.getValue(); \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      echoSwitch = echoSwitchArg.getValue(); \
      xmlSwitch = xmlSwitchArg.getValue(); \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      returnParameterFile = returnParameterFileArg.getValue(); \

#define GENERATE_TCLAP GENERATE_TCLAP_PARSE;GENERATE_TCLAP_ASSIGNMENT
#define GENERATE_TCLAP_ASSIGNMENT_IFSET \
    if( InputVolumeArg.isSet() ) \
      { \
      InputVolume = InputVolumeArg.getValue(); \
      } \
    if( OutputGeometryArg.isSet() ) \
      { \
      OutputGeometry = OutputGeometryArg.getValue(); \
      } \
    if( ThresholdArg.isSet() ) \
      { \
      Threshold = ThresholdArg.getValue(); \
      } \
    if( NameArg.isSet() ) \
      { \
      Name = NameArg.getValue(); \
      } \
    if( SmoothArg.isSet() ) \
      { \
      Smooth = SmoothArg.getValue(); \
      } \
    if( DecimateArg.isSet() ) \
      { \
      Decimate = DecimateArg.getValue(); \
      } \
    if( SplitNormalsArg.isSet() ) \
      { \
      SplitNormals = SplitNormalsArg.getValue(); \
      } \
    if( PointNormalsArg.isSet() ) \
      { \
      PointNormals = PointNormalsArg.getValue(); \
      } \
    if( DebugArg.isSet() ) \
      { \
      Debug = DebugArg.getValue(); \
      } \
    if( parametersSerializeArg.isSet() ) \
      { \
      parametersSerialize = parametersSerializeArg.getValue(); \
      } \
    if( parametersDeSerializeArg.isSet() ) \
      { \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      } \
    if( echoSwitchArg.isSet() ) \
      { \
      echoSwitch = echoSwitchArg.getValue(); \
      } \
    if( xmlSwitchArg.isSet() ) \
      { \
      xmlSwitch = xmlSwitchArg.getValue(); \
      } \
    if( processInformationAddressStringArg.isSet() ) \
      { \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      } \
    if( returnParameterFileArg.isSet() ) \
      { \
      returnParameterFile = returnParameterFileArg.getValue(); \
      } \

#define GENERATE_ECHOARGS \
if (echoSwitch) \
{ \
std::cout << "Command Line Arguments" << std::endl; \
std::cout << "    InputVolume: " << InputVolume << std::endl; \
std::cout << "    OutputGeometry: " << OutputGeometry << std::endl; \
std::cout << "    Threshold: " << Threshold << std::endl; \
std::cout << "    Name: " << Name << std::endl; \
std::cout << "    Smooth: " << Smooth << std::endl; \
std::cout << "    Decimate: " << Decimate << std::endl; \
std::cout << "    SplitNormals: " << SplitNormals << std::endl; \
std::cout << "    PointNormals: " << PointNormals << std::endl; \
std::cout << "    Debug: " << Debug << std::endl; \
std::cout << "    parametersSerialize: " << parametersSerialize << std::endl; \
std::cout << "    parametersDeSerialize: " << parametersDeSerialize << std::endl; \
std::cout << "    echoSwitch: " << echoSwitch << std::endl; \
std::cout << "    xmlSwitch: " << xmlSwitch << std::endl; \
std::cout << "    processInformationAddressString: " << processInformationAddressString << std::endl; \
std::cout << "    returnParameterFile: " << returnParameterFile << std::endl; \
}
#define GENERATE_ProcessInformationAddressDecoding \
ModuleProcessInformation *CLPProcessInformation = 0; \
if (processInformationAddressString != "") \
{ \
sscanf(processInformationAddressString.c_str(), "%p", &CLPProcessInformation); \
}
#define PARSE_ARGS GENERATE_LOGO;GENERATE_XML;GENERATE_DECLARE;GENERATE_DESERIALIZATION;GENERATE_TCLAP;GENERATE_ECHOARGS;GENERATE_ProcessInformationAddressDecoding;GENERATE_SERIALIZATION;
