// This file was automatically generated by:
//  /usr/bin/GenerateCLP --logoFiles /usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/NAMICLogo.h --InputXML /usr/src/RPM/BUILD/slicer-4.11.20210226/Modules/CLI/ModelMaker/ModelMaker.xml --OutputCxx /usr/src/RPM/BUILD/slicer-4.11.20210226/BUILD/Modules/CLI/ModelMaker/ModelMakerCLP.h
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
#include <map>

#include <sstream>
#include <fstream>
#include <stdexcept>

#include "tclap/CmdLine.h"
#include "JsonSerializationUtilities.h"
#include "ModuleProcessInformation.h"

#ifdef _WIN32
#define Module_EXPORT __declspec(dllexport)
#elif defined(MODULE_HIDDEN_VISIBILITY)
#define Module_EXPORT __attribute__((visibility("default")))
#else
#define Module_EXPORT
#endif


extern "C" {
Module_EXPORT char JSONModuleDescription[] =
"{\n"
"	\"Category\" : \"Surface Models\",\n"
"	\"Contributor\" : \"Nicole Aucoin (SPL, BWH), Ron Kikinis (SPL, BWH), Bill Lorensen (GE)\",\n"
"	\"Description\" : \"Create 3D surface models from segmented data.<p>Models are imported into Slicer under a model hierarchy node in a MRML scene. The model colors are set by the color table associated with the input volume (these colours will only be visible if you load the model scene file).</p><p><b>IO:</b></p><p>Specify an <i>Input Volume</i> that is a segmented label map volume. Create a new <i>Models</i> hierarchy to provide a structure to contain the return models created from the input volume.</p><p><b>Create Multiple:</b></p><p>If you specify a list of <i>Labels</i>, it will over ride any start/end label settings.</p><p>If you click <i>Generate All</i> it will over ride the list of labels and any start/end label settings.</p><p><b>Model Maker Parameters:</b></p><p>You can set the number of smoothing iterations, target reduction in number of polygons (decimal percentage). Use 0 and 1 if you wish no smoothing nor decimation.<br>You can set the flags to split normals or generate point normals in this pane as well.<br>You can save a copy of the models after intermediate steps (marching cubes, smoothing, and decimation if not joint smoothing, otherwise just after decimation); these models are not saved in the mrml file, turn off deleting temporary files first in the python window:<br><i>slicer.modules.modelmaker.cliModuleLogic().DeleteTemporaryFilesOff()</i></p>\",\n"
"	\"DocumentationURL\" : \"http://wiki.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/ModelMaker\",\n"
"	\"License\" : \"slicer4\",\n"
"	\"ParameterGroups\" : \n"
"	[\n"
"		{\n"
"			\"Description\" : \"Input/output parameters\",\n"
"			\"Label\" : \"IO\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Input label map. The Input Volume drop down menu is populated with the label map volumes that are present in the scene, select one from which to generate models.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"0\",\n"
"					\"Label\" : \"Input Volume\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"InputVolume\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Color table to make labels to colors and objects\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"\",\n"
"					\"LongFlag\" : \"color\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"ColorTable\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"table\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"output\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Generated models, under a model hierarchy node. Models are imported into Slicer under a model hierarchy node, and their colors are set by the color table associated with the input label map volume. The model hierarchy node must be created before running the model maker, by selecting Create New ModelHierarchy from the Models drop down menu. If you're running from the command line, a model hierarchy node in a new mrml scene will be created for you.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Models\",\n"
"					\"LongFlag\" : \"modelSceneFile\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"true\",\n"
"					\"Name\" : \"ModelSceneFile\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"geometry\",\n"
"					\"Value\" : \"models.mrml\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Create more than one model at the same time, used for continuous ranges of labels.\",\n"
"			\"Label\" : \"Create Multiple\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Name to use for this model. Any text entered in the entry box will be the starting string for the created model file names. The label number and the color name will also be part of the file name. If making multiple models, use this as a prefix to the label and color name.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"n\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Model Name\",\n"
"					\"LongFlag\" : \"name\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Name\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string\",\n"
"					\"Value\" : \"Model\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Generate models for all labels in the input volume. select this option if you want to create all models that correspond to all values in a labelmap volume (using the Joint Smoothing option below is useful with this option). Ignores Labels, Start Label, End Label settings. Skips label 0.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Generate All Models\",\n"
"					\"LongFlag\" : \"generateAll\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"GenerateAll\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"true\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Parameters used for making models.\",\n"
"			\"Label\" : \"Model Maker Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::vector<int>\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"A comma separated list of label values from which to make models. f you specify a list of Labels, it will override any start/end label settings. If you click Generate All Models it will override the list of labels and any start/end label settings.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"l\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Labels\",\n"
"					\"LongFlag\" : \"labels\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Labels\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer-vector\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"If you want to specify a continuous range of labels from which to generate models, enter the lower label here. Voxel value from which to start making models. Used instead of the label list to specify a range (make sure the label list is empty or it will over ride this).\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"s\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Start Label\",\n"
"					\"LongFlag\" : \"start\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"StartLabel\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"-1\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"If you want to specify a continuous range of labels from which to generate models, enter the higher label here. Voxel value up to which to continue making models. Skip any values with zero voxels.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"e\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"End Label\",\n"
"					\"LongFlag\" : \"end\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"EndLabel\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"-1\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Select this to not generate models from labels that do not have names defined in the color look up table associated with the input label map. If true, only models which have an entry in the color table will be generated.  If false, generate all models that exist within the label range.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Skip Un-Named Labels\",\n"
"					\"LongFlag\" : \"skipUnNamed\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"SkipUnNamed\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"true\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"This will ensure that all resulting models fit together smoothly, like jigsaw puzzle pieces. Otherwise the models will be smoothed independently and may overlap.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"j\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Joint Smoothing\",\n"
"					\"LongFlag\" : \"jointsmooth\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"JointSmoothing\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"false\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Here you can set the number of smoothing iterations for Laplacian smoothing, or the degree of the polynomial approximating the windowed Sinc function. Use 0 if you wish no smoothing.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Smooth\",\n"
"					\"LongFlag\" : \"smooth\",\n"
"					\"Maximum\" : \"100\",\n"
"					\"Minimum\" : \"0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Smooth\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"10\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"You can control the type of smoothing done on the models by selecting a filter type of either Sinc or Laplacian.\",\n"
"					\"Elements\" : [ \"Sinc\", \"Laplacian\" ],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Filter Type\",\n"
"					\"LongFlag\" : \"filtertype\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"FilterType\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"string-enumeration\",\n"
"					\"Value\" : \"Sinc\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"float\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Chose the target reduction in number of polygons as a decimal percentage (between 0 and 1) of the number of polygons. Specifies the percentage of triangles to be removed. For example, 0.1 means 10% reduction and 0.9 means 90% reduction.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Decimate\",\n"
"					\"LongFlag\" : \"decimate\",\n"
"					\"Maximum\" : \"1.0\",\n"
"					\"Minimum\" : \"0.0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Decimate\",\n"
"					\"Step\" : \"0.01\",\n"
"					\"Tag\" : \"float\",\n"
"					\"Value\" : \"0.25\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Splitting normals is useful for visualizing sharp features. However it creates holes in surfaces which affects measurements.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Split Normals\",\n"
"					\"LongFlag\" : \"splitnormals\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"SplitNormals\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"true\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Turn this flag on if you wish to calculate the normal vectors for the points.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Point Normals\",\n"
"					\"LongFlag\" : \"pointnormals\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"PointNormals\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"true\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Pad the input volume with zero value voxels on all 6 faces in order to ensure the production of closed surfaces. Sets the origin translation and extent translation so that the models still line up with the unpadded input volume.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Pad\",\n"
"					\"LongFlag\" : \"pad\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"Pad\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"true\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"\",\n"
"			\"Label\" : \"Debug\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"A mrml file that contains a template model hierarchy tree with a hierarchy node per color used in the input volume's color table. Color names used for the models are matched to template hierarchy names to create a multi level output tree. Create a hierarchy in the Models GUI and save a scene, then clean it up to remove everything but the model hierarchy and display nodes.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Color Hierarchy\",\n"
"					\"LongFlag\" : \"modelHierarchyFile\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"ModelHierarchyFile\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"file\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"You can save a copy of the models after each of the intermediate steps (marching cubes, smoothing, and decimation if not joint smoothing, otherwise just after decimation). These intermediate models are not saved in the mrml file, you have to load them manually after turning off deleting temporary files in they python console (View ->Python Interactor) using the following command slicer.modules.modelmaker.cliModuleLogic().DeleteTemporaryFilesOff().\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Save Intermediate Models\",\n"
"					\"LongFlag\" : \"saveIntermediateModels\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"SaveIntermediateModels\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"false\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"bool\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"turn this flag on in order to see debugging output (look in the Error Log window that is accessed via the View menu)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"d\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Debug\",\n"
"					\"LongFlag\" : \"debug\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"debug\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"boolean\",\n"
"					\"Value\" : \"false\"\n"
"				}\n"
"			]\n"
"		}\n"
"	],\n"
"	\"Title\" : \"Model Maker\",\n"
"	\"Version\" : \"4.4\"\n"
"}\n"
"\n"
;
}
#define GENERATE_DESERIALIZATION \
    if (argc >= 2) \
      { \
      for (int arg_idx = 0; arg_idx < argc; ++arg_idx) \
        { \
        if (strcmp(argv[arg_idx],"--deserialize") == 0) \
          { \
          std::ifstream fStream( argv[arg_idx+1] ); \
          if( !fStream.is_open() ) \
            { \
            std::cerr << "Could not open file: " << argv[arg_idx+1] << " for writing." << std::endl; \
            return EXIT_FAILURE; \
            } \
          Json::Value root; \
          Json::Reader reader; \
          reader.parse( fStream, root ); \
          const Json::Value & parameters = root["Parameters"]; \
          if (!parameters["IO"]["InputVolume"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["InputVolume"].asString()); \
            } \
          if (!parameters["IO"]["ColorTable"].isNull()) \
            { \
            Json::Value param = parameters["IO"]["ColorTable"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--color"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--color"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["IO"]["ModelSceneFile"].isNull()) \
            { \
            Json::Value param = parameters["IO"]["ModelSceneFile"]; \
            if(param.size() > 0) \
              { \
              std::vector<std::string> values; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                values.push_back(param[i].asString()); \
                } \
              if (!values.empty()) \
                { \
                deserializedMultipleArgsMap["--modelSceneFile"] = values; \
                } \
              } \
            } \
          if (!parameters["Create Multiple"]["Name"].isNull()) \
            { \
            Json::Value param = parameters["Create Multiple"]["Name"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--name"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--name"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Create Multiple"]["GenerateAll"].isNull()) \
            { \
            if (parameters["Create Multiple"]["GenerateAll"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--generateAll"); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["Labels"].isNull()) \
            { \
            Json::Value param = parameters["Model Maker Parameters"]["Labels"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--labels"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--labels"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["StartLabel"].isNull()) \
            { \
            Json::Value param = parameters["Model Maker Parameters"]["StartLabel"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--start"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--start"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["EndLabel"].isNull()) \
            { \
            Json::Value param = parameters["Model Maker Parameters"]["EndLabel"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--end"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--end"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["SkipUnNamed"].isNull()) \
            { \
            if (parameters["Model Maker Parameters"]["SkipUnNamed"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--skipUnNamed"); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["JointSmoothing"].isNull()) \
            { \
            if (parameters["Model Maker Parameters"]["JointSmoothing"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--jointsmooth"); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["Smooth"].isNull()) \
            { \
            Json::Value param = parameters["Model Maker Parameters"]["Smooth"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--smooth"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--smooth"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["FilterType"].isNull()) \
            { \
            Json::Value param = parameters["Model Maker Parameters"]["FilterType"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--filtertype"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--filtertype"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["Decimate"].isNull()) \
            { \
            Json::Value param = parameters["Model Maker Parameters"]["Decimate"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--decimate"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--decimate"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["SplitNormals"].isNull()) \
            { \
            if (parameters["Model Maker Parameters"]["SplitNormals"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--splitnormals"); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["PointNormals"].isNull()) \
            { \
            if (parameters["Model Maker Parameters"]["PointNormals"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--pointnormals"); \
              } \
            } \
          if (!parameters["Model Maker Parameters"]["Pad"].isNull()) \
            { \
            if (parameters["Model Maker Parameters"]["Pad"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--pad"); \
              } \
            } \
          if (!parameters["Debug"]["ModelHierarchyFile"].isNull()) \
            { \
            Json::Value param = parameters["Debug"]["ModelHierarchyFile"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--modelHierarchyFile"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--modelHierarchyFile"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Debug"]["SaveIntermediateModels"].isNull()) \
            { \
            if (parameters["Debug"]["SaveIntermediateModels"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--saveIntermediateModels"); \
              } \
            } \
          if (!parameters["Debug"]["debug"].isNull()) \
            { \
            if (parameters["Debug"]["debug"].asBool()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--debug"); \
              } \
            } \
          } \
        } \
      }
#define GENERATE_SERIALIZATION \
    if( parametersSerializeArg.isSet() ) \
      { \
      Json::Value root; \
      Json::Value & parameters = root["Parameters"]; \
        { \
        Json::Value & parameterGroup = parameters["IO"]; \
        parameterGroup["InputVolume"] = JsonSerialize( InputVolume ); \
        parameterGroup["ColorTable"] = JsonSerialize( ColorTable ); \
        parameterGroup["ModelSceneFile"] = JsonSerialize( ModelSceneFile ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Create Multiple"]; \
        parameterGroup["Name"] = JsonSerialize( Name ); \
        parameterGroup["GenerateAll"] = JsonSerialize( GenerateAll ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Model Maker Parameters"]; \
        parameterGroup["Labels"] = JsonSerialize( Labels ); \
        parameterGroup["StartLabel"] = JsonSerialize( StartLabel ); \
        parameterGroup["EndLabel"] = JsonSerialize( EndLabel ); \
        parameterGroup["SkipUnNamed"] = JsonSerialize( SkipUnNamed ); \
        parameterGroup["JointSmoothing"] = JsonSerialize( JointSmoothing ); \
        parameterGroup["Smooth"] = JsonSerialize( Smooth ); \
        parameterGroup["FilterType"] = JsonSerialize( FilterType ); \
        parameterGroup["Decimate"] = JsonSerialize( Decimate ); \
        parameterGroup["SplitNormals"] = JsonSerialize( SplitNormals ); \
        parameterGroup["PointNormals"] = JsonSerialize( PointNormals ); \
        parameterGroup["Pad"] = JsonSerialize( Pad ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Debug"]; \
        parameterGroup["ModelHierarchyFile"] = JsonSerialize( ModelHierarchyFile ); \
        parameterGroup["SaveIntermediateModels"] = JsonSerialize( SaveIntermediateModels ); \
        parameterGroup["debug"] = JsonSerialize( debug ); \
        } \
      std::ofstream fStream( parametersSerializeArg.getValue().c_str() ); \
      if( !fStream.is_open() ) \
        { \
        std::cerr << "Could not open file: " << parametersSerializeArg.getValue() << " for writing." << std::endl; \
        return EXIT_FAILURE; \
        } \
      Json::StyledStreamWriter writer; \
      writer.write( fStream, root ); \
      fStream.close(); \
      }
#if defined(main) && !defined(REGISTER_TEST)
// If main defined as a preprocessor symbol, redefine it to the expected entry point.
#undef main
#define main ModuleEntryPoint

extern "C" {
  Module_EXPORT char *GetXMLModuleDescription();
  Module_EXPORT int ModuleEntryPoint(int, char*[]);
  Module_EXPORT unsigned char *GetModuleLogo(int *width, int *height, int *pixel_size, unsigned long *bufferLength);
}
#endif

extern "C" {
Module_EXPORT char XMLModuleDescription[] = 
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<executable>\n"
"  <category>Surface Models</category>\n"
"  <title>Model Maker</title>\n"
"  <description><![CDATA[Create 3D surface models from segmented data.<p>Models are imported into Slicer under a model hierarchy node in a MRML scene. The model colors are set by the color table associated with the input volume (these colours will only be visible if you load the model scene file).</p><p><b>IO:</b></p><p>Specify an <i>Input Volume</i> that is a segmented label map volume. Create a new <i>Models</i> hierarchy to provide a structure to contain the return models created from the input volume.</p><p><b>Create Multiple:</b></p><p>If you specify a list of <i>Labels</i>, it will over ride any start/end label settings.</p><p>If you click <i>Generate All</i> it will over ride the list of labels and any start/end label settings.</p><p><b>Model Maker Parameters:</b></p><p>You can set the number of smoothing iterations, target reduction in number of polygons (decimal percentage). Use 0 and 1 if you wish no smoothing nor decimation.<br>You can set the flags to split normals or generate point normals in this pane as well.<br>You can save a copy of the models after intermediate steps (marching cubes, smoothing, and decimation if not joint smoothing, otherwise just after decimation); these models are not saved in the mrml file, turn off deleting temporary files first in the python window:<br><i>slicer.modules.modelmaker.cliModuleLogic().DeleteTemporaryFilesOff()</i></p>]]></description>\n"
"  <version>4.4</version>\n"
"  <documentation-url>http://wiki.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/ModelMaker</documentation-url>\n"
"  <license>slicer4</license>\n"
"  <contributor>Nicole Aucoin (SPL, BWH), Ron Kikinis (SPL, BWH), Bill Lorensen (GE)</contributor>\n"
"  <acknowledgements><![CDATA[This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health through the NIH Roadmap for Medical Research, Grant U54 EB005149.]]></acknowledgements>\n"
"  <parameters>\n"
"    <label>IO</label>\n"
"    <description><![CDATA[Input/output parameters]]></description>\n"
"    <image type=\"label\">\n"
"      <name>InputVolume</name>\n"
"      <label>Input Volume</label>\n"
"      <channel>input</channel>\n"
"      <index>0</index>\n"
"      <description><![CDATA[Input label map. The Input Volume drop down menu is populated with the label map volumes that are present in the scene, select one from which to generate models.]]></description>\n"
"    </image>\n"
"    <table hidden=\"true\" type=\"color\" reference=\"InputVolume\">\n"
"      <name>ColorTable</name>\n"
"      <channel>input</channel>\n"
"      <longflag>color</longflag>\n"
"      <description><![CDATA[Color table to make labels to colors and objects]]></description>\n"
"    </table>\n"
"    <geometry aggregate=\"true\" fileExtensions=\".mrml\" multiple=\"true\">\n"
"      <name>ModelSceneFile</name>\n"
"      <channel>output</channel>\n"
"      <label>Models</label>\n"
"      <longflag>--modelSceneFile</longflag>\n"
"      <description><![CDATA[Generated models, under a model hierarchy node. Models are imported into Slicer under a model hierarchy node, and their colors are set by the color table associated with the input label map volume. The model hierarchy node must be created before running the model maker, by selecting Create New ModelHierarchy from the Models drop down menu. If you're running from the command line, a model hierarchy node in a new mrml scene will be created for you.]]></description>\n"
"      <default>models.mrml</default>\n"
"    </geometry>\n"
"  </parameters>\n"
"  <parameters>\n"
"    <label>Create Multiple</label>\n"
"    <description><![CDATA[Create more than one model at the same time, used for continuous ranges of labels.]]></description>\n"
"    <string>\n"
"      <name>Name</name>\n"
"      <label>Model Name</label>\n"
"      <flag>-n</flag>\n"
"      <longflag>--name</longflag>\n"
"      <description><![CDATA[Name to use for this model. Any text entered in the entry box will be the starting string for the created model file names. The label number and the color name will also be part of the file name. If making multiple models, use this as a prefix to the label and color name.]]></description>\n"
"      <default>Model</default>\n"
"    </string>\n"
"    <boolean>\n"
"      <name>GenerateAll</name>\n"
"      <label>Generate All Models</label>\n"
"      <longflag>--generateAll</longflag>\n"
"      <description><![CDATA[Generate models for all labels in the input volume. select this option if you want to create all models that correspond to all values in a labelmap volume (using the Joint Smoothing option below is useful with this option). Ignores Labels, Start Label, End Label settings. Skips label 0.]]></description>\n"
"      <default>true</default>\n"
"    </boolean>\n"
"  </parameters>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Model Maker Parameters</label>\n"
"    <description><![CDATA[Parameters used for making models.]]></description>\n"
"    <integer-vector>\n"
"      <name>Labels</name>\n"
"      <flag>-l</flag>\n"
"      <longflag>-labels</longflag>\n"
"      <description><![CDATA[A comma separated list of label values from which to make models. f you specify a list of Labels, it will override any start/end label settings. If you click Generate All Models it will override the list of labels and any start/end label settings.]]></description>\n"
"      <label>Labels</label>\n"
"    </integer-vector>\n"
"    <integer>\n"
"      <name>StartLabel</name>\n"
"      <label>Start Label</label>\n"
"      <flag>-s</flag>\n"
"      <longflag>--start</longflag>\n"
"      <description><![CDATA[If you want to specify a continuous range of labels from which to generate models, enter the lower label here. Voxel value from which to start making models. Used instead of the label list to specify a range (make sure the label list is empty or it will over ride this).]]></description>\n"
"      <default>-1</default>\n"
"    </integer>\n"
"    <integer>\n"
"      <name>EndLabel</name>\n"
"      <label>End Label</label>\n"
"      <flag>-e</flag>\n"
"      <longflag>--end</longflag>\n"
"      <description><![CDATA[If you want to specify a continuous range of labels from which to generate models, enter the higher label here. Voxel value up to which to continue making models. Skip any values with zero voxels.]]></description>\n"
"      <default>-1</default>\n"
"    </integer>\n"
"    <boolean>\n"
"      <name>SkipUnNamed</name>\n"
"      <label>Skip Un-Named Labels</label>\n"
"      <longflag>--skipUnNamed</longflag>\n"
"      <description><![CDATA[Select this to not generate models from labels that do not have names defined in the color look up table associated with the input label map. If true, only models which have an entry in the color table will be generated.  If false, generate all models that exist within the label range.]]></description>\n"
"      <default>true</default>\n"
"    </boolean>\n"
"    <boolean>\n"
"      <name>JointSmoothing</name>\n"
"      <label>Joint Smoothing</label>\n"
"      <description><![CDATA[This will ensure that all resulting models fit together smoothly, like jigsaw puzzle pieces. Otherwise the models will be smoothed independently and may overlap.]]></description>\n"
"      <flag>-j</flag>\n"
"      <longflag>--jointsmooth</longflag>\n"
"      <default>false</default>\n"
"    </boolean>\n"
"    <integer>\n"
"      <name>Smooth</name>\n"
"      <label>Smooth</label>\n"
"      <longflag>--smooth</longflag>\n"
"      <description><![CDATA[Here you can set the number of smoothing iterations for Laplacian smoothing, or the degree of the polynomial approximating the windowed Sinc function. Use 0 if you wish no smoothing. ]]></description>\n"
"      <default>10</default>\n"
"      <constraints>\n"
"        <minimum>0</minimum>\n"
"        <maximum>100</maximum>\n"
"      </constraints>\n"
"    </integer>\n"
"    <string-enumeration>\n"
"      <name>FilterType</name>\n"
"      <label>Filter Type</label>\n"
"      <description><![CDATA[You can control the type of smoothing done on the models by selecting a filter type of either Sinc or Laplacian.]]></description>\n"
"      <longflag>--filtertype</longflag>\n"
"      <default>Sinc</default>\n"
"      <element>Sinc</element>\n"
"      <element>Laplacian</element>\n"
"    </string-enumeration>\n"
"    <float>\n"
"      <name>Decimate</name>\n"
"      <label>Decimate</label>\n"
"      <longflag>--decimate</longflag>\n"
"      <description><![CDATA[Chose the target reduction in number of polygons as a decimal percentage (between 0 and 1) of the number of polygons. Specifies the percentage of triangles to be removed. For example, 0.1 means 10% reduction and 0.9 means 90% reduction.]]></description>\n"
"      <default>0.25</default>\n"
"      <constraints>\n"
"        <minimum>0.0</minimum>\n"
"        <maximum>1.0</maximum>\n"
"        <step>0.01</step>\n"
"      </constraints>\n"
"    </float>\n"
"    <boolean>\n"
"      <name>SplitNormals</name>\n"
"      <label>Split Normals</label>\n"
"      <longflag>--splitnormals</longflag>\n"
"      <description><![CDATA[Splitting normals is useful for visualizing sharp features. However it creates holes in surfaces which affects measurements.]]></description>\n"
"      <default>true</default>\n"
"    </boolean>\n"
"    <boolean>\n"
"      <name>PointNormals</name>\n"
"      <label>Point Normals</label>\n"
"      <longflag>--pointnormals</longflag>\n"
"      <description><![CDATA[Turn this flag on if you wish to calculate the normal vectors for the points.]]></description>\n"
"      <default>true</default>\n"
"    </boolean>\n"
"    <boolean>\n"
"      <name>Pad</name>\n"
"      <label>Pad</label>\n"
"      <longflag>--pad</longflag>\n"
"      <description><![CDATA[Pad the input volume with zero value voxels on all 6 faces in order to ensure the production of closed surfaces. Sets the origin translation and extent translation so that the models still line up with the unpadded input volume.]]></description>\n"
"      <default>true</default>\n"
"    </boolean>\n"
"  </parameters>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Debug</label>\n"
"    <file fileExtensions=\".mrml\">\n"
"      <name>ModelHierarchyFile</name>\n"
"      <channel>input</channel>\n"
"      <label>Color Hierarchy</label>\n"
"      <longflag>--modelHierarchyFile</longflag>\n"
"      <description><![CDATA[A mrml file that contains a template model hierarchy tree with a hierarchy node per color used in the input volume's color table. Color names used for the models are matched to template hierarchy names to create a multi level output tree. Create a hierarchy in the Models GUI and save a scene, then clean it up to remove everything but the model hierarchy and display nodes.]]></description>\n"
"    </file>\n"
"    <boolean>\n"
"      <name>SaveIntermediateModels</name>\n"
"      <label>Save Intermediate Models</label>\n"
"      <longflag>saveIntermediateModels</longflag>\n"
"      <description><![CDATA[You can save a copy of the models after each of the intermediate steps (marching cubes, smoothing, and decimation if not joint smoothing, otherwise just after decimation). These intermediate models are not saved in the mrml file, you have to load them manually after turning off deleting temporary files in they python console (View ->Python Interactor) using the following command slicer.modules.modelmaker.cliModuleLogic().DeleteTemporaryFilesOff().]]></description>\n"
"      <default>false</default>\n"
"    </boolean>\n"
"    <boolean>\n"
"      <name>debug</name>\n"
"      <label>Debug</label>\n"
"      <description><![CDATA[turn this flag on in order to see debugging output (look in the Error Log window that is accessed via the View menu)]]></description>\n"
"      <flag>-d</flag>\n"
"      <longflag>--debug</longflag>\n"
"      <default>false</default>\n"
"    </boolean>\n"
"  </parameters>\n"
"</executable>\n"
"\n"
;

#define static Module_EXPORT
#define const
#define image_NAMICLogo_width ModuleLogoWidth
#define image_NAMICLogo_height ModuleLogoHeight
#define image_NAMICLogo_pixel_size ModuleLogoPixelSize
#define image_NAMICLogo_length ModuleLogoLength
#define image_NAMICLogo ModuleLogoImage
#include "/usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/NAMICLogo.h"
#undef static
#undef const
#undef image_NAMICLogo_width
#undef image_NAMICLogo_height
#undef image_NAMICLogo_pixel_size
#undef image_NAMICLogo_length
#undef image_NAMICLogo
}

void
splitString (const std::string &text,
             const std::string &separators,
             std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  std::string::size_type start = text.find_first_not_of(separators);
  while (start < n)
    {
    std::string::size_type stop = text.find_first_of(separators, start);
    if (stop > n) stop = n;
    words.push_back(text.substr(start, stop - start));
    start = text.find_first_not_of(separators, stop+1);
    }
}

void
splitFilenames (const std::string &text,
                std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  bool quoted;
  std::string comma(",");
  std::string quote("\"");
  std::string::size_type start = text.find_first_not_of(comma);
  while (start < n)
    {
    quoted = false;
    std::string::size_type startq = text.find_first_of(quote, start);
    std::string::size_type stopq = text.find_first_of(quote, startq+1);
    std::string::size_type stop = text.find_first_of(comma, start);
    if (stop > n) stop = n;
    if (startq != std::string::npos && stopq != std::string::npos)
      {
      while (startq < stop && stop < stopq && stop != n)
         {
         quoted = true;
         stop = text.find_first_of(comma, stop+1);
         if (stop > n) stop = n;
         }
      }
    if (!quoted)
      {
      words.push_back(text.substr(start, stop - start));
      }
    else
      {
      words.push_back(text.substr(start+1, stop - start-2));
      }
    start = text.find_first_not_of(comma, stop+1);
    }
}

unsigned char *GetModuleLogo(int *width,
                             int *height,
                             int *pixel_size,
                             unsigned long *length)
{
  *width = ModuleLogoWidth;
  *height = ModuleLogoHeight;
  *pixel_size = ModuleLogoPixelSize;
  *length = ModuleLogoLength;
  return const_cast<unsigned char *>(ModuleLogoImage);
}

char *GetXMLModuleDescription()
{
   return XMLModuleDescription;
}

#define GENERATE_LOGO \
  if (argc >= 2 && (strcmp(argv[1],"--logo") == 0)) \
    { \
    int width, height, pixel_size;     \
    unsigned long length;  \
    unsigned char *logo = GetModuleLogo(&width, &height, &pixel_size, &length);  \
    std::cout << "LOGO" << std::endl;  \
    std::cout << width << std::endl;  \
    std::cout << height << std::endl;  \
    std::cout << pixel_size << std::endl;  \
    std::cout << length << std::endl;  \
    std::cout << logo << std::endl;  \
    return EXIT_SUCCESS;  \
    }
#define GENERATE_XML \
  if (argc >= 2 && (strcmp(argv[1],"--xml") == 0)) \
    { \
    std::cout << GetXMLModuleDescription(); \
    return EXIT_SUCCESS; \
    }
#define GENERATE_DECLARE \
    /* These two vectors are used to store the JSON deserialized value */ \
    /* that are then compiled with the command line. */ \
    std::vector< std::string > deserializedVectorFlaggedArgs; \
    std::vector< std::string > deserializedVectorPositionalArgs; \
    /* This map is used to store the JSON deserialized value of multiple args*/ \
    /* where the key is the argument flag and the value the values of each arg. */ \
    std::map< std::string, std::vector<std::string> > deserializedMultipleArgsMap; \
 \
    /* This vector is used to look up if a flag requires an argument after it. */ \
    /* This is used to differentiate between: */ \
    /* ./myExec --boolFlag /my/first/arg */ \
    /* ./myExec --flag flagArg */ \
    std::vector< std::string > nonbooleanFlags; \
    nonbooleanFlags.push_back("--color"); \
    nonbooleanFlags.push_back("--modelSceneFile"); \
    nonbooleanFlags.push_back("-n"); \
    nonbooleanFlags.push_back("--name"); \
    nonbooleanFlags.push_back("-l"); \
    nonbooleanFlags.push_back("--labels"); \
    nonbooleanFlags.push_back("-s"); \
    nonbooleanFlags.push_back("--start"); \
    nonbooleanFlags.push_back("-e"); \
    nonbooleanFlags.push_back("--end"); \
    nonbooleanFlags.push_back("--smooth"); \
    nonbooleanFlags.push_back("--filtertype"); \
    nonbooleanFlags.push_back("--decimate"); \
    nonbooleanFlags.push_back("--modelHierarchyFile"); \
    nonbooleanFlags.push_back("--serialize"); \
    nonbooleanFlags.push_back("--deserialize"); \
    nonbooleanFlags.push_back("--processinformationaddress"); \
    nonbooleanFlags.push_back("--returnparameterfile"); \
    /* This map use is twofold: */ \
    /*  - to find whether a flag is multiple */ \
    /*  - to know if we need to reset the multiple arg value because it was */ \
    /*    in the JSON and it's also in the command line. */ \
    std::map<std::string, bool> multipleFlags; \
    multipleFlags["--modelSceneFile"] = false; \
    std::string InputVolume; \
    std::string ColorTable; \
    std::vector<std::string> ModelSceneFile; \
    std::string Name = "Model"; \
    bool GenerateAll = false; \
    std::string LabelsTemp; \
    std::vector<int> Labels; \
    int StartLabel = -1; \
    int EndLabel = -1; \
    bool SkipUnNamed = false; \
    bool JointSmoothing = false; \
    int Smooth = 10; \
    std::string FilterType = "Sinc"; \
    std::vector<std::string> FilterTypeAllowed; \
    FilterTypeAllowed.push_back("Sinc");  \
    FilterTypeAllowed.push_back("Laplacian");  \
    TCLAP::ValuesConstraint<std::string> FilterTypeAllowedVals (FilterTypeAllowed);  \
    float Decimate = 0.25; \
    bool SplitNormals = false; \
    bool PointNormals = false; \
    bool Pad = false; \
    std::string ModelHierarchyFile; \
    bool SaveIntermediateModels = false; \
    bool debug = false; \
    std::string parametersSerialize; \
    std::string parametersDeSerialize; \
    bool echoSwitch = false; \
    bool xmlSwitch = false; \
    std::string processInformationAddressString = "0"; \
    std::string returnParameterFile; \

#define GENERATE_TCLAP_PARSE \
    std::string fullDescription("Description: "); \
    fullDescription += "Create 3D surface models from segmented data.<p>Models are imported into Slicer under a model hierarchy node in a MRML scene. The model colors are set by the color table associated with the input volume (these colours will only be visible if you load the model scene file).</p><p><b>IO:</b></p><p>Specify an <i>Input Volume</i> that is a segmented label map volume. Create a new <i>Models</i> hierarchy to provide a structure to contain the return models created from the input volume.</p><p><b>Create Multiple:</b></p><p>If you specify a list of <i>Labels</i>, it will over ride any start/end label settings.</p><p>If you click <i>Generate All</i> it will over ride the list of labels and any start/end label settings.</p><p><b>Model Maker Parameters:</b></p><p>You can set the number of smoothing iterations, target reduction in number of polygons (decimal percentage). Use 0 and 1 if you wish no smoothing nor decimation.<br>You can set the flags to split normals or generate point normals in this pane as well.<br>You can save a copy of the models after intermediate steps (marching cubes, smoothing, and decimation if not joint smoothing, otherwise just after decimation); these models are not saved in the mrml file, turn off deleting temporary files first in the python window:<br><i>slicer.modules.modelmaker.cliModuleLogic().DeleteTemporaryFilesOff()</i></p>"; \
    if (!std::string("Nicole Aucoin (SPL, BWH), Ron Kikinis (SPL, BWH), Bill Lorensen (GE)").empty()) \
      { \
      fullDescription += "\nAuthor(s): Nicole Aucoin (SPL, BWH), Ron Kikinis (SPL, BWH), Bill Lorensen (GE)"; \
      } \
    if (!std::string("This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health through the NIH Roadmap for Medical Research, Grant U54 EB005149.").empty()) \
      { \
      fullDescription += "\nAcknowledgements: This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health through the NIH Roadmap for Medical Research, Grant U54 EB005149."; \
      } \
    TCLAP::CmdLine commandLine (fullDescription, \
       ' ', \
      "4.4" ); \
 \
      std::ostringstream msg; \
    msg.str("");msg << "Input label map. The Input Volume drop down menu is populated with the label map volumes that are present in the scene, select one from which to generate models.";    TCLAP::UnlabeledValueArg<std::string> InputVolumeArg("InputVolume", msg.str(), 1, InputVolume, "std::string", commandLine); \
 \
    msg.str("");msg << "Color table to make labels to colors and objects";    TCLAP::ValueArg<std::string > ColorTableArg("", "color", msg.str(), 0, ColorTable, "std::string", commandLine); \
 \
    msg.str("");msg << "Generated models, under a model hierarchy node. Models are imported into Slicer under a model hierarchy node, and their colors are set by the color table associated with the input label map volume. The model hierarchy node must be created before running the model maker, by selecting Create New ModelHierarchy from the Models drop down menu. If you're running from the command line, a model hierarchy node in a new mrml scene will be created for you. (value: " << "None" << ")"; \
    TCLAP::MultiArg<std::string > ModelSceneFileArg("", "modelSceneFile", msg.str(), 0, "std::string", commandLine); \
 \
    msg.str("");msg << "Name to use for this model. Any text entered in the entry box will be the starting string for the created model file names. The label number and the color name will also be part of the file name. If making multiple models, use this as a prefix to the label and color name. (value: " << Name << ")"; \
    TCLAP::ValueArg<std::string > NameArg("n", "name", msg.str(), 0, Name, "std::string", commandLine); \
 \
    msg.str("");msg << "Generate models for all labels in the input volume. select this option if you want to create all models that correspond to all values in a labelmap volume (using the Joint Smoothing option below is useful with this option). Ignores Labels, Start Label, End Label settings. Skips label 0. (value: " << GenerateAll << ")"; \
    TCLAP::SwitchArg GenerateAllArg("", "generateAll", msg.str(), commandLine, GenerateAll); \
 \
    msg.str("");msg << "A comma separated list of label values from which to make models. f you specify a list of Labels, it will override any start/end label settings. If you click Generate All Models it will override the list of labels and any start/end label settings.";    TCLAP::ValueArg<std::string > LabelsArg("l", "labels", msg.str(), 0, LabelsTemp, "std::vector<int>", commandLine); \
 \
    msg.str("");msg << "If you want to specify a continuous range of labels from which to generate models, enter the lower label here. Voxel value from which to start making models. Used instead of the label list to specify a range (make sure the label list is empty or it will over ride this). (value: " << StartLabel << ")"; \
    TCLAP::ValueArg<int > StartLabelArg("s", "start", msg.str(), 0, StartLabel, "int", commandLine); \
 \
    msg.str("");msg << "If you want to specify a continuous range of labels from which to generate models, enter the higher label here. Voxel value up to which to continue making models. Skip any values with zero voxels. (value: " << EndLabel << ")"; \
    TCLAP::ValueArg<int > EndLabelArg("e", "end", msg.str(), 0, EndLabel, "int", commandLine); \
 \
    msg.str("");msg << "Select this to not generate models from labels that do not have names defined in the color look up table associated with the input label map. If true, only models which have an entry in the color table will be generated.  If false, generate all models that exist within the label range. (value: " << SkipUnNamed << ")"; \
    TCLAP::SwitchArg SkipUnNamedArg("", "skipUnNamed", msg.str(), commandLine, SkipUnNamed); \
 \
    msg.str("");msg << "This will ensure that all resulting models fit together smoothly, like jigsaw puzzle pieces. Otherwise the models will be smoothed independently and may overlap. (value: " << JointSmoothing << ")"; \
    TCLAP::SwitchArg JointSmoothingArg("j", "jointsmooth", msg.str(), commandLine, JointSmoothing); \
 \
    msg.str("");msg << "Here you can set the number of smoothing iterations for Laplacian smoothing, or the degree of the polynomial approximating the windowed Sinc function. Use 0 if you wish no smoothing. (value: " << Smooth << ")"; \
    TCLAP::ValueArg<int > SmoothArg("", "smooth", msg.str(), 0, Smooth, "int", commandLine); \
 \
    msg.str("");msg << "You can control the type of smoothing done on the models by selecting a filter type of either Sinc or Laplacian. (value: " << FilterType << ")"; \
    TCLAP::ValueArg<std::string> FilterTypeArg("", "filtertype", msg.str(), 0, FilterType, &FilterTypeAllowedVals, commandLine); \
 \
    msg.str("");msg << "Chose the target reduction in number of polygons as a decimal percentage (between 0 and 1) of the number of polygons. Specifies the percentage of triangles to be removed. For example, 0.1 means 10% reduction and 0.9 means 90% reduction. (value: " << Decimate << ")"; \
    TCLAP::ValueArg<float > DecimateArg("", "decimate", msg.str(), 0, Decimate, "float", commandLine); \
 \
    msg.str("");msg << "Splitting normals is useful for visualizing sharp features. However it creates holes in surfaces which affects measurements. (value: " << SplitNormals << ")"; \
    TCLAP::SwitchArg SplitNormalsArg("", "splitnormals", msg.str(), commandLine, SplitNormals); \
 \
    msg.str("");msg << "Turn this flag on if you wish to calculate the normal vectors for the points. (value: " << PointNormals << ")"; \
    TCLAP::SwitchArg PointNormalsArg("", "pointnormals", msg.str(), commandLine, PointNormals); \
 \
    msg.str("");msg << "Pad the input volume with zero value voxels on all 6 faces in order to ensure the production of closed surfaces. Sets the origin translation and extent translation so that the models still line up with the unpadded input volume. (value: " << Pad << ")"; \
    TCLAP::SwitchArg PadArg("", "pad", msg.str(), commandLine, Pad); \
 \
    msg.str("");msg << "A mrml file that contains a template model hierarchy tree with a hierarchy node per color used in the input volume's color table. Color names used for the models are matched to template hierarchy names to create a multi level output tree. Create a hierarchy in the Models GUI and save a scene, then clean it up to remove everything but the model hierarchy and display nodes.";    TCLAP::ValueArg<std::string > ModelHierarchyFileArg("", "modelHierarchyFile", msg.str(), 0, ModelHierarchyFile, "std::string", commandLine); \
 \
    msg.str("");msg << "You can save a copy of the models after each of the intermediate steps (marching cubes, smoothing, and decimation if not joint smoothing, otherwise just after decimation). These intermediate models are not saved in the mrml file, you have to load them manually after turning off deleting temporary files in they python console (View ->Python Interactor) using the following command slicer.modules.modelmaker.cliModuleLogic().DeleteTemporaryFilesOff(). (value: " << SaveIntermediateModels << ")"; \
    TCLAP::SwitchArg SaveIntermediateModelsArg("", "saveIntermediateModels", msg.str(), commandLine, SaveIntermediateModels); \
 \
    msg.str("");msg << "turn this flag on in order to see debugging output (look in the Error Log window that is accessed via the View menu) (value: " << debug << ")"; \
    TCLAP::SwitchArg debugArg("d", "debug", msg.str(), commandLine, debug); \
 \
    msg.str("");msg << "Store the module's parameters to a file.";    TCLAP::ValueArg<std::string > parametersSerializeArg("", "serialize", msg.str(), 0, parametersSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Restore the module's parameters that were previously archived.";    TCLAP::ValueArg<std::string > parametersDeSerializeArg("", "deserialize", msg.str(), 0, parametersDeSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Echo the command line arguments (value: " << echoSwitch << ")"; \
    TCLAP::SwitchArg echoSwitchArg("", "echo", msg.str(), commandLine, echoSwitch); \
 \
    msg.str("");msg << "Produce xml description of command line arguments (value: " << xmlSwitch << ")"; \
    TCLAP::SwitchArg xmlSwitchArg("", "xml", msg.str(), commandLine, xmlSwitch); \
 \
    msg.str("");msg << "Address of a structure to store process information (progress, abort, etc.). (value: " << processInformationAddressString << ")"; \
    TCLAP::ValueArg<std::string > processInformationAddressStringArg("", "processinformationaddress", msg.str(), 0, processInformationAddressString, "std::string", commandLine); \
 \
    msg.str("");msg << "Filename in which to write simple return parameters (int, float, int-vector, etc.) as opposed to bulk return parameters (image, geometry, transform, measurement, table).";    TCLAP::ValueArg<std::string > returnParameterFileArg("", "returnparameterfile", msg.str(), 0, returnParameterFile, "std::string", commandLine); \
 \
try \
  { \
    /* Build a map of flag aliases to the true flag */ \
    std::map<std::string,std::string> flagAliasMap; \
    std::map<std::string,std::string> deprecatedFlagAliasMap; \
    std::map<std::string,std::string> longFlagAliasMap; \
    std::map<std::string,std::string> deprecatedLongFlagAliasMap; \
 \
    /* Go through argc and consolidate the JSON with the parameters from the command line */ \
    /* In case of conflict, take the command line. */ \
    std::map<std::string,std::string>::iterator ait; \
    std::map<std::string,std::string>::iterator dait; \
    std::vector<std::string>::iterator dvOptionnalArgsIt = deserializedVectorFlaggedArgs.begin(); \
    std::map<std::string, std::vector<std::string> >::iterator dvMultipleArgsIt; \
    size_t noFlagCounter = 0; \
    size_t ac = 1; \
 \
    while (ac < static_cast<size_t>(argc)) \
      { \
      /* short flag case && long flag case */ \
       if ((strlen(argv[ac]) == 2 && argv[ac][0]=='-') \
           || (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]=='-')) \
         { \
         std::string flag = argv[ac]; \
         /* Remap the flag if necessary */ \
         if (strlen(argv[ac]) == 2) \
           { \
           /* Short flag remapping */ \
           ait = flagAliasMap.find(flag); \
           dait = deprecatedFlagAliasMap.find(flag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << flag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         else \
           { \
           /* Long flag remapping */ \
           ait = longFlagAliasMap.find(flag); \
           dait = deprecatedLongFlagAliasMap.find(flag); \
           if (ait != longFlagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedLongFlagAliasMap.end()) \
             { \
             std::cout << "Long flag \"" << flag << "\" is deprecated. Please use long flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         bool isMultiple = multipleFlags.find(flag) != multipleFlags.end(); \
         bool isBoolean = std::find(nonbooleanFlags.begin(), nonbooleanFlags.end(), flag) == nonbooleanFlags.end(); \
         dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), flag); \
         bool isPresentVFA = dvOptionnalArgsIt != deserializedVectorFlaggedArgs.end(); \
         if (isBoolean) \
           { \
           /*Ignore if boolean and already present*/ \
           /*Otherwise add it*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           } \
         else if (isMultiple) \
           { \
           dvMultipleArgsIt = deserializedMultipleArgsMap.find(flag); \
           bool isPresentMA = dvMultipleArgsIt != deserializedMultipleArgsMap.end(); \
           /*Ignore if boolean and already present*/ \
           /*Reset/Add the value if first deserialize or not present*/ \
           if (!isPresentMA || !multipleFlags[flag]) \
             { \
             deserializedMultipleArgsMap[flag] = std::vector<std::string>(); \
             multipleFlags[flag] = true; \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           deserializedMultipleArgsMap[flag].push_back(value); \
           } \
         else \
           { \
           /*Add the flag and if needed*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(value);  \
             } \
           else \
             { \
             *(++dvOptionnalArgsIt) = value; \
             } \
           } \
         } \
       /* short flag case where multiple flags are given at once */ \
       else if (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]!='-') \
         { \
         std::string rflag(argv[ac], 1, std::string::npos); \
         for (std::string::size_type fi=0; fi < rflag.size(); ++fi) \
           { \
           std::string tf(rflag, fi, 1); \
           std::string newFlag ="-"; \
           newFlag += tf; \
           ait = flagAliasMap.find(newFlag); \
           dait = deprecatedFlagAliasMap.find(newFlag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             newFlag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << newFlag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             newFlag = (*dait).second; \
             } \
           dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), newFlag); \
           /*These flags are always boolean, just add it if it's not there already */ \
           if (dvOptionnalArgsIt == deserializedVectorFlaggedArgs.end()) \
             { \
             deserializedVectorFlaggedArgs.push_back(newFlag); \
             } \
           } \
         ++ac; \
         } \
       else \
         { \
         /* Replace if needed, otherwise append.*/ \
         if (noFlagCounter < deserializedVectorPositionalArgs.size()) \
           { \
           deserializedVectorPositionalArgs[noFlagCounter] = argv[ac]; \
           } \
         else \
           { \
           deserializedVectorPositionalArgs.push_back(argv[ac]); \
           } \
         ++ac; \
         ++noFlagCounter; \
         } \
       } \
 \
    /* Put the now compiled arguments in the argvVector */ \
    std::vector<std::string> argvVector; \
    argvVector.push_back(argv[0]); \
    argvVector.insert(argvVector.end(), deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end()); \
    std::map<std::string, std::vector<std::string> >::iterator mavit; \
    for (mavit = deserializedMultipleArgsMap.begin(); mavit != deserializedMultipleArgsMap.end(); ++mavit) \
      { \
      for (size_t i = 0; i < mavit->second.size(); ++i) \
        { \
        argvVector.push_back(mavit->first); \
        argvVector.push_back(mavit->second.at(i)); \
        } \
      } \
    argvVector.insert(argvVector.end(), deserializedVectorPositionalArgs.begin(), deserializedVectorPositionalArgs.end()); \
 \
   /* Remap args to a structure that CmdLine::parse() can understand*/ \
   std::vector<char*> vargs; \
   for (ac = 0; ac < argvVector.size(); ++ac) \
     {  \
     vargs.push_back(const_cast<char *>(argvVector[ac].c_str())); \
     } \
    commandLine.parse ( static_cast<int>(vargs.size()), (char**) &(vargs[0]) ); \
  } \
catch ( TCLAP::ArgException & e ) \
  { \
  std::cerr << "error: " << e.error() << " for arg " << e.argId() << std::endl; \
  return ( EXIT_FAILURE ); \
  }
#define GENERATE_TCLAP_ASSIGNMENT \
      InputVolume = InputVolumeArg.getValue(); \
      ColorTable = ColorTableArg.getValue(); \
      ModelSceneFile = ModelSceneFileArg.getValue(); \
      Name = NameArg.getValue(); \
      GenerateAll = GenerateAllArg.getValue(); \
      LabelsTemp = LabelsArg.getValue(); \
      StartLabel = StartLabelArg.getValue(); \
      EndLabel = EndLabelArg.getValue(); \
      SkipUnNamed = SkipUnNamedArg.getValue(); \
      JointSmoothing = JointSmoothingArg.getValue(); \
      Smooth = SmoothArg.getValue(); \
      FilterType = FilterTypeArg.getValue(); \
      Decimate = DecimateArg.getValue(); \
      SplitNormals = SplitNormalsArg.getValue(); \
      PointNormals = PointNormalsArg.getValue(); \
      Pad = PadArg.getValue(); \
      ModelHierarchyFile = ModelHierarchyFileArg.getValue(); \
      SaveIntermediateModels = SaveIntermediateModelsArg.getValue(); \
      debug = debugArg.getValue(); \
      parametersSerialize = parametersSerializeArg.getValue(); \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      echoSwitch = echoSwitchArg.getValue(); \
      xmlSwitch = xmlSwitchArg.getValue(); \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      returnParameterFile = returnParameterFileArg.getValue(); \
      { /* Assignment for Labels */ \
      Labels.clear(); \
      std::vector<std::string> words; \
      std::string sep(","); \
      splitString(LabelsTemp, sep, words); \
      for (unsigned int _j = 0; _j < words.size(); _j++) \
        { \
        Labels.push_back(atoi(words[_j].c_str())); \
        } \
      } \

#define GENERATE_TCLAP GENERATE_TCLAP_PARSE;GENERATE_TCLAP_ASSIGNMENT
#define GENERATE_TCLAP_ASSIGNMENT_IFSET \
    if( InputVolumeArg.isSet() ) \
      { \
      InputVolume = InputVolumeArg.getValue(); \
      } \
    if( ColorTableArg.isSet() ) \
      { \
      ColorTable = ColorTableArg.getValue(); \
      } \
    if( ModelSceneFileArg.isSet() ) \
      { \
      ModelSceneFile = ModelSceneFileArg.getValue(); \
      } \
    if( NameArg.isSet() ) \
      { \
      Name = NameArg.getValue(); \
      } \
    if( GenerateAllArg.isSet() ) \
      { \
      GenerateAll = GenerateAllArg.getValue(); \
      } \
    if( LabelsArg.isSet() ) \
      { \
      LabelsTemp = LabelsArg.getValue(); \
      } \
    if( StartLabelArg.isSet() ) \
      { \
      StartLabel = StartLabelArg.getValue(); \
      } \
    if( EndLabelArg.isSet() ) \
      { \
      EndLabel = EndLabelArg.getValue(); \
      } \
    if( SkipUnNamedArg.isSet() ) \
      { \
      SkipUnNamed = SkipUnNamedArg.getValue(); \
      } \
    if( JointSmoothingArg.isSet() ) \
      { \
      JointSmoothing = JointSmoothingArg.getValue(); \
      } \
    if( SmoothArg.isSet() ) \
      { \
      Smooth = SmoothArg.getValue(); \
      } \
    if( FilterTypeArg.isSet() ) \
      { \
      FilterType = FilterTypeArg.getValue(); \
      } \
    if( DecimateArg.isSet() ) \
      { \
      Decimate = DecimateArg.getValue(); \
      } \
    if( SplitNormalsArg.isSet() ) \
      { \
      SplitNormals = SplitNormalsArg.getValue(); \
      } \
    if( PointNormalsArg.isSet() ) \
      { \
      PointNormals = PointNormalsArg.getValue(); \
      } \
    if( PadArg.isSet() ) \
      { \
      Pad = PadArg.getValue(); \
      } \
    if( ModelHierarchyFileArg.isSet() ) \
      { \
      ModelHierarchyFile = ModelHierarchyFileArg.getValue(); \
      } \
    if( SaveIntermediateModelsArg.isSet() ) \
      { \
      SaveIntermediateModels = SaveIntermediateModelsArg.getValue(); \
      } \
    if( debugArg.isSet() ) \
      { \
      debug = debugArg.getValue(); \
      } \
    if( parametersSerializeArg.isSet() ) \
      { \
      parametersSerialize = parametersSerializeArg.getValue(); \
      } \
    if( parametersDeSerializeArg.isSet() ) \
      { \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      } \
    if( echoSwitchArg.isSet() ) \
      { \
      echoSwitch = echoSwitchArg.getValue(); \
      } \
    if( xmlSwitchArg.isSet() ) \
      { \
      xmlSwitch = xmlSwitchArg.getValue(); \
      } \
    if( processInformationAddressStringArg.isSet() ) \
      { \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      } \
    if( returnParameterFileArg.isSet() ) \
      { \
      returnParameterFile = returnParameterFileArg.getValue(); \
      } \
    if( LabelsArg.isSet() ) \
      { /* Assignment for Labels */ \
      Labels.clear(); \
      std::vector<std::string> words; \
      std::string sep(","); \
      splitString(LabelsTemp, sep, words); \
      for (unsigned int _j = 0; _j < words.size(); _j++) \
        { \
        Labels.push_back(atoi(words[_j].c_str())); \
        } \
      } \

#define GENERATE_ECHOARGS \
if (echoSwitch) \
{ \
std::cout << "Command Line Arguments" << std::endl; \
std::cout << "    InputVolume: " << InputVolume << std::endl; \
std::cout << "    ColorTable: " << ColorTable << std::endl; \
std::cout << "    ModelSceneFile: "; \
for (unsigned int _i =0; _i < ModelSceneFile.size(); _i++) \
{ \
std::cout << ModelSceneFile[_i] << ", "; \
} \
std::cout <<std::endl; \
std::cout << "    Name: " << Name << std::endl; \
std::cout << "    GenerateAll: " << GenerateAll << std::endl; \
std::cout << "    Labels: "; \
for (unsigned int _i =0; _i < Labels.size(); _i++) \
{ \
std::cout << Labels[_i] << ", "; \
} \
std::cout <<std::endl; \
std::cout << "    StartLabel: " << StartLabel << std::endl; \
std::cout << "    EndLabel: " << EndLabel << std::endl; \
std::cout << "    SkipUnNamed: " << SkipUnNamed << std::endl; \
std::cout << "    JointSmoothing: " << JointSmoothing << std::endl; \
std::cout << "    Smooth: " << Smooth << std::endl; \
std::cout << "    FilterType: " << FilterType << std::endl; \
std::cout << "    Decimate: " << Decimate << std::endl; \
std::cout << "    SplitNormals: " << SplitNormals << std::endl; \
std::cout << "    PointNormals: " << PointNormals << std::endl; \
std::cout << "    Pad: " << Pad << std::endl; \
std::cout << "    ModelHierarchyFile: " << ModelHierarchyFile << std::endl; \
std::cout << "    SaveIntermediateModels: " << SaveIntermediateModels << std::endl; \
std::cout << "    debug: " << debug << std::endl; \
std::cout << "    parametersSerialize: " << parametersSerialize << std::endl; \
std::cout << "    parametersDeSerialize: " << parametersDeSerialize << std::endl; \
std::cout << "    echoSwitch: " << echoSwitch << std::endl; \
std::cout << "    xmlSwitch: " << xmlSwitch << std::endl; \
std::cout << "    processInformationAddressString: " << processInformationAddressString << std::endl; \
std::cout << "    returnParameterFile: " << returnParameterFile << std::endl; \
}
#define GENERATE_ProcessInformationAddressDecoding \
ModuleProcessInformation *CLPProcessInformation = 0; \
if (processInformationAddressString != "") \
{ \
sscanf(processInformationAddressString.c_str(), "%p", &CLPProcessInformation); \
}
#define PARSE_ARGS GENERATE_LOGO;GENERATE_XML;GENERATE_DECLARE;GENERATE_DESERIALIZATION;GENERATE_TCLAP;GENERATE_ECHOARGS;GENERATE_ProcessInformationAddressDecoding;GENERATE_SERIALIZATION;
