// This file was automatically generated by:
//  /usr/bin/GenerateCLP --logoFiles /usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/NAMICLogo.h --InputXML /usr/src/RPM/BUILD/slicer-4.11.20210226/Modules/CLI/N4ITKBiasFieldCorrection/N4ITKBiasFieldCorrection.xml --OutputCxx /usr/src/RPM/BUILD/slicer-4.11.20210226/BUILD/Modules/CLI/N4ITKBiasFieldCorrection/N4ITKBiasFieldCorrectionCLP.h
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
#include <map>

#include <sstream>
#include <fstream>
#include <stdexcept>

#include "tclap/CmdLine.h"
#include "JsonSerializationUtilities.h"
#include "ModuleProcessInformation.h"

#ifdef _WIN32
#define Module_EXPORT __declspec(dllexport)
#elif defined(MODULE_HIDDEN_VISIBILITY)
#define Module_EXPORT __attribute__((visibility("default")))
#else
#define Module_EXPORT
#endif


extern "C" {
Module_EXPORT char JSONModuleDescription[] =
"{\n"
"	\"Category\" : \"Filtering\",\n"
"	\"Contributor\" : \"Nick Tustison (UPenn), Andrey Fedorov (SPL, BWH), Ron Kikinis (SPL, BWH)\",\n"
"	\"Description\" : \"Performs image bias correction using N4 algorithm. This module is based on the ITK filters contributed in the following publication:  Tustison N, Gee J 'N4ITK: Nick's N3 ITK Implementation For MRI Bias Field Correction', The Insight Journal 2009 January-June, http://hdl.handle.net/10380/3053\",\n"
"	\"DocumentationURL\" : \"http://wiki.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/N4ITKBiasFieldCorrection\",\n"
"	\"License\" : \"\",\n"
"	\"ParameterGroups\" : \n"
"	[\n"
"		{\n"
"			\"Description\" : \"Input/output parameters\",\n"
"			\"Label\" : \"IO\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Input image where you observe signal inhomegeneity\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"0\",\n"
"					\"Label\" : \"Input Image\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"inputImageName\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Binary mask that defines the structure of your interest. NOTE: This parameter is OPTIONAL. If the mask is not specified, the module will use internally Otsu thresholding to define this mask. Better processing results can often be obtained when a meaningful mask is defined.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Mask Image\",\n"
"					\"LongFlag\" : \"maskimage\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"maskImageName\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"output\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Result of processing\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"1\",\n"
"					\"Label\" : \"Output Volume\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"outputImageName\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"output\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Recovered bias field (OPTIONAL)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Output bias field image\",\n"
"					\"LongFlag\" : \"outputbiasfield\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"outputBiasFieldName\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"\",\n"
"			\"Label\" : \"N4 Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::vector<float>\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Resolution of the initial bspline grid defined as a sequence of three numbers. The actual resolution will be defined by adding the bspline order (default is 3) to the resolution in each dimension specified here. For example, 1,1,1 will result in a 4x4x4 grid of control points. This parameter may need to be adjusted based on your input image. In the multi-resolution N4 framework, the resolution of the bspline grid at subsequent iterations will be doubled. The number of resolutions is implicitly defined by Number of iterations parameter (the size of this list is the number of resolutions)\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"BSpline grid resolution\",\n"
"					\"LongFlag\" : \"meshresolution\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"initialMeshResolution\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"float-vector\",\n"
"					\"Value\" : \"1,1,1\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"float\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"An alternative means to define the spline grid, by setting the distance between the control points. This parameter is used only if the grid resolution is not specified.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Spline distance\",\n"
"					\"LongFlag\" : \"splinedistance\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"splineDistance\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"float\",\n"
"					\"Value\" : \"0\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"float\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Bias field Full Width at Half Maximum. Zero implies use of the default value.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Bias field Full Width at Half Maximum\",\n"
"					\"LongFlag\" : \"bffwhm\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"bfFWHM\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"float\",\n"
"					\"Value\" : \"0\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Advanced parameters of the algorithm\",\n"
"			\"Label\" : \"Advanced N4 Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::vector<int>\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Maximum number of iterations at each level of resolution. Larger values will increase execution time, but may lead to better results.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Number of iterations\",\n"
"					\"LongFlag\" : \"iterations\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"numberOfIterations\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer-vector\",\n"
"					\"Value\" : \"50,40,30\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"float\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Stopping criterion for the iterative bias estimation. Larger values will lead to smaller execution time.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Convergence threshold\",\n"
"					\"LongFlag\" : \"convergencethreshold\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"convergenceThreshold\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"float\",\n"
"					\"Value\" : \"0.0001\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Order of B-spline used in the approximation. Larger values will lead to longer execution times, may result in overfitting and poor result.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"BSpline order\",\n"
"					\"LongFlag\" : \"bsplineorder\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"bsplineOrder\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"3\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Defines how much the image should be upsampled before estimating the inhomogeneity field. Increase if you want to reduce the execution time. 1 corresponds to the original resolution. Larger values will significantly reduce the computation time.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Shrink factor\",\n"
"					\"LongFlag\" : \"shrinkfactor\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"shrinkFactor\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"4\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Weight Image\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Weight Image\",\n"
"					\"LongFlag\" : \"weightimage\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"weightImageName\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"float\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Wiener filter noise. Zero implies use of the default value.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Wiener filter noise\",\n"
"					\"LongFlag\" : \"wienerfilternoise\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"wienerFilterNoise\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"float\",\n"
"					\"Value\" : \"0\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Number of histogram bins. Zero implies use of the default value.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Number of histogram bins\",\n"
"					\"LongFlag\" : \"nhistogrambins\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"nHistogramBins\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"0\"\n"
"				}\n"
"			]\n"
"		}\n"
"	],\n"
"	\"Title\" : \"N4ITK MRI Bias correction\",\n"
"	\"Version\" : \"9\"\n"
"}\n"
"\n"
;
}
#define GENERATE_DESERIALIZATION \
    if (argc >= 2) \
      { \
      for (int arg_idx = 0; arg_idx < argc; ++arg_idx) \
        { \
        if (strcmp(argv[arg_idx],"--deserialize") == 0) \
          { \
          std::ifstream fStream( argv[arg_idx+1] ); \
          if( !fStream.is_open() ) \
            { \
            std::cerr << "Could not open file: " << argv[arg_idx+1] << " for writing." << std::endl; \
            return EXIT_FAILURE; \
            } \
          Json::Value root; \
          Json::Reader reader; \
          reader.parse( fStream, root ); \
          const Json::Value & parameters = root["Parameters"]; \
          if (!parameters["IO"]["inputImageName"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["inputImageName"].asString()); \
            } \
          if (!parameters["IO"]["maskImageName"].isNull()) \
            { \
            Json::Value param = parameters["IO"]["maskImageName"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--maskimage"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--maskimage"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["IO"]["outputImageName"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["outputImageName"].asString()); \
            } \
          if (!parameters["IO"]["outputBiasFieldName"].isNull()) \
            { \
            Json::Value param = parameters["IO"]["outputBiasFieldName"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--outputbiasfield"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--outputbiasfield"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["N4 Parameters"]["initialMeshResolution"].isNull()) \
            { \
            Json::Value param = parameters["N4 Parameters"]["initialMeshResolution"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--meshresolution"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--meshresolution"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["N4 Parameters"]["splineDistance"].isNull()) \
            { \
            Json::Value param = parameters["N4 Parameters"]["splineDistance"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--splinedistance"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--splinedistance"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["N4 Parameters"]["bfFWHM"].isNull()) \
            { \
            Json::Value param = parameters["N4 Parameters"]["bfFWHM"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--bffwhm"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--bffwhm"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Advanced N4 Parameters"]["numberOfIterations"].isNull()) \
            { \
            Json::Value param = parameters["Advanced N4 Parameters"]["numberOfIterations"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--iterations"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--iterations"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Advanced N4 Parameters"]["convergenceThreshold"].isNull()) \
            { \
            Json::Value param = parameters["Advanced N4 Parameters"]["convergenceThreshold"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--convergencethreshold"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--convergencethreshold"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Advanced N4 Parameters"]["bsplineOrder"].isNull()) \
            { \
            Json::Value param = parameters["Advanced N4 Parameters"]["bsplineOrder"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--bsplineorder"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--bsplineorder"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Advanced N4 Parameters"]["shrinkFactor"].isNull()) \
            { \
            Json::Value param = parameters["Advanced N4 Parameters"]["shrinkFactor"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--shrinkfactor"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--shrinkfactor"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Advanced N4 Parameters"]["weightImageName"].isNull()) \
            { \
            Json::Value param = parameters["Advanced N4 Parameters"]["weightImageName"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--weightimage"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--weightimage"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Advanced N4 Parameters"]["wienerFilterNoise"].isNull()) \
            { \
            Json::Value param = parameters["Advanced N4 Parameters"]["wienerFilterNoise"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--wienerfilternoise"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--wienerfilternoise"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Advanced N4 Parameters"]["nHistogramBins"].isNull()) \
            { \
            Json::Value param = parameters["Advanced N4 Parameters"]["nHistogramBins"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--nhistogrambins"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--nhistogrambins"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          } \
        } \
      }
#define GENERATE_SERIALIZATION \
    if( parametersSerializeArg.isSet() ) \
      { \
      Json::Value root; \
      Json::Value & parameters = root["Parameters"]; \
        { \
        Json::Value & parameterGroup = parameters["IO"]; \
        parameterGroup["inputImageName"] = JsonSerialize( inputImageName ); \
        parameterGroup["maskImageName"] = JsonSerialize( maskImageName ); \
        parameterGroup["outputImageName"] = JsonSerialize( outputImageName ); \
        parameterGroup["outputBiasFieldName"] = JsonSerialize( outputBiasFieldName ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["N4 Parameters"]; \
        parameterGroup["initialMeshResolution"] = JsonSerialize( initialMeshResolution ); \
        parameterGroup["splineDistance"] = JsonSerialize( splineDistance ); \
        parameterGroup["bfFWHM"] = JsonSerialize( bfFWHM ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Advanced N4 Parameters"]; \
        parameterGroup["numberOfIterations"] = JsonSerialize( numberOfIterations ); \
        parameterGroup["convergenceThreshold"] = JsonSerialize( convergenceThreshold ); \
        parameterGroup["bsplineOrder"] = JsonSerialize( bsplineOrder ); \
        parameterGroup["shrinkFactor"] = JsonSerialize( shrinkFactor ); \
        parameterGroup["weightImageName"] = JsonSerialize( weightImageName ); \
        parameterGroup["wienerFilterNoise"] = JsonSerialize( wienerFilterNoise ); \
        parameterGroup["nHistogramBins"] = JsonSerialize( nHistogramBins ); \
        } \
      std::ofstream fStream( parametersSerializeArg.getValue().c_str() ); \
      if( !fStream.is_open() ) \
        { \
        std::cerr << "Could not open file: " << parametersSerializeArg.getValue() << " for writing." << std::endl; \
        return EXIT_FAILURE; \
        } \
      Json::StyledStreamWriter writer; \
      writer.write( fStream, root ); \
      fStream.close(); \
      }
#if defined(main) && !defined(REGISTER_TEST)
// If main defined as a preprocessor symbol, redefine it to the expected entry point.
#undef main
#define main ModuleEntryPoint

extern "C" {
  Module_EXPORT char *GetXMLModuleDescription();
  Module_EXPORT int ModuleEntryPoint(int, char*[]);
  Module_EXPORT unsigned char *GetModuleLogo(int *width, int *height, int *pixel_size, unsigned long *bufferLength);
}
#endif

extern "C" {
Module_EXPORT char XMLModuleDescription[] = 
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<executable>\n"
"  <category>Filtering</category>\n"
"  <title>N4ITK MRI Bias correction</title>\n"
"  <index>3</index>\n"
"  <description><![CDATA[Performs image bias correction using N4 algorithm. This module is based on the ITK filters contributed in the following publication:  Tustison N, Gee J \"N4ITK: Nick's N3 ITK Implementation For MRI Bias Field Correction\", The Insight Journal 2009 January-June, http://hdl.handle.net/10380/3053]]></description>\n"
"  <version>9</version>\n"
"  <documentation-url>http://wiki.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/N4ITKBiasFieldCorrection</documentation-url>\n"
"  <license/>\n"
"  <contributor>Nick Tustison (UPenn), Andrey Fedorov (SPL, BWH), Ron Kikinis (SPL, BWH)</contributor>\n"
"  <acknowledgements><![CDATA[The development of this module was partially supported by NIH grants R01 AA016748-01, R01 CA111288 and U01 CA151261 as well as by NA-MIC, NAC, NCIGT and the Slicer community.]]></acknowledgements>\n"
"  <parameters>\n"
"    <label>IO</label>\n"
"    <description><![CDATA[Input/output parameters]]></description>\n"
"    <image>\n"
"      <name>inputImageName</name>\n"
"      <label>Input Image</label>\n"
"      <channel>input</channel>\n"
"      <index>0</index>\n"
"      <description><![CDATA[Input image where you observe signal inhomegeneity]]></description>\n"
"    </image>\n"
"    <image>\n"
"      <longflag>maskimage</longflag>\n"
"      <name>maskImageName</name>\n"
"      <label>Mask Image</label>\n"
"      <channel>input</channel>\n"
"      <description><![CDATA[Binary mask that defines the structure of your interest. NOTE: This parameter is OPTIONAL. If the mask is not specified, the module will use internally Otsu thresholding to define this mask. Better processing results can often be obtained when a meaningful mask is defined.]]></description>\n"
"    </image>\n"
"    <image reference=\"inputImageName\">\n"
"      <name>outputImageName</name>\n"
"      <label>Output Volume</label>\n"
"      <channel>output</channel>\n"
"      <index>1</index>\n"
"      <description><![CDATA[Result of processing]]></description>\n"
"    </image>\n"
"    <image reference=\"inputImageName\">\n"
"      <longflag>outputbiasfield</longflag>\n"
"      <name>outputBiasFieldName</name>\n"
"      <label>Output bias field image</label>\n"
"      <channel>output</channel>\n"
"      <description><![CDATA[Recovered bias field (OPTIONAL)]]></description>\n"
"    </image>\n"
"  </parameters>\n"
"  <parameters>\n"
"    <label>N4 Parameters</label>\n"
"    <float-vector>\n"
"      <name>initialMeshResolution</name>\n"
"      <longflag>meshresolution</longflag>\n"
"      <label>BSpline grid resolution</label>\n"
"      <description><![CDATA[Resolution of the initial bspline grid defined as a sequence of three numbers. The actual resolution will be defined by adding the bspline order (default is 3) to the resolution in each dimension specified here. For example, 1,1,1 will result in a 4x4x4 grid of control points. This parameter may need to be adjusted based on your input image. In the multi-resolution N4 framework, the resolution of the bspline grid at subsequent iterations will be doubled. The number of resolutions is implicitly defined by Number of iterations parameter (the size of this list is the number of resolutions)]]></description>\n"
"      <default>1,1,1</default>\n"
"    </float-vector>\n"
"    <float>\n"
"      <name>splineDistance</name>\n"
"      <longflag>splinedistance</longflag>\n"
"      <label>Spline distance</label>\n"
"      <description><![CDATA[An alternative means to define the spline grid, by setting the distance between the control points. This parameter is used only if the grid resolution is not specified.]]></description>\n"
"      <default>0</default>\n"
"    </float>\n"
"\n"
"    <float>\n"
"      <name>bfFWHM</name>\n"
"      <longflag>bffwhm</longflag>\n"
"      <label>Bias field Full Width at Half Maximum</label>\n"
"      <description><![CDATA[Bias field Full Width at Half Maximum. Zero implies use of the default value.]]></description>\n"
"      <default>0</default>\n"
"    </float>\n"
"\n"
"  </parameters>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Advanced N4 Parameters</label>\n"
"    <description><![CDATA[Advanced parameters of the algorithm]]></description>\n"
"\n"
"    <integer-vector>\n"
"      <name>numberOfIterations</name>\n"
"      <longflag>iterations</longflag>\n"
"      <label>Number of iterations</label>\n"
"      <description><![CDATA[Maximum number of iterations at each level of resolution. Larger values will increase execution time, but may lead to better results.]]></description>\n"
"      <default>50,40,30</default>\n"
"    </integer-vector>\n"
"    <float>\n"
"      <name>convergenceThreshold</name>\n"
"      <longflag>convergencethreshold</longflag>\n"
"      <label>Convergence threshold</label>\n"
"      <description><![CDATA[Stopping criterion for the iterative bias estimation. Larger values will lead to smaller execution time.]]></description>\n"
"      <default>0.0001</default>\n"
"    </float>\n"
"\n"
"    <integer>\n"
"      <name>bsplineOrder</name>\n"
"      <longflag>bsplineorder</longflag>\n"
"      <label>BSpline order</label>\n"
"      <description><![CDATA[Order of B-spline used in the approximation. Larger values will lead to longer execution times, may result in overfitting and poor result.]]></description>\n"
"      <default>3</default>\n"
"    </integer>\n"
"\n"
"    <integer>\n"
"      <name>shrinkFactor</name>\n"
"      <longflag>shrinkfactor</longflag>\n"
"      <label>Shrink factor</label>\n"
"      <description><![CDATA[Defines how much the image should be upsampled before estimating the inhomogeneity field. Increase if you want to reduce the execution time. 1 corresponds to the original resolution. Larger values will significantly reduce the computation time.]]></description>\n"
"      <default>4</default>\n"
"    </integer>\n"
"\n"
"    <image>\n"
"      <longflag>weightimage</longflag>\n"
"      <name>weightImageName</name>\n"
"      <label>Weight Image</label>\n"
"      <channel>input</channel>\n"
"      <description><![CDATA[Weight Image]]></description>\n"
"    </image>\n"
"\n"
"    <float>\n"
"      <name>wienerFilterNoise</name>\n"
"      <longflag>wienerfilternoise</longflag>\n"
"      <label>Wiener filter noise</label>\n"
"      <description><![CDATA[Wiener filter noise. Zero implies use of the default value.]]></description>\n"
"      <default>0</default>\n"
"    </float>\n"
"\n"
"    <integer>\n"
"      <name>nHistogramBins</name>\n"
"      <longflag>nhistogrambins</longflag>\n"
"      <label>Number of histogram bins</label>\n"
"      <description><![CDATA[Number of histogram bins. Zero implies use of the default value.]]></description>\n"
"      <default>0</default>\n"
"    </integer>\n"
"\n"
"  </parameters>\n"
"</executable>\n"
"\n"
;

#define static Module_EXPORT
#define const
#define image_NAMICLogo_width ModuleLogoWidth
#define image_NAMICLogo_height ModuleLogoHeight
#define image_NAMICLogo_pixel_size ModuleLogoPixelSize
#define image_NAMICLogo_length ModuleLogoLength
#define image_NAMICLogo ModuleLogoImage
#include "/usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/NAMICLogo.h"
#undef static
#undef const
#undef image_NAMICLogo_width
#undef image_NAMICLogo_height
#undef image_NAMICLogo_pixel_size
#undef image_NAMICLogo_length
#undef image_NAMICLogo
}

void
splitString (const std::string &text,
             const std::string &separators,
             std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  std::string::size_type start = text.find_first_not_of(separators);
  while (start < n)
    {
    std::string::size_type stop = text.find_first_of(separators, start);
    if (stop > n) stop = n;
    words.push_back(text.substr(start, stop - start));
    start = text.find_first_not_of(separators, stop+1);
    }
}

void
splitFilenames (const std::string &text,
                std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  bool quoted;
  std::string comma(",");
  std::string quote("\"");
  std::string::size_type start = text.find_first_not_of(comma);
  while (start < n)
    {
    quoted = false;
    std::string::size_type startq = text.find_first_of(quote, start);
    std::string::size_type stopq = text.find_first_of(quote, startq+1);
    std::string::size_type stop = text.find_first_of(comma, start);
    if (stop > n) stop = n;
    if (startq != std::string::npos && stopq != std::string::npos)
      {
      while (startq < stop && stop < stopq && stop != n)
         {
         quoted = true;
         stop = text.find_first_of(comma, stop+1);
         if (stop > n) stop = n;
         }
      }
    if (!quoted)
      {
      words.push_back(text.substr(start, stop - start));
      }
    else
      {
      words.push_back(text.substr(start+1, stop - start-2));
      }
    start = text.find_first_not_of(comma, stop+1);
    }
}

unsigned char *GetModuleLogo(int *width,
                             int *height,
                             int *pixel_size,
                             unsigned long *length)
{
  *width = ModuleLogoWidth;
  *height = ModuleLogoHeight;
  *pixel_size = ModuleLogoPixelSize;
  *length = ModuleLogoLength;
  return const_cast<unsigned char *>(ModuleLogoImage);
}

char *GetXMLModuleDescription()
{
   return XMLModuleDescription;
}

#define GENERATE_LOGO \
  if (argc >= 2 && (strcmp(argv[1],"--logo") == 0)) \
    { \
    int width, height, pixel_size;     \
    unsigned long length;  \
    unsigned char *logo = GetModuleLogo(&width, &height, &pixel_size, &length);  \
    std::cout << "LOGO" << std::endl;  \
    std::cout << width << std::endl;  \
    std::cout << height << std::endl;  \
    std::cout << pixel_size << std::endl;  \
    std::cout << length << std::endl;  \
    std::cout << logo << std::endl;  \
    return EXIT_SUCCESS;  \
    }
#define GENERATE_XML \
  if (argc >= 2 && (strcmp(argv[1],"--xml") == 0)) \
    { \
    std::cout << GetXMLModuleDescription(); \
    return EXIT_SUCCESS; \
    }
#define GENERATE_DECLARE \
    /* These two vectors are used to store the JSON deserialized value */ \
    /* that are then compiled with the command line. */ \
    std::vector< std::string > deserializedVectorFlaggedArgs; \
    std::vector< std::string > deserializedVectorPositionalArgs; \
    /* This map is used to store the JSON deserialized value of multiple args*/ \
    /* where the key is the argument flag and the value the values of each arg. */ \
    std::map< std::string, std::vector<std::string> > deserializedMultipleArgsMap; \
 \
    /* This vector is used to look up if a flag requires an argument after it. */ \
    /* This is used to differentiate between: */ \
    /* ./myExec --boolFlag /my/first/arg */ \
    /* ./myExec --flag flagArg */ \
    std::vector< std::string > nonbooleanFlags; \
    nonbooleanFlags.push_back("--maskimage"); \
    nonbooleanFlags.push_back("--outputbiasfield"); \
    nonbooleanFlags.push_back("--meshresolution"); \
    nonbooleanFlags.push_back("--splinedistance"); \
    nonbooleanFlags.push_back("--bffwhm"); \
    nonbooleanFlags.push_back("--iterations"); \
    nonbooleanFlags.push_back("--convergencethreshold"); \
    nonbooleanFlags.push_back("--bsplineorder"); \
    nonbooleanFlags.push_back("--shrinkfactor"); \
    nonbooleanFlags.push_back("--weightimage"); \
    nonbooleanFlags.push_back("--wienerfilternoise"); \
    nonbooleanFlags.push_back("--nhistogrambins"); \
    nonbooleanFlags.push_back("--serialize"); \
    nonbooleanFlags.push_back("--deserialize"); \
    nonbooleanFlags.push_back("--processinformationaddress"); \
    nonbooleanFlags.push_back("--returnparameterfile"); \
    /* This map use is twofold: */ \
    /*  - to find whether a flag is multiple */ \
    /*  - to know if we need to reset the multiple arg value because it was */ \
    /*    in the JSON and it's also in the command line. */ \
    std::map<std::string, bool> multipleFlags; \
    std::string inputImageName; \
    std::string maskImageName; \
    std::string outputImageName; \
    std::string outputBiasFieldName; \
    std::string initialMeshResolutionTemp = "1,1,1"; \
    std::vector<float> initialMeshResolution; \
    float splineDistance = 0; \
    float bfFWHM = 0; \
    std::string numberOfIterationsTemp = "50,40,30"; \
    std::vector<int> numberOfIterations; \
    float convergenceThreshold = 0.0001; \
    int bsplineOrder = 3; \
    int shrinkFactor = 4; \
    std::string weightImageName; \
    float wienerFilterNoise = 0; \
    int nHistogramBins = 0; \
    std::string parametersSerialize; \
    std::string parametersDeSerialize; \
    bool echoSwitch = false; \
    bool xmlSwitch = false; \
    std::string processInformationAddressString = "0"; \
    std::string returnParameterFile; \

#define GENERATE_TCLAP_PARSE \
    std::string fullDescription("Description: "); \
    fullDescription += "Performs image bias correction using N4 algorithm. This module is based on the ITK filters contributed in the following publication:  Tustison N, Gee J 'N4ITK: Nick's N3 ITK Implementation For MRI Bias Field Correction', The Insight Journal 2009 January-June, http://hdl.handle.net/10380/3053"; \
    if (!std::string("Nick Tustison (UPenn), Andrey Fedorov (SPL, BWH), Ron Kikinis (SPL, BWH)").empty()) \
      { \
      fullDescription += "\nAuthor(s): Nick Tustison (UPenn), Andrey Fedorov (SPL, BWH), Ron Kikinis (SPL, BWH)"; \
      } \
    if (!std::string("The development of this module was partially supported by NIH grants R01 AA016748-01, R01 CA111288 and U01 CA151261 as well as by NA-MIC, NAC, NCIGT and the Slicer community.").empty()) \
      { \
      fullDescription += "\nAcknowledgements: The development of this module was partially supported by NIH grants R01 AA016748-01, R01 CA111288 and U01 CA151261 as well as by NA-MIC, NAC, NCIGT and the Slicer community."; \
      } \
    TCLAP::CmdLine commandLine (fullDescription, \
       ' ', \
      "9" ); \
 \
      std::ostringstream msg; \
    msg.str("");msg << "Input image where you observe signal inhomegeneity";    TCLAP::UnlabeledValueArg<std::string> inputImageNameArg("inputImageName", msg.str(), 1, inputImageName, "std::string", commandLine); \
 \
    msg.str("");msg << "Binary mask that defines the structure of your interest. NOTE: This parameter is OPTIONAL. If the mask is not specified, the module will use internally Otsu thresholding to define this mask. Better processing results can often be obtained when a meaningful mask is defined.";    TCLAP::ValueArg<std::string > maskImageNameArg("", "maskimage", msg.str(), 0, maskImageName, "std::string", commandLine); \
 \
    msg.str("");msg << "Result of processing";    TCLAP::UnlabeledValueArg<std::string> outputImageNameArg("outputImageName", msg.str(), 1, outputImageName, "std::string", commandLine); \
 \
    msg.str("");msg << "Recovered bias field (OPTIONAL)";    TCLAP::ValueArg<std::string > outputBiasFieldNameArg("", "outputbiasfield", msg.str(), 0, outputBiasFieldName, "std::string", commandLine); \
 \
    msg.str("");msg << "Resolution of the initial bspline grid defined as a sequence of three numbers. The actual resolution will be defined by adding the bspline order (default is 3) to the resolution in each dimension specified here. For example, 1,1,1 will result in a 4x4x4 grid of control points. This parameter may need to be adjusted based on your input image. In the multi-resolution N4 framework, the resolution of the bspline grid at subsequent iterations will be doubled. The number of resolutions is implicitly defined by Number of iterations parameter (the size of this list is the number of resolutions) (value: " << initialMeshResolutionTemp << ")"; \
    TCLAP::ValueArg<std::string > initialMeshResolutionArg("", "meshresolution", msg.str(), 0, initialMeshResolutionTemp, "std::vector<float>", commandLine); \
 \
    msg.str("");msg << "An alternative means to define the spline grid, by setting the distance between the control points. This parameter is used only if the grid resolution is not specified. (value: " << splineDistance << ")"; \
    TCLAP::ValueArg<float > splineDistanceArg("", "splinedistance", msg.str(), 0, splineDistance, "float", commandLine); \
 \
    msg.str("");msg << "Bias field Full Width at Half Maximum. Zero implies use of the default value. (value: " << bfFWHM << ")"; \
    TCLAP::ValueArg<float > bfFWHMArg("", "bffwhm", msg.str(), 0, bfFWHM, "float", commandLine); \
 \
    msg.str("");msg << "Maximum number of iterations at each level of resolution. Larger values will increase execution time, but may lead to better results. (value: " << numberOfIterationsTemp << ")"; \
    TCLAP::ValueArg<std::string > numberOfIterationsArg("", "iterations", msg.str(), 0, numberOfIterationsTemp, "std::vector<int>", commandLine); \
 \
    msg.str("");msg << "Stopping criterion for the iterative bias estimation. Larger values will lead to smaller execution time. (value: " << convergenceThreshold << ")"; \
    TCLAP::ValueArg<float > convergenceThresholdArg("", "convergencethreshold", msg.str(), 0, convergenceThreshold, "float", commandLine); \
 \
    msg.str("");msg << "Order of B-spline used in the approximation. Larger values will lead to longer execution times, may result in overfitting and poor result. (value: " << bsplineOrder << ")"; \
    TCLAP::ValueArg<int > bsplineOrderArg("", "bsplineorder", msg.str(), 0, bsplineOrder, "int", commandLine); \
 \
    msg.str("");msg << "Defines how much the image should be upsampled before estimating the inhomogeneity field. Increase if you want to reduce the execution time. 1 corresponds to the original resolution. Larger values will significantly reduce the computation time. (value: " << shrinkFactor << ")"; \
    TCLAP::ValueArg<int > shrinkFactorArg("", "shrinkfactor", msg.str(), 0, shrinkFactor, "int", commandLine); \
 \
    msg.str("");msg << "Weight Image";    TCLAP::ValueArg<std::string > weightImageNameArg("", "weightimage", msg.str(), 0, weightImageName, "std::string", commandLine); \
 \
    msg.str("");msg << "Wiener filter noise. Zero implies use of the default value. (value: " << wienerFilterNoise << ")"; \
    TCLAP::ValueArg<float > wienerFilterNoiseArg("", "wienerfilternoise", msg.str(), 0, wienerFilterNoise, "float", commandLine); \
 \
    msg.str("");msg << "Number of histogram bins. Zero implies use of the default value. (value: " << nHistogramBins << ")"; \
    TCLAP::ValueArg<int > nHistogramBinsArg("", "nhistogrambins", msg.str(), 0, nHistogramBins, "int", commandLine); \
 \
    msg.str("");msg << "Store the module's parameters to a file.";    TCLAP::ValueArg<std::string > parametersSerializeArg("", "serialize", msg.str(), 0, parametersSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Restore the module's parameters that were previously archived.";    TCLAP::ValueArg<std::string > parametersDeSerializeArg("", "deserialize", msg.str(), 0, parametersDeSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Echo the command line arguments (value: " << echoSwitch << ")"; \
    TCLAP::SwitchArg echoSwitchArg("", "echo", msg.str(), commandLine, echoSwitch); \
 \
    msg.str("");msg << "Produce xml description of command line arguments (value: " << xmlSwitch << ")"; \
    TCLAP::SwitchArg xmlSwitchArg("", "xml", msg.str(), commandLine, xmlSwitch); \
 \
    msg.str("");msg << "Address of a structure to store process information (progress, abort, etc.). (value: " << processInformationAddressString << ")"; \
    TCLAP::ValueArg<std::string > processInformationAddressStringArg("", "processinformationaddress", msg.str(), 0, processInformationAddressString, "std::string", commandLine); \
 \
    msg.str("");msg << "Filename in which to write simple return parameters (int, float, int-vector, etc.) as opposed to bulk return parameters (image, geometry, transform, measurement, table).";    TCLAP::ValueArg<std::string > returnParameterFileArg("", "returnparameterfile", msg.str(), 0, returnParameterFile, "std::string", commandLine); \
 \
try \
  { \
    /* Build a map of flag aliases to the true flag */ \
    std::map<std::string,std::string> flagAliasMap; \
    std::map<std::string,std::string> deprecatedFlagAliasMap; \
    std::map<std::string,std::string> longFlagAliasMap; \
    std::map<std::string,std::string> deprecatedLongFlagAliasMap; \
 \
    /* Go through argc and consolidate the JSON with the parameters from the command line */ \
    /* In case of conflict, take the command line. */ \
    std::map<std::string,std::string>::iterator ait; \
    std::map<std::string,std::string>::iterator dait; \
    std::vector<std::string>::iterator dvOptionnalArgsIt = deserializedVectorFlaggedArgs.begin(); \
    std::map<std::string, std::vector<std::string> >::iterator dvMultipleArgsIt; \
    size_t noFlagCounter = 0; \
    size_t ac = 1; \
 \
    while (ac < static_cast<size_t>(argc)) \
      { \
      /* short flag case && long flag case */ \
       if ((strlen(argv[ac]) == 2 && argv[ac][0]=='-') \
           || (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]=='-')) \
         { \
         std::string flag = argv[ac]; \
         /* Remap the flag if necessary */ \
         if (strlen(argv[ac]) == 2) \
           { \
           /* Short flag remapping */ \
           ait = flagAliasMap.find(flag); \
           dait = deprecatedFlagAliasMap.find(flag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << flag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         else \
           { \
           /* Long flag remapping */ \
           ait = longFlagAliasMap.find(flag); \
           dait = deprecatedLongFlagAliasMap.find(flag); \
           if (ait != longFlagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedLongFlagAliasMap.end()) \
             { \
             std::cout << "Long flag \"" << flag << "\" is deprecated. Please use long flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         bool isMultiple = multipleFlags.find(flag) != multipleFlags.end(); \
         bool isBoolean = std::find(nonbooleanFlags.begin(), nonbooleanFlags.end(), flag) == nonbooleanFlags.end(); \
         dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), flag); \
         bool isPresentVFA = dvOptionnalArgsIt != deserializedVectorFlaggedArgs.end(); \
         if (isBoolean) \
           { \
           /*Ignore if boolean and already present*/ \
           /*Otherwise add it*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           } \
         else if (isMultiple) \
           { \
           dvMultipleArgsIt = deserializedMultipleArgsMap.find(flag); \
           bool isPresentMA = dvMultipleArgsIt != deserializedMultipleArgsMap.end(); \
           /*Ignore if boolean and already present*/ \
           /*Reset/Add the value if first deserialize or not present*/ \
           if (!isPresentMA || !multipleFlags[flag]) \
             { \
             deserializedMultipleArgsMap[flag] = std::vector<std::string>(); \
             multipleFlags[flag] = true; \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           deserializedMultipleArgsMap[flag].push_back(value); \
           } \
         else \
           { \
           /*Add the flag and if needed*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(value);  \
             } \
           else \
             { \
             *(++dvOptionnalArgsIt) = value; \
             } \
           } \
         } \
       /* short flag case where multiple flags are given at once */ \
       else if (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]!='-') \
         { \
         std::string rflag(argv[ac], 1, std::string::npos); \
         for (std::string::size_type fi=0; fi < rflag.size(); ++fi) \
           { \
           std::string tf(rflag, fi, 1); \
           std::string newFlag ="-"; \
           newFlag += tf; \
           ait = flagAliasMap.find(newFlag); \
           dait = deprecatedFlagAliasMap.find(newFlag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             newFlag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << newFlag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             newFlag = (*dait).second; \
             } \
           dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), newFlag); \
           /*These flags are always boolean, just add it if it's not there already */ \
           if (dvOptionnalArgsIt == deserializedVectorFlaggedArgs.end()) \
             { \
             deserializedVectorFlaggedArgs.push_back(newFlag); \
             } \
           } \
         ++ac; \
         } \
       else \
         { \
         /* Replace if needed, otherwise append.*/ \
         if (noFlagCounter < deserializedVectorPositionalArgs.size()) \
           { \
           deserializedVectorPositionalArgs[noFlagCounter] = argv[ac]; \
           } \
         else \
           { \
           deserializedVectorPositionalArgs.push_back(argv[ac]); \
           } \
         ++ac; \
         ++noFlagCounter; \
         } \
       } \
 \
    /* Put the now compiled arguments in the argvVector */ \
    std::vector<std::string> argvVector; \
    argvVector.push_back(argv[0]); \
    argvVector.insert(argvVector.end(), deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end()); \
    std::map<std::string, std::vector<std::string> >::iterator mavit; \
    for (mavit = deserializedMultipleArgsMap.begin(); mavit != deserializedMultipleArgsMap.end(); ++mavit) \
      { \
      for (size_t i = 0; i < mavit->second.size(); ++i) \
        { \
        argvVector.push_back(mavit->first); \
        argvVector.push_back(mavit->second.at(i)); \
        } \
      } \
    argvVector.insert(argvVector.end(), deserializedVectorPositionalArgs.begin(), deserializedVectorPositionalArgs.end()); \
 \
   /* Remap args to a structure that CmdLine::parse() can understand*/ \
   std::vector<char*> vargs; \
   for (ac = 0; ac < argvVector.size(); ++ac) \
     {  \
     vargs.push_back(const_cast<char *>(argvVector[ac].c_str())); \
     } \
    commandLine.parse ( static_cast<int>(vargs.size()), (char**) &(vargs[0]) ); \
  } \
catch ( TCLAP::ArgException & e ) \
  { \
  std::cerr << "error: " << e.error() << " for arg " << e.argId() << std::endl; \
  return ( EXIT_FAILURE ); \
  }
#define GENERATE_TCLAP_ASSIGNMENT \
      inputImageName = inputImageNameArg.getValue(); \
      maskImageName = maskImageNameArg.getValue(); \
      outputImageName = outputImageNameArg.getValue(); \
      outputBiasFieldName = outputBiasFieldNameArg.getValue(); \
      initialMeshResolutionTemp = initialMeshResolutionArg.getValue(); \
      splineDistance = splineDistanceArg.getValue(); \
      bfFWHM = bfFWHMArg.getValue(); \
      numberOfIterationsTemp = numberOfIterationsArg.getValue(); \
      convergenceThreshold = convergenceThresholdArg.getValue(); \
      bsplineOrder = bsplineOrderArg.getValue(); \
      shrinkFactor = shrinkFactorArg.getValue(); \
      weightImageName = weightImageNameArg.getValue(); \
      wienerFilterNoise = wienerFilterNoiseArg.getValue(); \
      nHistogramBins = nHistogramBinsArg.getValue(); \
      parametersSerialize = parametersSerializeArg.getValue(); \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      echoSwitch = echoSwitchArg.getValue(); \
      xmlSwitch = xmlSwitchArg.getValue(); \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      returnParameterFile = returnParameterFileArg.getValue(); \
      { /* Assignment for initialMeshResolution */ \
      initialMeshResolution.clear(); \
      std::vector<std::string> words; \
      std::string sep(","); \
      splitString(initialMeshResolutionTemp, sep, words); \
      for (unsigned int _j = 0; _j < words.size(); _j++) \
        { \
        initialMeshResolution.push_back(atof(words[_j].c_str())); \
        } \
      } \
      { /* Assignment for numberOfIterations */ \
      numberOfIterations.clear(); \
      std::vector<std::string> words; \
      std::string sep(","); \
      splitString(numberOfIterationsTemp, sep, words); \
      for (unsigned int _j = 0; _j < words.size(); _j++) \
        { \
        numberOfIterations.push_back(atoi(words[_j].c_str())); \
        } \
      } \

#define GENERATE_TCLAP GENERATE_TCLAP_PARSE;GENERATE_TCLAP_ASSIGNMENT
#define GENERATE_TCLAP_ASSIGNMENT_IFSET \
    if( inputImageNameArg.isSet() ) \
      { \
      inputImageName = inputImageNameArg.getValue(); \
      } \
    if( maskImageNameArg.isSet() ) \
      { \
      maskImageName = maskImageNameArg.getValue(); \
      } \
    if( outputImageNameArg.isSet() ) \
      { \
      outputImageName = outputImageNameArg.getValue(); \
      } \
    if( outputBiasFieldNameArg.isSet() ) \
      { \
      outputBiasFieldName = outputBiasFieldNameArg.getValue(); \
      } \
    if( initialMeshResolutionArg.isSet() ) \
      { \
      initialMeshResolutionTemp = initialMeshResolutionArg.getValue(); \
      } \
    if( splineDistanceArg.isSet() ) \
      { \
      splineDistance = splineDistanceArg.getValue(); \
      } \
    if( bfFWHMArg.isSet() ) \
      { \
      bfFWHM = bfFWHMArg.getValue(); \
      } \
    if( numberOfIterationsArg.isSet() ) \
      { \
      numberOfIterationsTemp = numberOfIterationsArg.getValue(); \
      } \
    if( convergenceThresholdArg.isSet() ) \
      { \
      convergenceThreshold = convergenceThresholdArg.getValue(); \
      } \
    if( bsplineOrderArg.isSet() ) \
      { \
      bsplineOrder = bsplineOrderArg.getValue(); \
      } \
    if( shrinkFactorArg.isSet() ) \
      { \
      shrinkFactor = shrinkFactorArg.getValue(); \
      } \
    if( weightImageNameArg.isSet() ) \
      { \
      weightImageName = weightImageNameArg.getValue(); \
      } \
    if( wienerFilterNoiseArg.isSet() ) \
      { \
      wienerFilterNoise = wienerFilterNoiseArg.getValue(); \
      } \
    if( nHistogramBinsArg.isSet() ) \
      { \
      nHistogramBins = nHistogramBinsArg.getValue(); \
      } \
    if( parametersSerializeArg.isSet() ) \
      { \
      parametersSerialize = parametersSerializeArg.getValue(); \
      } \
    if( parametersDeSerializeArg.isSet() ) \
      { \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      } \
    if( echoSwitchArg.isSet() ) \
      { \
      echoSwitch = echoSwitchArg.getValue(); \
      } \
    if( xmlSwitchArg.isSet() ) \
      { \
      xmlSwitch = xmlSwitchArg.getValue(); \
      } \
    if( processInformationAddressStringArg.isSet() ) \
      { \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      } \
    if( returnParameterFileArg.isSet() ) \
      { \
      returnParameterFile = returnParameterFileArg.getValue(); \
      } \
    if( initialMeshResolutionArg.isSet() ) \
      { /* Assignment for initialMeshResolution */ \
      initialMeshResolution.clear(); \
      std::vector<std::string> words; \
      std::string sep(","); \
      splitString(initialMeshResolutionTemp, sep, words); \
      for (unsigned int _j = 0; _j < words.size(); _j++) \
        { \
        initialMeshResolution.push_back(atof(words[_j].c_str())); \
        } \
      } \
    if( numberOfIterationsArg.isSet() ) \
      { /* Assignment for numberOfIterations */ \
      numberOfIterations.clear(); \
      std::vector<std::string> words; \
      std::string sep(","); \
      splitString(numberOfIterationsTemp, sep, words); \
      for (unsigned int _j = 0; _j < words.size(); _j++) \
        { \
        numberOfIterations.push_back(atoi(words[_j].c_str())); \
        } \
      } \

#define GENERATE_ECHOARGS \
if (echoSwitch) \
{ \
std::cout << "Command Line Arguments" << std::endl; \
std::cout << "    inputImageName: " << inputImageName << std::endl; \
std::cout << "    maskImageName: " << maskImageName << std::endl; \
std::cout << "    outputImageName: " << outputImageName << std::endl; \
std::cout << "    outputBiasFieldName: " << outputBiasFieldName << std::endl; \
std::cout << "    initialMeshResolution: "; \
for (unsigned int _i =0; _i < initialMeshResolution.size(); _i++) \
{ \
std::cout << initialMeshResolution[_i] << ", "; \
} \
std::cout <<std::endl; \
std::cout << "    splineDistance: " << splineDistance << std::endl; \
std::cout << "    bfFWHM: " << bfFWHM << std::endl; \
std::cout << "    numberOfIterations: "; \
for (unsigned int _i =0; _i < numberOfIterations.size(); _i++) \
{ \
std::cout << numberOfIterations[_i] << ", "; \
} \
std::cout <<std::endl; \
std::cout << "    convergenceThreshold: " << convergenceThreshold << std::endl; \
std::cout << "    bsplineOrder: " << bsplineOrder << std::endl; \
std::cout << "    shrinkFactor: " << shrinkFactor << std::endl; \
std::cout << "    weightImageName: " << weightImageName << std::endl; \
std::cout << "    wienerFilterNoise: " << wienerFilterNoise << std::endl; \
std::cout << "    nHistogramBins: " << nHistogramBins << std::endl; \
std::cout << "    parametersSerialize: " << parametersSerialize << std::endl; \
std::cout << "    parametersDeSerialize: " << parametersDeSerialize << std::endl; \
std::cout << "    echoSwitch: " << echoSwitch << std::endl; \
std::cout << "    xmlSwitch: " << xmlSwitch << std::endl; \
std::cout << "    processInformationAddressString: " << processInformationAddressString << std::endl; \
std::cout << "    returnParameterFile: " << returnParameterFile << std::endl; \
}
#define GENERATE_ProcessInformationAddressDecoding \
ModuleProcessInformation *CLPProcessInformation = 0; \
if (processInformationAddressString != "") \
{ \
sscanf(processInformationAddressString.c_str(), "%p", &CLPProcessInformation); \
}
#define PARSE_ARGS GENERATE_LOGO;GENERATE_XML;GENERATE_DECLARE;GENERATE_DESERIALIZATION;GENERATE_TCLAP;GENERATE_ECHOARGS;GENERATE_ProcessInformationAddressDecoding;GENERATE_SERIALIZATION;
