// This file was automatically generated by:
//  /usr/bin/GenerateCLP --logoFiles /usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/NAMICLogo.h --InputXML /usr/src/RPM/BUILD/slicer-4.11.20210226/Modules/CLI/RobustStatisticsSegmenter/RobustStatisticsSegmenter.xml --OutputCxx /usr/src/RPM/BUILD/slicer-4.11.20210226/BUILD/Modules/CLI/RobustStatisticsSegmenter/RobustStatisticsSegmenterCLP.h
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
#include <map>

#include <sstream>
#include <fstream>
#include <stdexcept>

#include "tclap/CmdLine.h"
#include "JsonSerializationUtilities.h"
#include "ModuleProcessInformation.h"

#ifdef _WIN32
#define Module_EXPORT __declspec(dllexport)
#elif defined(MODULE_HIDDEN_VISIBILITY)
#define Module_EXPORT __attribute__((visibility("default")))
#else
#define Module_EXPORT
#endif


extern "C" {
Module_EXPORT char JSONModuleDescription[] =
"{\n"
"	\"Category\" : \"Segmentation.Specialized\",\n"
"	\"Contributor\" : \"Yi Gao (gatech), Allen Tannenbaum (gatech), Ron Kikinis (SPL, BWH)\",\n"
"	\"Description\" : \"Active contour segmentation using robust statistic.\",\n"
"	\"DocumentationURL\" : \"http://wiki.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/RobustStatisticsSegmenter\",\n"
"	\"License\" : \"\",\n"
"	\"ParameterGroups\" : \n"
"	[\n"
"		{\n"
"			\"Description\" : \"Parameters for robust statistics segmentation\",\n"
"			\"Label\" : \"Segmentation Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"double\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The approximate volume of the object, in mL.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"v\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Approximate volume(mL)\",\n"
"					\"LongFlag\" : \"expectedVolume\",\n"
"					\"Maximum\" : \"1000000\",\n"
"					\"Minimum\" : \"0.0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"expectedVolume\",\n"
"					\"Step\" : \"100\",\n"
"					\"Tag\" : \"double\",\n"
"					\"Value\" : \"50\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Some auxiliary parameters to control the stop criteria.\",\n"
"			\"Label\" : \"Auxiliary Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"double\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"What is the homogeneity of intensity within the object? Given constant intensity at 1.0 score and extreme fluctuating intensity at 0.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Intensity Homogeneity[0-1.0]\",\n"
"					\"LongFlag\" : \"intensityHomogeneity\",\n"
"					\"Maximum\" : \"1.0\",\n"
"					\"Minimum\" : \"0.0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"intensityHomogeneity\",\n"
"					\"Step\" : \"0.1\",\n"
"					\"Tag\" : \"double\",\n"
"					\"Value\" : \"0.6\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"double\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Given sphere 1.0 score and extreme rough bounday/surface 0 score, what is the expected smoothness of the object?\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"c\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Boundary Smoothness[0-1.0]\",\n"
"					\"LongFlag\" : \"curvatureWeight\",\n"
"					\"Maximum\" : \"1.0\",\n"
"					\"Minimum\" : \"0.0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"curvatureWeight\",\n"
"					\"Step\" : \"0.1\",\n"
"					\"Tag\" : \"double\",\n"
"					\"Value\" : \"0.5\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Label value of the output image\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Output Label Value\",\n"
"					\"LongFlag\" : \"labelValue\",\n"
"					\"Maximum\" : \"1000\",\n"
"					\"Minimum\" : \"1\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"labelValue\",\n"
"					\"Step\" : \"1\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"1\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"double\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The program will stop if this time is reached.\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Max running time(min)\",\n"
"					\"LongFlag\" : \"maxRunningTime\",\n"
"					\"Maximum\" : \"60\",\n"
"					\"Minimum\" : \"0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"maxRunningTime\",\n"
"					\"Step\" : \"1\",\n"
"					\"Tag\" : \"double\",\n"
"					\"Value\" : \"10\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Input/output parameters\",\n"
"			\"Label\" : \"IO\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Original image to be segmented\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"0\",\n"
"					\"Label\" : \"Original Image\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"originalImageFileName\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Label image for initialization\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"1\",\n"
"					\"Label\" : \"Label Image\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"labelImageFileName\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"output\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Segmented image\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"2\",\n"
"					\"Label\" : \"Output Volume\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"segmentedImageFileName\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				}\n"
"			]\n"
"		}\n"
"	],\n"
"	\"Title\" : \"Robust Statistics Segmenter\",\n"
"	\"Version\" : \"1.0\"\n"
"}\n"
"\n"
;
}
#define GENERATE_DESERIALIZATION \
    if (argc >= 2) \
      { \
      for (int arg_idx = 0; arg_idx < argc; ++arg_idx) \
        { \
        if (strcmp(argv[arg_idx],"--deserialize") == 0) \
          { \
          std::ifstream fStream( argv[arg_idx+1] ); \
          if( !fStream.is_open() ) \
            { \
            std::cerr << "Could not open file: " << argv[arg_idx+1] << " for writing." << std::endl; \
            return EXIT_FAILURE; \
            } \
          Json::Value root; \
          Json::Reader reader; \
          reader.parse( fStream, root ); \
          const Json::Value & parameters = root["Parameters"]; \
          if (!parameters["Segmentation Parameters"]["expectedVolume"].isNull()) \
            { \
            Json::Value param = parameters["Segmentation Parameters"]["expectedVolume"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--expectedVolume"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--expectedVolume"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Auxiliary Parameters"]["intensityHomogeneity"].isNull()) \
            { \
            Json::Value param = parameters["Auxiliary Parameters"]["intensityHomogeneity"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--intensityHomogeneity"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--intensityHomogeneity"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Auxiliary Parameters"]["curvatureWeight"].isNull()) \
            { \
            Json::Value param = parameters["Auxiliary Parameters"]["curvatureWeight"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--curvatureWeight"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--curvatureWeight"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Auxiliary Parameters"]["labelValue"].isNull()) \
            { \
            Json::Value param = parameters["Auxiliary Parameters"]["labelValue"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--labelValue"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--labelValue"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Auxiliary Parameters"]["maxRunningTime"].isNull()) \
            { \
            Json::Value param = parameters["Auxiliary Parameters"]["maxRunningTime"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--maxRunningTime"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--maxRunningTime"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["IO"]["originalImageFileName"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["originalImageFileName"].asString()); \
            } \
          if (!parameters["IO"]["labelImageFileName"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["labelImageFileName"].asString()); \
            } \
          if (!parameters["IO"]["segmentedImageFileName"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["segmentedImageFileName"].asString()); \
            } \
          } \
        } \
      }
#define GENERATE_SERIALIZATION \
    if( parametersSerializeArg.isSet() ) \
      { \
      Json::Value root; \
      Json::Value & parameters = root["Parameters"]; \
        { \
        Json::Value & parameterGroup = parameters["Segmentation Parameters"]; \
        parameterGroup["expectedVolume"] = JsonSerialize( expectedVolume ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Auxiliary Parameters"]; \
        parameterGroup["intensityHomogeneity"] = JsonSerialize( intensityHomogeneity ); \
        parameterGroup["curvatureWeight"] = JsonSerialize( curvatureWeight ); \
        parameterGroup["labelValue"] = JsonSerialize( labelValue ); \
        parameterGroup["maxRunningTime"] = JsonSerialize( maxRunningTime ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["IO"]; \
        parameterGroup["originalImageFileName"] = JsonSerialize( originalImageFileName ); \
        parameterGroup["labelImageFileName"] = JsonSerialize( labelImageFileName ); \
        parameterGroup["segmentedImageFileName"] = JsonSerialize( segmentedImageFileName ); \
        } \
      std::ofstream fStream( parametersSerializeArg.getValue().c_str() ); \
      if( !fStream.is_open() ) \
        { \
        std::cerr << "Could not open file: " << parametersSerializeArg.getValue() << " for writing." << std::endl; \
        return EXIT_FAILURE; \
        } \
      Json::StyledStreamWriter writer; \
      writer.write( fStream, root ); \
      fStream.close(); \
      }
#if defined(main) && !defined(REGISTER_TEST)
// If main defined as a preprocessor symbol, redefine it to the expected entry point.
#undef main
#define main ModuleEntryPoint

extern "C" {
  Module_EXPORT char *GetXMLModuleDescription();
  Module_EXPORT int ModuleEntryPoint(int, char*[]);
  Module_EXPORT unsigned char *GetModuleLogo(int *width, int *height, int *pixel_size, unsigned long *bufferLength);
}
#endif

extern "C" {
Module_EXPORT char XMLModuleDescription[] = 
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<executable>\n"
"  <category>Segmentation.Specialized</category>\n"
"  <title>Robust Statistics Segmenter</title>\n"
"  <description><![CDATA[Active contour segmentation using robust statistic.]]></description>\n"
"  <version>1.0</version>\n"
"  <documentation-url>http://wiki.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/RobustStatisticsSegmenter</documentation-url>\n"
"  <license/>\n"
"  <contributor>Yi Gao (gatech), Allen Tannenbaum (gatech), Ron Kikinis (SPL, BWH)</contributor>\n"
"  <acknowledgements><![CDATA[This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health]]></acknowledgements>\n"
"  <parameters>\n"
"    <label>Segmentation Parameters</label>\n"
"    <description><![CDATA[Parameters for robust statistics segmentation]]></description>\n"
"    <double>\n"
"      <name>expectedVolume</name>\n"
"      <longflag>expectedVolume</longflag>\n"
"      <flag>v</flag>\n"
"      <description><![CDATA[The approximate volume of the object, in mL.]]></description>\n"
"      <label>Approximate volume(mL)</label>\n"
"      <default>50</default>\n"
"      <constraints>\n"
"        <minimum>0.0</minimum>\n"
"        <maximum>1000000</maximum>\n"
"        <step>100</step>\n"
"      </constraints>\n"
"    </double>\n"
"  </parameters>\n"
"  <parameters>\n"
"    <label>Auxiliary Parameters</label>\n"
"    <description><![CDATA[Some auxiliary parameters to control the stop criteria.]]></description>\n"
"    <double>\n"
"      <name>intensityHomogeneity</name>\n"
"      <longflag>intensityHomogeneity</longflag>\n"
"      <description><![CDATA[What is the homogeneity of intensity within the object? Given constant intensity at 1.0 score and extreme fluctuating intensity at 0.]]></description>\n"
"      <label>Intensity Homogeneity[0-1.0]</label>\n"
"      <default>0.6</default>\n"
"      <constraints>\n"
"        <minimum>0.0</minimum>\n"
"        <maximum>1.0</maximum>\n"
"        <step>0.1</step>\n"
"      </constraints>\n"
"    </double>\n"
"    <double>\n"
"      <name>curvatureWeight</name>\n"
"      <longflag>curvatureWeight</longflag>\n"
"      <flag>c</flag>\n"
"      <description><![CDATA[Given sphere 1.0 score and extreme rough bounday/surface 0 score, what is the expected smoothness of the object?]]></description>\n"
"      <label>Boundary Smoothness[0-1.0]</label>\n"
"      <default>0.5</default>\n"
"      <constraints>\n"
"        <minimum>0.0</minimum>\n"
"        <maximum>1.0</maximum>\n"
"        <step>0.1</step>\n"
"      </constraints>\n"
"    </double>\n"
"    <integer>\n"
"      <name>labelValue</name>\n"
"      <longflag>labelValue</longflag>\n"
"      <description><![CDATA[Label value of the output image]]></description>\n"
"      <label>Output Label Value</label>\n"
"      <default>1</default>\n"
"      <constraints>\n"
"        <minimum>1</minimum>\n"
"        <maximum>1000</maximum>\n"
"        <step>1</step>\n"
"      </constraints>\n"
"    </integer>\n"
"    <double>\n"
"      <name>maxRunningTime</name>\n"
"      <longflag>maxRunningTime</longflag>\n"
"      <description><![CDATA[The program will stop if this time is reached.]]></description>\n"
"      <label>Max running time(min)</label>\n"
"      <default>10</default>\n"
"      <constraints>\n"
"        <minimum>0</minimum>\n"
"        <maximum>60</maximum>\n"
"        <step>1</step>\n"
"      </constraints>\n"
"    </double>\n"
"  </parameters>\n"
"  <parameters>\n"
"    <label>IO</label>\n"
"    <description><![CDATA[Input/output parameters]]></description>\n"
"    <image type=\"scalar\">\n"
"      <name>originalImageFileName</name>\n"
"      <label>Original Image</label>\n"
"      <channel>input</channel>\n"
"      <index>0</index>\n"
"      <description><![CDATA[Original image to be segmented]]></description>\n"
"    </image>\n"
"    <image type=\"label\">\n"
"      <name>labelImageFileName</name>\n"
"      <label>Label Image</label>\n"
"      <channel>input</channel>\n"
"      <index>1</index>\n"
"      <description><![CDATA[Label image for initialization]]></description>\n"
"    </image>\n"
"    <image type=\"label\" reference=\"originalImageFileName\">\n"
"      <name>segmentedImageFileName</name>\n"
"      <label>Output Volume</label>\n"
"      <channel>output</channel>\n"
"      <index>2</index>\n"
"      <description><![CDATA[Segmented image]]></description>\n"
"    </image>\n"
"  </parameters>\n"
"</executable>\n"
"\n"
;

#define static Module_EXPORT
#define const
#define image_NAMICLogo_width ModuleLogoWidth
#define image_NAMICLogo_height ModuleLogoHeight
#define image_NAMICLogo_pixel_size ModuleLogoPixelSize
#define image_NAMICLogo_length ModuleLogoLength
#define image_NAMICLogo ModuleLogoImage
#include "/usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/NAMICLogo.h"
#undef static
#undef const
#undef image_NAMICLogo_width
#undef image_NAMICLogo_height
#undef image_NAMICLogo_pixel_size
#undef image_NAMICLogo_length
#undef image_NAMICLogo
}

void
splitString (const std::string &text,
             const std::string &separators,
             std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  std::string::size_type start = text.find_first_not_of(separators);
  while (start < n)
    {
    std::string::size_type stop = text.find_first_of(separators, start);
    if (stop > n) stop = n;
    words.push_back(text.substr(start, stop - start));
    start = text.find_first_not_of(separators, stop+1);
    }
}

void
splitFilenames (const std::string &text,
                std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  bool quoted;
  std::string comma(",");
  std::string quote("\"");
  std::string::size_type start = text.find_first_not_of(comma);
  while (start < n)
    {
    quoted = false;
    std::string::size_type startq = text.find_first_of(quote, start);
    std::string::size_type stopq = text.find_first_of(quote, startq+1);
    std::string::size_type stop = text.find_first_of(comma, start);
    if (stop > n) stop = n;
    if (startq != std::string::npos && stopq != std::string::npos)
      {
      while (startq < stop && stop < stopq && stop != n)
         {
         quoted = true;
         stop = text.find_first_of(comma, stop+1);
         if (stop > n) stop = n;
         }
      }
    if (!quoted)
      {
      words.push_back(text.substr(start, stop - start));
      }
    else
      {
      words.push_back(text.substr(start+1, stop - start-2));
      }
    start = text.find_first_not_of(comma, stop+1);
    }
}

unsigned char *GetModuleLogo(int *width,
                             int *height,
                             int *pixel_size,
                             unsigned long *length)
{
  *width = ModuleLogoWidth;
  *height = ModuleLogoHeight;
  *pixel_size = ModuleLogoPixelSize;
  *length = ModuleLogoLength;
  return const_cast<unsigned char *>(ModuleLogoImage);
}

char *GetXMLModuleDescription()
{
   return XMLModuleDescription;
}

#define GENERATE_LOGO \
  if (argc >= 2 && (strcmp(argv[1],"--logo") == 0)) \
    { \
    int width, height, pixel_size;     \
    unsigned long length;  \
    unsigned char *logo = GetModuleLogo(&width, &height, &pixel_size, &length);  \
    std::cout << "LOGO" << std::endl;  \
    std::cout << width << std::endl;  \
    std::cout << height << std::endl;  \
    std::cout << pixel_size << std::endl;  \
    std::cout << length << std::endl;  \
    std::cout << logo << std::endl;  \
    return EXIT_SUCCESS;  \
    }
#define GENERATE_XML \
  if (argc >= 2 && (strcmp(argv[1],"--xml") == 0)) \
    { \
    std::cout << GetXMLModuleDescription(); \
    return EXIT_SUCCESS; \
    }
#define GENERATE_DECLARE \
    /* These two vectors are used to store the JSON deserialized value */ \
    /* that are then compiled with the command line. */ \
    std::vector< std::string > deserializedVectorFlaggedArgs; \
    std::vector< std::string > deserializedVectorPositionalArgs; \
    /* This map is used to store the JSON deserialized value of multiple args*/ \
    /* where the key is the argument flag and the value the values of each arg. */ \
    std::map< std::string, std::vector<std::string> > deserializedMultipleArgsMap; \
 \
    /* This vector is used to look up if a flag requires an argument after it. */ \
    /* This is used to differentiate between: */ \
    /* ./myExec --boolFlag /my/first/arg */ \
    /* ./myExec --flag flagArg */ \
    std::vector< std::string > nonbooleanFlags; \
    nonbooleanFlags.push_back("-v"); \
    nonbooleanFlags.push_back("--expectedVolume"); \
    nonbooleanFlags.push_back("--intensityHomogeneity"); \
    nonbooleanFlags.push_back("-c"); \
    nonbooleanFlags.push_back("--curvatureWeight"); \
    nonbooleanFlags.push_back("--labelValue"); \
    nonbooleanFlags.push_back("--maxRunningTime"); \
    nonbooleanFlags.push_back("--serialize"); \
    nonbooleanFlags.push_back("--deserialize"); \
    nonbooleanFlags.push_back("--processinformationaddress"); \
    nonbooleanFlags.push_back("--returnparameterfile"); \
    /* This map use is twofold: */ \
    /*  - to find whether a flag is multiple */ \
    /*  - to know if we need to reset the multiple arg value because it was */ \
    /*    in the JSON and it's also in the command line. */ \
    std::map<std::string, bool> multipleFlags; \
    double expectedVolume = 50; \
    double intensityHomogeneity = 0.6; \
    double curvatureWeight = 0.5; \
    int labelValue = 1; \
    double maxRunningTime = 10; \
    std::string originalImageFileName; \
    std::string labelImageFileName; \
    std::string segmentedImageFileName; \
    std::string parametersSerialize; \
    std::string parametersDeSerialize; \
    bool echoSwitch = false; \
    bool xmlSwitch = false; \
    std::string processInformationAddressString = "0"; \
    std::string returnParameterFile; \

#define GENERATE_TCLAP_PARSE \
    std::string fullDescription("Description: "); \
    fullDescription += "Active contour segmentation using robust statistic."; \
    if (!std::string("Yi Gao (gatech), Allen Tannenbaum (gatech), Ron Kikinis (SPL, BWH)").empty()) \
      { \
      fullDescription += "\nAuthor(s): Yi Gao (gatech), Allen Tannenbaum (gatech), Ron Kikinis (SPL, BWH)"; \
      } \
    if (!std::string("This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health").empty()) \
      { \
      fullDescription += "\nAcknowledgements: This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health"; \
      } \
    TCLAP::CmdLine commandLine (fullDescription, \
       ' ', \
      "1.0" ); \
 \
      std::ostringstream msg; \
    msg.str("");msg << "The approximate volume of the object, in mL. (value: " << expectedVolume << ")"; \
    TCLAP::ValueArg<double > expectedVolumeArg("v", "expectedVolume", msg.str(), 0, expectedVolume, "double", commandLine); \
 \
    msg.str("");msg << "What is the homogeneity of intensity within the object? Given constant intensity at 1.0 score and extreme fluctuating intensity at 0. (value: " << intensityHomogeneity << ")"; \
    TCLAP::ValueArg<double > intensityHomogeneityArg("", "intensityHomogeneity", msg.str(), 0, intensityHomogeneity, "double", commandLine); \
 \
    msg.str("");msg << "Given sphere 1.0 score and extreme rough bounday/surface 0 score, what is the expected smoothness of the object? (value: " << curvatureWeight << ")"; \
    TCLAP::ValueArg<double > curvatureWeightArg("c", "curvatureWeight", msg.str(), 0, curvatureWeight, "double", commandLine); \
 \
    msg.str("");msg << "Label value of the output image (value: " << labelValue << ")"; \
    TCLAP::ValueArg<int > labelValueArg("", "labelValue", msg.str(), 0, labelValue, "int", commandLine); \
 \
    msg.str("");msg << "The program will stop if this time is reached. (value: " << maxRunningTime << ")"; \
    TCLAP::ValueArg<double > maxRunningTimeArg("", "maxRunningTime", msg.str(), 0, maxRunningTime, "double", commandLine); \
 \
    msg.str("");msg << "Original image to be segmented";    TCLAP::UnlabeledValueArg<std::string> originalImageFileNameArg("originalImageFileName", msg.str(), 1, originalImageFileName, "std::string", commandLine); \
 \
    msg.str("");msg << "Label image for initialization";    TCLAP::UnlabeledValueArg<std::string> labelImageFileNameArg("labelImageFileName", msg.str(), 1, labelImageFileName, "std::string", commandLine); \
 \
    msg.str("");msg << "Segmented image";    TCLAP::UnlabeledValueArg<std::string> segmentedImageFileNameArg("segmentedImageFileName", msg.str(), 1, segmentedImageFileName, "std::string", commandLine); \
 \
    msg.str("");msg << "Store the module's parameters to a file.";    TCLAP::ValueArg<std::string > parametersSerializeArg("", "serialize", msg.str(), 0, parametersSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Restore the module's parameters that were previously archived.";    TCLAP::ValueArg<std::string > parametersDeSerializeArg("", "deserialize", msg.str(), 0, parametersDeSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Echo the command line arguments (value: " << echoSwitch << ")"; \
    TCLAP::SwitchArg echoSwitchArg("", "echo", msg.str(), commandLine, echoSwitch); \
 \
    msg.str("");msg << "Produce xml description of command line arguments (value: " << xmlSwitch << ")"; \
    TCLAP::SwitchArg xmlSwitchArg("", "xml", msg.str(), commandLine, xmlSwitch); \
 \
    msg.str("");msg << "Address of a structure to store process information (progress, abort, etc.). (value: " << processInformationAddressString << ")"; \
    TCLAP::ValueArg<std::string > processInformationAddressStringArg("", "processinformationaddress", msg.str(), 0, processInformationAddressString, "std::string", commandLine); \
 \
    msg.str("");msg << "Filename in which to write simple return parameters (int, float, int-vector, etc.) as opposed to bulk return parameters (image, geometry, transform, measurement, table).";    TCLAP::ValueArg<std::string > returnParameterFileArg("", "returnparameterfile", msg.str(), 0, returnParameterFile, "std::string", commandLine); \
 \
try \
  { \
    /* Build a map of flag aliases to the true flag */ \
    std::map<std::string,std::string> flagAliasMap; \
    std::map<std::string,std::string> deprecatedFlagAliasMap; \
    std::map<std::string,std::string> longFlagAliasMap; \
    std::map<std::string,std::string> deprecatedLongFlagAliasMap; \
 \
    /* Go through argc and consolidate the JSON with the parameters from the command line */ \
    /* In case of conflict, take the command line. */ \
    std::map<std::string,std::string>::iterator ait; \
    std::map<std::string,std::string>::iterator dait; \
    std::vector<std::string>::iterator dvOptionnalArgsIt = deserializedVectorFlaggedArgs.begin(); \
    std::map<std::string, std::vector<std::string> >::iterator dvMultipleArgsIt; \
    size_t noFlagCounter = 0; \
    size_t ac = 1; \
 \
    while (ac < static_cast<size_t>(argc)) \
      { \
      /* short flag case && long flag case */ \
       if ((strlen(argv[ac]) == 2 && argv[ac][0]=='-') \
           || (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]=='-')) \
         { \
         std::string flag = argv[ac]; \
         /* Remap the flag if necessary */ \
         if (strlen(argv[ac]) == 2) \
           { \
           /* Short flag remapping */ \
           ait = flagAliasMap.find(flag); \
           dait = deprecatedFlagAliasMap.find(flag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << flag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         else \
           { \
           /* Long flag remapping */ \
           ait = longFlagAliasMap.find(flag); \
           dait = deprecatedLongFlagAliasMap.find(flag); \
           if (ait != longFlagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedLongFlagAliasMap.end()) \
             { \
             std::cout << "Long flag \"" << flag << "\" is deprecated. Please use long flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         bool isMultiple = multipleFlags.find(flag) != multipleFlags.end(); \
         bool isBoolean = std::find(nonbooleanFlags.begin(), nonbooleanFlags.end(), flag) == nonbooleanFlags.end(); \
         dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), flag); \
         bool isPresentVFA = dvOptionnalArgsIt != deserializedVectorFlaggedArgs.end(); \
         if (isBoolean) \
           { \
           /*Ignore if boolean and already present*/ \
           /*Otherwise add it*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           } \
         else if (isMultiple) \
           { \
           dvMultipleArgsIt = deserializedMultipleArgsMap.find(flag); \
           bool isPresentMA = dvMultipleArgsIt != deserializedMultipleArgsMap.end(); \
           /*Ignore if boolean and already present*/ \
           /*Reset/Add the value if first deserialize or not present*/ \
           if (!isPresentMA || !multipleFlags[flag]) \
             { \
             deserializedMultipleArgsMap[flag] = std::vector<std::string>(); \
             multipleFlags[flag] = true; \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           deserializedMultipleArgsMap[flag].push_back(value); \
           } \
         else \
           { \
           /*Add the flag and if needed*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(value);  \
             } \
           else \
             { \
             *(++dvOptionnalArgsIt) = value; \
             } \
           } \
         } \
       /* short flag case where multiple flags are given at once */ \
       else if (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]!='-') \
         { \
         std::string rflag(argv[ac], 1, std::string::npos); \
         for (std::string::size_type fi=0; fi < rflag.size(); ++fi) \
           { \
           std::string tf(rflag, fi, 1); \
           std::string newFlag ="-"; \
           newFlag += tf; \
           ait = flagAliasMap.find(newFlag); \
           dait = deprecatedFlagAliasMap.find(newFlag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             newFlag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << newFlag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             newFlag = (*dait).second; \
             } \
           dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), newFlag); \
           /*These flags are always boolean, just add it if it's not there already */ \
           if (dvOptionnalArgsIt == deserializedVectorFlaggedArgs.end()) \
             { \
             deserializedVectorFlaggedArgs.push_back(newFlag); \
             } \
           } \
         ++ac; \
         } \
       else \
         { \
         /* Replace if needed, otherwise append.*/ \
         if (noFlagCounter < deserializedVectorPositionalArgs.size()) \
           { \
           deserializedVectorPositionalArgs[noFlagCounter] = argv[ac]; \
           } \
         else \
           { \
           deserializedVectorPositionalArgs.push_back(argv[ac]); \
           } \
         ++ac; \
         ++noFlagCounter; \
         } \
       } \
 \
    /* Put the now compiled arguments in the argvVector */ \
    std::vector<std::string> argvVector; \
    argvVector.push_back(argv[0]); \
    argvVector.insert(argvVector.end(), deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end()); \
    std::map<std::string, std::vector<std::string> >::iterator mavit; \
    for (mavit = deserializedMultipleArgsMap.begin(); mavit != deserializedMultipleArgsMap.end(); ++mavit) \
      { \
      for (size_t i = 0; i < mavit->second.size(); ++i) \
        { \
        argvVector.push_back(mavit->first); \
        argvVector.push_back(mavit->second.at(i)); \
        } \
      } \
    argvVector.insert(argvVector.end(), deserializedVectorPositionalArgs.begin(), deserializedVectorPositionalArgs.end()); \
 \
   /* Remap args to a structure that CmdLine::parse() can understand*/ \
   std::vector<char*> vargs; \
   for (ac = 0; ac < argvVector.size(); ++ac) \
     {  \
     vargs.push_back(const_cast<char *>(argvVector[ac].c_str())); \
     } \
    commandLine.parse ( static_cast<int>(vargs.size()), (char**) &(vargs[0]) ); \
  } \
catch ( TCLAP::ArgException & e ) \
  { \
  std::cerr << "error: " << e.error() << " for arg " << e.argId() << std::endl; \
  return ( EXIT_FAILURE ); \
  }
#define GENERATE_TCLAP_ASSIGNMENT \
      expectedVolume = expectedVolumeArg.getValue(); \
      intensityHomogeneity = intensityHomogeneityArg.getValue(); \
      curvatureWeight = curvatureWeightArg.getValue(); \
      labelValue = labelValueArg.getValue(); \
      maxRunningTime = maxRunningTimeArg.getValue(); \
      originalImageFileName = originalImageFileNameArg.getValue(); \
      labelImageFileName = labelImageFileNameArg.getValue(); \
      segmentedImageFileName = segmentedImageFileNameArg.getValue(); \
      parametersSerialize = parametersSerializeArg.getValue(); \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      echoSwitch = echoSwitchArg.getValue(); \
      xmlSwitch = xmlSwitchArg.getValue(); \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      returnParameterFile = returnParameterFileArg.getValue(); \

#define GENERATE_TCLAP GENERATE_TCLAP_PARSE;GENERATE_TCLAP_ASSIGNMENT
#define GENERATE_TCLAP_ASSIGNMENT_IFSET \
    if( expectedVolumeArg.isSet() ) \
      { \
      expectedVolume = expectedVolumeArg.getValue(); \
      } \
    if( intensityHomogeneityArg.isSet() ) \
      { \
      intensityHomogeneity = intensityHomogeneityArg.getValue(); \
      } \
    if( curvatureWeightArg.isSet() ) \
      { \
      curvatureWeight = curvatureWeightArg.getValue(); \
      } \
    if( labelValueArg.isSet() ) \
      { \
      labelValue = labelValueArg.getValue(); \
      } \
    if( maxRunningTimeArg.isSet() ) \
      { \
      maxRunningTime = maxRunningTimeArg.getValue(); \
      } \
    if( originalImageFileNameArg.isSet() ) \
      { \
      originalImageFileName = originalImageFileNameArg.getValue(); \
      } \
    if( labelImageFileNameArg.isSet() ) \
      { \
      labelImageFileName = labelImageFileNameArg.getValue(); \
      } \
    if( segmentedImageFileNameArg.isSet() ) \
      { \
      segmentedImageFileName = segmentedImageFileNameArg.getValue(); \
      } \
    if( parametersSerializeArg.isSet() ) \
      { \
      parametersSerialize = parametersSerializeArg.getValue(); \
      } \
    if( parametersDeSerializeArg.isSet() ) \
      { \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      } \
    if( echoSwitchArg.isSet() ) \
      { \
      echoSwitch = echoSwitchArg.getValue(); \
      } \
    if( xmlSwitchArg.isSet() ) \
      { \
      xmlSwitch = xmlSwitchArg.getValue(); \
      } \
    if( processInformationAddressStringArg.isSet() ) \
      { \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      } \
    if( returnParameterFileArg.isSet() ) \
      { \
      returnParameterFile = returnParameterFileArg.getValue(); \
      } \

#define GENERATE_ECHOARGS \
if (echoSwitch) \
{ \
std::cout << "Command Line Arguments" << std::endl; \
std::cout << "    expectedVolume: " << expectedVolume << std::endl; \
std::cout << "    intensityHomogeneity: " << intensityHomogeneity << std::endl; \
std::cout << "    curvatureWeight: " << curvatureWeight << std::endl; \
std::cout << "    labelValue: " << labelValue << std::endl; \
std::cout << "    maxRunningTime: " << maxRunningTime << std::endl; \
std::cout << "    originalImageFileName: " << originalImageFileName << std::endl; \
std::cout << "    labelImageFileName: " << labelImageFileName << std::endl; \
std::cout << "    segmentedImageFileName: " << segmentedImageFileName << std::endl; \
std::cout << "    parametersSerialize: " << parametersSerialize << std::endl; \
std::cout << "    parametersDeSerialize: " << parametersDeSerialize << std::endl; \
std::cout << "    echoSwitch: " << echoSwitch << std::endl; \
std::cout << "    xmlSwitch: " << xmlSwitch << std::endl; \
std::cout << "    processInformationAddressString: " << processInformationAddressString << std::endl; \
std::cout << "    returnParameterFile: " << returnParameterFile << std::endl; \
}
#define GENERATE_ProcessInformationAddressDecoding \
ModuleProcessInformation *CLPProcessInformation = 0; \
if (processInformationAddressString != "") \
{ \
sscanf(processInformationAddressString.c_str(), "%p", &CLPProcessInformation); \
}
#define PARSE_ARGS GENERATE_LOGO;GENERATE_XML;GENERATE_DECLARE;GENERATE_DESERIALIZATION;GENERATE_TCLAP;GENERATE_ECHOARGS;GENERATE_ProcessInformationAddressDecoding;GENERATE_SERIALIZATION;
