// This file was automatically generated by:
//  /usr/bin/GenerateCLP --logoFiles /usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/ITKLogo.h --InputXML /usr/src/RPM/BUILD/slicer-4.11.20210226/Modules/CLI/SimpleRegionGrowingSegmentation/SimpleRegionGrowingSegmentation.xml --OutputCxx /usr/src/RPM/BUILD/slicer-4.11.20210226/BUILD/Modules/CLI/SimpleRegionGrowingSegmentation/SimpleRegionGrowingSegmentationCLP.h
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
#include <map>

#include <sstream>
#include <fstream>
#include <stdexcept>

#include "tclap/CmdLine.h"
#include "JsonSerializationUtilities.h"
#include "ModuleProcessInformation.h"

#ifdef _WIN32
#define Module_EXPORT __declspec(dllexport)
#elif defined(MODULE_HIDDEN_VISIBILITY)
#define Module_EXPORT __attribute__((visibility("default")))
#else
#define Module_EXPORT
#endif


extern "C" {
Module_EXPORT char JSONModuleDescription[] =
"{\n"
"	\"Category\" : \"Segmentation\",\n"
"	\"Contributor\" : \"Jim Miller (GE)\",\n"
"	\"Description\" : \"A simple region growing segmentation algorithm based on intensity statistics. To create a list of fiducials (Seeds) for this algorithm, click on the tool bar icon of an arrow pointing to a sphere fiducial to enter the 'place a new object mode' and then use the Markups module. This module uses the Slicer Command Line Interface (CLI) and the ITK filters CurvatureFlowImageFilter and ConfidenceConnectedImageFilter.\",\n"
"	\"DocumentationURL\" : \"http://www.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/SimpleRegionGrowingSegmentation\",\n"
"	\"License\" : \"\",\n"
"	\"ParameterGroups\" : \n"
"	[\n"
"		{\n"
"			\"Description\" : \"Parameters to denoise the image prior to segmenting\",\n"
"			\"Label\" : \"Smoothing Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Number of smoothing iterations\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Smoothing iterations\",\n"
"					\"LongFlag\" : \"smoothingIterations\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"smoothingIterations\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"5\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"double\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Timestep for curvature flow\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Timestep\",\n"
"					\"LongFlag\" : \"timestep\",\n"
"					\"Maximum\" : \"1\",\n"
"					\"Minimum\" : \"0.001\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"timestep\",\n"
"					\"Step\" : \"0.0001\",\n"
"					\"Tag\" : \"double\",\n"
"					\"Value\" : \"0.0625\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Parameters to prescribe the region growing\",\n"
"			\"Label\" : \"Segmentation Parameters\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Number of iterations of region growing\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Number of iterations\",\n"
"					\"LongFlag\" : \"iterations\",\n"
"					\"Maximum\" : \"100\",\n"
"					\"Minimum\" : \"0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"iterations\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"5\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"double\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Number of standard deviations to include in intensity model\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Multiplier\",\n"
"					\"LongFlag\" : \"multiplier\",\n"
"					\"Maximum\" : \"10\",\n"
"					\"Minimum\" : \"0\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"multiplier\",\n"
"					\"Step\" : \"0.01\",\n"
"					\"Tag\" : \"double\",\n"
"					\"Value\" : \"2.5\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The radius of the neighborhood over which to calculate intensity model\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Neighborhood Radius\",\n"
"					\"LongFlag\" : \"neighborhood\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"neighborhood\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"1\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"int\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"The integer value (0-255) to use for the segmentation results. This will determine the color of the segmentation that will be generated by the Region growing algorithm\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Output Label Value\",\n"
"					\"LongFlag\" : \"labelvalue\",\n"
"					\"Maximum\" : \"255\",\n"
"					\"Minimum\" : \"1\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"labelvalue\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"integer\",\n"
"					\"Value\" : \"2\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::vector<std::vector<float> >\",\n"
"					\"Channel\" : \"\",\n"
"					\"CoordinateSystem\" : \"ras\",\n"
"					\"Description\" : \"Seed point(s) for region growing\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"\",\n"
"					\"Label\" : \"Seeds\",\n"
"					\"LongFlag\" : \"seed\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"true\",\n"
"					\"Name\" : \"seed\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"point\",\n"
"					\"Value\" : \"0,0,0\"\n"
"				}\n"
"			]\n"
"		},\n"
"		{\n"
"			\"Description\" : \"Input/output parameters\",\n"
"			\"Label\" : \"IO\",\n"
"			\"Parameters\" : \n"
"			[\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"input\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Input volume to be filtered\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"0\",\n"
"					\"Label\" : \"Input Volume\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"inputVolume\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				},\n"
"				{\n"
"					\"CPPType\" : \"std::string\",\n"
"					\"Channel\" : \"output\",\n"
"					\"CoordinateSystem\" : \"\",\n"
"					\"Description\" : \"Output filtered\",\n"
"					\"Elements\" : [],\n"
"					\"Flag\" : \"\",\n"
"					\"Index\" : \"1\",\n"
"					\"Label\" : \"Output Volume\",\n"
"					\"LongFlag\" : \"\",\n"
"					\"Maximum\" : \"\",\n"
"					\"Minimum\" : \"\",\n"
"					\"Multiple\" : \"false\",\n"
"					\"Name\" : \"outputVolume\",\n"
"					\"Step\" : \"\",\n"
"					\"Tag\" : \"image\",\n"
"					\"Value\" : \"\"\n"
"				}\n"
"			]\n"
"		}\n"
"	],\n"
"	\"Title\" : \"Simple Region Growing Segmentation\",\n"
"	\"Version\" : \"0.1.0.$Revision$(alpha)\"\n"
"}\n"
"\n"
;
}
#define GENERATE_DESERIALIZATION \
    if (argc >= 2) \
      { \
      for (int arg_idx = 0; arg_idx < argc; ++arg_idx) \
        { \
        if (strcmp(argv[arg_idx],"--deserialize") == 0) \
          { \
          std::ifstream fStream( argv[arg_idx+1] ); \
          if( !fStream.is_open() ) \
            { \
            std::cerr << "Could not open file: " << argv[arg_idx+1] << " for writing." << std::endl; \
            return EXIT_FAILURE; \
            } \
          Json::Value root; \
          Json::Reader reader; \
          reader.parse( fStream, root ); \
          const Json::Value & parameters = root["Parameters"]; \
          if (!parameters["Smoothing Parameters"]["smoothingIterations"].isNull()) \
            { \
            Json::Value param = parameters["Smoothing Parameters"]["smoothingIterations"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--smoothingIterations"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--smoothingIterations"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Smoothing Parameters"]["timestep"].isNull()) \
            { \
            Json::Value param = parameters["Smoothing Parameters"]["timestep"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--timestep"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--timestep"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Segmentation Parameters"]["iterations"].isNull()) \
            { \
            Json::Value param = parameters["Segmentation Parameters"]["iterations"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--iterations"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--iterations"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Segmentation Parameters"]["multiplier"].isNull()) \
            { \
            Json::Value param = parameters["Segmentation Parameters"]["multiplier"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--multiplier"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--multiplier"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Segmentation Parameters"]["neighborhood"].isNull()) \
            { \
            Json::Value param = parameters["Segmentation Parameters"]["neighborhood"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--neighborhood"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--neighborhood"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Segmentation Parameters"]["labelvalue"].isNull()) \
            { \
            Json::Value param = parameters["Segmentation Parameters"]["labelvalue"]; \
            if (!param.isArray()) \
              { \
              deserializedVectorFlaggedArgs.push_back("--labelvalue"); \
              deserializedVectorFlaggedArgs.push_back(param.asString()); \
              } \
            else if(param.size() > 0) \
              { \
              std::string value = ""; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                value += param[i].asString(); \
                if (i < param.size() - 1) \
                  { \
                  value += ", "; \
                  } \
                } \
              deserializedVectorFlaggedArgs.push_back("--labelvalue"); \
              deserializedVectorFlaggedArgs.push_back(value); \
              } \
            } \
          if (!parameters["Segmentation Parameters"]["seed"].isNull()) \
            { \
            Json::Value param = parameters["Segmentation Parameters"]["seed"]; \
            if(param.size() > 0) \
              { \
              std::vector<std::string> values; \
              for (unsigned int i = 0; i < param.size(); ++i) \
                { \
                std::string value = ""; \
                for (unsigned int j = 0; j < param[i].size(); ++j) \
                  { \
                  value += param[i][j].asString(); \
                  if (j < param[i].size() - 1) \
                    { \
                    value += ", "; \
                    } \
                  } \
                values.push_back(value); \
                } \
              if (!values.empty()) \
                { \
                deserializedMultipleArgsMap["--seed"] = values; \
                } \
              } \
            } \
          if (!parameters["IO"]["inputVolume"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["inputVolume"].asString()); \
            } \
          if (!parameters["IO"]["outputVolume"].isNull()) \
            { \
            deserializedVectorPositionalArgs.push_back(parameters["IO"]["outputVolume"].asString()); \
            } \
          } \
        } \
      }
#define GENERATE_SERIALIZATION \
    if( parametersSerializeArg.isSet() ) \
      { \
      Json::Value root; \
      Json::Value & parameters = root["Parameters"]; \
        { \
        Json::Value & parameterGroup = parameters["Smoothing Parameters"]; \
        parameterGroup["smoothingIterations"] = JsonSerialize( smoothingIterations ); \
        parameterGroup["timestep"] = JsonSerialize( timestep ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["Segmentation Parameters"]; \
        parameterGroup["iterations"] = JsonSerialize( iterations ); \
        parameterGroup["multiplier"] = JsonSerialize( multiplier ); \
        parameterGroup["neighborhood"] = JsonSerialize( neighborhood ); \
        parameterGroup["labelvalue"] = JsonSerialize( labelvalue ); \
        parameterGroup["seed"] = JsonSerialize( seed ); \
        } \
        { \
        Json::Value & parameterGroup = parameters["IO"]; \
        parameterGroup["inputVolume"] = JsonSerialize( inputVolume ); \
        parameterGroup["outputVolume"] = JsonSerialize( outputVolume ); \
        } \
      std::ofstream fStream( parametersSerializeArg.getValue().c_str() ); \
      if( !fStream.is_open() ) \
        { \
        std::cerr << "Could not open file: " << parametersSerializeArg.getValue() << " for writing." << std::endl; \
        return EXIT_FAILURE; \
        } \
      Json::StyledStreamWriter writer; \
      writer.write( fStream, root ); \
      fStream.close(); \
      }
#if defined(main) && !defined(REGISTER_TEST)
// If main defined as a preprocessor symbol, redefine it to the expected entry point.
#undef main
#define main ModuleEntryPoint

extern "C" {
  Module_EXPORT char *GetXMLModuleDescription();
  Module_EXPORT int ModuleEntryPoint(int, char*[]);
  Module_EXPORT unsigned char *GetModuleLogo(int *width, int *height, int *pixel_size, unsigned long *bufferLength);
}
#endif

extern "C" {
Module_EXPORT char XMLModuleDescription[] = 
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<executable>\n"
"  <category>Segmentation</category>\n"
"  <title>Simple Region Growing Segmentation</title>\n"
"  <description><![CDATA[A simple region growing segmentation algorithm based on intensity statistics. To create a list of fiducials (Seeds) for this algorithm, click on the tool bar icon of an arrow pointing to a sphere fiducial to enter the 'place a new object mode' and then use the Markups module. This module uses the Slicer Command Line Interface (CLI) and the ITK filters CurvatureFlowImageFilter and ConfidenceConnectedImageFilter.]]></description>\n"
"  <version>0.1.0.$Revision$(alpha)</version>\n"
"  <documentation-url>http://www.slicer.org/slicerWiki/index.php/Documentation/Nightly/Modules/SimpleRegionGrowingSegmentation</documentation-url>\n"
"  <license/>\n"
"  <contributor>Jim Miller (GE)</contributor>\n"
"  <acknowledgements><![CDATA[This command module was derived from Insight/Examples (copyright) Insight Software Consortium]]></acknowledgements>\n"
"  <parameters advanced=\"true\">\n"
"    <label>Smoothing Parameters</label>\n"
"    <description><![CDATA[Parameters to denoise the image prior to segmenting]]></description>\n"
"    <integer>\n"
"      <name>smoothingIterations</name>\n"
"      <label>Smoothing iterations</label>\n"
"      <longflag>--smoothingIterations</longflag>\n"
"      <description><![CDATA[Number of smoothing iterations]]></description>\n"
"      <default>5</default>\n"
"    </integer>\n"
"    <double>\n"
"      <name>timestep</name>\n"
"      <label>Timestep</label>\n"
"      <longflag>--timestep</longflag>\n"
"      <description><![CDATA[Timestep for curvature flow]]></description>\n"
"      <default>0.0625</default>\n"
"      <constraints>\n"
"        <minimum>0.001</minimum>\n"
"        <maximum>1</maximum>\n"
"        <step>0.0001</step>\n"
"      </constraints>\n"
"    </double>\n"
"  </parameters>\n"
"  <parameters>\n"
"    <label>Segmentation Parameters</label>\n"
"    <description><![CDATA[Parameters to prescribe the region growing]]></description>\n"
"    <integer>\n"
"      <name>iterations</name>\n"
"      <longflag>--iterations</longflag>\n"
"      <description><![CDATA[Number of iterations of region growing]]></description>\n"
"      <label>Number of iterations</label>\n"
"      <default>5</default>\n"
"      <constraints>\n"
"        <minimum>0</minimum>\n"
"        <maximum>100</maximum>\n"
"      </constraints>\n"
"    </integer>\n"
"    <double>\n"
"      <name>multiplier</name>\n"
"      <longflag>--multiplier</longflag>\n"
"      <description><![CDATA[Number of standard deviations to include in intensity model]]></description>\n"
"      <label>Multiplier</label>\n"
"      <default>2.5</default>\n"
"      <constraints>\n"
"        <minimum>0</minimum>\n"
"        <maximum>10</maximum>\n"
"        <step>0.01</step>\n"
"      </constraints>\n"
"    </double>\n"
"    <integer>\n"
"      <name>neighborhood</name>\n"
"      <longflag>--neighborhood</longflag>\n"
"      <description><![CDATA[The radius of the neighborhood over which to calculate intensity model]]></description>\n"
"      <label>Neighborhood Radius</label>\n"
"      <default>1</default>\n"
"    </integer>\n"
"    <integer>\n"
"      <name>labelvalue</name>\n"
"      <longflag>--labelvalue</longflag>\n"
"      <description><![CDATA[The integer value (0-255) to use for the segmentation results. This will determine the color of the segmentation that will be generated by the Region growing algorithm]]></description>\n"
"      <label>Output Label Value</label>\n"
"      <default>2</default>\n"
"      <constraints>\n"
"        <minimum>1</minimum>\n"
"        <maximum>255</maximum>\n"
"      </constraints>\n"
"    </integer>\n"
"    <point multiple=\"true\" coordinateSystem=\"ras\">\n"
"      <name>seed</name>\n"
"      <label>Seeds</label>\n"
"      <longflag>--seed</longflag>\n"
"      <description><![CDATA[Seed point(s) for region growing]]></description>\n"
"      <default>0,0,0</default>\n"
"    </point>\n"
"  </parameters>\n"
"  <parameters>\n"
"    <label>IO</label>\n"
"    <description><![CDATA[Input/output parameters]]></description>\n"
"    <image>\n"
"      <name>inputVolume</name>\n"
"      <label>Input Volume</label>\n"
"      <channel>input</channel>\n"
"      <index>0</index>\n"
"      <description><![CDATA[Input volume to be filtered]]></description>\n"
"    </image>\n"
"    <image type=\"label\" reference=\"inputVolume\">\n"
"      <name>outputVolume</name>\n"
"      <label>Output Volume</label>\n"
"      <channel>output</channel>\n"
"      <index>1</index>\n"
"      <description><![CDATA[Output filtered]]></description>\n"
"    </image>\n"
"  </parameters>\n"
"</executable>\n"
"\n"
;

#define static Module_EXPORT
#define const
#define image_ITKLogo_width ModuleLogoWidth
#define image_ITKLogo_height ModuleLogoHeight
#define image_ITKLogo_pixel_size ModuleLogoPixelSize
#define image_ITKLogo_length ModuleLogoLength
#define image_ITKLogo ModuleLogoImage
#include "/usr/src/RPM/BUILD/slicer-4.11.20210226/Resources/ITKLogo.h"
#undef static
#undef const
#undef image_ITKLogo_width
#undef image_ITKLogo_height
#undef image_ITKLogo_pixel_size
#undef image_ITKLogo_length
#undef image_ITKLogo
}

void
splitString (const std::string &text,
             const std::string &separators,
             std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  std::string::size_type start = text.find_first_not_of(separators);
  while (start < n)
    {
    std::string::size_type stop = text.find_first_of(separators, start);
    if (stop > n) stop = n;
    words.push_back(text.substr(start, stop - start));
    start = text.find_first_not_of(separators, stop+1);
    }
}

void
splitFilenames (const std::string &text,
                std::vector<std::string> &words)
{
  const std::string::size_type n = text.length();
  bool quoted;
  std::string comma(",");
  std::string quote("\"");
  std::string::size_type start = text.find_first_not_of(comma);
  while (start < n)
    {
    quoted = false;
    std::string::size_type startq = text.find_first_of(quote, start);
    std::string::size_type stopq = text.find_first_of(quote, startq+1);
    std::string::size_type stop = text.find_first_of(comma, start);
    if (stop > n) stop = n;
    if (startq != std::string::npos && stopq != std::string::npos)
      {
      while (startq < stop && stop < stopq && stop != n)
         {
         quoted = true;
         stop = text.find_first_of(comma, stop+1);
         if (stop > n) stop = n;
         }
      }
    if (!quoted)
      {
      words.push_back(text.substr(start, stop - start));
      }
    else
      {
      words.push_back(text.substr(start+1, stop - start-2));
      }
    start = text.find_first_not_of(comma, stop+1);
    }
}

unsigned char *GetModuleLogo(int *width,
                             int *height,
                             int *pixel_size,
                             unsigned long *length)
{
  *width = ModuleLogoWidth;
  *height = ModuleLogoHeight;
  *pixel_size = ModuleLogoPixelSize;
  *length = ModuleLogoLength;
  return const_cast<unsigned char *>(ModuleLogoImage);
}

char *GetXMLModuleDescription()
{
   return XMLModuleDescription;
}

#define GENERATE_LOGO \
  if (argc >= 2 && (strcmp(argv[1],"--logo") == 0)) \
    { \
    int width, height, pixel_size;     \
    unsigned long length;  \
    unsigned char *logo = GetModuleLogo(&width, &height, &pixel_size, &length);  \
    std::cout << "LOGO" << std::endl;  \
    std::cout << width << std::endl;  \
    std::cout << height << std::endl;  \
    std::cout << pixel_size << std::endl;  \
    std::cout << length << std::endl;  \
    std::cout << logo << std::endl;  \
    return EXIT_SUCCESS;  \
    }
#define GENERATE_XML \
  if (argc >= 2 && (strcmp(argv[1],"--xml") == 0)) \
    { \
    std::cout << GetXMLModuleDescription(); \
    return EXIT_SUCCESS; \
    }
#define GENERATE_DECLARE \
    /* These two vectors are used to store the JSON deserialized value */ \
    /* that are then compiled with the command line. */ \
    std::vector< std::string > deserializedVectorFlaggedArgs; \
    std::vector< std::string > deserializedVectorPositionalArgs; \
    /* This map is used to store the JSON deserialized value of multiple args*/ \
    /* where the key is the argument flag and the value the values of each arg. */ \
    std::map< std::string, std::vector<std::string> > deserializedMultipleArgsMap; \
 \
    /* This vector is used to look up if a flag requires an argument after it. */ \
    /* This is used to differentiate between: */ \
    /* ./myExec --boolFlag /my/first/arg */ \
    /* ./myExec --flag flagArg */ \
    std::vector< std::string > nonbooleanFlags; \
    nonbooleanFlags.push_back("--smoothingIterations"); \
    nonbooleanFlags.push_back("--timestep"); \
    nonbooleanFlags.push_back("--iterations"); \
    nonbooleanFlags.push_back("--multiplier"); \
    nonbooleanFlags.push_back("--neighborhood"); \
    nonbooleanFlags.push_back("--labelvalue"); \
    nonbooleanFlags.push_back("--seed"); \
    nonbooleanFlags.push_back("--serialize"); \
    nonbooleanFlags.push_back("--deserialize"); \
    nonbooleanFlags.push_back("--processinformationaddress"); \
    nonbooleanFlags.push_back("--returnparameterfile"); \
    /* This map use is twofold: */ \
    /*  - to find whether a flag is multiple */ \
    /*  - to know if we need to reset the multiple arg value because it was */ \
    /*    in the JSON and it's also in the command line. */ \
    std::map<std::string, bool> multipleFlags; \
    multipleFlags["--seed"] = false; \
    int smoothingIterations = 5; \
    double timestep = 0.0625; \
    int iterations = 5; \
    double multiplier = 2.5; \
    int neighborhood = 1; \
    int labelvalue = 2; \
    std::vector<std::string> seedTemp; \
    std::vector<std::vector<float> > seed; \
    std::string inputVolume; \
    std::string outputVolume; \
    std::string parametersSerialize; \
    std::string parametersDeSerialize; \
    bool echoSwitch = false; \
    bool xmlSwitch = false; \
    std::string processInformationAddressString = "0"; \
    std::string returnParameterFile; \

#define GENERATE_TCLAP_PARSE \
    std::string fullDescription("Description: "); \
    fullDescription += "A simple region growing segmentation algorithm based on intensity statistics. To create a list of fiducials (Seeds) for this algorithm, click on the tool bar icon of an arrow pointing to a sphere fiducial to enter the 'place a new object mode' and then use the Markups module. This module uses the Slicer Command Line Interface (CLI) and the ITK filters CurvatureFlowImageFilter and ConfidenceConnectedImageFilter."; \
    if (!std::string("Jim Miller (GE)").empty()) \
      { \
      fullDescription += "\nAuthor(s): Jim Miller (GE)"; \
      } \
    if (!std::string("This command module was derived from Insight/Examples (copyright) Insight Software Consortium").empty()) \
      { \
      fullDescription += "\nAcknowledgements: This command module was derived from Insight/Examples (copyright) Insight Software Consortium"; \
      } \
    TCLAP::CmdLine commandLine (fullDescription, \
       ' ', \
      "0.1.0.$Revision$(alpha)" ); \
 \
      std::ostringstream msg; \
    msg.str("");msg << "Number of smoothing iterations (value: " << smoothingIterations << ")"; \
    TCLAP::ValueArg<int > smoothingIterationsArg("", "smoothingIterations", msg.str(), 0, smoothingIterations, "int", commandLine); \
 \
    msg.str("");msg << "Timestep for curvature flow (value: " << timestep << ")"; \
    TCLAP::ValueArg<double > timestepArg("", "timestep", msg.str(), 0, timestep, "double", commandLine); \
 \
    msg.str("");msg << "Number of iterations of region growing (value: " << iterations << ")"; \
    TCLAP::ValueArg<int > iterationsArg("", "iterations", msg.str(), 0, iterations, "int", commandLine); \
 \
    msg.str("");msg << "Number of standard deviations to include in intensity model (value: " << multiplier << ")"; \
    TCLAP::ValueArg<double > multiplierArg("", "multiplier", msg.str(), 0, multiplier, "double", commandLine); \
 \
    msg.str("");msg << "The radius of the neighborhood over which to calculate intensity model (value: " << neighborhood << ")"; \
    TCLAP::ValueArg<int > neighborhoodArg("", "neighborhood", msg.str(), 0, neighborhood, "int", commandLine); \
 \
    msg.str("");msg << "The integer value (0-255) to use for the segmentation results. This will determine the color of the segmentation that will be generated by the Region growing algorithm (value: " << labelvalue << ")"; \
    TCLAP::ValueArg<int > labelvalueArg("", "labelvalue", msg.str(), 0, labelvalue, "int", commandLine); \
 \
    msg.str("");msg << "Seed point(s) for region growing (value: " << "None" << ")"; \
    TCLAP::MultiArg<std::string > seedArg("", "seed", msg.str(), 0, "std::vector<std::vector<float> >", commandLine); \
 \
    msg.str("");msg << "Input volume to be filtered";    TCLAP::UnlabeledValueArg<std::string> inputVolumeArg("inputVolume", msg.str(), 1, inputVolume, "std::string", commandLine); \
 \
    msg.str("");msg << "Output filtered";    TCLAP::UnlabeledValueArg<std::string> outputVolumeArg("outputVolume", msg.str(), 1, outputVolume, "std::string", commandLine); \
 \
    msg.str("");msg << "Store the module's parameters to a file.";    TCLAP::ValueArg<std::string > parametersSerializeArg("", "serialize", msg.str(), 0, parametersSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Restore the module's parameters that were previously archived.";    TCLAP::ValueArg<std::string > parametersDeSerializeArg("", "deserialize", msg.str(), 0, parametersDeSerialize, "std::string", commandLine); \
 \
    msg.str("");msg << "Echo the command line arguments (value: " << echoSwitch << ")"; \
    TCLAP::SwitchArg echoSwitchArg("", "echo", msg.str(), commandLine, echoSwitch); \
 \
    msg.str("");msg << "Produce xml description of command line arguments (value: " << xmlSwitch << ")"; \
    TCLAP::SwitchArg xmlSwitchArg("", "xml", msg.str(), commandLine, xmlSwitch); \
 \
    msg.str("");msg << "Address of a structure to store process information (progress, abort, etc.). (value: " << processInformationAddressString << ")"; \
    TCLAP::ValueArg<std::string > processInformationAddressStringArg("", "processinformationaddress", msg.str(), 0, processInformationAddressString, "std::string", commandLine); \
 \
    msg.str("");msg << "Filename in which to write simple return parameters (int, float, int-vector, etc.) as opposed to bulk return parameters (image, geometry, transform, measurement, table).";    TCLAP::ValueArg<std::string > returnParameterFileArg("", "returnparameterfile", msg.str(), 0, returnParameterFile, "std::string", commandLine); \
 \
try \
  { \
    /* Build a map of flag aliases to the true flag */ \
    std::map<std::string,std::string> flagAliasMap; \
    std::map<std::string,std::string> deprecatedFlagAliasMap; \
    std::map<std::string,std::string> longFlagAliasMap; \
    std::map<std::string,std::string> deprecatedLongFlagAliasMap; \
 \
    /* Go through argc and consolidate the JSON with the parameters from the command line */ \
    /* In case of conflict, take the command line. */ \
    std::map<std::string,std::string>::iterator ait; \
    std::map<std::string,std::string>::iterator dait; \
    std::vector<std::string>::iterator dvOptionnalArgsIt = deserializedVectorFlaggedArgs.begin(); \
    std::map<std::string, std::vector<std::string> >::iterator dvMultipleArgsIt; \
    size_t noFlagCounter = 0; \
    size_t ac = 1; \
 \
    while (ac < static_cast<size_t>(argc)) \
      { \
      /* short flag case && long flag case */ \
       if ((strlen(argv[ac]) == 2 && argv[ac][0]=='-') \
           || (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]=='-')) \
         { \
         std::string flag = argv[ac]; \
         /* Remap the flag if necessary */ \
         if (strlen(argv[ac]) == 2) \
           { \
           /* Short flag remapping */ \
           ait = flagAliasMap.find(flag); \
           dait = deprecatedFlagAliasMap.find(flag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << flag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         else \
           { \
           /* Long flag remapping */ \
           ait = longFlagAliasMap.find(flag); \
           dait = deprecatedLongFlagAliasMap.find(flag); \
           if (ait != longFlagAliasMap.end()) \
             { \
             /* remap the flag */ \
             flag = (*ait).second; \
             } \
           else if (dait != deprecatedLongFlagAliasMap.end()) \
             { \
             std::cout << "Long flag \"" << flag << "\" is deprecated. Please use long flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             flag = (*dait).second; \
             } \
           } \
         bool isMultiple = multipleFlags.find(flag) != multipleFlags.end(); \
         bool isBoolean = std::find(nonbooleanFlags.begin(), nonbooleanFlags.end(), flag) == nonbooleanFlags.end(); \
         dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), flag); \
         bool isPresentVFA = dvOptionnalArgsIt != deserializedVectorFlaggedArgs.end(); \
         if (isBoolean) \
           { \
           /*Ignore if boolean and already present*/ \
           /*Otherwise add it*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           } \
         else if (isMultiple) \
           { \
           dvMultipleArgsIt = deserializedMultipleArgsMap.find(flag); \
           bool isPresentMA = dvMultipleArgsIt != deserializedMultipleArgsMap.end(); \
           /*Ignore if boolean and already present*/ \
           /*Reset/Add the value if first deserialize or not present*/ \
           if (!isPresentMA || !multipleFlags[flag]) \
             { \
             deserializedMultipleArgsMap[flag] = std::vector<std::string>(); \
             multipleFlags[flag] = true; \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           deserializedMultipleArgsMap[flag].push_back(value); \
           } \
         else \
           { \
           /*Add the flag and if needed*/ \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(flag); \
             } \
           ++ac; \
           std::string value = ""; \
           if (ac < static_cast<size_t>(argc)) \
             { \
             value = argv[ac]; \
             ++ac; \
             } \
           if (!isPresentVFA) \
             { \
             deserializedVectorFlaggedArgs.push_back(value);  \
             } \
           else \
             { \
             *(++dvOptionnalArgsIt) = value; \
             } \
           } \
         } \
       /* short flag case where multiple flags are given at once */ \
       else if (strlen(argv[ac]) > 2 && argv[ac][0]=='-' && argv[ac][1]!='-') \
         { \
         std::string rflag(argv[ac], 1, std::string::npos); \
         for (std::string::size_type fi=0; fi < rflag.size(); ++fi) \
           { \
           std::string tf(rflag, fi, 1); \
           std::string newFlag ="-"; \
           newFlag += tf; \
           ait = flagAliasMap.find(newFlag); \
           dait = deprecatedFlagAliasMap.find(newFlag); \
           if (ait != flagAliasMap.end()) \
             { \
             /* remap the flag */ \
             newFlag = (*ait).second; \
             } \
           else if (dait != deprecatedFlagAliasMap.end()) \
             { \
             std::cout << "Flag \"" << newFlag << "\" is deprecated. Please use flag \"" << (*dait).second << "\" instead. " << std::endl; \
             /* remap the flag */ \
             newFlag = (*dait).second; \
             } \
           dvOptionnalArgsIt = std::find(deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end(), newFlag); \
           /*These flags are always boolean, just add it if it's not there already */ \
           if (dvOptionnalArgsIt == deserializedVectorFlaggedArgs.end()) \
             { \
             deserializedVectorFlaggedArgs.push_back(newFlag); \
             } \
           } \
         ++ac; \
         } \
       else \
         { \
         /* Replace if needed, otherwise append.*/ \
         if (noFlagCounter < deserializedVectorPositionalArgs.size()) \
           { \
           deserializedVectorPositionalArgs[noFlagCounter] = argv[ac]; \
           } \
         else \
           { \
           deserializedVectorPositionalArgs.push_back(argv[ac]); \
           } \
         ++ac; \
         ++noFlagCounter; \
         } \
       } \
 \
    /* Put the now compiled arguments in the argvVector */ \
    std::vector<std::string> argvVector; \
    argvVector.push_back(argv[0]); \
    argvVector.insert(argvVector.end(), deserializedVectorFlaggedArgs.begin(), deserializedVectorFlaggedArgs.end()); \
    std::map<std::string, std::vector<std::string> >::iterator mavit; \
    for (mavit = deserializedMultipleArgsMap.begin(); mavit != deserializedMultipleArgsMap.end(); ++mavit) \
      { \
      for (size_t i = 0; i < mavit->second.size(); ++i) \
        { \
        argvVector.push_back(mavit->first); \
        argvVector.push_back(mavit->second.at(i)); \
        } \
      } \
    argvVector.insert(argvVector.end(), deserializedVectorPositionalArgs.begin(), deserializedVectorPositionalArgs.end()); \
 \
   /* Remap args to a structure that CmdLine::parse() can understand*/ \
   std::vector<char*> vargs; \
   for (ac = 0; ac < argvVector.size(); ++ac) \
     {  \
     vargs.push_back(const_cast<char *>(argvVector[ac].c_str())); \
     } \
    commandLine.parse ( static_cast<int>(vargs.size()), (char**) &(vargs[0]) ); \
  } \
catch ( TCLAP::ArgException & e ) \
  { \
  std::cerr << "error: " << e.error() << " for arg " << e.argId() << std::endl; \
  return ( EXIT_FAILURE ); \
  }
#define GENERATE_TCLAP_ASSIGNMENT \
      smoothingIterations = smoothingIterationsArg.getValue(); \
      timestep = timestepArg.getValue(); \
      iterations = iterationsArg.getValue(); \
      multiplier = multiplierArg.getValue(); \
      neighborhood = neighborhoodArg.getValue(); \
      labelvalue = labelvalueArg.getValue(); \
      seedTemp = seedArg.getValue(); \
      inputVolume = inputVolumeArg.getValue(); \
      outputVolume = outputVolumeArg.getValue(); \
      parametersSerialize = parametersSerializeArg.getValue(); \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      echoSwitch = echoSwitchArg.getValue(); \
      xmlSwitch = xmlSwitchArg.getValue(); \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      returnParameterFile = returnParameterFileArg.getValue(); \
      { /* Assignment for seed */ \
      for (unsigned int _i = 0; _i < seedTemp.size(); _i++) \
        { \
        std::vector<std::string> words; \
        words.clear(); \
      std::string sep(","); \
        splitString(seedTemp[_i], sep, words); \
        std::vector<float> elements; \
        for (unsigned int _j= 0; _j < words.size(); _j++) \
          { \
          elements.push_back(atof(words[_j].c_str())); \
          } \
        seed.push_back(elements); \
        } \
      } \

#define GENERATE_TCLAP GENERATE_TCLAP_PARSE;GENERATE_TCLAP_ASSIGNMENT
#define GENERATE_TCLAP_ASSIGNMENT_IFSET \
    if( smoothingIterationsArg.isSet() ) \
      { \
      smoothingIterations = smoothingIterationsArg.getValue(); \
      } \
    if( timestepArg.isSet() ) \
      { \
      timestep = timestepArg.getValue(); \
      } \
    if( iterationsArg.isSet() ) \
      { \
      iterations = iterationsArg.getValue(); \
      } \
    if( multiplierArg.isSet() ) \
      { \
      multiplier = multiplierArg.getValue(); \
      } \
    if( neighborhoodArg.isSet() ) \
      { \
      neighborhood = neighborhoodArg.getValue(); \
      } \
    if( labelvalueArg.isSet() ) \
      { \
      labelvalue = labelvalueArg.getValue(); \
      } \
    if( seedArg.isSet() ) \
      { \
      seedTemp = seedArg.getValue(); \
      } \
    if( inputVolumeArg.isSet() ) \
      { \
      inputVolume = inputVolumeArg.getValue(); \
      } \
    if( outputVolumeArg.isSet() ) \
      { \
      outputVolume = outputVolumeArg.getValue(); \
      } \
    if( parametersSerializeArg.isSet() ) \
      { \
      parametersSerialize = parametersSerializeArg.getValue(); \
      } \
    if( parametersDeSerializeArg.isSet() ) \
      { \
      parametersDeSerialize = parametersDeSerializeArg.getValue(); \
      } \
    if( echoSwitchArg.isSet() ) \
      { \
      echoSwitch = echoSwitchArg.getValue(); \
      } \
    if( xmlSwitchArg.isSet() ) \
      { \
      xmlSwitch = xmlSwitchArg.getValue(); \
      } \
    if( processInformationAddressStringArg.isSet() ) \
      { \
      processInformationAddressString = processInformationAddressStringArg.getValue(); \
      } \
    if( returnParameterFileArg.isSet() ) \
      { \
      returnParameterFile = returnParameterFileArg.getValue(); \
      } \
      { /* Assignment for seed */ \
      for (unsigned int _i = 0; _i < seedTemp.size(); _i++) \
        { \
        std::vector<std::string> words; \
        words.clear(); \
      std::string sep(","); \
        splitString(seedTemp[_i], sep, words); \
        std::vector<float> elements; \
        for (unsigned int _j= 0; _j < words.size(); _j++) \
          { \
          elements.push_back(atof(words[_j].c_str())); \
          } \
        seed.push_back(elements); \
        } \
      } \

#define GENERATE_ECHOARGS \
if (echoSwitch) \
{ \
std::cout << "Command Line Arguments" << std::endl; \
std::cout << "    smoothingIterations: " << smoothingIterations << std::endl; \
std::cout << "    timestep: " << timestep << std::endl; \
std::cout << "    iterations: " << iterations << std::endl; \
std::cout << "    multiplier: " << multiplier << std::endl; \
std::cout << "    neighborhood: " << neighborhood << std::endl; \
std::cout << "    labelvalue: " << labelvalue << std::endl; \
for (unsigned int _i= 0; _i < seedTemp.size(); _i++) \
{ \
std::cout << "seed[" << _i << "]: "; \
std::vector<std::string> words; \
words.clear(); \
      std::string sep(","); \
splitString(seedTemp[_i], sep, words); \
for (unsigned int _j= 0; _j < words.size(); _j++) \
{ \
std::cout <<  words[_j] << " "; \
} \
std::cout << std::endl; \
} \
std::cout << "    inputVolume: " << inputVolume << std::endl; \
std::cout << "    outputVolume: " << outputVolume << std::endl; \
std::cout << "    parametersSerialize: " << parametersSerialize << std::endl; \
std::cout << "    parametersDeSerialize: " << parametersDeSerialize << std::endl; \
std::cout << "    echoSwitch: " << echoSwitch << std::endl; \
std::cout << "    xmlSwitch: " << xmlSwitch << std::endl; \
std::cout << "    processInformationAddressString: " << processInformationAddressString << std::endl; \
std::cout << "    returnParameterFile: " << returnParameterFile << std::endl; \
}
#define GENERATE_ProcessInformationAddressDecoding \
ModuleProcessInformation *CLPProcessInformation = 0; \
if (processInformationAddressString != "") \
{ \
sscanf(processInformationAddressString.c_str(), "%p", &CLPProcessInformation); \
}
#define PARSE_ARGS GENERATE_LOGO;GENERATE_XML;GENERATE_DECLARE;GENERATE_DESERIALIZATION;GENERATE_TCLAP;GENERATE_ECHOARGS;GENERATE_ProcessInformationAddressDecoding;GENERATE_SERIALIZATION;
