// python wrapper for vtkSlicerAnnotationModuleLogic
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkSlicerAnnotationModuleLogic.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSlicerAnnotationModuleLogic(PyObject *dict); }
extern "C" { PyObject *PyvtkSlicerAnnotationModuleLogic_ClassNew(); }

#ifndef DECLARED_PyvtkSlicerModuleLogic_ClassNew
extern "C" { PyObject *PyvtkSlicerModuleLogic_ClassNew(); }
#define DECLARED_PyvtkSlicerModuleLogic_ClassNew
#endif

static const char *PyvtkSlicerAnnotationModuleLogic_Doc =
  "vtkSlicerAnnotationModuleLogic - \\ingroup Slicer_QtModules_Annotation\n\n"
  "Superclass: vtkSlicerModuleLogic\n\n"
;

static PyTypeObject PyvtkSlicerAnnotationModuleLogic_Events_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerAnnotationsModuleLogic.vtkSlicerAnnotationModuleLogic.Events", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkSlicerAnnotationModuleLogic_Events_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkSlicerAnnotationModuleLogic_Events_Type, static_cast<int>(val));
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerAnnotationModuleLogic::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSlicerAnnotationModuleLogic::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSlicerAnnotationModuleLogic *tempr = vtkSlicerAnnotationModuleLogic::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkSlicerAnnotationModuleLogic *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSlicerAnnotationModuleLogic::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerAnnotationModuleLogic::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_StartPlaceMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartPlaceMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  bool temp0 = false;
  vtkMRMLInteractionNode *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 2) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp1, "vtkMRMLInteractionNode")))
  {
    if (ap.IsBound())
    {
      op->StartPlaceMode(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::StartPlaceMode(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_StopPlaceMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StopPlaceMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  bool temp0 = false;
  vtkMRMLInteractionNode *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 2) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp1, "vtkMRMLInteractionNode")))
  {
    if (ap.IsBound())
    {
      op->StopPlaceMode(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::StopPlaceMode(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_AddAnnotationNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddAnnotationNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->AddAnnotationNode(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::AddAnnotationNode(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_AddNodeCompleted(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddNodeCompleted");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    if (ap.IsBound())
    {
      op->AddNodeCompleted(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::AddNodeCompleted(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_CancelCurrentOrRemoveLastAddedAnnotationNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CancelCurrentOrRemoveLastAddedAnnotationNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLInteractionNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp0, "vtkMRMLInteractionNode")))
  {
    if (ap.IsBound())
    {
      op->CancelCurrentOrRemoveLastAddedAnnotationNode(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::CancelCurrentOrRemoveLastAddedAnnotationNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_RemoveAnnotationNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAnnotationNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    if (ap.IsBound())
    {
      op->RemoveAnnotationNode(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::RemoveAnnotationNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_RegisterNodes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RegisterNodes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RegisterNodes();
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::RegisterNodes();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_IsAnnotationNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsAnnotationNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsAnnotationNode(temp0) :
      op->vtkSlicerAnnotationModuleLogic::IsAnnotationNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_IsAnnotationHierarchyNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsAnnotationHierarchyNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsAnnotationHierarchyNode(temp0) :
      op->vtkSlicerAnnotationModuleLogic::IsAnnotationHierarchyNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetTextDisplayNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTextDisplayNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLAnnotationTextDisplayNode *tempr = (ap.IsBound() ?
      op->GetTextDisplayNode(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetTextDisplayNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetPointDisplayNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPointDisplayNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLAnnotationPointDisplayNode *tempr = (ap.IsBound() ?
      op->GetPointDisplayNode(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetPointDisplayNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetLineDisplayNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLineDisplayNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLAnnotationLineDisplayNode *tempr = (ap.IsBound() ?
      op->GetLineDisplayNode(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetLineDisplayNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetAnnotationName(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetAnnotationText(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationText(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAnnotationText(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationText(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationTextScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationTextScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double tempr = (ap.IsBound() ?
      op->GetAnnotationTextScale(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationTextScale(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationTextScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationTextScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAnnotationTextScale(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationTextScale(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationTextSelectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationTextSelectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAnnotationTextSelectedColor(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationTextSelectedColor(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationTextSelectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationTextSelectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetAnnotationTextSelectedColor(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationTextSelectedColor(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationTextUnselectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationTextUnselectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAnnotationTextUnselectedColor(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationTextUnselectedColor(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationTextUnselectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationTextUnselectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetAnnotationTextUnselectedColor(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationTextUnselectedColor(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAnnotationColor(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationColor(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetAnnotationColor(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationColor(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationUnselectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationUnselectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAnnotationUnselectedColor(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationUnselectedColor(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationUnselectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationUnselectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetAnnotationUnselectedColor(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationUnselectedColor(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationPointColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationPointColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAnnotationPointColor(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationPointColor(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationPointColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationPointColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetAnnotationPointColor(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationPointColor(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationPointUnselectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationPointUnselectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAnnotationPointUnselectedColor(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationPointUnselectedColor(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationPointUnselectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationPointUnselectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetAnnotationPointUnselectedColor(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationPointUnselectedColor(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationPointGlyphTypeAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationPointGlyphTypeAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetAnnotationPointGlyphTypeAsString(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationPointGlyphTypeAsString(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationPointGlyphType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationPointGlyphType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAnnotationPointGlyphType(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationPointGlyphType(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationPointGlyphTypeFromString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationPointGlyphTypeFromString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAnnotationPointGlyphTypeFromString(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationPointGlyphTypeFromString(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationPointGlyphType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationPointGlyphType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAnnotationPointGlyphType(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationPointGlyphType(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationLineColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationLineColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAnnotationLineColor(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationLineColor(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationLineColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationLineColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetAnnotationLineColor(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationLineColor(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationLineUnselectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationLineUnselectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAnnotationLineUnselectedColor(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationLineUnselectedColor(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationLineUnselectedColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationLineUnselectedColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetAnnotationLineUnselectedColor(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationLineUnselectedColor(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationMeasurement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationMeasurement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetAnnotationMeasurement(temp0, temp1) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationMeasurement(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationIcon_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationIcon");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetAnnotationIcon(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationIcon(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationIcon_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationIcon");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode"))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetAnnotationIcon(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationIcon(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSlicerAnnotationModuleLogic_GetAnnotationIcon_Methods[] = {
  {nullptr, PyvtkSlicerAnnotationModuleLogic_GetAnnotationIcon_s1, METH_VARARGS,
   "@z"},
  {nullptr, PyvtkSlicerAnnotationModuleLogic_GetAnnotationIcon_s2, METH_VARARGS,
   "@V *vtkMRMLNode"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationIcon(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkSlicerAnnotationModuleLogic_GetAnnotationIcon_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetAnnotationIcon");
  return nullptr;
}



static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationLockedUnlocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationLockedUnlocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAnnotationLockedUnlocked(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationLockedUnlocked(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationLockedUnlocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationLockedUnlocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAnnotationLockedUnlocked(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationLockedUnlocked(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetAnnotationVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAnnotationVisibility(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetAnnotationVisibility(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAnnotationVisibility(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAnnotationSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAnnotationSelected(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAnnotationSelected(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetAllAnnotationsSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAllAnnotationsSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAllAnnotationsSelected(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetAllAnnotationsSelected(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_BackupAnnotationNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BackupAnnotationNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->BackupAnnotationNode(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::BackupAnnotationNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_RestoreAnnotationNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RestoreAnnotationNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RestoreAnnotationNode(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::RestoreAnnotationNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_DeleteBackupNodes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeleteBackupNodes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->DeleteBackupNodes(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::DeleteBackupNodes(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_JumpSlicesToAnnotationCoordinate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "JumpSlicesToAnnotationCoordinate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->JumpSlicesToAnnotationCoordinate(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::JumpSlicesToAnnotationCoordinate(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_MoveAnnotationUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MoveAnnotationUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->MoveAnnotationUp(temp0) :
      op->vtkSlicerAnnotationModuleLogic::MoveAnnotationUp(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_MoveAnnotationDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MoveAnnotationDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->MoveAnnotationDown(temp0) :
      op->vtkSlicerAnnotationModuleLogic::MoveAnnotationDown(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_CreateSnapShot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateSnapShot");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  int temp2;
  double temp3;
  vtkImageData *temp4 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetVTKObject(temp4, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->CreateSnapShot(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::CreateSnapShot(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_ModifySnapShot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ModifySnapShot");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkStdString temp0;
  const char *temp1 = nullptr;
  const char *temp2 = nullptr;
  int temp3;
  double temp4;
  vtkImageData *temp5 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetVTKObject(temp5, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->ModifySnapShot(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::ModifySnapShot(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetSnapShotName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSnapShotName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetSnapShotName(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetSnapShotName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetSnapShotDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSnapShotDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetSnapShotDescription(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetSnapShotDescription(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetSnapShotScreenshotType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSnapShotScreenshotType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSnapShotScreenshotType(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetSnapShotScreenshotType(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetSnapShotScaleFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSnapShotScaleFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSnapShotScaleFactor(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetSnapShotScaleFactor(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetSnapShotScreenshot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSnapShotScreenshot");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetSnapShotScreenshot(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetSnapShotScreenshot(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_IsSnapshotNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsSnapshotNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsSnapshotNode(temp0) :
      op->vtkSlicerAnnotationModuleLogic::IsSnapshotNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_AddHierarchy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddHierarchy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->AddHierarchy() :
      op->vtkSlicerAnnotationModuleLogic::AddHierarchy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetTopLevelHierarchyNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTopLevelHierarchyNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp0, "vtkMRMLNode")))
  {
    char *tempr = (ap.IsBound() ?
      op->GetTopLevelHierarchyNodeID(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetTopLevelHierarchyNodeID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetTopLevelHierarchyNodeIDForNodeClass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTopLevelHierarchyNodeIDForNodeClass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    char *tempr = (ap.IsBound() ?
      op->GetTopLevelHierarchyNodeIDForNodeClass(temp0) :
      op->vtkSlicerAnnotationModuleLogic::GetTopLevelHierarchyNodeIDForNodeClass(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetActiveHierarchyNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetActiveHierarchyNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLAnnotationHierarchyNode *tempr = (ap.IsBound() ?
      op->GetActiveHierarchyNode() :
      op->vtkSlicerAnnotationModuleLogic::GetActiveHierarchyNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetActiveHierarchyNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetActiveHierarchyNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetActiveHierarchyNodeID() :
      op->vtkSlicerAnnotationModuleLogic::GetActiveHierarchyNodeID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetActiveHierarchyNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetActiveHierarchyNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetActiveHierarchyNodeID(temp0);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetActiveHierarchyNodeID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetHierarchyAnnotationsVisibleFlag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHierarchyAnnotationsVisibleFlag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLAnnotationHierarchyNode *temp0 = nullptr;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationHierarchyNode") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetHierarchyAnnotationsVisibleFlag(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetHierarchyAnnotationsVisibleFlag(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_SetHierarchyAnnotationsLockFlag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHierarchyAnnotationsLockFlag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLAnnotationHierarchyNode *temp0 = nullptr;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationHierarchyNode") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetHierarchyAnnotationsLockFlag(temp0, temp1);
    }
    else
    {
      op->vtkSlicerAnnotationModuleLogic::SetHierarchyAnnotationsLockFlag(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetHTMLRepresentation_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHTMLRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode") &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetHTMLRepresentation(temp0, temp1) :
      op->vtkSlicerAnnotationModuleLogic::GetHTMLRepresentation(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetHTMLRepresentation_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHTMLRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLAnnotationHierarchyNode *temp0 = nullptr;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationHierarchyNode") &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetHTMLRepresentation(temp0, temp1) :
      op->vtkSlicerAnnotationModuleLogic::GetHTMLRepresentation(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSlicerAnnotationModuleLogic_GetHTMLRepresentation_Methods[] = {
  {nullptr, PyvtkSlicerAnnotationModuleLogic_GetHTMLRepresentation_s1, METH_VARARGS,
   "@Vi *vtkMRMLAnnotationNode"},
  {nullptr, PyvtkSlicerAnnotationModuleLogic_GetHTMLRepresentation_s2, METH_VARARGS,
   "@Vi *vtkMRMLAnnotationHierarchyNode"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkSlicerAnnotationModuleLogic_GetHTMLRepresentation(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkSlicerAnnotationModuleLogic_GetHTMLRepresentation_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetHTMLRepresentation");
  return nullptr;
}



static PyObject *
PyvtkSlicerAnnotationModuleLogic_AddDisplayNodeForHierarchyNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddDisplayNodeForHierarchyNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  vtkMRMLAnnotationHierarchyNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationHierarchyNode"))
  {
    const char *tempr = (ap.IsBound() ?
      op->AddDisplayNodeForHierarchyNode(temp0) :
      op->vtkSlicerAnnotationModuleLogic::AddDisplayNodeForHierarchyNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_LoadFiducialList(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadFiducialList");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    char *tempr = (ap.IsBound() ?
      op->LoadFiducialList(temp0) :
      op->vtkSlicerAnnotationModuleLogic::LoadFiducialList(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_LoadAnnotation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadAnnotation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    char *tempr = (ap.IsBound() ?
      op->LoadAnnotation(temp0, temp1, temp2) :
      op->vtkSlicerAnnotationModuleLogic::LoadAnnotation(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerAnnotationModuleLogic_AddFiducial(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddFiducial");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerAnnotationModuleLogic *op = static_cast<vtkSlicerAnnotationModuleLogic *>(vp);

  double temp0 = 0.0;
  double temp1 = 0.0;
  double temp2 = 0.0;
  const char *temp3 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 4) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)))
  {
    char *tempr = (ap.IsBound() ?
      op->AddFiducial(temp0, temp1, temp2, temp3) :
      op->vtkSlicerAnnotationModuleLogic::AddFiducial(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSlicerAnnotationModuleLogic_Methods[] = {
  {"IsTypeOf", PyvtkSlicerAnnotationModuleLogic_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkSlicerAnnotationModuleLogic_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkSlicerAnnotationModuleLogic_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSlicerAnnotationModuleLogic\nC++: static vtkSlicerAnnotationModuleLogic *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSlicerAnnotationModuleLogic_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSlicerAnnotationModuleLogic\nC++: vtkSlicerAnnotationModuleLogic *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkSlicerAnnotationModuleLogic_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkSlicerAnnotationModuleLogic_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"StartPlaceMode", PyvtkSlicerAnnotationModuleLogic_StartPlaceMode, METH_VARARGS,
   "V.StartPlaceMode(bool, vtkMRMLInteractionNode)\nC++: void StartPlaceMode(bool persistent=false,\n    vtkMRMLInteractionNode *interactionNode=nullptr)\n\nStart the place mode for annotations. By default, the singleton\ninteraction node is updated.\n"},
  {"StopPlaceMode", PyvtkSlicerAnnotationModuleLogic_StopPlaceMode, METH_VARARGS,
   "V.StopPlaceMode(bool, vtkMRMLInteractionNode)\nC++: void StopPlaceMode(bool persistent=false,\n    vtkMRMLInteractionNode *interactionNode=nullptr)\n\nExit the place mode for annotations. By default, the singleton\ninteraction node is updated.\n"},
  {"AddAnnotationNode", PyvtkSlicerAnnotationModuleLogic_AddAnnotationNode, METH_VARARGS,
   "V.AddAnnotationNode(string, bool)\nC++: void AddAnnotationNode(const char *nodeDescriptor,\n    bool persistent=false)\n\n"},
  {"AddNodeCompleted", PyvtkSlicerAnnotationModuleLogic_AddNodeCompleted, METH_VARARGS,
   "V.AddNodeCompleted(vtkMRMLAnnotationNode)\nC++: void AddNodeCompleted(vtkMRMLAnnotationNode *annotationNode)\n\n"},
  {"CancelCurrentOrRemoveLastAddedAnnotationNode", PyvtkSlicerAnnotationModuleLogic_CancelCurrentOrRemoveLastAddedAnnotationNode, METH_VARARGS,
   "V.CancelCurrentOrRemoveLastAddedAnnotationNode(\n    vtkMRMLInteractionNode)\nC++: void CancelCurrentOrRemoveLastAddedAnnotationNode(\n    vtkMRMLInteractionNode *interactionNode=nullptr)\n\nCancel the current annotation placement or remove last annotation\nnode. By default, the singleton interaction node is updated.\n"},
  {"RemoveAnnotationNode", PyvtkSlicerAnnotationModuleLogic_RemoveAnnotationNode, METH_VARARGS,
   "V.RemoveAnnotationNode(vtkMRMLAnnotationNode)\nC++: void RemoveAnnotationNode(\n    vtkMRMLAnnotationNode *annotationNode)\n\nRemove an AnnotationNode and also its 1-1 IS-A hierarchyNode, if\nfound.\n"},
  {"RegisterNodes", PyvtkSlicerAnnotationModuleLogic_RegisterNodes, METH_VARARGS,
   "V.RegisterNodes()\nC++: void RegisterNodes() override;\n\nRegister MRML Node classes to Scene. Gets called automatically\nwhen the MRMLScene is attached to this logic class.\n"},
  {"IsAnnotationNode", PyvtkSlicerAnnotationModuleLogic_IsAnnotationNode, METH_VARARGS,
   "V.IsAnnotationNode(string) -> bool\nC++: bool IsAnnotationNode(const char *id)\n\nCheck if node id corresponds to an annotaton node\n"},
  {"IsAnnotationHierarchyNode", PyvtkSlicerAnnotationModuleLogic_IsAnnotationHierarchyNode, METH_VARARGS,
   "V.IsAnnotationHierarchyNode(string) -> bool\nC++: bool IsAnnotationHierarchyNode(const char *id)\n\n"},
  {"GetTextDisplayNode", PyvtkSlicerAnnotationModuleLogic_GetTextDisplayNode, METH_VARARGS,
   "V.GetTextDisplayNode(string) -> vtkMRMLAnnotationTextDisplayNode\nC++: vtkMRMLAnnotationTextDisplayNode *GetTextDisplayNode(\n    const char *id)\n\nReturn the text display node for the annotation mrml node with\nthis id, null if not a valid node, not an annotation node, or\ndoesn't have a text display node\n"},
  {"GetPointDisplayNode", PyvtkSlicerAnnotationModuleLogic_GetPointDisplayNode, METH_VARARGS,
   "V.GetPointDisplayNode(string) -> vtkMRMLAnnotationPointDisplayNode\nC++: vtkMRMLAnnotationPointDisplayNode *GetPointDisplayNode(\n    const char *id)\n\nReturn the point display node for the annotation mrml node with\nthis id, null if not a valid node, not an annotation node, or\ndoesn't have a point display node\n"},
  {"GetLineDisplayNode", PyvtkSlicerAnnotationModuleLogic_GetLineDisplayNode, METH_VARARGS,
   "V.GetLineDisplayNode(string) -> vtkMRMLAnnotationLineDisplayNode\nC++: vtkMRMLAnnotationLineDisplayNode *GetLineDisplayNode(\n    const char *id)\n\nReturn the line display node for the annotation mrml node with\nthis id, null if not a valid node, not an annotation node, or\ndoesn't have a line display node\n"},
  {"GetAnnotationName", PyvtkSlicerAnnotationModuleLogic_GetAnnotationName, METH_VARARGS,
   "V.GetAnnotationName(string) -> string\nC++: const char *GetAnnotationName(const char *id)\n\nGet the name of an Annotation MRML node\n"},
  {"GetAnnotationText", PyvtkSlicerAnnotationModuleLogic_GetAnnotationText, METH_VARARGS,
   "V.GetAnnotationText(string) -> string\nC++: vtkStdString GetAnnotationText(const char *id)\n\nReturn the text of an Annotation MRML node\n"},
  {"SetAnnotationText", PyvtkSlicerAnnotationModuleLogic_SetAnnotationText, METH_VARARGS,
   "V.SetAnnotationText(string, string)\nC++: void SetAnnotationText(const char *id, const char *newtext)\n\nSet the text of an Annotation MRML node\n"},
  {"GetAnnotationTextScale", PyvtkSlicerAnnotationModuleLogic_GetAnnotationTextScale, METH_VARARGS,
   "V.GetAnnotationTextScale(string) -> float\nC++: double GetAnnotationTextScale(const char *id)\n\nGet the text scale of an Annotation MRML node\n"},
  {"SetAnnotationTextScale", PyvtkSlicerAnnotationModuleLogic_SetAnnotationTextScale, METH_VARARGS,
   "V.SetAnnotationTextScale(string, float)\nC++: void SetAnnotationTextScale(const char *id, double textScale)\n\nSet the text scale of an Annotation MRML node\n"},
  {"GetAnnotationTextSelectedColor", PyvtkSlicerAnnotationModuleLogic_GetAnnotationTextSelectedColor, METH_VARARGS,
   "V.GetAnnotationTextSelectedColor(string) -> (float, ...)\nC++: double *GetAnnotationTextSelectedColor(const char *id)\n\nGet the selected text color of an Annotation MRML node\n"},
  {"SetAnnotationTextSelectedColor", PyvtkSlicerAnnotationModuleLogic_SetAnnotationTextSelectedColor, METH_VARARGS,
   "V.SetAnnotationTextSelectedColor(string, [float, ...])\nC++: void SetAnnotationTextSelectedColor(const char *id,\n    double *color)\n\nSet the selected text color of an Annotation MRML node\n"},
  {"GetAnnotationTextUnselectedColor", PyvtkSlicerAnnotationModuleLogic_GetAnnotationTextUnselectedColor, METH_VARARGS,
   "V.GetAnnotationTextUnselectedColor(string) -> (float, ...)\nC++: double *GetAnnotationTextUnselectedColor(const char *id)\n\nGet the text color of an Annotation MRML node\n"},
  {"SetAnnotationTextUnselectedColor", PyvtkSlicerAnnotationModuleLogic_SetAnnotationTextUnselectedColor, METH_VARARGS,
   "V.SetAnnotationTextUnselectedColor(string, [float, ...])\nC++: void SetAnnotationTextUnselectedColor(const char *id,\n    double *color)\n\nSet the text color of an Annotation MRML node\n"},
  {"GetAnnotationColor", PyvtkSlicerAnnotationModuleLogic_GetAnnotationColor, METH_VARARGS,
   "V.GetAnnotationColor(string) -> (float, ...)\nC++: double *GetAnnotationColor(const char *id)\n\nGet the color of an annotation mrml node, returns null if can't\nfind it\n"},
  {"SetAnnotationColor", PyvtkSlicerAnnotationModuleLogic_SetAnnotationColor, METH_VARARGS,
   "V.SetAnnotationColor(string, [float, ...])\nC++: void SetAnnotationColor(const char *id, double *color)\n\nSet the color of an annotation mrml node\n"},
  {"GetAnnotationUnselectedColor", PyvtkSlicerAnnotationModuleLogic_GetAnnotationUnselectedColor, METH_VARARGS,
   "V.GetAnnotationUnselectedColor(string) -> (float, ...)\nC++: double *GetAnnotationUnselectedColor(const char *id)\n\nGet the unselected color of an annotation mrml node, returns null\nif can't find it\n"},
  {"SetAnnotationUnselectedColor", PyvtkSlicerAnnotationModuleLogic_SetAnnotationUnselectedColor, METH_VARARGS,
   "V.SetAnnotationUnselectedColor(string, [float, ...])\nC++: void SetAnnotationUnselectedColor(const char *id,\n    double *color)\n\nSet the unselected color of an annotation mrml node\n"},
  {"GetAnnotationPointColor", PyvtkSlicerAnnotationModuleLogic_GetAnnotationPointColor, METH_VARARGS,
   "V.GetAnnotationPointColor(string) -> (float, ...)\nC++: double *GetAnnotationPointColor(const char *id)\n\nGet the point color of an annotation mrml node, returns null if\ncan't find it\n"},
  {"SetAnnotationPointColor", PyvtkSlicerAnnotationModuleLogic_SetAnnotationPointColor, METH_VARARGS,
   "V.SetAnnotationPointColor(string, [float, ...])\nC++: void SetAnnotationPointColor(const char *id, double *color)\n\nSet the point color of an annotation mrml node\n"},
  {"GetAnnotationPointUnselectedColor", PyvtkSlicerAnnotationModuleLogic_GetAnnotationPointUnselectedColor, METH_VARARGS,
   "V.GetAnnotationPointUnselectedColor(string) -> (float, ...)\nC++: double *GetAnnotationPointUnselectedColor(const char *id)\n\nGet the unselected point color of an annotation mrml node,\nreturns null if can't find it\n"},
  {"SetAnnotationPointUnselectedColor", PyvtkSlicerAnnotationModuleLogic_SetAnnotationPointUnselectedColor, METH_VARARGS,
   "V.SetAnnotationPointUnselectedColor(string, [float, ...])\nC++: void SetAnnotationPointUnselectedColor(const char *id,\n    double *color)\n\nSet the unselected point color of an annotation mrml node\n"},
  {"GetAnnotationPointGlyphTypeAsString", PyvtkSlicerAnnotationModuleLogic_GetAnnotationPointGlyphTypeAsString, METH_VARARGS,
   "V.GetAnnotationPointGlyphTypeAsString(string) -> string\nC++: const char *GetAnnotationPointGlyphTypeAsString(\n    const char *id)\n\nGet the point glyph type of the annotation mrml node as a string,\nreturns null if can't find it\n"},
  {"GetAnnotationPointGlyphType", PyvtkSlicerAnnotationModuleLogic_GetAnnotationPointGlyphType, METH_VARARGS,
   "V.GetAnnotationPointGlyphType(string) -> int\nC++: int GetAnnotationPointGlyphType(const char *id)\n\nGet the point glyph type of the annotation mrml node,\n"},
  {"SetAnnotationPointGlyphTypeFromString", PyvtkSlicerAnnotationModuleLogic_SetAnnotationPointGlyphTypeFromString, METH_VARARGS,
   "V.SetAnnotationPointGlyphTypeFromString(string, string)\nC++: void SetAnnotationPointGlyphTypeFromString(const char *id,\n    const char *glyphType)\n\nSet the point glyph type of the annotation mrml node from a\nstring\n"},
  {"SetAnnotationPointGlyphType", PyvtkSlicerAnnotationModuleLogic_SetAnnotationPointGlyphType, METH_VARARGS,
   "V.SetAnnotationPointGlyphType(string, int)\nC++: void SetAnnotationPointGlyphType(const char *id,\n    int glyphType)\n\nSet the point glyph type of the annotation mrml node\n"},
  {"GetAnnotationLineColor", PyvtkSlicerAnnotationModuleLogic_GetAnnotationLineColor, METH_VARARGS,
   "V.GetAnnotationLineColor(string) -> (float, ...)\nC++: double *GetAnnotationLineColor(const char *id)\n\nGet the line color of an annotation mrml node, returns null if\ncan't find it\n"},
  {"SetAnnotationLineColor", PyvtkSlicerAnnotationModuleLogic_SetAnnotationLineColor, METH_VARARGS,
   "V.SetAnnotationLineColor(string, [float, ...])\nC++: void SetAnnotationLineColor(const char *id, double *color)\n\nSet the line color of an annotation mrml node\n"},
  {"GetAnnotationLineUnselectedColor", PyvtkSlicerAnnotationModuleLogic_GetAnnotationLineUnselectedColor, METH_VARARGS,
   "V.GetAnnotationLineUnselectedColor(string) -> (float, ...)\nC++: double *GetAnnotationLineUnselectedColor(const char *id)\n\nGet the unselected line color of an annotation mrml node, returns\nnull if can't find it\n"},
  {"SetAnnotationLineUnselectedColor", PyvtkSlicerAnnotationModuleLogic_SetAnnotationLineUnselectedColor, METH_VARARGS,
   "V.SetAnnotationLineUnselectedColor(string, [float, ...])\nC++: void SetAnnotationLineUnselectedColor(const char *id,\n    double *color)\n\nSet the unselected line color of an annotation mrml node\n"},
  {"GetAnnotationMeasurement", PyvtkSlicerAnnotationModuleLogic_GetAnnotationMeasurement, METH_VARARGS,
   "V.GetAnnotationMeasurement(string, bool) -> string\nC++: const char *GetAnnotationMeasurement(const char *id,\n    bool showUnits)\n\nGet the measurement value of an Annotation MRML node\n"},
  {"GetAnnotationIcon", PyvtkSlicerAnnotationModuleLogic_GetAnnotationIcon, METH_VARARGS,
   "V.GetAnnotationIcon(string) -> string\nC++: const char *GetAnnotationIcon(const char *id)\nV.GetAnnotationIcon(vtkMRMLNode) -> string\nC++: const char *GetAnnotationIcon(vtkMRMLNode *mrmlNode)\n\nGet the icon name of an Annotation MRML node\n"},
  {"GetAnnotationLockedUnlocked", PyvtkSlicerAnnotationModuleLogic_GetAnnotationLockedUnlocked, METH_VARARGS,
   "V.GetAnnotationLockedUnlocked(string) -> int\nC++: int GetAnnotationLockedUnlocked(const char *id)\n\nGet the lock flag of an Annotation MRML node\n"},
  {"SetAnnotationLockedUnlocked", PyvtkSlicerAnnotationModuleLogic_SetAnnotationLockedUnlocked, METH_VARARGS,
   "V.SetAnnotationLockedUnlocked(string)\nC++: void SetAnnotationLockedUnlocked(const char *id)\n\nToggle the lock flag of an Annotation MRML node\n"},
  {"GetAnnotationVisibility", PyvtkSlicerAnnotationModuleLogic_GetAnnotationVisibility, METH_VARARGS,
   "V.GetAnnotationVisibility(string) -> int\nC++: int GetAnnotationVisibility(const char *id)\n\nGet the visibility flag of an Annotation MRML node\n"},
  {"SetAnnotationVisibility", PyvtkSlicerAnnotationModuleLogic_SetAnnotationVisibility, METH_VARARGS,
   "V.SetAnnotationVisibility(string)\nC++: void SetAnnotationVisibility(const char *id)\n\nToggle the visibility flag of an Annotation MRML node\n"},
  {"SetAnnotationSelected", PyvtkSlicerAnnotationModuleLogic_SetAnnotationSelected, METH_VARARGS,
   "V.SetAnnotationSelected(string, bool)\nC++: void SetAnnotationSelected(const char *id, bool selected)\n\nSet the selected flag of an Annotation MRML node\n"},
  {"SetAllAnnotationsSelected", PyvtkSlicerAnnotationModuleLogic_SetAllAnnotationsSelected, METH_VARARGS,
   "V.SetAllAnnotationsSelected(bool)\nC++: void SetAllAnnotationsSelected(bool selected)\n\nSet the selected flag of all annotation mrml nodes\n"},
  {"BackupAnnotationNode", PyvtkSlicerAnnotationModuleLogic_BackupAnnotationNode, METH_VARARGS,
   "V.BackupAnnotationNode(string)\nC++: void BackupAnnotationNode(const char *id)\n\nBackup an Annotation MRML node\n"},
  {"RestoreAnnotationNode", PyvtkSlicerAnnotationModuleLogic_RestoreAnnotationNode, METH_VARARGS,
   "V.RestoreAnnotationNode(string)\nC++: void RestoreAnnotationNode(const char *id)\n\nRestore a backup of an Annotation MRML node\n"},
  {"DeleteBackupNodes", PyvtkSlicerAnnotationModuleLogic_DeleteBackupNodes, METH_VARARGS,
   "V.DeleteBackupNodes(string)\nC++: void DeleteBackupNodes(const char *id)\n\nDeletes a backup of an Annotation MRML node\n"},
  {"JumpSlicesToAnnotationCoordinate", PyvtkSlicerAnnotationModuleLogic_JumpSlicesToAnnotationCoordinate, METH_VARARGS,
   "V.JumpSlicesToAnnotationCoordinate(string)\nC++: void JumpSlicesToAnnotationCoordinate(const char *id)\n\nJump 2d Slices to the location of the first control point of an\nAnnotation MRML node\n"},
  {"MoveAnnotationUp", PyvtkSlicerAnnotationModuleLogic_MoveAnnotationUp, METH_VARARGS,
   "V.MoveAnnotationUp(string) -> string\nC++: const char *MoveAnnotationUp(const char *id)\n\n"},
  {"MoveAnnotationDown", PyvtkSlicerAnnotationModuleLogic_MoveAnnotationDown, METH_VARARGS,
   "V.MoveAnnotationDown(string) -> string\nC++: const char *MoveAnnotationDown(const char *id)\n\n"},
  {"CreateSnapShot", PyvtkSlicerAnnotationModuleLogic_CreateSnapShot, METH_VARARGS,
   "V.CreateSnapShot(string, string, int, float, vtkImageData)\nC++: void CreateSnapShot(const char *name,\n    const char *description, int screenshotType,\n    double scaleFactor, vtkImageData *screenshot)\n\nCreate a snapShot.\n"},
  {"ModifySnapShot", PyvtkSlicerAnnotationModuleLogic_ModifySnapShot, METH_VARARGS,
   "V.ModifySnapShot(string, string, string, int, float, vtkImageData)\nC++: void ModifySnapShot(vtkStdString id, const char *name,\n    const char *description, int screenshotType,\n    double scaleFactor, vtkImageData *screenshot)\n\nModify an existing snapShot.\n"},
  {"GetSnapShotName", PyvtkSlicerAnnotationModuleLogic_GetSnapShotName, METH_VARARGS,
   "V.GetSnapShotName(string) -> string\nC++: vtkStdString GetSnapShotName(const char *id)\n\nReturn the name of an existing annotation snapShot.\n"},
  {"GetSnapShotDescription", PyvtkSlicerAnnotationModuleLogic_GetSnapShotDescription, METH_VARARGS,
   "V.GetSnapShotDescription(string) -> string\nC++: vtkStdString GetSnapShotDescription(const char *id)\n\nReturn the description of an existing annotation snapShot.\n"},
  {"GetSnapShotScreenshotType", PyvtkSlicerAnnotationModuleLogic_GetSnapShotScreenshotType, METH_VARARGS,
   "V.GetSnapShotScreenshotType(string) -> int\nC++: int GetSnapShotScreenshotType(const char *id)\n\nReturn the screenshotType of an existing annotation snapShot.\n"},
  {"GetSnapShotScaleFactor", PyvtkSlicerAnnotationModuleLogic_GetSnapShotScaleFactor, METH_VARARGS,
   "V.GetSnapShotScaleFactor(string) -> float\nC++: double GetSnapShotScaleFactor(const char *id)\n\nReturn the scaleFactor of an existing annotation snapShot.\n"},
  {"GetSnapShotScreenshot", PyvtkSlicerAnnotationModuleLogic_GetSnapShotScreenshot, METH_VARARGS,
   "V.GetSnapShotScreenshot(string) -> vtkImageData\nC++: vtkImageData *GetSnapShotScreenshot(const char *id)\n\nReturn the screenshot of an existing annotation snapShot.\n"},
  {"IsSnapshotNode", PyvtkSlicerAnnotationModuleLogic_IsSnapshotNode, METH_VARARGS,
   "V.IsSnapshotNode(string) -> bool\nC++: bool IsSnapshotNode(const char *id)\n\nCheck if node id corresponds to a snapShot node\n"},
  {"AddHierarchy", PyvtkSlicerAnnotationModuleLogic_AddHierarchy, METH_VARARGS,
   "V.AddHierarchy() -> bool\nC++: bool AddHierarchy()\n\nAdd a new visible annotation hierarchy. The active hierarchy node\nwill be the parent. If there is no active hierarchy node, use the\ntop-level annotation hierarchy node as the parent. If there is no\ntop-level annotation hierarchy node, create additionally a\ntop-level hierarchy node which serves as a parent to the new\nhierarchy node. The newly added hierarchy node will be the active\nhierarchy node. Return true on success, false on failure.\n"},
  {"GetTopLevelHierarchyNodeID", PyvtkSlicerAnnotationModuleLogic_GetTopLevelHierarchyNodeID, METH_VARARGS,
   "V.GetTopLevelHierarchyNodeID(vtkMRMLNode) -> string\nC++: char *GetTopLevelHierarchyNodeID(vtkMRMLNode *node=nullptr)\n\nReturn the toplevel Annotation hierarchy node ID or create one\nand add it to the scene if there is none: If an optional\nannotationNode is given, insert the new toplevel hierarchy before\nit. If not, just add the new toplevel hierarchy node.\n"},
  {"GetTopLevelHierarchyNodeIDForNodeClass", PyvtkSlicerAnnotationModuleLogic_GetTopLevelHierarchyNodeIDForNodeClass, METH_VARARGS,
   "V.GetTopLevelHierarchyNodeIDForNodeClass(vtkMRMLAnnotationNode)\n    -> string\nC++: char *GetTopLevelHierarchyNodeIDForNodeClass(\n    vtkMRMLAnnotationNode *annotationNode)\n\nReturn the top level annotation hierarchy node for this node's\nclass, adding one under the top level annotation hierarchy if\nthere is none. If the passed in node is null, return null\n"},
  {"GetActiveHierarchyNode", PyvtkSlicerAnnotationModuleLogic_GetActiveHierarchyNode, METH_VARARGS,
   "V.GetActiveHierarchyNode() -> vtkMRMLAnnotationHierarchyNode\nC++: vtkMRMLAnnotationHierarchyNode *GetActiveHierarchyNode()\n\nGet the active hierarchy node which will be used as a parent for\nnew annotations\n"},
  {"GetActiveHierarchyNodeID", PyvtkSlicerAnnotationModuleLogic_GetActiveHierarchyNodeID, METH_VARARGS,
   "V.GetActiveHierarchyNodeID() -> string\nC++: virtual char *GetActiveHierarchyNodeID()\n\nget/set the id of the active hierarchy node\n"},
  {"SetActiveHierarchyNodeID", PyvtkSlicerAnnotationModuleLogic_SetActiveHierarchyNodeID, METH_VARARGS,
   "V.SetActiveHierarchyNodeID(string)\nC++: virtual void SetActiveHierarchyNodeID(const char *_arg)\n\n"},
  {"SetHierarchyAnnotationsVisibleFlag", PyvtkSlicerAnnotationModuleLogic_SetHierarchyAnnotationsVisibleFlag, METH_VARARGS,
   "V.SetHierarchyAnnotationsVisibleFlag(\n    vtkMRMLAnnotationHierarchyNode, bool)\nC++: void SetHierarchyAnnotationsVisibleFlag(\n    vtkMRMLAnnotationHierarchyNode *hierarchyNode, bool flag)\n\nSet the visible flag on all annotations in the hierarchy. If\nhierarchy is null, use active hierarchy\n"},
  {"SetHierarchyAnnotationsLockFlag", PyvtkSlicerAnnotationModuleLogic_SetHierarchyAnnotationsLockFlag, METH_VARARGS,
   "V.SetHierarchyAnnotationsLockFlag(vtkMRMLAnnotationHierarchyNode,\n    bool)\nC++: void SetHierarchyAnnotationsLockFlag(\n    vtkMRMLAnnotationHierarchyNode *hierarchyNode, bool flag)\n\nSet the lock flag on all annotations in the hierarchy. If\nhierarchy is null, use active hierarchy\n"},
  {"GetHTMLRepresentation", PyvtkSlicerAnnotationModuleLogic_GetHTMLRepresentation, METH_VARARGS,
   "V.GetHTMLRepresentation(vtkMRMLAnnotationNode, int) -> string\nC++: const char *GetHTMLRepresentation(\n    vtkMRMLAnnotationNode *annotationNode, int level)\nV.GetHTMLRepresentation(vtkMRMLAnnotationHierarchyNode, int)\n    -> string\nC++: const char *GetHTMLRepresentation(\n    vtkMRMLAnnotationHierarchyNode *hierarchyNode, int level)\n\nReturn HTML markup for a specific annotation node\n"},
  {"AddDisplayNodeForHierarchyNode", PyvtkSlicerAnnotationModuleLogic_AddDisplayNodeForHierarchyNode, METH_VARARGS,
   "V.AddDisplayNodeForHierarchyNode(vtkMRMLAnnotationHierarchyNode)\n    -> string\nC++: const char *AddDisplayNodeForHierarchyNode(\n    vtkMRMLAnnotationHierarchyNode *hnode)\n\nAdd a model display node to the scene for a passed in hierarchy\nnode, if it doesn't already have one, return the ID, nullptr on\nfailure\n"},
  {"LoadFiducialList", PyvtkSlicerAnnotationModuleLogic_LoadFiducialList, METH_VARARGS,
   "V.LoadFiducialList(string) -> string\nC++: char *LoadFiducialList(const char *filename)\n\nLegacy support: load a Slicer3 fiducial list from file. Uses\nFiducialsLogic to load into a legacy node first, then translates\ninto annotation nodes returns a comma separated list of the annot\nnodes loaded\n"},
  {"LoadAnnotation", PyvtkSlicerAnnotationModuleLogic_LoadAnnotation, METH_VARARGS,
   "V.LoadAnnotation(string, string, int) -> string\nC++: char *LoadAnnotation(const char *filename, const char *name,\n    int fileType)\n\nLoad an annotation from file, return nullptr on error, node ID\nstring otherwise. Adds the appropriate storage and display nodes\nto the scene as well. fileType is from this class's enum\n"},
  {"AddFiducial", PyvtkSlicerAnnotationModuleLogic_AddFiducial, METH_VARARGS,
   "V.AddFiducial(float, float, float, string) -> string\nC++: char *AddFiducial(double r=0.0, double a=0.0, double s=0.0,\n    const char *label=nullptr)\n\nAdd a new fiducial to the currently active hierarchy. Places the\nfiducial at the given RAS coordinates (default 0,0,0) with the\ngiven label (if nullptr, uses default naming convention). Returns\nthe ID of the newly added node.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkSlicerAnnotationModuleLogic_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerAnnotationsModuleLogic.vtkSlicerAnnotationModuleLogic", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkSlicerAnnotationModuleLogic_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSlicerAnnotationModuleLogic_StaticNew()
{
  return vtkSlicerAnnotationModuleLogic::New();
}

PyObject *PyvtkSlicerAnnotationModuleLogic_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkSlicerAnnotationModuleLogic_Type, PyvtkSlicerAnnotationModuleLogic_Methods,
    "vtkSlicerAnnotationModuleLogic",
 &PyvtkSlicerAnnotationModuleLogic_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkSlicerModuleLogic");

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkSlicerAnnotationModuleLogic_Events_Type);
  PyVTKEnum_Add(&PyvtkSlicerAnnotationModuleLogic_Events_Type, "vtkSlicerAnnotationModuleLogic.Events");

  o = (PyObject *)&PyvtkSlicerAnnotationModuleLogic_Events_Type;
  if (PyDict_SetItemString(d, "Events", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkSlicerAnnotationModuleLogic::Events cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "RefreshRequestEvent", vtkSlicerAnnotationModuleLogic::RefreshRequestEvent },
        { "HierarchyNodeAddedEvent", vtkSlicerAnnotationModuleLogic::HierarchyNodeAddedEvent },
      };

    o = PyvtkSlicerAnnotationModuleLogic_Events_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 4; c++)
  {
    static const struct { const char *name; int value; }
      constants[4] = {
        { "None", vtkSlicerAnnotationModuleLogic::None },
        { "Fiducial", vtkSlicerAnnotationModuleLogic::Fiducial },
        { "Ruler", vtkSlicerAnnotationModuleLogic::Ruler },
        { "ROI", vtkSlicerAnnotationModuleLogic::ROI },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkSlicerAnnotationModuleLogic(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSlicerAnnotationModuleLogic_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSlicerAnnotationModuleLogic", o) != 0)
  {
    Py_DECREF(o);
  }

}

