// python wrapper for vtkMRMLAnnotationAngleNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMRMLAnnotationAngleNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLAnnotationAngleNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLAnnotationAngleNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLAnnotationLinesNode_ClassNew
extern "C" { PyObject *PyvtkMRMLAnnotationLinesNode_ClassNew(); }
#define DECLARED_PyvtkMRMLAnnotationLinesNode_ClassNew
#endif

static const char *PyvtkMRMLAnnotationAngleNode_Doc =
  "vtkMRMLAnnotationAngleNode - \\ingroup Slicer_QtModules_Annotation\n\n"
  "Superclass: vtkMRMLAnnotationLinesNode\n\n"
;


static PyObject *
PyvtkMRMLAnnotationAngleNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLAnnotationAngleNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLAnnotationAngleNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLAnnotationAngleNode *tempr = vtkMRMLAnnotationAngleNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLAnnotationAngleNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLAnnotationAngleNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLAnnotationAngleNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLAnnotationAngleNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLAnnotationAngleNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLAnnotationAngleNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_Copy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Copy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode"))
  {
    if (ap.IsBound())
    {
      op->Copy(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::Copy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_UpdateScene(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateScene");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  vtkMRMLScene *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLScene"))
  {
    if (ap.IsBound())
    {
      op->UpdateScene(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::UpdateScene(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_ProcessMRMLEvents(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProcessMRMLEvents");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  vtkObject *temp0 = nullptr;
  unsigned long temp1;
  void  *temp2 = nullptr;
  Py_buffer pbuf2 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkObject") &&
      ap.GetValue(temp1) &&
      ap.GetBuffer(temp2, &pbuf2))
  {
    if (ap.IsBound())
    {
      op->ProcessMRMLEvents(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::ProcessMRMLEvents(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf2.obj != 0)
  {
    PyBuffer_Release(&pbuf2);
  }
#endif
  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetPosition1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPosition1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetPosition1() :
      op->vtkMRMLAnnotationAngleNode::GetPosition1());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPosition1_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    int tempr = (ap.IsBound() ?
      op->SetPosition1(temp0) :
      op->vtkMRMLAnnotationAngleNode::SetPosition1(temp0));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPosition1_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->SetPosition1(temp0, temp1, temp2) :
      op->vtkMRMLAnnotationAngleNode::SetPosition1(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPosition1(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkMRMLAnnotationAngleNode_SetPosition1_s1(self, args);
    case 3:
      return PyvtkMRMLAnnotationAngleNode_SetPosition1_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetPosition1");
  return nullptr;
}



static PyObject *
PyvtkMRMLAnnotationAngleNode_GetPosition2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPosition2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetPosition2() :
      op->vtkMRMLAnnotationAngleNode::GetPosition2());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPosition2_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    int tempr = (ap.IsBound() ?
      op->SetPosition2(temp0) :
      op->vtkMRMLAnnotationAngleNode::SetPosition2(temp0));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPosition2_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->SetPosition2(temp0, temp1, temp2) :
      op->vtkMRMLAnnotationAngleNode::SetPosition2(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPosition2(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkMRMLAnnotationAngleNode_SetPosition2_s1(self, args);
    case 3:
      return PyvtkMRMLAnnotationAngleNode_SetPosition2_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetPosition2");
  return nullptr;
}



static PyObject *
PyvtkMRMLAnnotationAngleNode_GetPositionCenter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPositionCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetPositionCenter() :
      op->vtkMRMLAnnotationAngleNode::GetPositionCenter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPositionCenter_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPositionCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    int tempr = (ap.IsBound() ?
      op->SetPositionCenter(temp0) :
      op->vtkMRMLAnnotationAngleNode::SetPositionCenter(temp0));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPositionCenter_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPositionCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->SetPositionCenter(temp0, temp1, temp2) :
      op->vtkMRMLAnnotationAngleNode::SetPositionCenter(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPositionCenter(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkMRMLAnnotationAngleNode_SetPositionCenter_s1(self, args);
    case 3:
      return PyvtkMRMLAnnotationAngleNode_SetPositionCenter_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetPositionCenter");
  return nullptr;
}



static PyObject *
PyvtkMRMLAnnotationAngleNode_GetLabelFormat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabelFormat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetLabelFormat() :
      op->vtkMRMLAnnotationAngleNode::GetLabelFormat());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetLabelFormat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelFormat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLabelFormat(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetLabelFormat(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetLabelScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabelScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetLabelScale() :
      op->vtkMRMLAnnotationAngleNode::GetLabelScale());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetLabelScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLabelScale(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetLabelScale(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetLabelVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabelVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLabelVisibility() :
      op->vtkMRMLAnnotationAngleNode::GetLabelVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetLabelVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLabelVisibility(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetLabelVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetAngle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAngle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  int temp0;
  int temp1;
  int temp2;
  int temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    int tempr = (ap.IsBound() ?
      op->SetAngle(temp0, temp1, temp2, temp3) :
      op->vtkMRMLAnnotationAngleNode::SetAngle(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetRay1Visibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRay1Visibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRay1Visibility() :
      op->vtkMRMLAnnotationAngleNode::GetRay1Visibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetRay1Visibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRay1Visibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRay1Visibility(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetRay1Visibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetRay2Visibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRay2Visibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRay2Visibility() :
      op->vtkMRMLAnnotationAngleNode::GetRay2Visibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetRay2Visibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRay2Visibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRay2Visibility(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetRay2Visibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetArcVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetArcVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetArcVisibility() :
      op->vtkMRMLAnnotationAngleNode::GetArcVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetArcVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetArcVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetArcVisibility(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetArcVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetResolution() :
      op->vtkMRMLAnnotationAngleNode::GetResolution());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetResolution(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetResolution(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetPointColour(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPointColour");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetPointColour() :
      op->vtkMRMLAnnotationAngleNode::GetPointColour());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetPointColour(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPointColour");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetPointColour(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetPointColour(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetLineColour(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLineColour");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetLineColour() :
      op->vtkMRMLAnnotationAngleNode::GetLineColour());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetLineColour(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLineColour");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetLineColour(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetLineColour(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetLabelTextColour(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabelTextColour");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetLabelTextColour() :
      op->vtkMRMLAnnotationAngleNode::GetLabelTextColour());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetLabelTextColour(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelTextColour");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetLabelTextColour(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetLabelTextColour(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_ApplyTransform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ApplyTransform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  vtkAbstractTransform *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAbstractTransform"))
  {
    if (ap.IsBound())
    {
      op->ApplyTransform(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::ApplyTransform(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_CreateDefaultStorageNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultStorageNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLStorageNode *tempr = (ap.IsBound() ?
      op->CreateDefaultStorageNode() :
      op->vtkMRMLAnnotationAngleNode::CreateDefaultStorageNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetModelID1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModelID1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetModelID1() :
      op->vtkMRMLAnnotationAngleNode::GetModelID1());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetModelID1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetModelID1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetModelID1(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetModelID1(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetModelID2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModelID2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetModelID2() :
      op->vtkMRMLAnnotationAngleNode::GetModelID2());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetModelID2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetModelID2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetModelID2(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetModelID2(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetModelIDCenter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModelIDCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetModelIDCenter() :
      op->vtkMRMLAnnotationAngleNode::GetModelIDCenter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetModelIDCenter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetModelIDCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetModelIDCenter(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetModelIDCenter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_SetAngleMeasurement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAngleMeasurement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAngleMeasurement(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationAngleNode::SetAngleMeasurement(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationAngleNode_GetAngleMeasurement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAngleMeasurement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationAngleNode *op = static_cast<vtkMRMLAnnotationAngleNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetAngleMeasurement() :
      op->vtkMRMLAnnotationAngleNode::GetAngleMeasurement());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLAnnotationAngleNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLAnnotationAngleNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLAnnotationAngleNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLAnnotationAngleNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLAnnotationAngleNode\nC++: static vtkMRMLAnnotationAngleNode *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLAnnotationAngleNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLAnnotationAngleNode\nC++: vtkMRMLAnnotationAngleNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLAnnotationAngleNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLAnnotationAngleNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"CreateNodeInstance", PyvtkMRMLAnnotationAngleNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\nMRMLNode methods\n"},
  {"GetNodeTagName", PyvtkMRMLAnnotationAngleNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"Copy", PyvtkMRMLAnnotationAngleNode_Copy, METH_VARARGS,
   "V.Copy(vtkMRMLNode)\nC++: void Copy(vtkMRMLNode *node) override;\n\nCopy the node's attributes to this object\n"},
  {"UpdateScene", PyvtkMRMLAnnotationAngleNode_UpdateScene, METH_VARARGS,
   "V.UpdateScene(vtkMRMLScene)\nC++: void UpdateScene(vtkMRMLScene *scene) override;\n\nFinds the storage node and read the data\n"},
  {"ProcessMRMLEvents", PyvtkMRMLAnnotationAngleNode_ProcessMRMLEvents, METH_VARARGS,
   "V.ProcessMRMLEvents(vtkObject, int, void)\nC++: void ProcessMRMLEvents(vtkObject *, unsigned long, void *)\n    override;\n\nalternative method to propagate events generated in Display nodes\n"},
  {"GetPosition1", PyvtkMRMLAnnotationAngleNode_GetPosition1, METH_VARARGS,
   "V.GetPosition1() -> (float, ...)\nC++: double *GetPosition1()\n\nget/set the first point position\n"},
  {"SetPosition1", PyvtkMRMLAnnotationAngleNode_SetPosition1, METH_VARARGS,
   "V.SetPosition1([float, float, float]) -> int\nC++: int SetPosition1(double newControl[3])\nV.SetPosition1(float, float, float) -> int\nC++: int SetPosition1(double nC1, double nC2, double nC3)\n\n"},
  {"GetPosition2", PyvtkMRMLAnnotationAngleNode_GetPosition2, METH_VARARGS,
   "V.GetPosition2() -> (float, ...)\nC++: double *GetPosition2()\n\n"},
  {"SetPosition2", PyvtkMRMLAnnotationAngleNode_SetPosition2, METH_VARARGS,
   "V.SetPosition2([float, float, float]) -> int\nC++: int SetPosition2(double newControl[3])\nV.SetPosition2(float, float, float) -> int\nC++: int SetPosition2(double nC1, double nC2, double nC3)\n\n"},
  {"GetPositionCenter", PyvtkMRMLAnnotationAngleNode_GetPositionCenter, METH_VARARGS,
   "V.GetPositionCenter() -> (float, ...)\nC++: double *GetPositionCenter()\n\n"},
  {"SetPositionCenter", PyvtkMRMLAnnotationAngleNode_SetPositionCenter, METH_VARARGS,
   "V.SetPositionCenter([float, float, float]) -> int\nC++: int SetPositionCenter(double newControl[3])\nV.SetPositionCenter(float, float, float) -> int\nC++: int SetPositionCenter(double nC1, double nC2, double nC3)\n\n"},
  {"GetLabelFormat", PyvtkMRMLAnnotationAngleNode_GetLabelFormat, METH_VARARGS,
   "V.GetLabelFormat() -> string\nC++: virtual char *GetLabelFormat()\n\nget/set the distance annotation format, it's in standard sprintf\nnotation\n"},
  {"SetLabelFormat", PyvtkMRMLAnnotationAngleNode_SetLabelFormat, METH_VARARGS,
   "V.SetLabelFormat(string)\nC++: virtual void SetLabelFormat(const char *_arg)\n\nget/set the distance annotation format, it's in standard sprintf\nnotation\n"},
  {"GetLabelScale", PyvtkMRMLAnnotationAngleNode_GetLabelScale, METH_VARARGS,
   "V.GetLabelScale() -> float\nC++: double GetLabelScale()\n\nKP Define - should be part of AnnotationAngleDisplayNode\n"},
  {"SetLabelScale", PyvtkMRMLAnnotationAngleNode_SetLabelScale, METH_VARARGS,
   "V.SetLabelScale(float)\nC++: void SetLabelScale(double init)\n\nKP Define - should be part of AnnotationAngleDisplayNode\n"},
  {"GetLabelVisibility", PyvtkMRMLAnnotationAngleNode_GetLabelVisibility, METH_VARARGS,
   "V.GetLabelVisibility() -> int\nC++: int GetLabelVisibility()\n\nget/set the distance annotation visbility\n"},
  {"SetLabelVisibility", PyvtkMRMLAnnotationAngleNode_SetLabelVisibility, METH_VARARGS,
   "V.SetLabelVisibility(int)\nC++: void SetLabelVisibility(int flag)\n\nget/set the distance annotation visbility\n"},
  {"SetAngle", PyvtkMRMLAnnotationAngleNode_SetAngle, METH_VARARGS,
   "V.SetAngle(int, int, int, int) -> int\nC++: int SetAngle(vtkIdType line1Id, vtkIdType line2Id, int sel,\n    int vis)\n\n"},
  {"GetRay1Visibility", PyvtkMRMLAnnotationAngleNode_GetRay1Visibility, METH_VARARGS,
   "V.GetRay1Visibility() -> int\nC++: int GetRay1Visibility()\n\n\n"},
  {"SetRay1Visibility", PyvtkMRMLAnnotationAngleNode_SetRay1Visibility, METH_VARARGS,
   "V.SetRay1Visibility(int)\nC++: void SetRay1Visibility(int flag)\n\n\n"},
  {"GetRay2Visibility", PyvtkMRMLAnnotationAngleNode_GetRay2Visibility, METH_VARARGS,
   "V.GetRay2Visibility() -> int\nC++: int GetRay2Visibility()\n\n\n"},
  {"SetRay2Visibility", PyvtkMRMLAnnotationAngleNode_SetRay2Visibility, METH_VARARGS,
   "V.SetRay2Visibility(int)\nC++: void SetRay2Visibility(int flag)\n\n\n"},
  {"GetArcVisibility", PyvtkMRMLAnnotationAngleNode_GetArcVisibility, METH_VARARGS,
   "V.GetArcVisibility() -> int\nC++: int GetArcVisibility()\n\n"},
  {"SetArcVisibility", PyvtkMRMLAnnotationAngleNode_SetArcVisibility, METH_VARARGS,
   "V.SetArcVisibility(int)\nC++: void SetArcVisibility(int flag)\n\n"},
  {"GetResolution", PyvtkMRMLAnnotationAngleNode_GetResolution, METH_VARARGS,
   "V.GetResolution() -> int\nC++: virtual int GetResolution()\n\nget/set the resolution (number of subdivisions) of the line.\n"},
  {"SetResolution", PyvtkMRMLAnnotationAngleNode_SetResolution, METH_VARARGS,
   "V.SetResolution(int)\nC++: virtual void SetResolution(int _arg)\n\nget/set the resolution (number of subdivisions) of the line.\n"},
  {"GetPointColour", PyvtkMRMLAnnotationAngleNode_GetPointColour, METH_VARARGS,
   "V.GetPointColour() -> (float, ...)\nC++: double *GetPointColour()\n\nget/set the point representation colour\n"},
  {"SetPointColour", PyvtkMRMLAnnotationAngleNode_SetPointColour, METH_VARARGS,
   "V.SetPointColour([float, float, float])\nC++: void SetPointColour(double initColor[3])\n\nget/set the point representation colour\n"},
  {"GetLineColour", PyvtkMRMLAnnotationAngleNode_GetLineColour, METH_VARARGS,
   "V.GetLineColour() -> (float, ...)\nC++: double *GetLineColour()\n\nget/set the line representation colour\n"},
  {"SetLineColour", PyvtkMRMLAnnotationAngleNode_SetLineColour, METH_VARARGS,
   "V.SetLineColour([float, float, float])\nC++: void SetLineColour(double newColor[3])\n\nget/set the line representation colour\n"},
  {"GetLabelTextColour", PyvtkMRMLAnnotationAngleNode_GetLabelTextColour, METH_VARARGS,
   "V.GetLabelTextColour() -> (float, ...)\nC++: double *GetLabelTextColour()\n\nget/set the distance annotation text colour\n"},
  {"SetLabelTextColour", PyvtkMRMLAnnotationAngleNode_SetLabelTextColour, METH_VARARGS,
   "V.SetLabelTextColour([float, float, float])\nC++: void SetLabelTextColour(double initColor[3])\n\nget/set the distance annotation text colour\n"},
  {"ApplyTransform", PyvtkMRMLAnnotationAngleNode_ApplyTransform, METH_VARARGS,
   "V.ApplyTransform(vtkAbstractTransform)\nC++: void ApplyTransform(vtkAbstractTransform *transform)\n    override;\n\ntransform utility functions\n"},
  {"CreateDefaultStorageNode", PyvtkMRMLAnnotationAngleNode_CreateDefaultStorageNode, METH_VARARGS,
   "V.CreateDefaultStorageNode() -> vtkMRMLStorageNode\nC++: vtkMRMLStorageNode *CreateDefaultStorageNode() override;\n\nCreate default storage node or nullptr if does not have one\n"},
  {"GetModelID1", PyvtkMRMLAnnotationAngleNode_GetModelID1, METH_VARARGS,
   "V.GetModelID1() -> string\nC++: virtual char *GetModelID1()\n\nget/set the id of the model the ends of the widget are\nconstrained upon\n"},
  {"SetModelID1", PyvtkMRMLAnnotationAngleNode_SetModelID1, METH_VARARGS,
   "V.SetModelID1(string)\nC++: virtual void SetModelID1(const char *_arg)\n\nget/set the id of the model the ends of the widget are\nconstrained upon\n"},
  {"GetModelID2", PyvtkMRMLAnnotationAngleNode_GetModelID2, METH_VARARGS,
   "V.GetModelID2() -> string\nC++: virtual char *GetModelID2()\n\nget/set the id of the model the ends of the widget are\nconstrained upon\n"},
  {"SetModelID2", PyvtkMRMLAnnotationAngleNode_SetModelID2, METH_VARARGS,
   "V.SetModelID2(string)\nC++: virtual void SetModelID2(const char *_arg)\n\nget/set the id of the model the ends of the widget are\nconstrained upon\n"},
  {"GetModelIDCenter", PyvtkMRMLAnnotationAngleNode_GetModelIDCenter, METH_VARARGS,
   "V.GetModelIDCenter() -> string\nC++: virtual char *GetModelIDCenter()\n\nget/set the id of the model the ends of the widget are\nconstrained upon\n"},
  {"SetModelIDCenter", PyvtkMRMLAnnotationAngleNode_SetModelIDCenter, METH_VARARGS,
   "V.SetModelIDCenter(string)\nC++: virtual void SetModelIDCenter(const char *_arg)\n\nget/set the id of the model the ends of the widget are\nconstrained upon\n"},
  {"SetAngleMeasurement", PyvtkMRMLAnnotationAngleNode_SetAngleMeasurement, METH_VARARGS,
   "V.SetAngleMeasurement(float)\nC++: void SetAngleMeasurement(double val)\n\n"},
  {"GetAngleMeasurement", PyvtkMRMLAnnotationAngleNode_GetAngleMeasurement, METH_VARARGS,
   "V.GetAngleMeasurement() -> float\nC++: double GetAngleMeasurement()\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLAnnotationAngleNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerAnnotationsModuleMRML.vtkMRMLAnnotationAngleNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLAnnotationAngleNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLAnnotationAngleNode_StaticNew()
{
  return vtkMRMLAnnotationAngleNode::New();
}

PyObject *PyvtkMRMLAnnotationAngleNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLAnnotationAngleNode_Type, PyvtkMRMLAnnotationAngleNode_Methods,
    "vtkMRMLAnnotationAngleNode",
 &PyvtkMRMLAnnotationAngleNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMRMLAnnotationLinesNode_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 2; c++)
  {
    static const struct { const char *name; int value; }
      constants[2] = {
        { "AngleNodeAddedEvent", vtkMRMLAnnotationAngleNode::AngleNodeAddedEvent },
        { "ValueModifiedEvent", vtkMRMLAnnotationAngleNode::ValueModifiedEvent },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLAnnotationAngleNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLAnnotationAngleNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLAnnotationAngleNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

