// python wrapper for vtkMRMLAnnotationDisplayableManagerHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMRMLAnnotationDisplayableManagerHelper.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLAnnotationDisplayableManagerHelper(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLAnnotationDisplayableManagerHelper_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char *PyvtkMRMLAnnotationDisplayableManagerHelper_Doc =
  "vtkMRMLAnnotationDisplayableManagerHelper - \\ingroup\nSlicer_QtModules_Annotation\n\n"
  "Superclass: vtkObject\n\n"
;


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLAnnotationDisplayableManagerHelper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLAnnotationDisplayableManagerHelper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLAnnotationDisplayableManagerHelper *tempr = vtkMRMLAnnotationDisplayableManagerHelper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLAnnotationDisplayableManagerHelper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLAnnotationDisplayableManagerHelper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLAnnotationDisplayableManagerHelper::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLAnnotationDisplayableManagerHelper::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateLockedAllWidgetsFromNodes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateLockedAllWidgetsFromNodes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateLockedAllWidgetsFromNodes();
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::UpdateLockedAllWidgetsFromNodes();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateLockedAllWidgetsFromInteractionNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateLockedAllWidgetsFromInteractionNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLInteractionNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLInteractionNode"))
  {
    if (ap.IsBound())
    {
      op->UpdateLockedAllWidgetsFromInteractionNode(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::UpdateLockedAllWidgetsFromInteractionNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateLockedAllWidgets(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateLockedAllWidgets");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->UpdateLockedAllWidgets(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::UpdateLockedAllWidgets(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    if (ap.IsBound())
    {
      op->UpdateLocked(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::UpdateLocked(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateVisible(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateVisible");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->UpdateVisible(temp0, temp1);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::UpdateVisible(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateWidget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateWidget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    if (ap.IsBound())
    {
      op->UpdateWidget(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::UpdateWidget(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_GetWidget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWidget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    vtkAbstractWidget *tempr = (ap.IsBound() ?
      op->GetWidget(temp0) :
      op->vtkMRMLAnnotationDisplayableManagerHelper::GetWidget(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_GetIntersectionWidget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIntersectionWidget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    vtkAbstractWidget *tempr = (ap.IsBound() ?
      op->GetIntersectionWidget(temp0) :
      op->vtkMRMLAnnotationDisplayableManagerHelper::GetIntersectionWidget(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_GetOverLineProjectionWidget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverLineProjectionWidget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    vtkAbstractWidget *tempr = (ap.IsBound() ?
      op->GetOverLineProjectionWidget(temp0) :
      op->vtkMRMLAnnotationDisplayableManagerHelper::GetOverLineProjectionWidget(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_GetUnderLineProjectionWidget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnderLineProjectionWidget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    vtkAbstractWidget *tempr = (ap.IsBound() ?
      op->GetUnderLineProjectionWidget(temp0) :
      op->vtkMRMLAnnotationDisplayableManagerHelper::GetUnderLineProjectionWidget(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_GetPointProjectionWidget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPointProjectionWidget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    vtkAbstractWidget *tempr = (ap.IsBound() ?
      op->GetPointProjectionWidget(temp0) :
      op->vtkMRMLAnnotationDisplayableManagerHelper::GetPointProjectionWidget(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_RemoveAllWidgetsAndNodes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllWidgetsAndNodes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllWidgetsAndNodes();
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::RemoveAllWidgetsAndNodes();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_RemoveWidgetAndNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveWidgetAndNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    if (ap.IsBound())
    {
      op->RemoveWidgetAndNode(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::RemoveWidgetAndNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_GetAnnotationNodeFromDisplayNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationNodeFromDisplayNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  vtkMRMLAnnotationDisplayNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationDisplayNode"))
  {
    vtkMRMLAnnotationNode *tempr = (ap.IsBound() ?
      op->GetAnnotationNodeFromDisplayNode(temp0) :
      op->vtkMRMLAnnotationDisplayableManagerHelper::GetAnnotationNodeFromDisplayNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_PlaceSeed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PlaceSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  double temp0;
  double temp1;
  vtkRenderWindowInteractor *temp2 = nullptr;
  vtkRenderer *temp3 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkRenderWindowInteractor") &&
      ap.GetVTKObject(temp3, "vtkRenderer"))
  {
    if (ap.IsBound())
    {
      op->PlaceSeed(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::PlaceSeed(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_GetSeed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkHandleWidget *tempr = (ap.IsBound() ?
      op->GetSeed(temp0) :
      op->vtkMRMLAnnotationDisplayableManagerHelper::GetSeed(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManagerHelper_RemoveSeeds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveSeeds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManagerHelper *op = static_cast<vtkMRMLAnnotationDisplayableManagerHelper *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveSeeds();
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManagerHelper::RemoveSeeds();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLAnnotationDisplayableManagerHelper_Methods[] = {
  {"IsTypeOf", PyvtkMRMLAnnotationDisplayableManagerHelper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLAnnotationDisplayableManagerHelper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLAnnotationDisplayableManagerHelper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkMRMLAnnotationDisplayableManagerHelper\nC++: static vtkMRMLAnnotationDisplayableManagerHelper *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLAnnotationDisplayableManagerHelper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLAnnotationDisplayableManagerHelper\nC++: vtkMRMLAnnotationDisplayableManagerHelper *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLAnnotationDisplayableManagerHelper_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLAnnotationDisplayableManagerHelper_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"UpdateLockedAllWidgetsFromNodes", PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateLockedAllWidgetsFromNodes, METH_VARARGS,
   "V.UpdateLockedAllWidgetsFromNodes()\nC++: void UpdateLockedAllWidgetsFromNodes()\n\nLock/Unlock all widgets based on the state of the nodes\n"},
  {"UpdateLockedAllWidgetsFromInteractionNode", PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateLockedAllWidgetsFromInteractionNode, METH_VARARGS,
   "V.UpdateLockedAllWidgetsFromInteractionNode(\n    vtkMRMLInteractionNode)\nC++: void UpdateLockedAllWidgetsFromInteractionNode(\n    vtkMRMLInteractionNode *interactionNode)\n\nLock/Unlock all widgets from interaction node\n"},
  {"UpdateLockedAllWidgets", PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateLockedAllWidgets, METH_VARARGS,
   "V.UpdateLockedAllWidgets(bool)\nC++: void UpdateLockedAllWidgets(bool locked)\n\nLock/Unlock all widgets\n"},
  {"UpdateLocked", PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateLocked, METH_VARARGS,
   "V.UpdateLocked(vtkMRMLAnnotationNode)\nC++: void UpdateLocked(vtkMRMLAnnotationNode *node)\n\nLock/Unlock a widget\n"},
  {"UpdateVisible", PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateVisible, METH_VARARGS,
   "V.UpdateVisible(vtkMRMLAnnotationNode, bool)\nC++: void UpdateVisible(vtkMRMLAnnotationNode *node,\n    bool displayableInViewer=true)\n\nHide/Show a widget according to node's visible flag and if it can\nbe displayed in this viewer\n"},
  {"UpdateWidget", PyvtkMRMLAnnotationDisplayableManagerHelper_UpdateWidget, METH_VARARGS,
   "V.UpdateWidget(vtkMRMLAnnotationNode)\nC++: void UpdateWidget(vtkMRMLAnnotationNode *node)\n\nUpdate lock and visibility of a widget\n"},
  {"GetWidget", PyvtkMRMLAnnotationDisplayableManagerHelper_GetWidget, METH_VARARGS,
   "V.GetWidget(vtkMRMLAnnotationNode) -> vtkAbstractWidget\nC++: vtkAbstractWidget *GetWidget(vtkMRMLAnnotationNode *node)\n\nGet a vtkAbstractWidget* given a node\n"},
  {"GetIntersectionWidget", PyvtkMRMLAnnotationDisplayableManagerHelper_GetIntersectionWidget, METH_VARARGS,
   "V.GetIntersectionWidget(vtkMRMLAnnotationNode)\n    -> vtkAbstractWidget\nC++: vtkAbstractWidget *GetIntersectionWidget(\n    vtkMRMLAnnotationNode *node)\n\n...an its associated vtkAbstractWidget* for Slice intersection\nrepresentation\n"},
  {"GetOverLineProjectionWidget", PyvtkMRMLAnnotationDisplayableManagerHelper_GetOverLineProjectionWidget, METH_VARARGS,
   "V.GetOverLineProjectionWidget(vtkMRMLAnnotationNode)\n    -> vtkAbstractWidget\nC++: vtkAbstractWidget *GetOverLineProjectionWidget(\n    vtkMRMLAnnotationNode *node)\n\n...an its associated vtkAbstractWidget* for Slice projection\nrepresentation\n"},
  {"GetUnderLineProjectionWidget", PyvtkMRMLAnnotationDisplayableManagerHelper_GetUnderLineProjectionWidget, METH_VARARGS,
   "V.GetUnderLineProjectionWidget(vtkMRMLAnnotationNode)\n    -> vtkAbstractWidget\nC++: vtkAbstractWidget *GetUnderLineProjectionWidget(\n    vtkMRMLAnnotationNode *node)\n\n...an its associated vtkAbstractWidget* for Slice projection\nrepresentation\n"},
  {"GetPointProjectionWidget", PyvtkMRMLAnnotationDisplayableManagerHelper_GetPointProjectionWidget, METH_VARARGS,
   "V.GetPointProjectionWidget(vtkMRMLAnnotationNode)\n    -> vtkAbstractWidget\nC++: vtkAbstractWidget *GetPointProjectionWidget(\n    vtkMRMLAnnotationNode *node)\n\n...an its associated vtkAbstractWidget* for Slice projection\nrepresentation\n"},
  {"RemoveAllWidgetsAndNodes", PyvtkMRMLAnnotationDisplayableManagerHelper_RemoveAllWidgetsAndNodes, METH_VARARGS,
   "V.RemoveAllWidgetsAndNodes()\nC++: void RemoveAllWidgetsAndNodes()\n\nRemove all widgets, intersection widgets, nodes\n"},
  {"RemoveWidgetAndNode", PyvtkMRMLAnnotationDisplayableManagerHelper_RemoveWidgetAndNode, METH_VARARGS,
   "V.RemoveWidgetAndNode(vtkMRMLAnnotationNode)\nC++: void RemoveWidgetAndNode(vtkMRMLAnnotationNode *node)\n\nRemove a node, its widget and its intersection widget\n"},
  {"GetAnnotationNodeFromDisplayNode", PyvtkMRMLAnnotationDisplayableManagerHelper_GetAnnotationNodeFromDisplayNode, METH_VARARGS,
   "V.GetAnnotationNodeFromDisplayNode(vtkMRMLAnnotationDisplayNode)\n    -> vtkMRMLAnnotationNode\nC++: vtkMRMLAnnotationNode *GetAnnotationNodeFromDisplayNode(\n    vtkMRMLAnnotationDisplayNode *displayNode)\n\nSearch the annotation node list and return the annotation node\nthat has this display node\n"},
  {"PlaceSeed", PyvtkMRMLAnnotationDisplayableManagerHelper_PlaceSeed, METH_VARARGS,
   "V.PlaceSeed(float, float, vtkRenderWindowInteractor, vtkRenderer)\nC++: void PlaceSeed(double x, double y,\n    vtkRenderWindowInteractor *interactor, vtkRenderer *renderer)\n\nPlacement of seeds for widget placement\n"},
  {"GetSeed", PyvtkMRMLAnnotationDisplayableManagerHelper_GetSeed, METH_VARARGS,
   "V.GetSeed(int) -> vtkHandleWidget\nC++: vtkHandleWidget *GetSeed(int index)\n\nGet a placed seed\n"},
  {"RemoveSeeds", PyvtkMRMLAnnotationDisplayableManagerHelper_RemoveSeeds, METH_VARARGS,
   "V.RemoveSeeds()\nC++: void RemoveSeeds()\n\nRemove all placed seeds\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLAnnotationDisplayableManagerHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerAnnotationsModuleMRMLDisplayableManager.vtkMRMLAnnotationDisplayableManagerHelper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLAnnotationDisplayableManagerHelper_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLAnnotationDisplayableManagerHelper_StaticNew()
{
  return vtkMRMLAnnotationDisplayableManagerHelper::New();
}

PyObject *PyvtkMRMLAnnotationDisplayableManagerHelper_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLAnnotationDisplayableManagerHelper_Type, PyvtkMRMLAnnotationDisplayableManagerHelper_Methods,
    "vtkMRMLAnnotationDisplayableManagerHelper",
 &PyvtkMRMLAnnotationDisplayableManagerHelper_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLAnnotationDisplayableManagerHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLAnnotationDisplayableManagerHelper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLAnnotationDisplayableManagerHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

