// python wrapper for vtkMRMLAnnotationDisplayableManager
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMRMLAnnotationDisplayableManager.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLAnnotationDisplayableManager(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLAnnotationDisplayableManager_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLAbstractDisplayableManager_ClassNew
extern "C" { PyObject *PyvtkMRMLAbstractDisplayableManager_ClassNew(); }
#define DECLARED_PyvtkMRMLAbstractDisplayableManager_ClassNew
#endif

static const char *PyvtkMRMLAnnotationDisplayableManager_Doc =
  "vtkMRMLAnnotationDisplayableManager - \\ingroup\nSlicer_QtModules_Annotation\n\n"
  "Superclass: vtkMRMLAbstractDisplayableManager\n\n"
;


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLAnnotationDisplayableManager::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLAnnotationDisplayableManager::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLAnnotationDisplayableManager *tempr = vtkMRMLAnnotationDisplayableManager::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLAnnotationDisplayableManager *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLAnnotationDisplayableManager::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLAnnotationDisplayableManager::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLAnnotationDisplayableManager::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_PropagateMRMLToWidget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PropagateMRMLToWidget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  vtkAbstractWidget *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode") &&
      ap.GetVTKObject(temp1, "vtkAbstractWidget"))
  {
    if (ap.IsBound())
    {
      op->PropagateMRMLToWidget(temp0, temp1);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManager::PropagateMRMLToWidget(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_PropagateWidgetToMRML(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PropagateWidgetToMRML");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  vtkAbstractWidget *temp0 = nullptr;
  vtkMRMLAnnotationNode *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkAbstractWidget") &&
      ap.GetVTKObject(temp1, "vtkMRMLAnnotationNode"))
  {
    if (ap.IsBound())
    {
      op->PropagateWidgetToMRML(temp0, temp1);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManager::PropagateWidgetToMRML(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_Is2DDisplayableManager(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Is2DDisplayableManager");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->Is2DDisplayableManager() :
      op->vtkMRMLAnnotationDisplayableManager::Is2DDisplayableManager());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetSliceNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLSliceNode *tempr = (ap.IsBound() ?
      op->GetSliceNode() :
      op->vtkMRMLAnnotationDisplayableManager::GetSliceNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_RestrictDisplayCoordinatesToViewport(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RestrictDisplayCoordinatesToViewport");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->RestrictDisplayCoordinatesToViewport(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManager::RestrictDisplayCoordinatesToViewport(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetDisplayCoordinatesChanged(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplayCoordinatesChanged");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp0, save0, size0);
    vtkPythonArgs::Save(temp1, save1, size1);

    bool tempr = (ap.IsBound() ?
      op->GetDisplayCoordinatesChanged(temp0, temp1) :
      op->vtkMRMLAnnotationDisplayableManager::GetDisplayCoordinatesChanged(temp0, temp1));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetWorldCoordinatesChanged(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWorldCoordinatesChanged");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp0, save0, size0);
    vtkPythonArgs::Save(temp1, save1, size1);

    bool tempr = (ap.IsBound() ?
      op->GetWorldCoordinatesChanged(temp0, temp1) :
      op->vtkMRMLAnnotationDisplayableManager::GetWorldCoordinatesChanged(temp0, temp1));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetDisplayToWorldCoordinates_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplayToWorldCoordinates");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  double temp0;
  double temp1;
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<double> store2(2*size2);
  double *temp2 = store2.Data();
  double *save2 = (size2 == 0 ? nullptr : temp2 + size2);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    vtkPythonArgs::Save(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->GetDisplayToWorldCoordinates(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManager::GetDisplayToWorldCoordinates(temp0, temp1, temp2);
    }

    if (vtkPythonArgs::HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetDisplayToWorldCoordinates_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplayToWorldCoordinates");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp0, save0, size0);
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetDisplayToWorldCoordinates(temp0, temp1);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManager::GetDisplayToWorldCoordinates(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetDisplayToWorldCoordinates(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkMRMLAnnotationDisplayableManager_GetDisplayToWorldCoordinates_s1(self, args);
    case 2:
      return PyvtkMRMLAnnotationDisplayableManager_GetDisplayToWorldCoordinates_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetDisplayToWorldCoordinates");
  return nullptr;
}



static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetWorldToLocalCoordinates(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWorldToLocalCoordinates");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(2*size1);
  double *temp1 = store1.Data();
  double *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<double> store2(2*size2);
  double *temp2 = store2.Data();
  double *save2 = (size2 == 0 ? nullptr : temp2 + size2);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode") &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2))
  {
    vtkPythonArgs::Save(temp1, save1, size1);
    vtkPythonArgs::Save(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->GetWorldToLocalCoordinates(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManager::GetWorldToLocalCoordinates(temp0, temp1, temp2);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (vtkPythonArgs::HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_SetParentTransformToWidget(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParentTransformToWidget");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  vtkAbstractWidget *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode") &&
      ap.GetVTKObject(temp1, "vtkAbstractWidget"))
  {
    if (ap.IsBound())
    {
      op->SetParentTransformToWidget(temp0, temp1);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManager::SetParentTransformToWidget(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_SetScaleFactor2D(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScaleFactor2D");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScaleFactor2D(temp0);
    }
    else
    {
      op->vtkMRMLAnnotationDisplayableManager::SetScaleFactor2D(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetScaleFactor2D(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScaleFactor2D");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetScaleFactor2D() :
      op->vtkMRMLAnnotationDisplayableManager::GetScaleFactor2D());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_IsInLightboxMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsInLightboxMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsInLightboxMode() :
      op->vtkMRMLAnnotationDisplayableManager::IsInLightboxMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_GetLightboxIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLightboxIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  int temp1 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    int tempr = (ap.IsBound() ?
      op->GetLightboxIndex(temp0, temp1) :
      op->vtkMRMLAnnotationDisplayableManager::GetLightboxIndex(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_AddAnnotation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddAnnotation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  vtkMRMLAnnotationNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLAnnotationNode"))
  {
    bool tempr = (ap.IsBound() ?
      op->AddAnnotation(temp0) :
      op->vtkMRMLAnnotationDisplayableManager::AddAnnotation(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_CanProcessInteractionEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CanProcessInteractionEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  vtkMRMLInteractionEventData *temp0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLInteractionEventData") &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->CanProcessInteractionEvent(temp0, temp1) :
      op->vtkMRMLAnnotationDisplayableManager::CanProcessInteractionEvent(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(1, temp1);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLAnnotationDisplayableManager_ProcessInteractionEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProcessInteractionEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLAnnotationDisplayableManager *op = static_cast<vtkMRMLAnnotationDisplayableManager *>(vp);

  vtkMRMLInteractionEventData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLInteractionEventData"))
  {
    bool tempr = (ap.IsBound() ?
      op->ProcessInteractionEvent(temp0) :
      op->vtkMRMLAnnotationDisplayableManager::ProcessInteractionEvent(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLAnnotationDisplayableManager_Methods[] = {
  {"IsTypeOf", PyvtkMRMLAnnotationDisplayableManager_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLAnnotationDisplayableManager_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLAnnotationDisplayableManager_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkMRMLAnnotationDisplayableManager\nC++: static vtkMRMLAnnotationDisplayableManager *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLAnnotationDisplayableManager_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLAnnotationDisplayableManager\nC++: vtkMRMLAnnotationDisplayableManager *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLAnnotationDisplayableManager_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLAnnotationDisplayableManager_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"PropagateMRMLToWidget", PyvtkMRMLAnnotationDisplayableManager_PropagateMRMLToWidget, METH_VARARGS,
   "V.PropagateMRMLToWidget(vtkMRMLAnnotationNode, vtkAbstractWidget)\nC++: virtual void PropagateMRMLToWidget(\n    vtkMRMLAnnotationNode *node, vtkAbstractWidget *widget)\n\nPropagate properties of MRML node to widget.\n"},
  {"PropagateWidgetToMRML", PyvtkMRMLAnnotationDisplayableManager_PropagateWidgetToMRML, METH_VARARGS,
   "V.PropagateWidgetToMRML(vtkAbstractWidget, vtkMRMLAnnotationNode)\nC++: virtual void PropagateWidgetToMRML(vtkAbstractWidget *widget,\n     vtkMRMLAnnotationNode *node)\n\nPropagate properties of widget to MRML node.\n"},
  {"Is2DDisplayableManager", PyvtkMRMLAnnotationDisplayableManager_Is2DDisplayableManager, METH_VARARGS,
   "V.Is2DDisplayableManager() -> bool\nC++: virtual bool Is2DDisplayableManager()\n\nCheck if this is a 2d SliceView displayable manager, returns true\nif so, false otherwise. Checks return from GetSliceNode for non\nnull, which means it's a 2d displayable manager\n"},
  {"GetSliceNode", PyvtkMRMLAnnotationDisplayableManager_GetSliceNode, METH_VARARGS,
   "V.GetSliceNode() -> vtkMRMLSliceNode\nC++: vtkMRMLSliceNode *GetSliceNode()\n\nGet the sliceNode, if registered. This would mean it is a 2D\nSliceView displayableManager.\n"},
  {"RestrictDisplayCoordinatesToViewport", PyvtkMRMLAnnotationDisplayableManager_RestrictDisplayCoordinatesToViewport, METH_VARARGS,
   "V.RestrictDisplayCoordinatesToViewport([float, ...])\nC++: void RestrictDisplayCoordinatesToViewport(\n    double *displayCoordinates)\n\nCheck if the displayCoordinates are inside the viewport and if\nnot, correct the displayCoordinates\n"},
  {"GetDisplayCoordinatesChanged", PyvtkMRMLAnnotationDisplayableManager_GetDisplayCoordinatesChanged, METH_VARARGS,
   "V.GetDisplayCoordinatesChanged([float, ...], [float, ...]) -> bool\nC++: bool GetDisplayCoordinatesChanged(\n    double *displayCoordinates1, double *displayCoordinates2)\n\nCheck if there are real changes between two sets of\ndisplayCoordinates\n"},
  {"GetWorldCoordinatesChanged", PyvtkMRMLAnnotationDisplayableManager_GetWorldCoordinatesChanged, METH_VARARGS,
   "V.GetWorldCoordinatesChanged([float, ...], [float, ...]) -> bool\nC++: bool GetWorldCoordinatesChanged(double *worldCoordinates1,\n    double *worldCoordinates2)\n\nCheck if there are real changes between two sets of\nworldCoordinates\n"},
  {"GetDisplayToWorldCoordinates", PyvtkMRMLAnnotationDisplayableManager_GetDisplayToWorldCoordinates, METH_VARARGS,
   "V.GetDisplayToWorldCoordinates(float, float, [float, ...])\nC++: void GetDisplayToWorldCoordinates(double x, double y,\n    double *worldCoordinates)\nV.GetDisplayToWorldCoordinates([float, ...], [float, ...])\nC++: void GetDisplayToWorldCoordinates(double *displayCoordinates,\n     double *worldCoordinates)\n\nConvert display to world coordinates\n"},
  {"GetWorldToLocalCoordinates", PyvtkMRMLAnnotationDisplayableManager_GetWorldToLocalCoordinates, METH_VARARGS,
   "V.GetWorldToLocalCoordinates(vtkMRMLAnnotationNode, [float, ...],\n    [float, ...])\nC++: virtual void GetWorldToLocalCoordinates(\n    vtkMRMLAnnotationNode *node, double *worldCoordinates,\n    double *localCoordinates)\n\nConvert world coordinates to local using mrml parent transform\n"},
  {"SetParentTransformToWidget", PyvtkMRMLAnnotationDisplayableManager_SetParentTransformToWidget, METH_VARARGS,
   "V.SetParentTransformToWidget(vtkMRMLAnnotationNode,\n    vtkAbstractWidget)\nC++: virtual void SetParentTransformToWidget(\n    vtkMRMLAnnotationNode *node, vtkAbstractWidget *widget)\n\nSet mrml parent transform to widgets\n"},
  {"SetScaleFactor2D", PyvtkMRMLAnnotationDisplayableManager_SetScaleFactor2D, METH_VARARGS,
   "V.SetScaleFactor2D(float)\nC++: virtual void SetScaleFactor2D(double _arg)\n\nSet/Get the 2d scale factor to divide 3D scale by to show 2D\nelements appropriately (usually set to 300)\n"},
  {"GetScaleFactor2D", PyvtkMRMLAnnotationDisplayableManager_GetScaleFactor2D, METH_VARARGS,
   "V.GetScaleFactor2D() -> float\nC++: virtual double GetScaleFactor2D()\n\n"},
  {"IsInLightboxMode", PyvtkMRMLAnnotationDisplayableManager_IsInLightboxMode, METH_VARARGS,
   "V.IsInLightboxMode() -> bool\nC++: bool IsInLightboxMode()\n\nReturn true if in lightbox mode - there is a slice node that has\nlayout grid columns or rows > 1\n"},
  {"GetLightboxIndex", PyvtkMRMLAnnotationDisplayableManager_GetLightboxIndex, METH_VARARGS,
   "V.GetLightboxIndex(vtkMRMLAnnotationNode, int) -> int\nC++: int GetLightboxIndex(vtkMRMLAnnotationNode *node,\n    int controlPointIndex=0)\n\nGets the world coordinate of the annotation node, transforms it\nto display coordinates. Defaults to returning the 0th control\npoint's light box index. Returns\n-1 if not in lightbox mode.\n"},
  {"AddAnnotation", PyvtkMRMLAnnotationDisplayableManager_AddAnnotation, METH_VARARGS,
   "V.AddAnnotation(vtkMRMLAnnotationNode) -> bool\nC++: bool AddAnnotation(vtkMRMLAnnotationNode *node)\n\nSet up data structures for an annotation node.  Returns false on\nfailure or if it's already set up. Can be called to reinitialise a\nnode's widgets after calling RemoveWidgetAndNode on the Helper\n\\sa vtkMRMLAnnotationDisplayableManagerHelper::RemoveWidgetAndNode\n    ()\n"},
  {"CanProcessInteractionEvent", PyvtkMRMLAnnotationDisplayableManager_CanProcessInteractionEvent, METH_VARARGS,
   "V.CanProcessInteractionEvent(vtkMRMLInteractionEventData, float)\n    -> bool\nC++: bool CanProcessInteractionEvent(\n    vtkMRMLInteractionEventData *eventData,\n    double &closestDistance2) override;\n\nReturn true if the displayable manager can process the event.\nDistance2 is the squared distance in display coordinates from the\nclosest interaction position. The displayable manager with the\nclosest distance will get the chance to process the interaction\nevent.\n"},
  {"ProcessInteractionEvent", PyvtkMRMLAnnotationDisplayableManager_ProcessInteractionEvent, METH_VARARGS,
   "V.ProcessInteractionEvent(vtkMRMLInteractionEventData) -> bool\nC++: bool ProcessInteractionEvent(\n    vtkMRMLInteractionEventData *eventData) override;\n\nProcess an interaction event. Returns true if the event should be\naborted (not processed any further by other event observers).\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLAnnotationDisplayableManager_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerAnnotationsModuleMRMLDisplayableManager.vtkMRMLAnnotationDisplayableManager", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLAnnotationDisplayableManager_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLAnnotationDisplayableManager_StaticNew()
{
  return vtkMRMLAnnotationDisplayableManager::New();
}

PyObject *PyvtkMRMLAnnotationDisplayableManager_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLAnnotationDisplayableManager_Type, PyvtkMRMLAnnotationDisplayableManager_Methods,
    "vtkMRMLAnnotationDisplayableManager",
 &PyvtkMRMLAnnotationDisplayableManager_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkMRMLAbstractDisplayableManager");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLAnnotationDisplayableManager(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLAnnotationDisplayableManager_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLAnnotationDisplayableManager", o) != 0)
  {
    Py_DECREF(o);
  }

}

