/*=========================================================================

  Program:   Visualization Toolkit
  Module:    vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory.h

  Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen
  All rights reserved.
  See Copyright.txt or http://www.kitware.com/Copyright.htm for details.

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory_h
#define __vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory_h

#include "vtkSlicerAnnotationsModuleMRMLDisplayableManagerModule.h" // For export macro
#include "vtkObjectFactory.h"

class VTK_SLICER_ANNOTATIONS_MODULE_MRMLDISPLAYABLEMANAGER_EXPORT vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory : public vtkObjectFactory
{
public:
  static vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory * New();
  vtkTypeMacro(vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory, vtkObjectFactory)

  const char * GetDescription() override { return "vtkSlicerAnnotationsModuleMRMLDisplayableManager factory overrides."; }

  const char * GetVTKSourceVersion() override;

  void PrintSelf(ostream &os, vtkIndent indent) override;

protected:
  vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory();

private:
  vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory(const vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory&) = delete;
  void operator=(const vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory&) = delete;
};

#endif // __vtkSlicerAnnotationsModuleMRMLDisplayableManagerObjectFactory_h
