// python wrapper for vtkAnnotationRulerRepresentation3D
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkAnnotationRulerRepresentation3D.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAnnotationRulerRepresentation3D(PyObject *dict); }
extern "C" { PyObject *PyvtkAnnotationRulerRepresentation3D_ClassNew(); }

#ifndef DECLARED_PyvtkDistanceRepresentation3D_ClassNew
extern "C" { PyObject *PyvtkDistanceRepresentation3D_ClassNew(); }
#define DECLARED_PyvtkDistanceRepresentation3D_ClassNew
#endif

static const char *PyvtkAnnotationRulerRepresentation3D_Doc =
  "vtkAnnotationRulerRepresentation3D - \\ingroup\nSlicer_QtModules_Annotation\n\n"
  "Superclass: vtkDistanceRepresentation3D\n\n"
;


static PyObject *
PyvtkAnnotationRulerRepresentation3D_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkAnnotationRulerRepresentation3D::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAnnotationRulerRepresentation3D::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkAnnotationRulerRepresentation3D *tempr = vtkAnnotationRulerRepresentation3D::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkAnnotationRulerRepresentation3D *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAnnotationRulerRepresentation3D::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkAnnotationRulerRepresentation3D::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkAnnotationRulerRepresentation3D::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_SetDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDistance(temp0);
    }
    else
    {
      op->vtkAnnotationRulerRepresentation3D::SetDistance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_GetLineProperty(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLineProperty");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkProperty *tempr = (ap.IsBound() ?
      op->GetLineProperty() :
      op->vtkAnnotationRulerRepresentation3D::GetLineProperty());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_SetLabelPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLabelPosition(temp0);
    }
    else
    {
      op->vtkAnnotationRulerRepresentation3D::SetLabelPosition(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_SetMaxTicks(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaxTicks");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaxTicks(temp0);
    }
    else
    {
      op->vtkAnnotationRulerRepresentation3D::SetMaxTicks(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_GetMaxTicks(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaxTicks");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaxTicks() :
      op->vtkAnnotationRulerRepresentation3D::GetMaxTicks());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_UpdateGlyphPolyData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateGlyphPolyData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  vtkPolyData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPolyData"))
  {
    if (ap.IsBound())
    {
      op->UpdateGlyphPolyData(temp0);
    }
    else
    {
      op->vtkAnnotationRulerRepresentation3D::UpdateGlyphPolyData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationRulerRepresentation3D_HasTranslucentPolygonalGeometry(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasTranslucentPolygonalGeometry");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationRulerRepresentation3D *op = static_cast<vtkAnnotationRulerRepresentation3D *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->HasTranslucentPolygonalGeometry() :
      op->vtkAnnotationRulerRepresentation3D::HasTranslucentPolygonalGeometry());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkAnnotationRulerRepresentation3D_Methods[] = {
  {"IsTypeOf", PyvtkAnnotationRulerRepresentation3D_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nStandard VTK methods.\n"},
  {"IsA", PyvtkAnnotationRulerRepresentation3D_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nStandard VTK methods.\n"},
  {"SafeDownCast", PyvtkAnnotationRulerRepresentation3D_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkAnnotationRulerRepresentation3D\nC++: static vtkAnnotationRulerRepresentation3D *SafeDownCast(\n    vtkObjectBase *o)\n\nStandard VTK methods.\n"},
  {"NewInstance", PyvtkAnnotationRulerRepresentation3D_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAnnotationRulerRepresentation3D\nC++: vtkAnnotationRulerRepresentation3D *NewInstance()\n\nStandard VTK methods.\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkAnnotationRulerRepresentation3D_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nStandard VTK methods.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkAnnotationRulerRepresentation3D_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nStandard VTK methods.\n"},
  {"SetDistance", PyvtkAnnotationRulerRepresentation3D_SetDistance, METH_VARARGS,
   "V.SetDistance(float)\nC++: void SetDistance(double distance)\n\n"},
  {"GetLineProperty", PyvtkAnnotationRulerRepresentation3D_GetLineProperty, METH_VARARGS,
   "V.GetLineProperty() -> vtkProperty\nC++: vtkProperty *GetLineProperty() override;\n\nGet the line actor property\n"},
  {"SetLabelPosition", PyvtkAnnotationRulerRepresentation3D_SetLabelPosition, METH_VARARGS,
   "V.SetLabelPosition(float)\nC++: void SetLabelPosition(double labelPosition)\n\nSet/Get position of the label title. 0 is at the start of the\nline whereas 1 is at the end. vtkSetMacro(LabelPosition, double);\n"},
  {"SetMaxTicks", PyvtkAnnotationRulerRepresentation3D_SetMaxTicks, METH_VARARGS,
   "V.SetMaxTicks(int)\nC++: virtual void SetMaxTicks(int _arg)\n\nSet/Get the maximum number of ticks in ruler mode\n"},
  {"GetMaxTicks", PyvtkAnnotationRulerRepresentation3D_GetMaxTicks, METH_VARARGS,
   "V.GetMaxTicks() -> int\nC++: virtual int GetMaxTicks()\n\nSet/Get the maximum number of ticks in ruler mode\n"},
  {"UpdateGlyphPolyData", PyvtkAnnotationRulerRepresentation3D_UpdateGlyphPolyData, METH_VARARGS,
   "V.UpdateGlyphPolyData(vtkPolyData)\nC++: void UpdateGlyphPolyData(vtkPolyData *polyData)\n\nChange the polydata displayed as tick markers\n"},
  {"HasTranslucentPolygonalGeometry", PyvtkAnnotationRulerRepresentation3D_HasTranslucentPolygonalGeometry, METH_VARARGS,
   "V.HasTranslucentPolygonalGeometry() -> int\nC++: int HasTranslucentPolygonalGeometry() override;\n\nWARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT\nUSE THESE METHODS OUTSIDE OF THE RENDERING PROCESS Does this prop\nhave some translucent polygonal geometry? This method is called\nduring the rendering process to know if there is some translucent\npolygonal geometry. A simple prop that has some translucent\npolygonal geometry will return true. A composite prop (like\nvtkAssembly) that has at least one sub-prop that has some\ntranslucent polygonal geometry will return true. Default\nimplementation return false.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkAnnotationRulerRepresentation3D_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerAnnotationsModuleVTKWidgets.vtkAnnotationRulerRepresentation3D", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkAnnotationRulerRepresentation3D_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAnnotationRulerRepresentation3D_StaticNew()
{
  return vtkAnnotationRulerRepresentation3D::New();
}

PyObject *PyvtkAnnotationRulerRepresentation3D_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkAnnotationRulerRepresentation3D_Type, PyvtkAnnotationRulerRepresentation3D_Methods,
    "vtkAnnotationRulerRepresentation3D",
 &PyvtkAnnotationRulerRepresentation3D_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkDistanceRepresentation3D");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkAnnotationRulerRepresentation3D(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAnnotationRulerRepresentation3D_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAnnotationRulerRepresentation3D", o) != 0)
  {
    Py_DECREF(o);
  }

}

