// python wrapper for vtkSlicerColorLogic
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSlicerColorLogic.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSlicerColorLogic(PyObject *dict); }
extern "C" { PyObject *PyvtkSlicerColorLogic_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLColorLogic_ClassNew
extern "C" { PyObject *PyvtkMRMLColorLogic_ClassNew(); }
#define DECLARED_PyvtkMRMLColorLogic_ClassNew
#endif

static const char *PyvtkSlicerColorLogic_Doc =
  "vtkSlicerColorLogic - no description provided.\n\n"
  "Superclass: vtkMRMLColorLogic\n\n"
;


static PyObject *
PyvtkSlicerColorLogic_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerColorLogic::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerColorLogic *op = static_cast<vtkSlicerColorLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSlicerColorLogic::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSlicerColorLogic *tempr = vtkSlicerColorLogic::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerColorLogic *op = static_cast<vtkSlicerColorLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkSlicerColorLogic *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSlicerColorLogic::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerColorLogic::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerColorLogic *op = static_cast<vtkSlicerColorLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkSlicerColorLogic::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_GetDefaultLabelMapColorNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultLabelMapColorNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerColorLogic *op = static_cast<vtkSlicerColorLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDefaultLabelMapColorNodeID() :
      op->vtkSlicerColorLogic::GetDefaultLabelMapColorNodeID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_GetDefaultEditorColorNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultEditorColorNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerColorLogic *op = static_cast<vtkSlicerColorLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDefaultEditorColorNodeID() :
      op->vtkSlicerColorLogic::GetDefaultEditorColorNodeID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_GetDefaultChartColorNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultChartColorNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerColorLogic *op = static_cast<vtkSlicerColorLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDefaultChartColorNodeID() :
      op->vtkSlicerColorLogic::GetDefaultChartColorNodeID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_FindDefaultColorFiles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FindDefaultColorFiles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerColorLogic *op = static_cast<vtkSlicerColorLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::vector<std::string> tempr = (ap.IsBound() ?
      op->FindDefaultColorFiles() :
      op->vtkSlicerColorLogic::FindDefaultColorFiles());

    if (!ap.ErrorOccurred())
    {
      if (tempr.size() == 0)
      {
        result = PyTuple_New(0);
      }
      else
      {
        result = ap.BuildTuple(tempr.data(), tempr.size());
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerColorLogic_FindUserColorFiles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FindUserColorFiles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerColorLogic *op = static_cast<vtkSlicerColorLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::vector<std::string> tempr = (ap.IsBound() ?
      op->FindUserColorFiles() :
      op->vtkSlicerColorLogic::FindUserColorFiles());

    if (!ap.ErrorOccurred())
    {
      if (tempr.size() == 0)
      {
        result = PyTuple_New(0);
      }
      else
      {
        result = ap.BuildTuple(tempr.data(), tempr.size());
      }
    }
  }

  return result;
}

static PyMethodDef PyvtkSlicerColorLogic_Methods[] = {
  {"IsTypeOf", PyvtkSlicerColorLogic_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkSlicerColorLogic_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkSlicerColorLogic_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSlicerColorLogic\nC++: static vtkSlicerColorLogic *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSlicerColorLogic_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSlicerColorLogic\nC++: vtkSlicerColorLogic *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkSlicerColorLogic_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkSlicerColorLogic_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetDefaultLabelMapColorNodeID", PyvtkSlicerColorLogic_GetDefaultLabelMapColorNodeID, METH_VARARGS,
   "V.GetDefaultLabelMapColorNodeID() -> string\nC++: const char *GetDefaultLabelMapColorNodeID() override;\n\nReturn a default color node id for a label map\n"},
  {"GetDefaultEditorColorNodeID", PyvtkSlicerColorLogic_GetDefaultEditorColorNodeID, METH_VARARGS,
   "V.GetDefaultEditorColorNodeID() -> string\nC++: const char *GetDefaultEditorColorNodeID() override;\n\nReturn a default color node id for the editor\n"},
  {"GetDefaultChartColorNodeID", PyvtkSlicerColorLogic_GetDefaultChartColorNodeID, METH_VARARGS,
   "V.GetDefaultChartColorNodeID() -> string\nC++: const char *GetDefaultChartColorNodeID() override;\n\nReturn a default color node id for the charts\n"},
  {"FindDefaultColorFiles", PyvtkSlicerColorLogic_FindDefaultColorFiles, METH_VARARGS,
   "V.FindDefaultColorFiles() -> Stvector_ISt6stringE\nC++: std::vector<std::string> FindDefaultColorFiles() override;\n\nlook for color files in the Base/Logic/Resources/ColorFiles\ndirectory and put their names in the ColorFiles list. Look in any\nuser defined color files paths and put them in the UserColorFiles\nlist.\n"},
  {"FindUserColorFiles", PyvtkSlicerColorLogic_FindUserColorFiles, METH_VARARGS,
   "V.FindUserColorFiles() -> Stvector_ISt6stringE\nC++: std::vector<std::string> FindUserColorFiles() override;\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkSlicerColorLogic_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerColorsModuleLogic.vtkSlicerColorLogic", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkSlicerColorLogic_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSlicerColorLogic_StaticNew()
{
  return vtkSlicerColorLogic::New();
}

PyObject *PyvtkSlicerColorLogic_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkSlicerColorLogic_Type, PyvtkSlicerColorLogic_Methods,
    "vtkSlicerColorLogic",
 &PyvtkSlicerColorLogic_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkMRMLColorLogic");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkSlicerColorLogic(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSlicerColorLogic_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSlicerColorLogic", o) != 0)
  {
    Py_DECREF(o);
  }

}

