// python wrapper for vtkSlicerMarkupsLogic
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkSlicerMarkupsLogic.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSlicerMarkupsLogic(PyObject *dict); }
extern "C" { PyObject *PyvtkSlicerMarkupsLogic_ClassNew(); }

#ifndef DECLARED_PyvtkSlicerModuleLogic_ClassNew
extern "C" { PyObject *PyvtkSlicerModuleLogic_ClassNew(); }
#define DECLARED_PyvtkSlicerModuleLogic_ClassNew
#endif

static const char *PyvtkSlicerMarkupsLogic_Doc =
  "vtkSlicerMarkupsLogic - slicer logic class for volumes manipulation\n\n"
  "Superclass: vtkSlicerModuleLogic\n\n"
  "This class manages the logic associated with reading, saving, and\n"
  "changing propertied of the volumes\n\n";


static PyObject *
PyvtkSlicerMarkupsLogic_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerMarkupsLogic::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSlicerMarkupsLogic::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSlicerMarkupsLogic *tempr = vtkSlicerMarkupsLogic::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkSlicerMarkupsLogic *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSlicerMarkupsLogic::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerMarkupsLogic::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkSlicerMarkupsLogic::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_ProcessMRMLNodesEvents(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProcessMRMLNodesEvents");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkObject *temp0 = nullptr;
  unsigned long temp1;
  void  *temp2 = nullptr;
  Py_buffer pbuf2 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkObject") &&
      ap.GetValue(temp1) &&
      ap.GetBuffer(temp2, &pbuf2))
  {
    if (ap.IsBound())
    {
      op->ProcessMRMLNodesEvents(temp0, temp1, temp2);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::ProcessMRMLNodesEvents(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf2.obj != 0)
  {
    PyBuffer_Release(&pbuf2);
  }
#endif
  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetSelectionNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSelectionNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetSelectionNodeID() :
      op->vtkSlicerMarkupsLogic::GetSelectionNodeID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetActiveListID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetActiveListID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetActiveListID() :
      op->vtkSlicerMarkupsLogic::GetActiveListID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_SetActiveListID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetActiveListID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsNode"))
  {
    if (ap.IsBound())
    {
      op->SetActiveListID(temp0);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::SetActiveListID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_AddNewDisplayNodeForMarkupsNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddNewDisplayNodeForMarkupsNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode"))
  {
    std::string tempr = (ap.IsBound() ?
      op->AddNewDisplayNodeForMarkupsNode(temp0) :
      op->vtkSlicerMarkupsLogic::AddNewDisplayNodeForMarkupsNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_AddNewFiducialNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddNewFiducialNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = "F";
  vtkMRMLScene *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 2) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp1, "vtkMRMLScene")))
  {
    std::string tempr = (ap.IsBound() ?
      op->AddNewFiducialNode(temp0, temp1) :
      op->vtkSlicerMarkupsLogic::AddNewFiducialNode(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_AddFiducial(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddFiducial");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  double temp0 = 0.0;
  double temp1 = 0.0;
  double temp2 = 0.0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    int tempr = (ap.IsBound() ?
      op->AddFiducial(temp0, temp1, temp2) :
      op->vtkSlicerMarkupsLogic::AddFiducial(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_JumpSlicesToLocation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "JumpSlicesToLocation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  double temp0;
  double temp1;
  double temp2;
  bool temp3 = false;
  int temp4 = -1;
  vtkMRMLSliceNode *temp5 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4, 6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp5, "vtkMRMLSliceNode")))
  {
    if (ap.IsBound())
    {
      op->JumpSlicesToLocation(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::JumpSlicesToLocation(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_JumpSlicesToNthPointInMarkup(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "JumpSlicesToNthPointInMarkup");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  bool temp2 = false;
  int temp3 = -1;
  vtkMRMLSliceNode *temp4 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp4, "vtkMRMLSliceNode")))
  {
    if (ap.IsBound())
    {
      op->JumpSlicesToNthPointInMarkup(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::JumpSlicesToNthPointInMarkup(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_FocusCamerasOnNthPointInMarkup(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FocusCamerasOnNthPointInMarkup");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->FocusCamerasOnNthPointInMarkup(temp0, temp1);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::FocusCamerasOnNthPointInMarkup(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_FocusCameraOnNthPointInMarkup(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FocusCameraOnNthPointInMarkup");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->FocusCameraOnNthPointInMarkup(temp0, temp1, temp2);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::FocusCameraOnNthPointInMarkup(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_LoadMarkups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadMarkups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    char *tempr = (ap.IsBound() ?
      op->LoadMarkups(temp0, temp1) :
      op->vtkSlicerMarkupsLogic::LoadMarkups(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_LoadMarkupsFiducials(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadMarkupsFiducials");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    char *tempr = (ap.IsBound() ?
      op->LoadMarkupsFiducials(temp0, temp1) :
      op->vtkSlicerMarkupsLogic::LoadMarkupsFiducials(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_LoadMarkupsFromFcsv(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadMarkupsFromFcsv");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    char *tempr = (ap.IsBound() ?
      op->LoadMarkupsFromFcsv(temp0, temp1) :
      op->vtkSlicerMarkupsLogic::LoadMarkupsFromFcsv(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_LoadMarkupsFromJson(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadMarkupsFromJson");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    char *tempr = (ap.IsBound() ?
      op->LoadMarkupsFromJson(temp0, temp1) :
      op->vtkSlicerMarkupsLogic::LoadMarkupsFromJson(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_SetAllMarkupsVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAllMarkupsVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsNode *temp0 = nullptr;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsNode") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAllMarkupsVisibility(temp0, temp1);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::SetAllMarkupsVisibility(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_ToggleAllMarkupsVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToggleAllMarkupsVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsNode"))
  {
    if (ap.IsBound())
    {
      op->ToggleAllMarkupsVisibility(temp0);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::ToggleAllMarkupsVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_SetAllMarkupsLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAllMarkupsLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsNode *temp0 = nullptr;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsNode") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAllMarkupsLocked(temp0, temp1);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::SetAllMarkupsLocked(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_ToggleAllMarkupsLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToggleAllMarkupsLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsNode"))
  {
    if (ap.IsBound())
    {
      op->ToggleAllMarkupsLocked(temp0);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::ToggleAllMarkupsLocked(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_SetAllMarkupsSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAllMarkupsSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsNode *temp0 = nullptr;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsNode") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAllMarkupsSelected(temp0, temp1);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::SetAllMarkupsSelected(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_ToggleAllMarkupsSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToggleAllMarkupsSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsNode"))
  {
    if (ap.IsBound())
    {
      op->ToggleAllMarkupsSelected(temp0);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::ToggleAllMarkupsSelected(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_SetDisplayNodeToDefaults(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplayNodeToDefaults");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsDisplayNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsDisplayNode"))
  {
    if (ap.IsBound())
    {
      op->SetDisplayNodeToDefaults(temp0);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::SetDisplayNodeToDefaults(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_SetDisplayDefaultsFromNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplayDefaultsFromNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsDisplayNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsDisplayNode"))
  {
    if (ap.IsBound())
    {
      op->SetDisplayDefaultsFromNode(temp0);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::SetDisplayDefaultsFromNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_CopyNthControlPointToNewList(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyNthControlPointToNewList");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  int temp0;
  vtkMRMLMarkupsNode *temp1 = nullptr;
  vtkMRMLMarkupsNode *temp2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMRMLMarkupsNode") &&
      ap.GetVTKObject(temp2, "vtkMRMLMarkupsNode"))
  {
    bool tempr = (ap.IsBound() ?
      op->CopyNthControlPointToNewList(temp0, temp1, temp2) :
      op->vtkSlicerMarkupsLogic::CopyNthControlPointToNewList(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_CopyNthMarkupToNewList(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyNthMarkupToNewList");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  int temp0;
  vtkMRMLMarkupsNode *temp1 = nullptr;
  vtkMRMLMarkupsNode *temp2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMRMLMarkupsNode") &&
      ap.GetVTKObject(temp2, "vtkMRMLMarkupsNode"))
  {
    bool tempr = (ap.IsBound() ?
      op->CopyNthMarkupToNewList(temp0, temp1, temp2) :
      op->vtkSlicerMarkupsLogic::CopyNthMarkupToNewList(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_MoveNthControlPointToNewListAtIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MoveNthControlPointToNewListAtIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  int temp0;
  vtkMRMLMarkupsNode *temp1 = nullptr;
  vtkMRMLMarkupsNode *temp2 = nullptr;
  int temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMRMLMarkupsNode") &&
      ap.GetVTKObject(temp2, "vtkMRMLMarkupsNode") &&
      ap.GetValue(temp3))
  {
    bool tempr = (ap.IsBound() ?
      op->MoveNthControlPointToNewListAtIndex(temp0, temp1, temp2, temp3) :
      op->vtkSlicerMarkupsLogic::MoveNthControlPointToNewListAtIndex(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_MoveNthMarkupToNewList(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MoveNthMarkupToNewList");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  int temp0;
  vtkMRMLMarkupsNode *temp1 = nullptr;
  vtkMRMLMarkupsNode *temp2 = nullptr;
  int temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMRMLMarkupsNode") &&
      ap.GetVTKObject(temp2, "vtkMRMLMarkupsNode") &&
      ap.GetValue(temp3))
  {
    bool tempr = (ap.IsBound() ?
      op->MoveNthMarkupToNewList(temp0, temp1, temp2, temp3) :
      op->vtkSlicerMarkupsLogic::MoveNthMarkupToNewList(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_ConvertAnnotationFiducialsToMarkups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ConvertAnnotationFiducialsToMarkups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ConvertAnnotationFiducialsToMarkups();
    }
    else
    {
      op->vtkSlicerMarkupsLogic::ConvertAnnotationFiducialsToMarkups();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_RenameAllMarkupsFromCurrentFormat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RenameAllMarkupsFromCurrentFormat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsNode"))
  {
    if (ap.IsBound())
    {
      op->RenameAllMarkupsFromCurrentFormat(temp0);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::RenameAllMarkupsFromCurrentFormat(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_StartPlaceMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartPlaceMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  bool temp0 = false;
  vtkMRMLInteractionNode *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp1, "vtkMRMLInteractionNode")))
  {
    bool tempr = (ap.IsBound() ?
      op->StartPlaceMode(temp0, temp1) :
      op->vtkSlicerMarkupsLogic::StartPlaceMode(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetSliceIntersectionsVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceIntersectionsVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSliceIntersectionsVisibility() :
      op->vtkSlicerMarkupsLogic::GetSliceIntersectionsVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_SetSliceIntersectionsVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSliceIntersectionsVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSliceIntersectionsVisibility(temp0);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::SetSliceIntersectionsVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_SetAutoCreateDisplayNodes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoCreateDisplayNodes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoCreateDisplayNodes(temp0);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::SetAutoCreateDisplayNodes(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetAutoCreateDisplayNodes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoCreateDisplayNodes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetAutoCreateDisplayNodes() :
      op->vtkSlicerMarkupsLogic::GetAutoCreateDisplayNodes());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_AutoCreateDisplayNodesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutoCreateDisplayNodesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutoCreateDisplayNodesOn();
    }
    else
    {
      op->vtkSlicerMarkupsLogic::AutoCreateDisplayNodesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_AutoCreateDisplayNodesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutoCreateDisplayNodesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutoCreateDisplayNodesOff();
    }
    else
    {
      op->vtkSlicerMarkupsLogic::AutoCreateDisplayNodesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetDefaultMarkupsDisplayNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultMarkupsDisplayNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLMarkupsDisplayNode *tempr = (ap.IsBound() ?
      op->GetDefaultMarkupsDisplayNode() :
      op->vtkSlicerMarkupsLogic::GetDefaultMarkupsDisplayNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_CopyBasicDisplayProperties(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyBasicDisplayProperties");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  vtkMRMLMarkupsDisplayNode *temp0 = nullptr;
  vtkMRMLMarkupsDisplayNode *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsDisplayNode") &&
      ap.GetVTKObject(temp1, "vtkMRMLMarkupsDisplayNode"))
  {
    if (ap.IsBound())
    {
      op->CopyBasicDisplayProperties(temp0, temp1);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::CopyBasicDisplayProperties(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetClosedCurveSurfaceArea(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetClosedCurveSurfaceArea");

  vtkMRMLMarkupsClosedCurveNode *temp0 = nullptr;
  vtkPolyData *temp1 = nullptr;
  bool temp2 = true;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1, 3) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsClosedCurveNode") &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp1, "vtkPolyData")) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    double tempr = vtkSlicerMarkupsLogic::GetClosedCurveSurfaceArea(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_FitSurfaceProjectWarp(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "FitSurfaceProjectWarp");

  vtkPoints *temp0 = nullptr;
  vtkPolyData *temp1 = nullptr;
  double temp2 = 1.0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2, 3) &&
      ap.GetVTKObject(temp0, "vtkPoints") &&
      ap.GetVTKObject(temp1, "vtkPolyData") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    bool tempr = vtkSlicerMarkupsLogic::FitSurfaceProjectWarp(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_FitSurfaceDiskWarp(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "FitSurfaceDiskWarp");

  vtkPoints *temp0 = nullptr;
  vtkPolyData *temp1 = nullptr;
  double temp2 = 1.0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2, 3) &&
      ap.GetVTKObject(temp0, "vtkPoints") &&
      ap.GetVTKObject(temp1, "vtkPolyData") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    bool tempr = vtkSlicerMarkupsLogic::FitSurfaceDiskWarp(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_IsPolygonClockwise(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsPolygonClockwise");

  vtkPoints *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPoints"))
  {
    bool tempr = vtkSlicerMarkupsLogic::IsPolygonClockwise(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetBestFitPlane(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetBestFitPlane");

  vtkMRMLMarkupsNode *temp0 = nullptr;
  vtkPlane *temp1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsNode") &&
      ap.GetVTKObject(temp1, "vtkPlane"))
  {
    bool tempr = vtkSlicerMarkupsLogic::GetBestFitPlane(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_GetJsonStorageNodeClassNameForMarkupsType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetJsonStorageNodeClassNameForMarkupsType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetJsonStorageNodeClassNameForMarkupsType(temp0) :
      op->vtkSlicerMarkupsLogic::GetJsonStorageNodeClassNameForMarkupsType(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_RegisterJsonStorageNodeForMarkupsType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RegisterJsonStorageNodeForMarkupsType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  std::string temp0;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->RegisterJsonStorageNodeForMarkupsType(temp0, temp1);
    }
    else
    {
      op->vtkSlicerMarkupsLogic::RegisterJsonStorageNodeForMarkupsType(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerMarkupsLogic_AddNewJsonStorageNodeForMarkupsType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddNewJsonStorageNodeForMarkupsType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerMarkupsLogic *op = static_cast<vtkSlicerMarkupsLogic *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLMarkupsJsonStorageNode *tempr = (ap.IsBound() ?
      op->AddNewJsonStorageNodeForMarkupsType(temp0) :
      op->vtkSlicerMarkupsLogic::AddNewJsonStorageNodeForMarkupsType(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSlicerMarkupsLogic_Methods[] = {
  {"IsTypeOf", PyvtkSlicerMarkupsLogic_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkSlicerMarkupsLogic_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkSlicerMarkupsLogic_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSlicerMarkupsLogic\nC++: static vtkSlicerMarkupsLogic *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSlicerMarkupsLogic_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSlicerMarkupsLogic\nC++: vtkSlicerMarkupsLogic *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkSlicerMarkupsLogic_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkSlicerMarkupsLogic_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"ProcessMRMLNodesEvents", PyvtkSlicerMarkupsLogic_ProcessMRMLNodesEvents, METH_VARARGS,
   "V.ProcessMRMLNodesEvents(vtkObject, int, void)\nC++: void ProcessMRMLNodesEvents(vtkObject *caller,\n    unsigned long event, void *callData) override;\n\nReceives all the events fired by the nodes. To listen to a node,\nyou can add an observer using GetMRMLNodesCallbackCommand() or\nuse the utility macros\nvtk[SetAndObserve|Observe]MRMLNode[Event]Macro\nProcessMRMLNodesEvents calls OnMRMLNodeModified when event is\nvtkCommand::ModifiedEvent.\n\\sa ProcessMRMLSceneEvents, ProcessMRMLLogicsEvents,\nOnMRMLNodeModified(), vtkSetAndObserveMRMLNodeMacro,\nvtkObserveMRMLNodeMacro, vtkSetAndObserveMRMLNodeEventMacro\n"},
  {"GetSelectionNodeID", PyvtkSlicerMarkupsLogic_GetSelectionNodeID, METH_VARARGS,
   "V.GetSelectionNodeID() -> string\nC++: std::string GetSelectionNodeID()\n\nUtility method to return the id of the selection node. Checks the\nmrml application logic if set, otherwise checks the scene for a\nsingleton selection node. Returns an empty string on failure.\n"},
  {"GetActiveListID", PyvtkSlicerMarkupsLogic_GetActiveListID, METH_VARARGS,
   "V.GetActiveListID() -> string\nC++: std::string GetActiveListID()\n\nUtility method to return the id of the active place node. Returns\nan empty string on failure.\n\\sa SetActiveListID\n"},
  {"SetActiveListID", PyvtkSlicerMarkupsLogic_SetActiveListID, METH_VARARGS,
   "V.SetActiveListID(vtkMRMLMarkupsNode)\nC++: void SetActiveListID(vtkMRMLMarkupsNode *markupsNode)\n\nUtility method to set the active place node from the passed\nmarkups node. Does not set the interaction mode to place.\n\\sa GetActiveListID, StartPlaceMode\n\\sa vtkMRMLSelectionNode::SetReferenceActivePlaceNodeClassName\n\\sa vtkMRMLSelectionNode::SetActivePlaceNodeID\n"},
  {"AddNewDisplayNodeForMarkupsNode", PyvtkSlicerMarkupsLogic_AddNewDisplayNodeForMarkupsNode, METH_VARARGS,
   "V.AddNewDisplayNodeForMarkupsNode(vtkMRMLNode) -> string\nC++: std::string AddNewDisplayNodeForMarkupsNode(\n    vtkMRMLNode *mrmlNode)\n\nCreate a new display node and observe it on the markups node. On\nsuccess, return the id, on failure return an empty string. If a\ndisplay node already exists for this node, return the id of that\nnode.\n"},
  {"AddNewFiducialNode", PyvtkSlicerMarkupsLogic_AddNewFiducialNode, METH_VARARGS,
   "V.AddNewFiducialNode(string, vtkMRMLScene) -> string\nC++: std::string AddNewFiducialNode(const char *name=\"F\",\n    vtkMRMLScene *scene=nullptr)\n\nCreate a new markups fiducial node and associated display node,\nadding both to the scene. If the scene argument is null use the\nscene set on the logic class, and also make it the active on on\nthe selection node, otherwise add to the passed scene. On\nsuccess, return the id, on failure return an empty string.\n"},
  {"AddFiducial", PyvtkSlicerMarkupsLogic_AddFiducial, METH_VARARGS,
   "V.AddFiducial(float, float, float) -> int\nC++: int AddFiducial(double r=0.0, double a=0.0, double s=0.0)\n\nAdd a new fiducial to the currently active list at the given RAS\ncoordinates (default 0,0,0). Will create a list is one is not\nactive. Returns -1 on failure, index of the added fiducial on\nsuccess.\n"},
  {"JumpSlicesToLocation", PyvtkSlicerMarkupsLogic_JumpSlicesToLocation, METH_VARARGS,
   "V.JumpSlicesToLocation(float, float, float, bool, int,\n    vtkMRMLSliceNode)\nC++: void JumpSlicesToLocation(double x, double y, double z,\n    bool centered, int viewGroup=-1,\n    vtkMRMLSliceNode *exclude=nullptr)\n\njump the slice windows to the given coordinate If viewGroup is -1\nthen all all slice views are updated, otherwise only those views\nthat are in the specified group.\n"},
  {"JumpSlicesToNthPointInMarkup", PyvtkSlicerMarkupsLogic_JumpSlicesToNthPointInMarkup, METH_VARARGS,
   "V.JumpSlicesToNthPointInMarkup(string, int, bool, int,\n    vtkMRMLSliceNode)\nC++: void JumpSlicesToNthPointInMarkup(const char *id, int n,\n    bool centered=false, int viewGroup=-1,\n    vtkMRMLSliceNode *exclude=nullptr)\n\njump the slice windows to the nth markup with the mrml id id\n\\sa JumpSlicesToLocation\n"},
  {"FocusCamerasOnNthPointInMarkup", PyvtkSlicerMarkupsLogic_FocusCamerasOnNthPointInMarkup, METH_VARARGS,
   "V.FocusCamerasOnNthPointInMarkup(string, int)\nC++: void FocusCamerasOnNthPointInMarkup(const char *id, int n)\n\nrefocus all of the 3D cameras to the nth markup with the mrml id\nid\n\\sa FocusCameraOnNthPointInMarkup\n"},
  {"FocusCameraOnNthPointInMarkup", PyvtkSlicerMarkupsLogic_FocusCameraOnNthPointInMarkup, METH_VARARGS,
   "V.FocusCameraOnNthPointInMarkup(string, string, int)\nC++: void FocusCameraOnNthPointInMarkup(const char *cameraNodeID,\n    const char *markupNodeID, int n)\n\nrefocus the camera with the given cameraNodeID on the nth markup\nin the markups node with id markupNodeID\n\\sa FocusCamerasOnNthPointInMarkup\n"},
  {"LoadMarkups", PyvtkSlicerMarkupsLogic_LoadMarkups, METH_VARARGS,
   "V.LoadMarkups(string, string) -> string\nC++: char *LoadMarkups(const char *fileName,\n    const char *fidsName=nullptr)\n\nLoad a markups fiducial list from fileName, return nullptr on\nerror, node ID string otherwise. Adds the appropriate storage and\ndisplay nodes to the scene as well.\n"},
  {"LoadMarkupsFiducials", PyvtkSlicerMarkupsLogic_LoadMarkupsFiducials, METH_VARARGS,
   "V.LoadMarkupsFiducials(string, string) -> string\nC++: char *LoadMarkupsFiducials(const char *fileName,\n    const char *fidsName=nullptr)\n\nThis method is deprecated. It is kept for backward compatibility\nonly, it does the same as LoadMarkups method.\n"},
  {"LoadMarkupsFromFcsv", PyvtkSlicerMarkupsLogic_LoadMarkupsFromFcsv, METH_VARARGS,
   "V.LoadMarkupsFromFcsv(string, string) -> string\nC++: char *LoadMarkupsFromFcsv(const char *fileName,\n    const char *nodeName)\n\n"},
  {"LoadMarkupsFromJson", PyvtkSlicerMarkupsLogic_LoadMarkupsFromJson, METH_VARARGS,
   "V.LoadMarkupsFromJson(string, string) -> string\nC++: char *LoadMarkupsFromJson(const char *fileName,\n    const char *nodeName)\n\n"},
  {"SetAllMarkupsVisibility", PyvtkSlicerMarkupsLogic_SetAllMarkupsVisibility, METH_VARARGS,
   "V.SetAllMarkupsVisibility(vtkMRMLMarkupsNode, bool)\nC++: void SetAllMarkupsVisibility(vtkMRMLMarkupsNode *node,\n    bool flag)\n\nUtility methods to operate on all markups in a markups node\n"},
  {"ToggleAllMarkupsVisibility", PyvtkSlicerMarkupsLogic_ToggleAllMarkupsVisibility, METH_VARARGS,
   "V.ToggleAllMarkupsVisibility(vtkMRMLMarkupsNode)\nC++: void ToggleAllMarkupsVisibility(vtkMRMLMarkupsNode *node)\n\n"},
  {"SetAllMarkupsLocked", PyvtkSlicerMarkupsLogic_SetAllMarkupsLocked, METH_VARARGS,
   "V.SetAllMarkupsLocked(vtkMRMLMarkupsNode, bool)\nC++: void SetAllMarkupsLocked(vtkMRMLMarkupsNode *node, bool flag)\n\n"},
  {"ToggleAllMarkupsLocked", PyvtkSlicerMarkupsLogic_ToggleAllMarkupsLocked, METH_VARARGS,
   "V.ToggleAllMarkupsLocked(vtkMRMLMarkupsNode)\nC++: void ToggleAllMarkupsLocked(vtkMRMLMarkupsNode *node)\n\n"},
  {"SetAllMarkupsSelected", PyvtkSlicerMarkupsLogic_SetAllMarkupsSelected, METH_VARARGS,
   "V.SetAllMarkupsSelected(vtkMRMLMarkupsNode, bool)\nC++: void SetAllMarkupsSelected(vtkMRMLMarkupsNode *node,\n    bool flag)\n\n"},
  {"ToggleAllMarkupsSelected", PyvtkSlicerMarkupsLogic_ToggleAllMarkupsSelected, METH_VARARGS,
   "V.ToggleAllMarkupsSelected(vtkMRMLMarkupsNode)\nC++: void ToggleAllMarkupsSelected(vtkMRMLMarkupsNode *node)\n\n"},
  {"SetDisplayNodeToDefaults", PyvtkSlicerMarkupsLogic_SetDisplayNodeToDefaults, METH_VARARGS,
   "V.SetDisplayNodeToDefaults(vtkMRMLMarkupsDisplayNode)\nC++: void SetDisplayNodeToDefaults(\n    vtkMRMLMarkupsDisplayNode *displayNode)\n\nutility method to set up a display node from the defaults\n"},
  {"SetDisplayDefaultsFromNode", PyvtkSlicerMarkupsLogic_SetDisplayDefaultsFromNode, METH_VARARGS,
   "V.SetDisplayDefaultsFromNode(vtkMRMLMarkupsDisplayNode)\nC++: void SetDisplayDefaultsFromNode(\n    vtkMRMLMarkupsDisplayNode *displayNode)\n\nutility method to set defaults from display node\n"},
  {"CopyNthControlPointToNewList", PyvtkSlicerMarkupsLogic_CopyNthControlPointToNewList, METH_VARARGS,
   "V.CopyNthControlPointToNewList(int, vtkMRMLMarkupsNode,\n    vtkMRMLMarkupsNode) -> bool\nC++: bool CopyNthControlPointToNewList(int n,\n    vtkMRMLMarkupsNode *markupsNode,\n    vtkMRMLMarkupsNode *newMarkupsNode)\n\nutility method to copy a control point from one list to another,\nadding it to the end of the new list\n\\sa vtkMRMLMarkupsNode::AddControlPoint\nReturns true on success, false on failure\n"},
  {"CopyNthMarkupToNewList", PyvtkSlicerMarkupsLogic_CopyNthMarkupToNewList, METH_VARARGS,
   "V.CopyNthMarkupToNewList(int, vtkMRMLMarkupsNode,\n    vtkMRMLMarkupsNode) -> bool\nC++: bool CopyNthMarkupToNewList(int n,\n    vtkMRMLMarkupsNode *markupsNode,\n    vtkMRMLMarkupsNode *newMarkupsNode)\n\n\\deprecated Use CopyNthControlPointToNewList instead.\n"},
  {"MoveNthControlPointToNewListAtIndex", PyvtkSlicerMarkupsLogic_MoveNthControlPointToNewListAtIndex, METH_VARARGS,
   "V.MoveNthControlPointToNewListAtIndex(int, vtkMRMLMarkupsNode,\n    vtkMRMLMarkupsNode, int) -> bool\nC++: bool MoveNthControlPointToNewListAtIndex(int n,\n    vtkMRMLMarkupsNode *markupsNode,\n    vtkMRMLMarkupsNode *newMarkupsNode, int newIndex)\n\nutility method to move a control point from one list to another,\ntrying to insert it at the given new index. If the new index is\nlarger than the number of control points in the list, adds it to\nthe end. If new index is smaller than 0, adds it at the\nbeginning. Otherwise inserts at that index.\n\\sa vtkMRMLMarkupsNode::InsertControlPoint\nReturns true on success, false on failure\n"},
  {"MoveNthMarkupToNewList", PyvtkSlicerMarkupsLogic_MoveNthMarkupToNewList, METH_VARARGS,
   "V.MoveNthMarkupToNewList(int, vtkMRMLMarkupsNode,\n    vtkMRMLMarkupsNode, int) -> bool\nC++: bool MoveNthMarkupToNewList(int n,\n    vtkMRMLMarkupsNode *markupsNode,\n    vtkMRMLMarkupsNode *newMarkupsNode, int newIndex)\n\n\\deprecated Use MoveNthControlPointToNewList instead.\n"},
  {"ConvertAnnotationFiducialsToMarkups", PyvtkSlicerMarkupsLogic_ConvertAnnotationFiducialsToMarkups, METH_VARARGS,
   "V.ConvertAnnotationFiducialsToMarkups()\nC++: void ConvertAnnotationFiducialsToMarkups()\n\nSearches the scene for annotation fidicual nodes, collecting a\nlist of annotation hierarchy nodes. Then iterates through those\nhierarchy nodes and moves the fiducials that are under them into\nnew markups nodes. Leaves the top level hierarchy nodes intact as\nthey may be parents to ruler or ROIs but deletes the 1:1\nhierarchy nodes.\n"},
  {"RenameAllMarkupsFromCurrentFormat", PyvtkSlicerMarkupsLogic_RenameAllMarkupsFromCurrentFormat, METH_VARARGS,
   "V.RenameAllMarkupsFromCurrentFormat(vtkMRMLMarkupsNode)\nC++: void RenameAllMarkupsFromCurrentFormat(\n    vtkMRMLMarkupsNode *markupsNode)\n\nIterate over the markups in the list and reset the markup labels\nusing the current MarkupLabelFormat setting. Try to keep current\nnumbering. Will work if there's a %d, %g or %f in the format\nstring, but precision is not handled.\n"},
  {"StartPlaceMode", PyvtkSlicerMarkupsLogic_StartPlaceMode, METH_VARARGS,
   "V.StartPlaceMode(bool, vtkMRMLInteractionNode) -> bool\nC++: bool StartPlaceMode(bool persistent,\n    vtkMRMLInteractionNode *interactionNode=nullptr)\n\nPut the interaction node into place mode, and set the persistence\nof place mode according to the persistent flag. Return true on\nsuccessfully going into place mode, false otherwise. By default,\nthe default interaction node is updated.\n\\sa SetActiveIDList\n"},
  {"GetSliceIntersectionsVisibility", PyvtkSlicerMarkupsLogic_GetSliceIntersectionsVisibility, METH_VARARGS,
   "V.GetSliceIntersectionsVisibility() -> int\nC++: int GetSliceIntersectionsVisibility()\n\nInspect all the slice composite nodes in the scene. Return 1 if\nall have SliceIntersectionVisibility set to true, 0 if all have\nit set to false, 2 if it's a combination of true and false, -1 on\nerror\n"},
  {"SetSliceIntersectionsVisibility", PyvtkSlicerMarkupsLogic_SetSliceIntersectionsVisibility, METH_VARARGS,
   "V.SetSliceIntersectionsVisibility(bool)\nC++: void SetSliceIntersectionsVisibility(bool flag)\n\nSet the slice intersections visbility on all the slice composite\nnodes in the scene\n"},
  {"SetAutoCreateDisplayNodes", PyvtkSlicerMarkupsLogic_SetAutoCreateDisplayNodes, METH_VARARGS,
   "V.SetAutoCreateDisplayNodes(bool)\nC++: virtual void SetAutoCreateDisplayNodes(bool _arg)\n\n"},
  {"GetAutoCreateDisplayNodes", PyvtkSlicerMarkupsLogic_GetAutoCreateDisplayNodes, METH_VARARGS,
   "V.GetAutoCreateDisplayNodes() -> bool\nC++: virtual bool GetAutoCreateDisplayNodes()\n\n"},
  {"AutoCreateDisplayNodesOn", PyvtkSlicerMarkupsLogic_AutoCreateDisplayNodesOn, METH_VARARGS,
   "V.AutoCreateDisplayNodesOn()\nC++: virtual void AutoCreateDisplayNodesOn()\n\n"},
  {"AutoCreateDisplayNodesOff", PyvtkSlicerMarkupsLogic_AutoCreateDisplayNodesOff, METH_VARARGS,
   "V.AutoCreateDisplayNodesOff()\nC++: virtual void AutoCreateDisplayNodesOff()\n\n"},
  {"GetDefaultMarkupsDisplayNode", PyvtkSlicerMarkupsLogic_GetDefaultMarkupsDisplayNode, METH_VARARGS,
   "V.GetDefaultMarkupsDisplayNode() -> vtkMRMLMarkupsDisplayNode\nC++: vtkMRMLMarkupsDisplayNode *GetDefaultMarkupsDisplayNode()\n\n"},
  {"CopyBasicDisplayProperties", PyvtkSlicerMarkupsLogic_CopyBasicDisplayProperties, METH_VARARGS,
   "V.CopyBasicDisplayProperties(vtkMRMLMarkupsDisplayNode,\n    vtkMRMLMarkupsDisplayNode)\nC++: void CopyBasicDisplayProperties(\n    vtkMRMLMarkupsDisplayNode *sourceDisplayNode,\n    vtkMRMLMarkupsDisplayNode *targetDisplayNode)\n\nCopies basic display properties between markups display nodes.\nThis is used for updating a display node to defaults.\n"},
  {"GetClosedCurveSurfaceArea", PyvtkSlicerMarkupsLogic_GetClosedCurveSurfaceArea, METH_VARARGS,
   "V.GetClosedCurveSurfaceArea(vtkMRMLMarkupsClosedCurveNode,\n    vtkPolyData, bool) -> float\nC++: static double GetClosedCurveSurfaceArea(\n    vtkMRMLMarkupsClosedCurveNode *curveNode,\n    vtkPolyData *surface=nullptr, bool projectWarp=true)\n\nMeasure surface area of the smooth surface that fits on the\nclosed curve in world coordinate system. If projectWarp option is\nenabled then FitSurfaceProjectWarp method is used otherwise\nFitSurfaceDiskWarp is used. FitSurfaceProjectWarp produces\naccurate results for all quasi-planar curves (while\nFitSurfaceDiskWarp may significantly overestimate surface area\nfor planar convex curves). FitSurfaceDiskWarp is kept for\ncompatison only and may be removed in the future.\n\\param curveNode points to fit the surface to\n\\param surface if not nullptr then the generated surface is saved\ninto that\n"},
  {"FitSurfaceProjectWarp", PyvtkSlicerMarkupsLogic_FitSurfaceProjectWarp, METH_VARARGS,
   "V.FitSurfaceProjectWarp(vtkPoints, vtkPolyData, float) -> bool\nC++: static bool FitSurfaceProjectWarp(vtkPoints *curvePoints,\n    vtkPolyData *surface, double radiusScalingFactor=1.0)\n\nCreate a \"soap bubble\" surface that fits on the provided point\nlist. First the contour points projected to best fit plane,\ntriangulated in 2D, and warped to the non-planar shape. Convex\nsurfaces are triangulated correctly. If the contour is\nself-intersecting after projected to best fit plane then the\nsurface will be invalid.\n\\param curvePoints: points to fit the surface to\n\\param radiusScalingFactor size of the surface. Value of 1.0\n    (default) means the surface edge fits on the points.\nLarger values increase the generated soap bubble outer radius,\nwhich may be useful to avoid coincident points when using this\nsurface for cutting another surface.\n\\warning Specifying radiusScalingFactor has no effect. Associated\nfeature is not yet implemented.\n"},
  {"FitSurfaceDiskWarp", PyvtkSlicerMarkupsLogic_FitSurfaceDiskWarp, METH_VARARGS,
   "V.FitSurfaceDiskWarp(vtkPoints, vtkPolyData, float) -> bool\nC++: static bool FitSurfaceDiskWarp(vtkPoints *curvePoints,\n    vtkPolyData *surface, double radiusScalingFactor=1.0)\n\nCreate a \"soap bubble\" surface that fits on the provided point\nlist. A triangulated disk is warped so that its boundary matches\nthe provided curve points using thin-plate spline transform. The\ngenerated surface may go beyond the boundary of the input points\nif the boundary is highly concave or curved.\n\\param curvePoints: points to fit the surface to\n\\param radiusScalingFactor size of the surface.Value of 1.0\n    (default) means the surface edge fits on the points.\nLarger values increase the generated soap bubble outer radius,\nwhich may be useful to avoid coincident points when using this\nsurface for cutting another surface.\n"},
  {"IsPolygonClockwise", PyvtkSlicerMarkupsLogic_IsPolygonClockwise, METH_VARARGS,
   "V.IsPolygonClockwise(vtkPoints) -> bool\nC++: static bool IsPolygonClockwise(vtkPoints *points)\n\nReturn tru if the polygon points are oriented clockwise.\n"},
  {"GetBestFitPlane", PyvtkSlicerMarkupsLogic_GetBestFitPlane, METH_VARARGS,
   "V.GetBestFitPlane(vtkMRMLMarkupsNode, vtkPlane) -> bool\nC++: static bool GetBestFitPlane(vtkMRMLMarkupsNode *curveNode,\n    vtkPlane *plane)\n\nGet best fit plane for a markup\n"},
  {"GetJsonStorageNodeClassNameForMarkupsType", PyvtkSlicerMarkupsLogic_GetJsonStorageNodeClassNameForMarkupsType, METH_VARARGS,
   "V.GetJsonStorageNodeClassNameForMarkupsType(string) -> string\nC++: std::string GetJsonStorageNodeClassNameForMarkupsType(\n    std::string markupsType)\n\n"},
  {"RegisterJsonStorageNodeForMarkupsType", PyvtkSlicerMarkupsLogic_RegisterJsonStorageNodeForMarkupsType, METH_VARARGS,
   "V.RegisterJsonStorageNodeForMarkupsType(string, string)\nC++: void RegisterJsonStorageNodeForMarkupsType(\n    std::string markupsType, std::string storageNodeClassName)\n\n"},
  {"AddNewJsonStorageNodeForMarkupsType", PyvtkSlicerMarkupsLogic_AddNewJsonStorageNodeForMarkupsType, METH_VARARGS,
   "V.AddNewJsonStorageNodeForMarkupsType(string)\n    -> vtkMRMLMarkupsJsonStorageNode\nC++: vtkMRMLMarkupsJsonStorageNode *AddNewJsonStorageNodeForMarkupsType(\n    std::string markupsType)\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkSlicerMarkupsLogic_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerMarkupsModuleLogic.vtkSlicerMarkupsLogic", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkSlicerMarkupsLogic_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSlicerMarkupsLogic_StaticNew()
{
  return vtkSlicerMarkupsLogic::New();
}

PyObject *PyvtkSlicerMarkupsLogic_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkSlicerMarkupsLogic_Type, PyvtkSlicerMarkupsLogic_Methods,
    "vtkSlicerMarkupsLogic",
 &PyvtkSlicerMarkupsLogic_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkSlicerModuleLogic");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkSlicerMarkupsLogic(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSlicerMarkupsLogic_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSlicerMarkupsLogic", o) != 0)
  {
    Py_DECREF(o);
  }

}

