// python wrapper for vtkCurveMeasurementsCalculator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkCurveMeasurementsCalculator.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCurveMeasurementsCalculator(PyObject *dict); }
extern "C" { PyObject *PyvtkCurveMeasurementsCalculator_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char *PyvtkCurveMeasurementsCalculator_Doc =
  "vtkCurveMeasurementsCalculator - Filter that generates curves between\npoints of an input polydata\n\n"
  "Superclass: vtkPolyDataAlgorithm\n\n"
;


static PyObject *
PyvtkCurveMeasurementsCalculator_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkCurveMeasurementsCalculator::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCurveMeasurementsCalculator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkCurveMeasurementsCalculator *tempr = vtkCurveMeasurementsCalculator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkCurveMeasurementsCalculator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCurveMeasurementsCalculator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkCurveMeasurementsCalculator::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkCurveMeasurementsCalculator::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_SetMeasurements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMeasurements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  vtkCollection *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCollection"))
  {
    if (ap.IsBound())
    {
      op->SetMeasurements(temp0);
    }
    else
    {
      op->vtkCurveMeasurementsCalculator::SetMeasurements(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_GetMeasurements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMeasurements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkCollection *tempr = (ap.IsBound() ?
      op->GetMeasurements() :
      op->vtkCurveMeasurementsCalculator::GetMeasurements());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_SetCurveIsClosed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCurveIsClosed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCurveIsClosed(temp0);
    }
    else
    {
      op->vtkCurveMeasurementsCalculator::SetCurveIsClosed(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_GetCurveIsClosed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurveIsClosed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetCurveIsClosed() :
      op->vtkCurveMeasurementsCalculator::GetCurveIsClosed());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_CurveIsClosedOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CurveIsClosedOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CurveIsClosedOn();
    }
    else
    {
      op->vtkCurveMeasurementsCalculator::CurveIsClosedOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_CurveIsClosedOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CurveIsClosedOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CurveIsClosedOff();
    }
    else
    {
      op->vtkCurveMeasurementsCalculator::CurveIsClosedOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_SetCalculateCurvature(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCalculateCurvature");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCalculateCurvature(temp0);
    }
    else
    {
      op->vtkCurveMeasurementsCalculator::SetCalculateCurvature(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_GetCalculateCurvature(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCalculateCurvature");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetCalculateCurvature() :
      op->vtkCurveMeasurementsCalculator::GetCalculateCurvature());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_CalculateCurvatureOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CalculateCurvatureOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CalculateCurvatureOn();
    }
    else
    {
      op->vtkCurveMeasurementsCalculator::CalculateCurvatureOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_CalculateCurvatureOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CalculateCurvatureOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CalculateCurvatureOff();
    }
    else
    {
      op->vtkCurveMeasurementsCalculator::CalculateCurvatureOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_GetMeanCurvatureName(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetMeanCurvatureName");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    const char *tempr = vtkCurveMeasurementsCalculator::GetMeanCurvatureName();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_GetMaxCurvatureName(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetMaxCurvatureName");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    const char *tempr = vtkCurveMeasurementsCalculator::GetMaxCurvatureName();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCurveMeasurementsCalculator_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCurveMeasurementsCalculator *op = static_cast<vtkCurveMeasurementsCalculator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkCurveMeasurementsCalculator::GetMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkCurveMeasurementsCalculator_Methods[] = {
  {"IsTypeOf", PyvtkCurveMeasurementsCalculator_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkCurveMeasurementsCalculator_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkCurveMeasurementsCalculator_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkCurveMeasurementsCalculator\nC++: static vtkCurveMeasurementsCalculator *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkCurveMeasurementsCalculator_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCurveMeasurementsCalculator\nC++: vtkCurveMeasurementsCalculator *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkCurveMeasurementsCalculator_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkCurveMeasurementsCalculator_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetMeasurements", PyvtkCurveMeasurementsCalculator_SetMeasurements, METH_VARARGS,
   "V.SetMeasurements(vtkCollection)\nC++: void SetMeasurements(vtkCollection *measurements)\n\nSet/Get measurement collection. The measurements that are enabled\nand contain control point data are used for interpolation\n"},
  {"GetMeasurements", PyvtkCurveMeasurementsCalculator_GetMeasurements, METH_VARARGS,
   "V.GetMeasurements() -> vtkCollection\nC++: vtkCollection *GetMeasurements()\n\nSet/Get measurement collection. The measurements that are enabled\nand contain control point data are used for interpolation\n"},
  {"SetCurveIsClosed", PyvtkCurveMeasurementsCalculator_SetCurveIsClosed, METH_VARARGS,
   "V.SetCurveIsClosed(bool)\nC++: virtual void SetCurveIsClosed(bool _arg)\n\nThis indicates whether the curve loops back in on itself,\nconnecting the last point back to the first point (disabled by\ndefault).\n"},
  {"GetCurveIsClosed", PyvtkCurveMeasurementsCalculator_GetCurveIsClosed, METH_VARARGS,
   "V.GetCurveIsClosed() -> bool\nC++: virtual bool GetCurveIsClosed()\n\nThis indicates whether the curve loops back in on itself,\nconnecting the last point back to the first point (disabled by\ndefault).\n"},
  {"CurveIsClosedOn", PyvtkCurveMeasurementsCalculator_CurveIsClosedOn, METH_VARARGS,
   "V.CurveIsClosedOn()\nC++: virtual void CurveIsClosedOn()\n\nThis indicates whether the curve loops back in on itself,\nconnecting the last point back to the first point (disabled by\ndefault).\n"},
  {"CurveIsClosedOff", PyvtkCurveMeasurementsCalculator_CurveIsClosedOff, METH_VARARGS,
   "V.CurveIsClosedOff()\nC++: virtual void CurveIsClosedOff()\n\nThis indicates whether the curve loops back in on itself,\nconnecting the last point back to the first point (disabled by\ndefault).\n"},
  {"SetCalculateCurvature", PyvtkCurveMeasurementsCalculator_SetCalculateCurvature, METH_VARARGS,
   "V.SetCalculateCurvature(bool)\nC++: virtual void SetCalculateCurvature(bool _arg)\n\nSet/Get flag determining whether to calculate curvature\n"},
  {"GetCalculateCurvature", PyvtkCurveMeasurementsCalculator_GetCalculateCurvature, METH_VARARGS,
   "V.GetCalculateCurvature() -> bool\nC++: virtual bool GetCalculateCurvature()\n\nSet/Get flag determining whether to calculate curvature\n"},
  {"CalculateCurvatureOn", PyvtkCurveMeasurementsCalculator_CalculateCurvatureOn, METH_VARARGS,
   "V.CalculateCurvatureOn()\nC++: virtual void CalculateCurvatureOn()\n\nSet/Get flag determining whether to calculate curvature\n"},
  {"CalculateCurvatureOff", PyvtkCurveMeasurementsCalculator_CalculateCurvatureOff, METH_VARARGS,
   "V.CalculateCurvatureOff()\nC++: virtual void CalculateCurvatureOff()\n\nSet/Get flag determining whether to calculate curvature\n"},
  {"GetMeanCurvatureName", PyvtkCurveMeasurementsCalculator_GetMeanCurvatureName, METH_VARARGS,
   "V.GetMeanCurvatureName() -> string\nC++: static const char *GetMeanCurvatureName()\n\nGet name of mean curvature measurement\n"},
  {"GetMaxCurvatureName", PyvtkCurveMeasurementsCalculator_GetMaxCurvatureName, METH_VARARGS,
   "V.GetMaxCurvatureName() -> string\nC++: static const char *GetMaxCurvatureName()\n\nGet name of max curvature measurement\n"},
  {"GetMTime", PyvtkCurveMeasurementsCalculator_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: vtkMTimeType GetMTime() override;\n\nReturn this object's modified time.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkCurveMeasurementsCalculator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerMarkupsModuleMRML.vtkCurveMeasurementsCalculator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkCurveMeasurementsCalculator_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCurveMeasurementsCalculator_StaticNew()
{
  return vtkCurveMeasurementsCalculator::New();
}

PyObject *PyvtkCurveMeasurementsCalculator_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkCurveMeasurementsCalculator_Type, PyvtkCurveMeasurementsCalculator_Methods,
    "vtkCurveMeasurementsCalculator",
 &PyvtkCurveMeasurementsCalculator_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkPolyDataAlgorithm");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkCurveMeasurementsCalculator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCurveMeasurementsCalculator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCurveMeasurementsCalculator", o) != 0)
  {
    Py_DECREF(o);
  }

}

