// python wrapper for vtkMRMLMarkupsClosedCurveNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkMRMLMarkupsClosedCurveNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLMarkupsClosedCurveNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLMarkupsClosedCurveNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLMarkupsCurveNode_ClassNew
extern "C" { PyObject *PyvtkMRMLMarkupsCurveNode_ClassNew(); }
#define DECLARED_PyvtkMRMLMarkupsCurveNode_ClassNew
#endif

static const char *PyvtkMRMLMarkupsClosedCurveNode_Doc =
  "vtkMRMLMarkupsClosedCurveNode - MRML node to represent a closed curve\nmarkup\n\n"
  "Superclass: vtkMRMLMarkupsCurveNode\n\n"
  "Closed Curve Markups nodes contain N control points. Visualization\n"
  "parameters are set in the vtkMRMLMarkupsDisplayNode class.\n\n"
  "Markups is intended to be used for manual marking/editing of point\n"
  "positions.\n\n"
  "\\ingroup Slicer_QtModules_Markups\n\n";


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLMarkupsClosedCurveNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsClosedCurveNode *op = static_cast<vtkMRMLMarkupsClosedCurveNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLMarkupsClosedCurveNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLMarkupsClosedCurveNode *tempr = vtkMRMLMarkupsClosedCurveNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsClosedCurveNode *op = static_cast<vtkMRMLMarkupsClosedCurveNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLMarkupsClosedCurveNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLMarkupsClosedCurveNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLMarkupsClosedCurveNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsClosedCurveNode *op = static_cast<vtkMRMLMarkupsClosedCurveNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLMarkupsClosedCurveNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_GetIcon(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIcon");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsClosedCurveNode *op = static_cast<vtkMRMLMarkupsClosedCurveNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetIcon() :
      op->vtkMRMLMarkupsClosedCurveNode::GetIcon());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsClosedCurveNode *op = static_cast<vtkMRMLMarkupsClosedCurveNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLMarkupsClosedCurveNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsClosedCurveNode *op = static_cast<vtkMRMLMarkupsClosedCurveNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLMarkupsClosedCurveNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_HasCopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasCopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsClosedCurveNode *op = static_cast<vtkMRMLMarkupsClosedCurveNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasCopyContent() :
      op->vtkMRMLMarkupsClosedCurveNode::HasCopyContent());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_GetClosedCurveSurfaceArea(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetClosedCurveSurfaceArea");

  vtkMRMLMarkupsClosedCurveNode *temp0 = nullptr;
  vtkPolyData *temp1 = nullptr;
  bool temp2 = true;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1, 3) &&
      ap.GetVTKObject(temp0, "vtkMRMLMarkupsClosedCurveNode") &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp1, "vtkPolyData")) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    double tempr = vtkMRMLMarkupsClosedCurveNode::GetClosedCurveSurfaceArea(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_FitSurfaceProjectWarp(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "FitSurfaceProjectWarp");

  vtkPoints *temp0 = nullptr;
  vtkPolyData *temp1 = nullptr;
  double temp2 = 1.0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2, 3) &&
      ap.GetVTKObject(temp0, "vtkPoints") &&
      ap.GetVTKObject(temp1, "vtkPolyData") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    bool tempr = vtkMRMLMarkupsClosedCurveNode::FitSurfaceProjectWarp(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_FitSurfaceDiskWarp(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "FitSurfaceDiskWarp");

  vtkPoints *temp0 = nullptr;
  vtkPolyData *temp1 = nullptr;
  double temp2 = 1.0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2, 3) &&
      ap.GetVTKObject(temp0, "vtkPoints") &&
      ap.GetVTKObject(temp1, "vtkPolyData") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    bool tempr = vtkMRMLMarkupsClosedCurveNode::FitSurfaceDiskWarp(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsClosedCurveNode_IsPolygonClockwise(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsPolygonClockwise");

  vtkPoints *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPoints"))
  {
    bool tempr = vtkMRMLMarkupsClosedCurveNode::IsPolygonClockwise(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLMarkupsClosedCurveNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLMarkupsClosedCurveNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLMarkupsClosedCurveNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLMarkupsClosedCurveNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLMarkupsClosedCurveNode\nC++: static vtkMRMLMarkupsClosedCurveNode *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLMarkupsClosedCurveNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLMarkupsClosedCurveNode\nC++: vtkMRMLMarkupsClosedCurveNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLMarkupsClosedCurveNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLMarkupsClosedCurveNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetIcon", PyvtkMRMLMarkupsClosedCurveNode_GetIcon, METH_VARARGS,
   "V.GetIcon() -> string\nC++: const char *GetIcon() override;\n\n"},
  {"CreateNodeInstance", PyvtkMRMLMarkupsClosedCurveNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\nMRMLNode methods\n"},
  {"GetNodeTagName", PyvtkMRMLMarkupsClosedCurveNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"HasCopyContent", PyvtkMRMLMarkupsClosedCurveNode_HasCopyContent, METH_VARARGS,
   "V.HasCopyContent() -> bool\nC++: bool HasCopyContent() override;\n\nCopy node content (excludes basic data, such as name and node\nreferences).\n\\sa vtkMRMLNode::CopyContent\n"},
  {"GetClosedCurveSurfaceArea", PyvtkMRMLMarkupsClosedCurveNode_GetClosedCurveSurfaceArea, METH_VARARGS,
   "V.GetClosedCurveSurfaceArea(vtkMRMLMarkupsClosedCurveNode,\n    vtkPolyData, bool) -> float\nC++: static double GetClosedCurveSurfaceArea(\n    vtkMRMLMarkupsClosedCurveNode *curveNode,\n    vtkPolyData *surface=nullptr, bool projectWarp=true)\n\nFor internal use only. Moved here temporarily until pluggable\nmarkups will be implemented. Then the methods will be moved back\nto markups logic.\n"},
  {"FitSurfaceProjectWarp", PyvtkMRMLMarkupsClosedCurveNode_FitSurfaceProjectWarp, METH_VARARGS,
   "V.FitSurfaceProjectWarp(vtkPoints, vtkPolyData, float) -> bool\nC++: static bool FitSurfaceProjectWarp(vtkPoints *curvePoints,\n    vtkPolyData *surface, double radiusScalingFactor=1.0)\n\nFor internal use only. Moved here temporarily until pluggable\nmarkups will be implemented. Then the methods will be moved back\nto markups logic.\n"},
  {"FitSurfaceDiskWarp", PyvtkMRMLMarkupsClosedCurveNode_FitSurfaceDiskWarp, METH_VARARGS,
   "V.FitSurfaceDiskWarp(vtkPoints, vtkPolyData, float) -> bool\nC++: static bool FitSurfaceDiskWarp(vtkPoints *curvePoints,\n    vtkPolyData *surface, double radiusScalingFactor=1.0)\n\nFor internal use only. Moved here temporarily until pluggable\nmarkups will be implemented. Then the methods will be moved back\nto markups logic.\n"},
  {"IsPolygonClockwise", PyvtkMRMLMarkupsClosedCurveNode_IsPolygonClockwise, METH_VARARGS,
   "V.IsPolygonClockwise(vtkPoints) -> bool\nC++: static bool IsPolygonClockwise(vtkPoints *points)\n\nFor internal use only. Moved here temporarily until pluggable\nmarkups will be implemented. Then the methods will be moved back\nto markups logic.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLMarkupsClosedCurveNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerMarkupsModuleMRML.vtkMRMLMarkupsClosedCurveNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLMarkupsClosedCurveNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLMarkupsClosedCurveNode_StaticNew()
{
  return vtkMRMLMarkupsClosedCurveNode::New();
}

PyObject *PyvtkMRMLMarkupsClosedCurveNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLMarkupsClosedCurveNode_Type, PyvtkMRMLMarkupsClosedCurveNode_Methods,
    "vtkMRMLMarkupsClosedCurveNode",
 &PyvtkMRMLMarkupsClosedCurveNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMRMLMarkupsCurveNode_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLMarkupsClosedCurveNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLMarkupsClosedCurveNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLMarkupsClosedCurveNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

