// python wrapper for vtkMRMLMarkupsFiducialNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkMRMLMarkupsFiducialNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLMarkupsFiducialNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLMarkupsFiducialNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLMarkupsNode_ClassNew
extern "C" { PyObject *PyvtkMRMLMarkupsNode_ClassNew(); }
#define DECLARED_PyvtkMRMLMarkupsNode_ClassNew
#endif

static const char *PyvtkMRMLMarkupsFiducialNode_Doc =
  "vtkMRMLMarkupsFiducialNode - MRML node to represent a fiducial markup\n\n"
  "Superclass: vtkMRMLMarkupsNode\n\n"
  "Fiducial Markups nodes contain a list of control points.\n"
  "Visualization parameters are set in the vtkMRMLMarkupsDisplayNode\n"
  "class.\n\n"
  "Markups is intended to be used for manual marking/editing of point\n"
  "positions. There is no specific limit for number of points that can\n"
  "be added to a list, but performance is optimal if there are less than\n"
  "2000 points.\n\n"
  "\\ingroup Slicer_QtModules_Markups\n\n";


static PyObject *
PyvtkMRMLMarkupsFiducialNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLMarkupsFiducialNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLMarkupsFiducialNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLMarkupsFiducialNode *tempr = vtkMRMLMarkupsFiducialNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLMarkupsFiducialNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLMarkupsFiducialNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLMarkupsFiducialNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLMarkupsFiducialNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetIcon(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIcon");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetIcon() :
      op->vtkMRMLMarkupsFiducialNode::GetIcon());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLMarkupsFiducialNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLMarkupsFiducialNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_Copy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Copy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode"))
  {
    if (ap.IsBound())
    {
      op->Copy(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::Copy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetMaximumNumberOfControlPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumNumberOfControlPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaximumNumberOfControlPoints(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetMaximumNumberOfControlPoints(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetRequiredNumberOfControlPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRequiredNumberOfControlPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRequiredNumberOfControlPoints(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetRequiredNumberOfControlPoints(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNumberOfFiducials(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfFiducials");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfFiducials() :
      op->vtkMRMLMarkupsFiducialNode::GetNumberOfFiducials());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_AddFiducial_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddFiducial");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->AddFiducial(temp0, temp1, temp2) :
      op->vtkMRMLMarkupsFiducialNode::AddFiducial(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLMarkupsFiducialNode_AddFiducial_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddFiducial");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  std::string temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    int tempr = (ap.IsBound() ?
      op->AddFiducial(temp0, temp1, temp2, temp3) :
      op->vtkMRMLMarkupsFiducialNode::AddFiducial(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLMarkupsFiducialNode_AddFiducial(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkMRMLMarkupsFiducialNode_AddFiducial_s1(self, args);
    case 4:
      return PyvtkMRMLMarkupsFiducialNode_AddFiducial_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "AddFiducial");
  return nullptr;
}



static PyObject *
PyvtkMRMLMarkupsFiducialNode_AddFiducialFromArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddFiducialFromArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  std::string temp1 = std::string();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetArray(temp0, size0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    int tempr = (ap.IsBound() ?
      op->AddFiducialFromArray(temp0, temp1) :
      op->vtkMRMLMarkupsFiducialNode::AddFiducialFromArray(temp0, temp1));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNthFiducialPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  const size_t size1 = 3;
  double temp1[3];
  double save1[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetNthFiducialPosition(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::GetNthFiducialPosition(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetNthFiducialPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    if (ap.IsBound())
    {
      op->SetNthFiducialPosition(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetNthFiducialPosition(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetNthFiducialPositionFromArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialPositionFromArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  const size_t size1 = 3;
  double temp1[3];
  double save1[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetNthFiducialPositionFromArray(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetNthFiducialPositionFromArray(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNthFiducialSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    bool tempr = (ap.IsBound() ?
      op->GetNthFiducialSelected(temp0) :
      op->vtkMRMLMarkupsFiducialNode::GetNthFiducialSelected(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetNthFiducialSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthFiducialSelected(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetNthFiducialSelected(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNthFiducialLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    bool tempr = (ap.IsBound() ?
      op->GetNthFiducialLocked(temp0) :
      op->vtkMRMLMarkupsFiducialNode::GetNthFiducialLocked(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetNthFiducialLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthFiducialLocked(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetNthFiducialLocked(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNthFiducialVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    bool tempr = (ap.IsBound() ?
      op->GetNthFiducialVisibility(temp0) :
      op->vtkMRMLMarkupsFiducialNode::GetNthFiducialVisibility(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetNthFiducialVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthFiducialVisibility(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetNthFiducialVisibility(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNthFiducialLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNthFiducialLabel(temp0) :
      op->vtkMRMLMarkupsFiducialNode::GetNthFiducialLabel(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetNthFiducialLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthFiducialLabel(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetNthFiducialLabel(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNthFiducialAssociatedNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialAssociatedNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNthFiducialAssociatedNodeID(temp0) :
      op->vtkMRMLMarkupsFiducialNode::GetNthFiducialAssociatedNodeID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetNthFiducialAssociatedNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialAssociatedNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthFiducialAssociatedNodeID(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetNthFiducialAssociatedNodeID(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_SetNthFiducialWorldCoordinates(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthFiducialWorldCoordinates");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  const size_t size1 = 4;
  double temp1[4];
  double save1[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetNthFiducialWorldCoordinates(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::SetNthFiducialWorldCoordinates(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_GetNthFiducialWorldCoordinates(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthFiducialWorldCoordinates");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  int temp0;
  const size_t size1 = 4;
  double temp1[4];
  double save1[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetNthFiducialWorldCoordinates(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::GetNthFiducialWorldCoordinates(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsFiducialNode_CreateDefaultDisplayNodes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultDisplayNodes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsFiducialNode *op = static_cast<vtkMRMLMarkupsFiducialNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CreateDefaultDisplayNodes();
    }
    else
    {
      op->vtkMRMLMarkupsFiducialNode::CreateDefaultDisplayNodes();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLMarkupsFiducialNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLMarkupsFiducialNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLMarkupsFiducialNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLMarkupsFiducialNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLMarkupsFiducialNode\nC++: static vtkMRMLMarkupsFiducialNode *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLMarkupsFiducialNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLMarkupsFiducialNode\nC++: vtkMRMLMarkupsFiducialNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLMarkupsFiducialNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLMarkupsFiducialNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetIcon", PyvtkMRMLMarkupsFiducialNode_GetIcon, METH_VARARGS,
   "V.GetIcon() -> string\nC++: const char *GetIcon() override;\n\n"},
  {"CreateNodeInstance", PyvtkMRMLMarkupsFiducialNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\nMRMLNode methods\n"},
  {"GetNodeTagName", PyvtkMRMLMarkupsFiducialNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"Copy", PyvtkMRMLMarkupsFiducialNode_Copy, METH_VARARGS,
   "V.Copy(vtkMRMLNode)\nC++: void Copy(vtkMRMLNode *node) override;\n\nCopy the node's attributes to this object\n"},
  {"SetMaximumNumberOfControlPoints", PyvtkMRMLMarkupsFiducialNode_SetMaximumNumberOfControlPoints, METH_VARARGS,
   "V.SetMaximumNumberOfControlPoints(int)\nC++: virtual void SetMaximumNumberOfControlPoints(int _arg)\n\nMaximum number of control points limits the number of markups\nallowed in the node. If maximum number of control points is set\nto 0 then no it means there is no limit (this is the default\nvalue). The value is an indication to the user interface and does\nnot affect prevent adding markups to a node programmatically. If\nvalue is set to lower value than the number of markups in the\nnode, then existing markups are not deleted. 2 for line, and 3\nfor angle Markups\n"},
  {"SetRequiredNumberOfControlPoints", PyvtkMRMLMarkupsFiducialNode_SetRequiredNumberOfControlPoints, METH_VARARGS,
   "V.SetRequiredNumberOfControlPoints(int)\nC++: virtual void SetRequiredNumberOfControlPoints(int _arg)\n\nSet the number of control points that are required for defining\nthis widget. Interaction mode remains in \"place\" mode until this\nnumber is reached. If the number is set to 0 then no it means\nthere is no preference (this is the default value).\n"},
  {"GetNumberOfFiducials", PyvtkMRMLMarkupsFiducialNode_GetNumberOfFiducials, METH_VARARGS,
   "V.GetNumberOfFiducials() -> int\nC++: int GetNumberOfFiducials()\n\nGet the number of fiducials in this node\n"},
  {"AddFiducial", PyvtkMRMLMarkupsFiducialNode_AddFiducial, METH_VARARGS,
   "V.AddFiducial(float, float, float) -> int\nC++: int AddFiducial(double x, double y, double z)\nV.AddFiducial(float, float, float, string) -> int\nC++: int AddFiducial(double x, double y, double z,\n    std::string label)\n\nAdd a new fiducial from x,y,z coordinates and return the fiducial\nindex\n"},
  {"AddFiducialFromArray", PyvtkMRMLMarkupsFiducialNode_AddFiducialFromArray, METH_VARARGS,
   "V.AddFiducialFromArray([float, float, float], string) -> int\nC++: int AddFiducialFromArray(double pos[3],\n    std::string label=std::string())\n\nAdd a new fiducial from an array and return the fiducial index\n"},
  {"GetNthFiducialPosition", PyvtkMRMLMarkupsFiducialNode_GetNthFiducialPosition, METH_VARARGS,
   "V.GetNthFiducialPosition(int, [float, float, float])\nC++: void GetNthFiducialPosition(int n, double pos[3])\n\nGet the position of the nth fiducial, returning it in the pos\narray\n"},
  {"SetNthFiducialPosition", PyvtkMRMLMarkupsFiducialNode_SetNthFiducialPosition, METH_VARARGS,
   "V.SetNthFiducialPosition(int, float, float, float)\nC++: void SetNthFiducialPosition(int n, double x, double y,\n    double z)\n\nSet the position of the nth fiducial from x, y, z coordinates\n"},
  {"SetNthFiducialPositionFromArray", PyvtkMRMLMarkupsFiducialNode_SetNthFiducialPositionFromArray, METH_VARARGS,
   "V.SetNthFiducialPositionFromArray(int, [float, float, float])\nC++: void SetNthFiducialPositionFromArray(int n, double pos[3])\n\nSet the position of the nth fiducial from a double array\n"},
  {"GetNthFiducialSelected", PyvtkMRMLMarkupsFiducialNode_GetNthFiducialSelected, METH_VARARGS,
   "V.GetNthFiducialSelected(int) -> bool\nC++: bool GetNthFiducialSelected(int n=0)\n\nGet selected property on Nth fiducial\n"},
  {"SetNthFiducialSelected", PyvtkMRMLMarkupsFiducialNode_SetNthFiducialSelected, METH_VARARGS,
   "V.SetNthFiducialSelected(int, bool)\nC++: void SetNthFiducialSelected(int n, bool flag)\n\nSet selected property on Nth fiducial\n"},
  {"GetNthFiducialLocked", PyvtkMRMLMarkupsFiducialNode_GetNthFiducialLocked, METH_VARARGS,
   "V.GetNthFiducialLocked(int) -> bool\nC++: bool GetNthFiducialLocked(int n=0)\n\nGet locked property on Nth fiducial\n"},
  {"SetNthFiducialLocked", PyvtkMRMLMarkupsFiducialNode_SetNthFiducialLocked, METH_VARARGS,
   "V.SetNthFiducialLocked(int, bool)\nC++: void SetNthFiducialLocked(int n, bool flag)\n\nSet locked property on Nth fiducial\n"},
  {"GetNthFiducialVisibility", PyvtkMRMLMarkupsFiducialNode_GetNthFiducialVisibility, METH_VARARGS,
   "V.GetNthFiducialVisibility(int) -> bool\nC++: bool GetNthFiducialVisibility(int n=0)\n\nGet visibility property on Nth fiducial\n"},
  {"SetNthFiducialVisibility", PyvtkMRMLMarkupsFiducialNode_SetNthFiducialVisibility, METH_VARARGS,
   "V.SetNthFiducialVisibility(int, bool)\nC++: void SetNthFiducialVisibility(int n, bool flag)\n\nSet visibility property on Nth fiducial. If the visibility is set\nto true on the node/list as a whole, the nth fiducial visibility\nis used to determine if it is visible. If the visibility is set\nto false on the node as a whole, all fiducials are hidden but\nkeep this value for when the list as a whole is turned visible.\n\\sa vtkMRMLDisplayableNode::SetDisplayVisibility\n\\sa vtkMRMLDisplayNode::SetVisibility\n"},
  {"GetNthFiducialLabel", PyvtkMRMLMarkupsFiducialNode_GetNthFiducialLabel, METH_VARARGS,
   "V.GetNthFiducialLabel(int) -> string\nC++: std::string GetNthFiducialLabel(int n=0)\n\nGet label on nth fiducial\n"},
  {"SetNthFiducialLabel", PyvtkMRMLMarkupsFiducialNode_SetNthFiducialLabel, METH_VARARGS,
   "V.SetNthFiducialLabel(int, string)\nC++: void SetNthFiducialLabel(int n, std::string label)\n\nSet label on nth fiducial\n"},
  {"GetNthFiducialAssociatedNodeID", PyvtkMRMLMarkupsFiducialNode_GetNthFiducialAssociatedNodeID, METH_VARARGS,
   "V.GetNthFiducialAssociatedNodeID(int) -> string\nC++: std::string GetNthFiducialAssociatedNodeID(int n=0)\n\nGet associated node id on nth fiducial\n"},
  {"SetNthFiducialAssociatedNodeID", PyvtkMRMLMarkupsFiducialNode_SetNthFiducialAssociatedNodeID, METH_VARARGS,
   "V.SetNthFiducialAssociatedNodeID(int, string)\nC++: void SetNthFiducialAssociatedNodeID(int n, const char *id)\n\nSet associated node id on nth fiducial\n"},
  {"SetNthFiducialWorldCoordinates", PyvtkMRMLMarkupsFiducialNode_SetNthFiducialWorldCoordinates, METH_VARARGS,
   "V.SetNthFiducialWorldCoordinates(int, [float, float, float,\n    float])\nC++: void SetNthFiducialWorldCoordinates(int n, double coords[4])\n\nSet world coordinates on nth fiducial\n"},
  {"GetNthFiducialWorldCoordinates", PyvtkMRMLMarkupsFiducialNode_GetNthFiducialWorldCoordinates, METH_VARARGS,
   "V.GetNthFiducialWorldCoordinates(int, [float, float, float,\n    float])\nC++: void GetNthFiducialWorldCoordinates(int n, double coords[4])\n\nGet world coordinates on nth fiducial\n"},
  {"CreateDefaultDisplayNodes", PyvtkMRMLMarkupsFiducialNode_CreateDefaultDisplayNodes, METH_VARARGS,
   "V.CreateDefaultDisplayNodes()\nC++: void CreateDefaultDisplayNodes() override;\n\nCreate and observe default display node(s)\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLMarkupsFiducialNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerMarkupsModuleMRML.vtkMRMLMarkupsFiducialNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLMarkupsFiducialNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLMarkupsFiducialNode_StaticNew()
{
  return vtkMRMLMarkupsFiducialNode::New();
}

PyObject *PyvtkMRMLMarkupsFiducialNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLMarkupsFiducialNode_Type, PyvtkMRMLMarkupsFiducialNode_Methods,
    "vtkMRMLMarkupsFiducialNode",
 &PyvtkMRMLMarkupsFiducialNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMRMLMarkupsNode_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLMarkupsFiducialNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLMarkupsFiducialNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLMarkupsFiducialNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

