// python wrapper for vtkMRMLMarkupsNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkVector.h"
#include "vtkVector.h"
#include "vtkMRMLMarkupsNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLMarkupsNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLMarkupsNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLDisplayableNode_ClassNew
extern "C" { PyObject *PyvtkMRMLDisplayableNode_ClassNew(); }
#define DECLARED_PyvtkMRMLDisplayableNode_ClassNew
#endif

static const char *PyvtkMRMLMarkupsNode_Doc =
  "vtkMRMLMarkupsNode - no description provided.\n\n"
  "Superclass: vtkMRMLDisplayableNode\n\n"
;


static PyObject *
PyvtkMRMLMarkupsNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLMarkupsNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLMarkupsNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLMarkupsNode *tempr = vtkMRMLMarkupsNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLMarkupsNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLMarkupsNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLMarkupsNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLMarkupsNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetIcon(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIcon");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetIcon() :
      op->vtkMRMLMarkupsNode::GetIcon());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLMarkupsNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLMarkupsNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_WriteCLI(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteCLI");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  std::vector<std::string> temp0(ap.GetArgSize(0));
  std::string temp1;
  int temp2 = 0;
  int temp3 = 1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 4) &&
      ap.GetArray(temp0.data(), temp0.size()) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)))
  {
    if (ap.IsBound())
    {
      op->WriteCLI(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkMRMLMarkupsNode::WriteCLI(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      PyObject *vec = (temp0.size() == 0 ?
        PyTuple_New(0) :
        vtkPythonArgs::BuildTuple(temp0.data(), temp0.size()));
      ap.SetContents(0, vec);
      Py_DECREF(vec);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_CopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->CopyContent(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::CopyContent(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_HasCopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasCopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasCopyContent() :
      op->vtkMRMLMarkupsNode::HasCopyContent());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_ProcessMRMLEvents(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProcessMRMLEvents");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  vtkObject *temp0 = nullptr;
  unsigned long temp1;
  void  *temp2 = nullptr;
  Py_buffer pbuf2 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkObject") &&
      ap.GetValue(temp1) &&
      ap.GetBuffer(temp2, &pbuf2))
  {
    if (ap.IsBound())
    {
      op->ProcessMRMLEvents(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsNode::ProcessMRMLEvents(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf2.obj != 0)
  {
    PyBuffer_Release(&pbuf2);
  }
#endif
  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_CreateDefaultStorageNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultStorageNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLStorageNode *tempr = (ap.IsBound() ?
      op->CreateDefaultStorageNode() :
      op->vtkMRMLMarkupsNode::CreateDefaultStorageNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_CreateDefaultDisplayNodes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultDisplayNodes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CreateDefaultDisplayNodes();
    }
    else
    {
      op->vtkMRMLMarkupsNode::CreateDefaultDisplayNodes();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNumberOfMeasurements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfMeasurements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfMeasurements() :
      op->vtkMRMLMarkupsNode::GetNumberOfMeasurements());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNumberOfEnabledMeasurements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfEnabledMeasurements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfEnabledMeasurements() :
      op->vtkMRMLMarkupsNode::GetNumberOfEnabledMeasurements());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthMeasurement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthMeasurement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLMeasurement *tempr = (ap.IsBound() ?
      op->GetNthMeasurement(temp0) :
      op->vtkMRMLMarkupsNode::GetNthMeasurement(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetMeasurement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMeasurement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLMeasurement *tempr = (ap.IsBound() ?
      op->GetMeasurement(temp0) :
      op->vtkMRMLMarkupsNode::GetMeasurement(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_AddMeasurement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddMeasurement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  vtkMRMLMeasurement *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLMeasurement"))
  {
    if (ap.IsBound())
    {
      op->AddMeasurement(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::AddMeasurement(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_RemoveNthMeasurement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveNthMeasurement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RemoveNthMeasurement(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::RemoveNthMeasurement(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_ClearValueForAllMeasurements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearValueForAllMeasurements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ClearValueForAllMeasurements();
    }
    else
    {
      op->vtkMRMLMarkupsNode::ClearValueForAllMeasurements();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_UpdateAllMeasurements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateAllMeasurements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateAllMeasurements();
    }
    else
    {
      op->vtkMRMLMarkupsNode::UpdateAllMeasurements();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthMeasurement_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthMeasurement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  vtkMRMLMeasurement *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMRMLMeasurement"))
  {
    if (ap.IsBound())
    {
      op->SetNthMeasurement(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthMeasurement(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLMarkupsNode_SetNthMeasurement_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthMeasurement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  std::string temp1;
  double temp2;
  std::string temp3;
  std::string temp4 = "";
  std::string temp5 = "";
  vtkCodedEntry *temp6 = nullptr;
  vtkCodedEntry *temp7 = nullptr;
  vtkCodedEntry *temp8 = nullptr;
  vtkCodedEntry *temp9 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4, 10) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp5)) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp6, "vtkCodedEntry")) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp7, "vtkCodedEntry")) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp8, "vtkCodedEntry")) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp9, "vtkCodedEntry")))
  {
    if (ap.IsBound())
    {
      op->SetNthMeasurement(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8, temp9);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthMeasurement(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8, temp9);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLMarkupsNode_SetNthMeasurement(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkMRMLMarkupsNode_SetNthMeasurement_s1(self, args);
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
    case 9:
    case 10:
      return PyvtkMRMLMarkupsNode_SetNthMeasurement_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetNthMeasurement");
  return nullptr;
}



static PyObject *
PyvtkMRMLMarkupsNode_RemoveAllMeasurements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllMeasurements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllMeasurements();
    }
    else
    {
      op->vtkMRMLMarkupsNode::RemoveAllMeasurements();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetPositionStatusAsString(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetPositionStatusAsString");

  int temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = vtkMRMLMarkupsNode::GetPositionStatusAsString(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetPositionStatusFromString(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetPositionStatusFromString");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLMarkupsNode::GetPositionStatusFromString(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_RemoveAllControlPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllControlPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllControlPoints();
    }
    else
    {
      op->vtkMRMLMarkupsNode::RemoveAllControlPoints();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_RemoveAllMarkups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllMarkups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllMarkups();
    }
    else
    {
      op->vtkMRMLMarkupsNode::RemoveAllMarkups();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLocked() :
      op->vtkMRMLMarkupsNode::GetLocked());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLocked(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetLocked(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_LockedOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LockedOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LockedOn();
    }
    else
    {
      op->vtkMRMLMarkupsNode::LockedOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_LockedOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LockedOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LockedOff();
    }
    else
    {
      op->vtkMRMLMarkupsNode::LockedOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetMarkupsDisplayNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMarkupsDisplayNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLMarkupsDisplayNode *tempr = (ap.IsBound() ?
      op->GetMarkupsDisplayNode() :
      op->vtkMRMLMarkupsNode::GetMarkupsDisplayNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_ControlPointExists(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ControlPointExists");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->ControlPointExists(temp0) :
      op->vtkMRMLMarkupsNode::ControlPointExists(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_MarkupExists(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MarkupExists");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->MarkupExists(temp0) :
      op->vtkMRMLMarkupsNode::MarkupExists(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNumberOfControlPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfControlPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfControlPoints() :
      op->vtkMRMLMarkupsNode::GetNumberOfControlPoints());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNumberOfDefinedControlPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfDefinedControlPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfDefinedControlPoints(temp0) :
      op->vtkMRMLMarkupsNode::GetNumberOfDefinedControlPoints(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNumberOfMarkups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfMarkups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfMarkups() :
      op->vtkMRMLMarkupsNode::GetNumberOfMarkups());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNumberOfPointsInNthMarkup(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPointsInNthMarkup");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfPointsInNthMarkup(temp0) :
      op->vtkMRMLMarkupsNode::GetNumberOfPointsInNthMarkup(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_AddControlPointWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddControlPointWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  vtkVector3d *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1 = std::string();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkVector3d") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    int tempr = (ap.IsBound() ?
      op->AddControlPointWorld(*temp0, temp1) :
      op->vtkMRMLMarkupsNode::AddControlPointWorld(*temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_AddControlPoint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddControlPoint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  vtkVector3d *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1 = std::string();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkVector3d") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    int tempr = (ap.IsBound() ?
      op->AddControlPoint(*temp0, temp1) :
      op->vtkMRMLMarkupsNode::AddControlPoint(*temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointPositionVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointPositionVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkVector3d tempr = (ap.IsBound() ?
      op->GetNthControlPointPositionVector(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointPositionVector(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkVector3d");
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetMarkupPointVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMarkupPointVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkVector3d tempr = (ap.IsBound() ?
      op->GetMarkupPointVector(temp0, temp1) :
      op->vtkMRMLMarkupsNode::GetMarkupPointVector(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkVector3d");
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetMarkupPoint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMarkupPoint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  int temp1;
  const size_t size2 = 3;
  double temp2[3];
  double save2[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    vtkPythonArgs::Save(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->GetMarkupPoint(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsNode::GetMarkupPoint(temp0, temp1, temp2);
    }

    if (vtkPythonArgs::HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointPosition_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 3;
  double temp1[3];
  double save1[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetNthControlPointPosition(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::GetNthControlPointPosition(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointPosition_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetNthControlPointPosition(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointPosition(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointPosition(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkMRMLMarkupsNode_GetNthControlPointPosition_s1(self, args);
    case 1:
      return PyvtkMRMLMarkupsNode_GetNthControlPointPosition_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetNthControlPointPosition");
  return nullptr;
}



static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointPositionWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointPositionWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 3;
  double temp1[3];
  double save1[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    int tempr = (ap.IsBound() ?
      op->GetNthControlPointPositionWorld(temp0, temp1) :
      op->vtkMRMLMarkupsNode::GetNthControlPointPositionWorld(temp0, temp1));

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointPositionStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointPositionStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNthControlPointPositionStatus(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointPositionStatus(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointIndexByPositionStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointIndexByPositionStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->GetNthControlPointIndexByPositionStatus(temp0, temp1) :
      op->vtkMRMLMarkupsNode::GetNthControlPointIndexByPositionStatus(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_UnsetNthControlPointPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UnsetNthControlPointPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->UnsetNthControlPointPosition(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::UnsetNthControlPointPosition(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_RemoveNthControlPoint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveNthControlPoint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RemoveNthControlPoint(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::RemoveNthControlPoint(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_RemoveMarkup(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveMarkup");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RemoveMarkup(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::RemoveMarkup(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_InsertControlPointWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InsertControlPointWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  vtkVector3d *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2 = std::string();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkVector3d") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    bool tempr = (ap.IsBound() ?
      op->InsertControlPointWorld(temp0, *temp1, temp2) :
      op->vtkMRMLMarkupsNode::InsertControlPointWorld(temp0, *temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj1);

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_InsertControlPoint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InsertControlPoint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  vtkVector3d *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2 = std::string();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkVector3d") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    bool tempr = (ap.IsBound() ?
      op->InsertControlPoint(temp0, *temp1, temp2) :
      op->vtkMRMLMarkupsNode::InsertControlPoint(temp0, *temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj1);

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SwapControlPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SwapControlPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SwapControlPoints(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SwapControlPoints(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointPositionFromPointer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointPositionFromPointer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(size1);
  double *temp1 = store1.Data();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointPositionFromPointer(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointPositionFromPointer(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointPositionFromArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointPositionFromArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 3;
  double temp1[3];
  int temp2 = vtkMRMLMarkupsNode::PositionDefined;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointPositionFromArray(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointPositionFromArray(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  double temp1;
  double temp2;
  double temp3;
  int temp4 = vtkMRMLMarkupsNode::PositionDefined;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointPosition(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointPosition(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointPositionWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointPositionWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointPositionWorld(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointPositionWorld(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointPositionWorldFromArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointPositionWorldFromArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 3;
  double temp1[3];
  int temp2 = vtkMRMLMarkupsNode::PositionDefined;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointPositionWorldFromArray(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointPositionWorldFromArray(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointPositionOrientationWorldFromArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointPositionOrientationWorldFromArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 3;
  double temp1[3];
  const size_t size2 = 9;
  double temp2[9];
  const char *temp3 = nullptr;
  int temp4 = vtkMRMLMarkupsNode::PositionDefined;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointPositionOrientationWorldFromArray(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointPositionOrientationWorldFromArray(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCenterPositionVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCenterPositionVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkVector3d tempr = (ap.IsBound() ?
      op->GetCenterPositionVector() :
      op->vtkMRMLMarkupsNode::GetCenterPositionVector());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkVector3d");
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCenterPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCenterPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetCenterPosition(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::GetCenterPosition(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCenterPositionWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCenterPositionWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    int tempr = (ap.IsBound() ?
      op->GetCenterPositionWorld(temp0) :
      op->vtkMRMLMarkupsNode::GetCenterPositionWorld(temp0));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetCenterPositionFromPointer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCenterPositionFromPointer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(size0);
  double *temp0 = store0.Data();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetCenterPositionFromPointer(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetCenterPositionFromPointer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetCenterPositionFromArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCenterPositionFromArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetCenterPositionFromArray(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetCenterPositionFromArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetCenterPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCenterPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetCenterPosition(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetCenterPosition(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetCenterPositionWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCenterPositionWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetCenterPositionWorld(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetCenterPositionWorld(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointOrientationFromPointer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointOrientationFromPointer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(size1);
  double *temp1 = store1.Data();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointOrientationFromPointer(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointOrientationFromPointer(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointOrientationFromArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointOrientationFromArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 4;
  double temp1[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointOrientationFromArray(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointOrientationFromArray(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointOrientation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointOrientation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  double temp1;
  double temp2;
  double temp3;
  double temp4;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointOrientation(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointOrientation(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointOrientation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointOrientation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 4;
  double temp1[4];
  double save1[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetNthControlPointOrientation(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::GetNthControlPointOrientation(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointOrientationMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointOrientationMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetNthControlPointOrientationMatrix(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointOrientationMatrix(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointOrientationMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointOrientationMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 9;
  double temp1[9];
  double save1[9];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetNthControlPointOrientationMatrix(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointOrientationMatrix(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointOrientationMatrixWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointOrientationMatrixWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 9;
  double temp1[9];
  double save1[9];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetNthControlPointOrientationMatrixWorld(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointOrientationMatrixWorld(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointNormal(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointNormal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetNthControlPointNormal(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointNormal(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointNormalWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointNormalWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  const size_t size1 = 3;
  double temp1[3];
  double save1[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetNthControlPointNormalWorld(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::GetNthControlPointNormalWorld(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointOrientationVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointOrientationVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkVector4d tempr = (ap.IsBound() ?
      op->GetNthControlPointOrientationVector(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointOrientationVector(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkVector4d");
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointAssociatedNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointAssociatedNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNthControlPointAssociatedNodeID(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointAssociatedNodeID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointAssociatedNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointAssociatedNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointAssociatedNodeID(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointAssociatedNodeID(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthMarkupAssociatedNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthMarkupAssociatedNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNthMarkupAssociatedNodeID(temp0) :
      op->vtkMRMLMarkupsNode::GetNthMarkupAssociatedNodeID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthMarkupAssociatedNodeID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthMarkupAssociatedNodeID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthMarkupAssociatedNodeID(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthMarkupAssociatedNodeID(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNthControlPointID(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthMarkupID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthMarkupID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNthMarkupID(temp0) :
      op->vtkMRMLMarkupsNode::GetNthMarkupID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointIndexByID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointIndexByID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNthControlPointIndexByID(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointIndexByID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    bool tempr = (ap.IsBound() ?
      op->GetNthControlPointSelected(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointSelected(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointSelected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointSelected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointSelected(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointSelected(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    bool tempr = (ap.IsBound() ?
      op->GetNthControlPointLocked(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointLocked(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointLocked(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointLocked(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthMarkupLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthMarkupLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    bool tempr = (ap.IsBound() ?
      op->GetNthMarkupLocked(temp0) :
      op->vtkMRMLMarkupsNode::GetNthMarkupLocked(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthMarkupLocked(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthMarkupLocked");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthMarkupLocked(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthMarkupLocked(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    bool tempr = (ap.IsBound() ?
      op->GetNthControlPointVisibility(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointVisibility(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  bool temp1 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointVisibility(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointVisibility(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNthControlPointLabel(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointLabel(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointLabel(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointLabel(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthMarkupLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthMarkupLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNthMarkupLabel(temp0) :
      op->vtkMRMLMarkupsNode::GetNthMarkupLabel(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthMarkupLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthMarkupLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthMarkupLabel(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthMarkupLabel(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetNthControlPointDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNthControlPointDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNthControlPointDescription(temp0) :
      op->vtkMRMLMarkupsNode::GetNthControlPointDescription(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetNthControlPointDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNthControlPointDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetNthControlPointDescription(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetNthControlPointDescription(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_CanApplyNonLinearTransforms(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CanApplyNonLinearTransforms");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->CanApplyNonLinearTransforms() :
      op->vtkMRMLMarkupsNode::CanApplyNonLinearTransforms());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_ApplyTransform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ApplyTransform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  vtkAbstractTransform *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAbstractTransform"))
  {
    if (ap.IsBound())
    {
      op->ApplyTransform(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::ApplyTransform(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetMarkupLabelFormat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMarkupLabelFormat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetMarkupLabelFormat() :
      op->vtkMRMLMarkupsNode::GetMarkupLabelFormat());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetMarkupLabelFormat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMarkupLabelFormat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMarkupLabelFormat(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetMarkupLabelFormat(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_ReplaceListNameInMarkupLabelFormat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReplaceListNameInMarkupLabelFormat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->ReplaceListNameInMarkupLabelFormat() :
      op->vtkMRMLMarkupsNode::ReplaceListNameInMarkupLabelFormat());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetModifiedSinceRead(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModifiedSinceRead");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetModifiedSinceRead() :
      op->vtkMRMLMarkupsNode::GetModifiedSinceRead());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_ResetNthControlPointID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResetNthControlPointID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->ResetNthControlPointID(temp0) :
      op->vtkMRMLMarkupsNode::ResetNthControlPointID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetRequiredNumberOfControlPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRequiredNumberOfControlPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRequiredNumberOfControlPoints() :
      op->vtkMRMLMarkupsNode::GetRequiredNumberOfControlPoints());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetMaximumNumberOfControlPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumNumberOfControlPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaximumNumberOfControlPoints() :
      op->vtkMRMLMarkupsNode::GetMaximumNumberOfControlPoints());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_ConvertOrientationMatrixToWXYZ(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "ConvertOrientationMatrixToWXYZ");

  const size_t size0 = 9;
  double temp0[9];
  const size_t size1 = 4;
  double temp1[4];
  double save1[4];
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    vtkMRMLMarkupsNode::ConvertOrientationMatrixToWXYZ(temp0, temp1);

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_ConvertOrientationWXYZToMatrix(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "ConvertOrientationWXYZToMatrix");

  const size_t size0 = 4;
  double temp0[4];
  double save0[4];
  const size_t size1 = 9;
  double temp1[9];
  double save1[9];
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp0, save0, size0);
    vtkPythonArgs::Save(temp1, save1, size1);

    vtkMRMLMarkupsNode::ConvertOrientationWXYZToMatrix(temp0, temp1);

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetControlPointLabels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetControlPointLabels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  vtkStringArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkStringArray"))
  {
    if (ap.IsBound())
    {
      op->GetControlPointLabels(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::GetControlPointLabels(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCurvePoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurvePoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPoints *tempr = (ap.IsBound() ?
      op->GetCurvePoints() :
      op->vtkMRMLMarkupsNode::GetCurvePoints());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCurvePointsWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurvePointsWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPoints *tempr = (ap.IsBound() ?
      op->GetCurvePointsWorld() :
      op->vtkMRMLMarkupsNode::GetCurvePointsWorld());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCurve(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurve");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPolyData *tempr = (ap.IsBound() ?
      op->GetCurve() :
      op->vtkMRMLMarkupsNode::GetCurve());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCurveWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurveWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPolyData *tempr = (ap.IsBound() ?
      op->GetCurveWorld() :
      op->vtkMRMLMarkupsNode::GetCurveWorld());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCurveWorldConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurveWorldConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkAlgorithmOutput *tempr = (ap.IsBound() ?
      op->GetCurveWorldConnection() :
      op->vtkMRMLMarkupsNode::GetCurveWorldConnection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCurveClosed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurveClosed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetCurveClosed() :
      op->vtkMRMLMarkupsNode::GetCurveClosed());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetControlPointIndexFromInterpolatedPointIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetControlPointIndexFromInterpolatedPointIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetControlPointIndexFromInterpolatedPointIndex(temp0) :
      op->vtkMRMLMarkupsNode::GetControlPointIndexFromInterpolatedPointIndex(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetCurveGenerator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurveGenerator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkCurveGenerator *tempr = (ap.IsBound() ?
      op->GetCurveGenerator() :
      op->vtkMRMLMarkupsNode::GetCurveGenerator());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetRASBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRASBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const size_t size0 = 6;
  double temp0[6];
  double save0[6];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetRASBounds(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::GetRASBounds(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const size_t size0 = 6;
  double temp0[6];
  double save0[6];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetBounds(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::GetBounds(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetClosestControlPointIndexToPositionWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClosestControlPointIndexToPositionWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    int tempr = (ap.IsBound() ?
      op->GetClosestControlPointIndexToPositionWorld(temp0) :
      op->vtkMRMLMarkupsNode::GetClosestControlPointIndexToPositionWorld(temp0));

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_SetControlPointPositionsWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetControlPointPositionsWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  vtkPoints *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPoints"))
  {
    if (ap.IsBound())
    {
      op->SetControlPointPositionsWorld(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::SetControlPointPositionsWorld(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetControlPointPositionsWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetControlPointPositionsWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  vtkPoints *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPoints"))
  {
    if (ap.IsBound())
    {
      op->GetControlPointPositionsWorld(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsNode::GetControlPointPositionsWorld(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetInteractionHandleToWorldMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInteractionHandleToWorldMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetInteractionHandleToWorldMatrix() :
      op->vtkMRMLMarkupsNode::GetInteractionHandleToWorldMatrix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetPropertiesLabelText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPropertiesLabelText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetPropertiesLabelText() :
      op->vtkMRMLMarkupsNode::GetPropertiesLabelText());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_GetUnitNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnitNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkMRMLUnitNode *tempr = (ap.IsBound() ?
      op->GetUnitNode(temp0) :
      op->vtkMRMLMarkupsNode::GetUnitNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsNode_UpdateAssignedAttribute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateAssignedAttribute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsNode *op = static_cast<vtkMRMLMarkupsNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateAssignedAttribute();
    }
    else
    {
      op->vtkMRMLMarkupsNode::UpdateAssignedAttribute();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLMarkupsNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLMarkupsNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLMarkupsNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLMarkupsNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLMarkupsNode\nC++: static vtkMRMLMarkupsNode *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLMarkupsNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLMarkupsNode\nC++: vtkMRMLMarkupsNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLMarkupsNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLMarkupsNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetIcon", PyvtkMRMLMarkupsNode_GetIcon, METH_VARARGS,
   "V.GetIcon() -> string\nC++: virtual const char *GetIcon()\n\n"},
  {"CreateNodeInstance", PyvtkMRMLMarkupsNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\nMRMLNode methods\n"},
  {"GetNodeTagName", PyvtkMRMLMarkupsNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"WriteCLI", PyvtkMRMLMarkupsNode_WriteCLI, METH_VARARGS,
   "V.WriteCLI(Stvector_ISt6stringE, string, int, int)\nC++: void WriteCLI(std::vector<std::string> &commandLine,\n    std::string prefix, int coordinateSystem=0,\n    int multipleFlag=1) override;\n\nWrite this node's information to a vector of strings for passing\nto a CLI, precede each datum with the prefix if not an empty\nstring coordinateSystemFlag = 0 for RAS, 1 for LPS multipleFlag =\n1 for the whole list, 1 for the first selected control point\n"},
  {"CopyContent", PyvtkMRMLMarkupsNode_CopyContent, METH_VARARGS,
   "V.CopyContent(vtkMRMLNode, bool)\nC++: void CopyContent(vtkMRMLNode *node, bool deepCopy=true)\n    override;\n\nCopy node content (excludes basic data, such as name and node\nreferences).\n\\sa vtkMRMLNode::CopyContent\n"},
  {"HasCopyContent", PyvtkMRMLMarkupsNode_HasCopyContent, METH_VARARGS,
   "V.HasCopyContent() -> bool\nC++: bool HasCopyContent() override;\n\nReturns true if the class supports deep and shallow copying node\n    content.\n"},
  {"ProcessMRMLEvents", PyvtkMRMLMarkupsNode_ProcessMRMLEvents, METH_VARARGS,
   "V.ProcessMRMLEvents(vtkObject, int, void)\nC++: void ProcessMRMLEvents(vtkObject *, unsigned long, void *)\n    override;\n\nAlternative method to propagate events generated in Display nodes\n"},
  {"CreateDefaultStorageNode", PyvtkMRMLMarkupsNode_CreateDefaultStorageNode, METH_VARARGS,
   "V.CreateDefaultStorageNode() -> vtkMRMLStorageNode\nC++: vtkMRMLStorageNode *CreateDefaultStorageNode() override;\n\nCreate default storage node or nullptr if does not have one\n"},
  {"CreateDefaultDisplayNodes", PyvtkMRMLMarkupsNode_CreateDefaultDisplayNodes, METH_VARARGS,
   "V.CreateDefaultDisplayNodes()\nC++: void CreateDefaultDisplayNodes() override;\n\nCreate and observe default display node(s)\n"},
  {"GetNumberOfMeasurements", PyvtkMRMLMarkupsNode_GetNumberOfMeasurements, METH_VARARGS,
   "V.GetNumberOfMeasurements() -> int\nC++: int GetNumberOfMeasurements()\n\nGet measurement data, such as length, angle, diameter,\ncross-section area. Add/remove/clear measurements.\n"},
  {"GetNumberOfEnabledMeasurements", PyvtkMRMLMarkupsNode_GetNumberOfEnabledMeasurements, METH_VARARGS,
   "V.GetNumberOfEnabledMeasurements() -> int\nC++: int GetNumberOfEnabledMeasurements()\n\nGet measurement data, such as length, angle, diameter,\ncross-section area. Add/remove/clear measurements.\n"},
  {"GetNthMeasurement", PyvtkMRMLMarkupsNode_GetNthMeasurement, METH_VARARGS,
   "V.GetNthMeasurement(int) -> vtkMRMLMeasurement\nC++: vtkMRMLMeasurement *GetNthMeasurement(int id)\n\nGet measurement data, such as length, angle, diameter,\ncross-section area. Add/remove/clear measurements.\n"},
  {"GetMeasurement", PyvtkMRMLMarkupsNode_GetMeasurement, METH_VARARGS,
   "V.GetMeasurement(string) -> vtkMRMLMeasurement\nC++: vtkMRMLMeasurement *GetMeasurement(const char *name)\n\nGet measurement data, such as length, angle, diameter,\ncross-section area. Add/remove/clear measurements.\n"},
  {"AddMeasurement", PyvtkMRMLMarkupsNode_AddMeasurement, METH_VARARGS,
   "V.AddMeasurement(vtkMRMLMeasurement)\nC++: void AddMeasurement(vtkMRMLMeasurement *measurement)\n\nGet measurement data, such as length, angle, diameter,\ncross-section area. Add/remove/clear measurements.\n"},
  {"RemoveNthMeasurement", PyvtkMRMLMarkupsNode_RemoveNthMeasurement, METH_VARARGS,
   "V.RemoveNthMeasurement(int)\nC++: void RemoveNthMeasurement(int id)\n\nGet measurement data, such as length, angle, diameter,\ncross-section area. Add/remove/clear measurements.\n"},
  {"ClearValueForAllMeasurements", PyvtkMRMLMarkupsNode_ClearValueForAllMeasurements, METH_VARARGS,
   "V.ClearValueForAllMeasurements()\nC++: void ClearValueForAllMeasurements()\n\nGet measurement data, such as length, angle, diameter,\ncross-section area. Add/remove/clear measurements.\n"},
  {"UpdateAllMeasurements", PyvtkMRMLMarkupsNode_UpdateAllMeasurements, METH_VARARGS,
   "V.UpdateAllMeasurements()\nC++: void UpdateAllMeasurements()\n\nUpdate all measurements. It should not be necessary for users to\ncall this method.\n"},
  {"SetNthMeasurement", PyvtkMRMLMarkupsNode_SetNthMeasurement, METH_VARARGS,
   "V.SetNthMeasurement(int, vtkMRMLMeasurement)\nC++: void SetNthMeasurement(int id,\n    vtkMRMLMeasurement *measurement)\nV.SetNthMeasurement(int, string, float, string, string, string,\n    vtkCodedEntry, vtkCodedEntry, vtkCodedEntry, vtkCodedEntry)\nC++: void SetNthMeasurement(int id, const std::string &name,\n    double value, const std::string &units,\n    std::string printFormat=\"\",\n    const std::string description=\"\",\n    vtkCodedEntry *quantityCode=nullptr,\n    vtkCodedEntry *derivationCode=nullptr,\n    vtkCodedEntry *unitsCode=nullptr,\n    vtkCodedEntry *methodCode=nullptr)\n\nSet measurement data, such as length, angle, diameter,\ncross-section area.\n\nIMPORTANT: These functions should not be used any more. Setting\nmeasurements now happens in the \\sa UpdateMeasurementsInternal\nfunctions by calling Compute on the measurements. Similarly,\nRemoveAllMeasurements should not be called to clear the values,\nbecause the measurements are not set externally but added\ninternally in the constructors and only updated (Compute called)\nas needed.\n"},
  {"RemoveAllMeasurements", PyvtkMRMLMarkupsNode_RemoveAllMeasurements, METH_VARARGS,
   "V.RemoveAllMeasurements()\nC++: void RemoveAllMeasurements()\n\nSet measurement data, such as length, angle, diameter,\ncross-section area.\n\nIMPORTANT: These functions should not be used any more. Setting\nmeasurements now happens in the \\sa UpdateMeasurementsInternal\nfunctions by calling Compute on the measurements. Similarly,\nRemoveAllMeasurements should not be called to clear the values,\nbecause the measurements are not set externally but added\ninternally in the constructors and only updated (Compute called)\nas needed.\n"},
  {"GetPositionStatusAsString", PyvtkMRMLMarkupsNode_GetPositionStatusAsString, METH_VARARGS,
   "V.GetPositionStatusAsString(int) -> string\nC++: static const char *GetPositionStatusAsString(int id)\n\n"},
  {"GetPositionStatusFromString", PyvtkMRMLMarkupsNode_GetPositionStatusFromString, METH_VARARGS,
   "V.GetPositionStatusFromString(string) -> int\nC++: static int GetPositionStatusFromString(const char *name)\n\n"},
  {"RemoveAllControlPoints", PyvtkMRMLMarkupsNode_RemoveAllControlPoints, METH_VARARGS,
   "V.RemoveAllControlPoints()\nC++: virtual void RemoveAllControlPoints()\n\nClear out the node of all control points\n"},
  {"RemoveAllMarkups", PyvtkMRMLMarkupsNode_RemoveAllMarkups, METH_VARARGS,
   "V.RemoveAllMarkups()\nC++: void RemoveAllMarkups()\n\n\\deprecated Use RemoveAllControlPoints instead.\n"},
  {"GetLocked", PyvtkMRMLMarkupsNode_GetLocked, METH_VARARGS,
   "V.GetLocked() -> int\nC++: virtual int GetLocked()\n\nGet the Locked property on the markupNode/list of control points.\n"},
  {"SetLocked", PyvtkMRMLMarkupsNode_SetLocked, METH_VARARGS,
   "V.SetLocked(int)\nC++: void SetLocked(int locked)\n\nSet the Locked property on the markupNode/list of control points\nIf set to 1 then parameters should not be changed, and dragging\nthe control points is disabled in 2d and 3d. Overrides the Locked\nflag on individual control points in that when the node is set to\nbe locked, all the control points in the list are locked. When\nthe node is unlocked, use the locked flag on the individual\ncontrol points to determine their locked state.\n"},
  {"LockedOn", PyvtkMRMLMarkupsNode_LockedOn, METH_VARARGS,
   "V.LockedOn()\nC++: virtual void LockedOn()\n\nGet/Set the Locked property on the markupNode. If set to 1 then\nparameters should not be changed\n"},
  {"LockedOff", PyvtkMRMLMarkupsNode_LockedOff, METH_VARARGS,
   "V.LockedOff()\nC++: virtual void LockedOff()\n\n"},
  {"GetMarkupsDisplayNode", PyvtkMRMLMarkupsNode_GetMarkupsDisplayNode, METH_VARARGS,
   "V.GetMarkupsDisplayNode() -> vtkMRMLMarkupsDisplayNode\nC++: vtkMRMLMarkupsDisplayNode *GetMarkupsDisplayNode()\n\nReturn a cast display node, returns null if none\n"},
  {"ControlPointExists", PyvtkMRMLMarkupsNode_ControlPointExists, METH_VARARGS,
   "V.ControlPointExists(int) -> bool\nC++: bool ControlPointExists(int n)\n\nReturn true if n is a valid control point, false otherwise.\n"},
  {"MarkupExists", PyvtkMRMLMarkupsNode_MarkupExists, METH_VARARGS,
   "V.MarkupExists(int) -> bool\nC++: bool MarkupExists(int n)\n\nDeprecated. Use ControlPointExists instead.\n"},
  {"GetNumberOfControlPoints", PyvtkMRMLMarkupsNode_GetNumberOfControlPoints, METH_VARARGS,
   "V.GetNumberOfControlPoints() -> int\nC++: int GetNumberOfControlPoints()\n\nReturn the number of control points that are stored in this node\n"},
  {"GetNumberOfDefinedControlPoints", PyvtkMRMLMarkupsNode_GetNumberOfDefinedControlPoints, METH_VARARGS,
   "V.GetNumberOfDefinedControlPoints(bool) -> int\nC++: int GetNumberOfDefinedControlPoints(\n    bool includePreview=false)\n\nReturn the number of control points that are already placed (not\nbeing previewed or undefined).\n"},
  {"GetNumberOfMarkups", PyvtkMRMLMarkupsNode_GetNumberOfMarkups, METH_VARARGS,
   "V.GetNumberOfMarkups() -> int\nC++: int GetNumberOfMarkups()\n\n\\deprecated Use GetNumberOfControlPoints() instead.\n"},
  {"GetNumberOfPointsInNthMarkup", PyvtkMRMLMarkupsNode_GetNumberOfPointsInNthMarkup, METH_VARARGS,
   "V.GetNumberOfPointsInNthMarkup(int) -> int\nC++: int GetNumberOfPointsInNthMarkup(int)\n\n\\deprecated Use GetNumberOfControlPoints() instead.\n"},
  {"AddControlPointWorld", PyvtkMRMLMarkupsNode_AddControlPointWorld, METH_VARARGS,
   "V.AddControlPointWorld(vtkVector3d, string) -> int\nC++: int AddControlPointWorld(vtkVector3d point,\n    std::string label=std::string())\n\nAdd a new control point, defined in the world coordinate system.\nReturn index of point index, -1 on failure.\n"},
  {"AddControlPoint", PyvtkMRMLMarkupsNode_AddControlPoint, METH_VARARGS,
   "V.AddControlPoint(vtkVector3d, string) -> int\nC++: int AddControlPoint(vtkVector3d point,\n    std::string label=std::string())\n\nAdd a new control point, returning the point index, -1 on\nfailure.\n"},
  {"GetNthControlPointPositionVector", PyvtkMRMLMarkupsNode_GetNthControlPointPositionVector, METH_VARARGS,
   "V.GetNthControlPointPositionVector(int) -> vtkVector3d\nC++: vtkVector3d GetNthControlPointPositionVector(int pointIndex)\n\nGet the position of the Nth control point returning it as a\nvtkVector3d, return (0,0,0) if not found\n"},
  {"GetMarkupPointVector", PyvtkMRMLMarkupsNode_GetMarkupPointVector, METH_VARARGS,
   "V.GetMarkupPointVector(int, int) -> vtkVector3d\nC++: vtkVector3d GetMarkupPointVector(int markupIndex, int)\n\n\\deprecated Use GetNthControlPointPositionVector() method\ninstead.\n"},
  {"GetMarkupPoint", PyvtkMRMLMarkupsNode_GetMarkupPoint, METH_VARARGS,
   "V.GetMarkupPoint(int, int, [float, float, float])\nC++: void GetMarkupPoint(int markupIndex, int pointIndex,\n    double point[3])\n\n\\deprecated Use GetNthControlPointPosition method instead.\n"},
  {"GetNthControlPointPosition", PyvtkMRMLMarkupsNode_GetNthControlPointPosition, METH_VARARGS,
   "V.GetNthControlPointPosition(int, [float, float, float])\nC++: void GetNthControlPointPosition(int pointIndex,\n    double point[3])\nV.GetNthControlPointPosition(int) -> (float, ...)\nC++: double *GetNthControlPointPosition(int pointIndex)\n\nGet the position of the Nth control point setting the elements of\npoint\n"},
  {"GetNthControlPointPositionWorld", PyvtkMRMLMarkupsNode_GetNthControlPointPositionWorld, METH_VARARGS,
   "V.GetNthControlPointPositionWorld(int, [float, float, float])\n    -> int\nC++: int GetNthControlPointPositionWorld(int pointIndex,\n    double worldxyz[3])\n\nGet the position of the Nth control point in World coordinate\nsystem Returns 0 on failure, 1 on success.\n"},
  {"GetNthControlPointPositionStatus", PyvtkMRMLMarkupsNode_GetNthControlPointPositionStatus, METH_VARARGS,
   "V.GetNthControlPointPositionStatus(int) -> int\nC++: int GetNthControlPointPositionStatus(int pointIndex)\n\nGet control point position status (PositionUndefined,\nPositionPreview, PositionDefined)\n"},
  {"GetNthControlPointIndexByPositionStatus", PyvtkMRMLMarkupsNode_GetNthControlPointIndexByPositionStatus, METH_VARARGS,
   "V.GetNthControlPointIndexByPositionStatus(int, int) -> int\nC++: int GetNthControlPointIndexByPositionStatus(int pointIndex,\n    int positionStatus)\n\nGet index of N-th control point of the specified status. (for\nexample, get index of N-th placed control point). pointIndex is\nzero-based, so to get index of the first control point, use\npointIndex=0. Return -1 if no such control point is found.\n"},
  {"UnsetNthControlPointPosition", PyvtkMRMLMarkupsNode_UnsetNthControlPointPosition, METH_VARARGS,
   "V.UnsetNthControlPointPosition(int)\nC++: void UnsetNthControlPointPosition(int pointIndex)\n\nSet control point status to undefined.\n"},
  {"RemoveNthControlPoint", PyvtkMRMLMarkupsNode_RemoveNthControlPoint, METH_VARARGS,
   "V.RemoveNthControlPoint(int)\nC++: void RemoveNthControlPoint(int pointIndex)\n\nRemove Nth Control Point\n"},
  {"RemoveMarkup", PyvtkMRMLMarkupsNode_RemoveMarkup, METH_VARARGS,
   "V.RemoveMarkup(int)\nC++: void RemoveMarkup(int pointIndex)\n\n\\deprecated Use RemoveNthControlPoint instead.\n"},
  {"InsertControlPointWorld", PyvtkMRMLMarkupsNode_InsertControlPointWorld, METH_VARARGS,
   "V.InsertControlPointWorld(int, vtkVector3d, string) -> bool\nC++: bool InsertControlPointWorld(int n, vtkVector3d pointWorld,\n    std::string label=std::string())\n\n"},
  {"InsertControlPoint", PyvtkMRMLMarkupsNode_InsertControlPoint, METH_VARARGS,
   "V.InsertControlPoint(int, vtkVector3d, string) -> bool\nC++: bool InsertControlPoint(int n, vtkVector3d point,\n    std::string label=std::string())\n\n"},
  {"SwapControlPoints", PyvtkMRMLMarkupsNode_SwapControlPoints, METH_VARARGS,
   "V.SwapControlPoints(int, int)\nC++: void SwapControlPoints(int m1, int m2)\n\nSwap the position of two control points\n"},
  {"SetNthControlPointPositionFromPointer", PyvtkMRMLMarkupsNode_SetNthControlPointPositionFromPointer, METH_VARARGS,
   "V.SetNthControlPointPositionFromPointer(int, (float, ...))\nC++: void SetNthControlPointPositionFromPointer(\n    const int pointIndex, const double *pos)\n\nSet of the Nth control point position from a pointer to an array\n\\sa SetNthControlPointPosition\n"},
  {"SetNthControlPointPositionFromArray", PyvtkMRMLMarkupsNode_SetNthControlPointPositionFromArray, METH_VARARGS,
   "V.SetNthControlPointPositionFromArray(int, (float, float, float),\n    int)\nC++: void SetNthControlPointPositionFromArray(\n    const int pointIndex, const double pos[3],\n    int positionStatus=PositionDefined)\n\nSet of the Nth control point position from an array\n\\sa SetNthControlPointPosition\n"},
  {"SetNthControlPointPosition", PyvtkMRMLMarkupsNode_SetNthControlPointPosition, METH_VARARGS,
   "V.SetNthControlPointPosition(int, float, float, float, int)\nC++: void SetNthControlPointPosition(const int pointIndex,\n    const double x, const double y, const double z,\n    int positionStatus=PositionDefined)\n\nSet of the Nth control point position from coordinates\n\\sa SetNthControlPointPositionFromPointer,\n    SetNthControlPointPositionFromArray\n"},
  {"SetNthControlPointPositionWorld", PyvtkMRMLMarkupsNode_SetNthControlPointPositionWorld, METH_VARARGS,
   "V.SetNthControlPointPositionWorld(int, float, float, float)\nC++: void SetNthControlPointPositionWorld(const int pointIndex,\n    const double x, const double y, const double z)\n\nSet of the Nth control point position using World coordinate\nsystem Calls SetNthControlPointPosition after transforming the\npassed in coordinate\n\\sa SetNthControlPointPosition\n"},
  {"SetNthControlPointPositionWorldFromArray", PyvtkMRMLMarkupsNode_SetNthControlPointPositionWorldFromArray, METH_VARARGS,
   "V.SetNthControlPointPositionWorldFromArray(int, (float, float,\n    float), int)\nC++: void SetNthControlPointPositionWorldFromArray(\n    const int pointIndex, const double pos[3],\n    int positionStatus=PositionDefined)\n\nSet of the Nth control point position from an array using World\ncoordinate system\n\\sa SetNthControlPointPosition\n"},
  {"SetNthControlPointPositionOrientationWorldFromArray", PyvtkMRMLMarkupsNode_SetNthControlPointPositionOrientationWorldFromArray, METH_VARARGS,
   "V.SetNthControlPointPositionOrientationWorldFromArray(int, (float,\n     float, float), (float, float, float, float, float, float,\n    float, float, float), string, int)\nC++: void SetNthControlPointPositionOrientationWorldFromArray(\n    const int pointIndex, const double pos[3],\n    const double orientationMatrix[9],\n    const char *associatedNodeID,\n    int positionStatus=PositionDefined)\n\nSet of the Nth control point position and orientation from an\narray using World coordinate system.\n\\sa SetNthControlPointPosition\n"},
  {"GetCenterPositionVector", PyvtkMRMLMarkupsNode_GetCenterPositionVector, METH_VARARGS,
   "V.GetCenterPositionVector() -> vtkVector3d\nC++: vtkVector3d GetCenterPositionVector()\n\nGet the position of the center returning it as a vtkVector3d,\nreturn (0,0,0) if not found\n"},
  {"GetCenterPosition", PyvtkMRMLMarkupsNode_GetCenterPosition, METH_VARARGS,
   "V.GetCenterPosition([float, float, float])\nC++: void GetCenterPosition(double point[3])\n\nGet the position of the center setting the elements of point\n"},
  {"GetCenterPositionWorld", PyvtkMRMLMarkupsNode_GetCenterPositionWorld, METH_VARARGS,
   "V.GetCenterPositionWorld([float, float, float]) -> int\nC++: int GetCenterPositionWorld(double worldxyz[3])\n\nGet the position of the center in World coordinate system Returns\n0 on failure, 1 on success.\n"},
  {"SetCenterPositionFromPointer", PyvtkMRMLMarkupsNode_SetCenterPositionFromPointer, METH_VARARGS,
   "V.SetCenterPositionFromPointer((float, ...))\nC++: void SetCenterPositionFromPointer(const double *pos)\n\nSet the center position from a pointer to an array\n\\sa SetCenterPosition\n"},
  {"SetCenterPositionFromArray", PyvtkMRMLMarkupsNode_SetCenterPositionFromArray, METH_VARARGS,
   "V.SetCenterPositionFromArray((float, float, float))\nC++: void SetCenterPositionFromArray(const double pos[3])\n\nSet the center position position from an array\n\\sa SetCenterPosition\n"},
  {"SetCenterPosition", PyvtkMRMLMarkupsNode_SetCenterPosition, METH_VARARGS,
   "V.SetCenterPosition(float, float, float)\nC++: void SetCenterPosition(const double x, const double y,\n    const double z)\n\nSet the center position position from coordinates\n\\sa SetCenterPositionFromPointer, SetCenterPositionFromArray\n"},
  {"SetCenterPositionWorld", PyvtkMRMLMarkupsNode_SetCenterPositionWorld, METH_VARARGS,
   "V.SetCenterPositionWorld(float, float, float)\nC++: void SetCenterPositionWorld(const double x, const double y,\n    const double z)\n\nSet the center position position using World coordinate system\nCalls SetCenterPosition after transforming the passed in\ncoordinate\n\\sa SetCenterPosition\n"},
  {"SetNthControlPointOrientationFromPointer", PyvtkMRMLMarkupsNode_SetNthControlPointOrientationFromPointer, METH_VARARGS,
   "V.SetNthControlPointOrientationFromPointer(int, (float, ...))\nC++: void SetNthControlPointOrientationFromPointer(int n,\n    const double *orientationWXYZ)\n\nSet the orientation for the Nth control point from a pointer to a\ndouble array WXYZ\n"},
  {"SetNthControlPointOrientationFromArray", PyvtkMRMLMarkupsNode_SetNthControlPointOrientationFromArray, METH_VARARGS,
   "V.SetNthControlPointOrientationFromArray(int, (float, float,\n    float, float))\nC++: void SetNthControlPointOrientationFromArray(int n,\n    const double orientationWXYZ[4])\n\nSet the orientation for the Nth control point from a double array\nWXYZ\n"},
  {"SetNthControlPointOrientation", PyvtkMRMLMarkupsNode_SetNthControlPointOrientation, METH_VARARGS,
   "V.SetNthControlPointOrientation(int, float, float, float, float)\nC++: void SetNthControlPointOrientation(int n, double w, double x,\n     double y, double z)\n\nSet the orientation for the Nth control point from passed\nparameters\n"},
  {"GetNthControlPointOrientation", PyvtkMRMLMarkupsNode_GetNthControlPointOrientation, METH_VARARGS,
   "V.GetNthControlPointOrientation(int, [float, float, float, float])\nC++: void GetNthControlPointOrientation(int n,\n    double orientationWXYZ[4])\n\nGet the WXYZ orientation for the Nth control point\n"},
  {"GetNthControlPointOrientationMatrix", PyvtkMRMLMarkupsNode_GetNthControlPointOrientationMatrix, METH_VARARGS,
   "V.GetNthControlPointOrientationMatrix(int) -> (float, ...)\nC++: double *GetNthControlPointOrientationMatrix(int n)\n\nGet orientation as 9 values: x, y, and z axis directions,\nrespectively.\n"},
  {"SetNthControlPointOrientationMatrix", PyvtkMRMLMarkupsNode_SetNthControlPointOrientationMatrix, METH_VARARGS,
   "V.SetNthControlPointOrientationMatrix(int, [float, float, float,\n    float, float, float, float, float, float])\nC++: void SetNthControlPointOrientationMatrix(int n,\n    double orientationMatrix[9])\n\nSet orientation as 9 values: x, y, and z axis directions,\nrespectively.\n"},
  {"SetNthControlPointOrientationMatrixWorld", PyvtkMRMLMarkupsNode_SetNthControlPointOrientationMatrixWorld, METH_VARARGS,
   "V.SetNthControlPointOrientationMatrixWorld(int, [float, float,\n    float, float, float, float, float, float, float])\nC++: void SetNthControlPointOrientationMatrixWorld(int n,\n    double orientationMatrix[9])\n\nSet orientation as 9 values: x, y, and z axis directions,\nrespectively. Important: this method just calls\nSetNthControlPointOrientationMatrix and does not convert from\nworld coordinate yet.\n"},
  {"GetNthControlPointNormal", PyvtkMRMLMarkupsNode_GetNthControlPointNormal, METH_VARARGS,
   "V.GetNthControlPointNormal(int) -> (float, ...)\nC++: double *GetNthControlPointNormal(int n)\n\nGet normal direction (orientation of z axis) in local coordinate\nsystem.\n"},
  {"GetNthControlPointNormalWorld", PyvtkMRMLMarkupsNode_GetNthControlPointNormalWorld, METH_VARARGS,
   "V.GetNthControlPointNormalWorld(int, [float, float, float])\nC++: void GetNthControlPointNormalWorld(int n,\n    double normalWorld[3])\n\nGet normal direction (orientation of z axis) in world coordinate\nsystem.\n"},
  {"GetNthControlPointOrientationVector", PyvtkMRMLMarkupsNode_GetNthControlPointOrientationVector, METH_VARARGS,
   "V.GetNthControlPointOrientationVector(int) -> vtkVector4d\nC++: vtkVector4d GetNthControlPointOrientationVector(\n    int pointIndex)\n\nGet the WXYZ orientation for the Nth control point returning it\nas a vtkVector4d, return (0,0,0,0) if not found. Note that\nvtkVector4d stores components in the order XYZW (in all other\nmethods we get/set components in WXYZ order).\n"},
  {"GetNthControlPointAssociatedNodeID", PyvtkMRMLMarkupsNode_GetNthControlPointAssociatedNodeID, METH_VARARGS,
   "V.GetNthControlPointAssociatedNodeID(int) -> string\nC++: std::string GetNthControlPointAssociatedNodeID(int n=0)\n\nGet/Set the associated node id for the Nth control point\n"},
  {"SetNthControlPointAssociatedNodeID", PyvtkMRMLMarkupsNode_SetNthControlPointAssociatedNodeID, METH_VARARGS,
   "V.SetNthControlPointAssociatedNodeID(int, string)\nC++: void SetNthControlPointAssociatedNodeID(int n,\n    std::string id)\n\n"},
  {"GetNthMarkupAssociatedNodeID", PyvtkMRMLMarkupsNode_GetNthMarkupAssociatedNodeID, METH_VARARGS,
   "V.GetNthMarkupAssociatedNodeID(int) -> string\nC++: std::string GetNthMarkupAssociatedNodeID(int n=0)\n\n\\deprecated Use GetNthControlPointAssociatedNodeID instead.\n"},
  {"SetNthMarkupAssociatedNodeID", PyvtkMRMLMarkupsNode_SetNthMarkupAssociatedNodeID, METH_VARARGS,
   "V.SetNthMarkupAssociatedNodeID(int, string)\nC++: void SetNthMarkupAssociatedNodeID(int n, std::string id)\n\n\\deprecated Use SetNthControlPointAssociatedNodeID instead.\n"},
  {"GetNthControlPointID", PyvtkMRMLMarkupsNode_GetNthControlPointID, METH_VARARGS,
   "V.GetNthControlPointID(int) -> string\nC++: std::string GetNthControlPointID(int n)\n\nGet the id for the Nth control point\n"},
  {"GetNthMarkupID", PyvtkMRMLMarkupsNode_GetNthMarkupID, METH_VARARGS,
   "V.GetNthMarkupID(int) -> string\nC++: std::string GetNthMarkupID(int n=0)\n\n\\deprecated Use GetNthControlPointID instead.\n"},
  {"GetNthControlPointIndexByID", PyvtkMRMLMarkupsNode_GetNthControlPointIndexByID, METH_VARARGS,
   "V.GetNthControlPointIndexByID(string) -> int\nC++: int GetNthControlPointIndexByID(const char *controlPointID)\n\nGet the Nth control point index based on it's ID\n"},
  {"GetNthControlPointSelected", PyvtkMRMLMarkupsNode_GetNthControlPointSelected, METH_VARARGS,
   "V.GetNthControlPointSelected(int) -> bool\nC++: bool GetNthControlPointSelected(int n=0)\n\nGet the Selected flag on the Nth control point, returns false if\ncontrol point doesn't exist\n"},
  {"SetNthControlPointSelected", PyvtkMRMLMarkupsNode_SetNthControlPointSelected, METH_VARARGS,
   "V.SetNthControlPointSelected(int, bool)\nC++: void SetNthControlPointSelected(int n, bool flag)\n\nSet the Selected flag on the Nth control point\n\\sa vtkMRMLNode::SetSelected\n"},
  {"GetNthControlPointLocked", PyvtkMRMLMarkupsNode_GetNthControlPointLocked, METH_VARARGS,
   "V.GetNthControlPointLocked(int) -> bool\nC++: bool GetNthControlPointLocked(int n=0)\n\nGet the Lock flag on the Nth control point, returns false if\ncontrol point doesn't exist\n"},
  {"SetNthControlPointLocked", PyvtkMRMLMarkupsNode_SetNthControlPointLocked, METH_VARARGS,
   "V.SetNthControlPointLocked(int, bool)\nC++: void SetNthControlPointLocked(int n, bool flag)\n\nSet Locked property on Nth control point. If locked is set to\ntrue on the node/list as a whole, the Nth control point locked\nflag is used to determine if it is locked. If the locked flag is\nset to false on the node as a whole, all control point are locked\nbut keep this value for when the list as a whole is turned\nunlocked.\n\\sa vtMRMLMarkupsNode::SetLocked\n"},
  {"GetNthMarkupLocked", PyvtkMRMLMarkupsNode_GetNthMarkupLocked, METH_VARARGS,
   "V.GetNthMarkupLocked(int) -> bool\nC++: bool GetNthMarkupLocked(int n=0)\n\n\\deprecated Use GetNthControlPointLocked instead.\n"},
  {"SetNthMarkupLocked", PyvtkMRMLMarkupsNode_SetNthMarkupLocked, METH_VARARGS,
   "V.SetNthMarkupLocked(int, bool)\nC++: void SetNthMarkupLocked(int n, bool flag)\n\n\\deprecated Use SetNthControlPointLocked instead.\n"},
  {"GetNthControlPointVisibility", PyvtkMRMLMarkupsNode_GetNthControlPointVisibility, METH_VARARGS,
   "V.GetNthControlPointVisibility(int) -> bool\nC++: bool GetNthControlPointVisibility(int n=0)\n\nGet the Visibility flag on the Nth control point, returns false\nif control point doesn't exist\n"},
  {"SetNthControlPointVisibility", PyvtkMRMLMarkupsNode_SetNthControlPointVisibility, METH_VARARGS,
   "V.SetNthControlPointVisibility(int, bool)\nC++: void SetNthControlPointVisibility(int n, bool flag)\n\nSet Visibility property on Nth control point. If the visibility\nis set to true on the node/list as a whole, the Nth control point\nvisibility is used to determine if it is visible. If the\nvisibility is set to false on the node as a whole, all control\npoints are hidden but keep this value for when the list as a\nwhole is turned visible.\n\\sa vtkMRMLDisplayableNode::SetDisplayVisibility\n\\sa vtkMRMLDisplayNode::SetVisibility\n"},
  {"GetNthControlPointLabel", PyvtkMRMLMarkupsNode_GetNthControlPointLabel, METH_VARARGS,
   "V.GetNthControlPointLabel(int) -> string\nC++: std::string GetNthControlPointLabel(int n=0)\n\nGet the Label on the Nth control point, returns false if control\npoint doesn't exist\n"},
  {"SetNthControlPointLabel", PyvtkMRMLMarkupsNode_SetNthControlPointLabel, METH_VARARGS,
   "V.SetNthControlPointLabel(int, string)\nC++: void SetNthControlPointLabel(int n, std::string label)\n\nSet the Label on the Nth control point\n"},
  {"GetNthMarkupLabel", PyvtkMRMLMarkupsNode_GetNthMarkupLabel, METH_VARARGS,
   "V.GetNthMarkupLabel(int) -> string\nC++: std::string GetNthMarkupLabel(int n=0)\n\n\\deprecated Use GetNthControlPointLabel instead.\n"},
  {"SetNthMarkupLabel", PyvtkMRMLMarkupsNode_SetNthMarkupLabel, METH_VARARGS,
   "V.SetNthMarkupLabel(int, string)\nC++: void SetNthMarkupLabel(int n, std::string label)\n\n\\deprecated Use SetNthControlPointLabel instead.\n"},
  {"GetNthControlPointDescription", PyvtkMRMLMarkupsNode_GetNthControlPointDescription, METH_VARARGS,
   "V.GetNthControlPointDescription(int) -> string\nC++: std::string GetNthControlPointDescription(int n=0)\n\nGet the Description flag on the Nth control point, returns false\nif control point doesn't exist\n"},
  {"SetNthControlPointDescription", PyvtkMRMLMarkupsNode_SetNthControlPointDescription, METH_VARARGS,
   "V.SetNthControlPointDescription(int, string)\nC++: void SetNthControlPointDescription(int n,\n    std::string description)\n\nSet the Description on the Nth control point\n"},
  {"CanApplyNonLinearTransforms", PyvtkMRMLMarkupsNode_CanApplyNonLinearTransforms, METH_VARARGS,
   "V.CanApplyNonLinearTransforms() -> bool\nC++: bool CanApplyNonLinearTransforms() override;\n\nReturns true since can apply non linear transforms\n\\sa ApplyTransform\n"},
  {"ApplyTransform", PyvtkMRMLMarkupsNode_ApplyTransform, METH_VARARGS,
   "V.ApplyTransform(vtkAbstractTransform)\nC++: void ApplyTransform(vtkAbstractTransform *transform)\n    override;\n\nApply the passed transformation to all of the control points\n\\sa CanApplyNonLinearTransforms\n"},
  {"GetMarkupLabelFormat", PyvtkMRMLMarkupsNode_GetMarkupLabelFormat, METH_VARARGS,
   "V.GetMarkupLabelFormat() -> string\nC++: std::string GetMarkupLabelFormat()\n\nGet the markup node label format string that defines the markup\nnames.\n\\sa SetMarkupLabelFormat\n"},
  {"SetMarkupLabelFormat", PyvtkMRMLMarkupsNode_SetMarkupLabelFormat, METH_VARARGS,
   "V.SetMarkupLabelFormat(string)\nC++: void SetMarkupLabelFormat(std::string format)\n\nSet the markup node label format string that defines the markup\nnames, then invoke the LabelFormatModifedEvent In standard printf\nnotation, with the addition of %N being replaced by the list\nname. %d will resolve to the highest not yet used list index\ninteger. Character strings will otherwise pass through Defaults\nto %N-%d which will yield markup names of Name-0, Name-1, Name-2\n\\sa GetMarkupLabelFormat\n"},
  {"ReplaceListNameInMarkupLabelFormat", PyvtkMRMLMarkupsNode_ReplaceListNameInMarkupLabelFormat, METH_VARARGS,
   "V.ReplaceListNameInMarkupLabelFormat() -> string\nC++: std::string ReplaceListNameInMarkupLabelFormat()\n\nIf the MarkupLabelFormat contains the string %N, return a string\nin which that has been replaced with the list name. If the list\nname is nullptr, replace it with an empty string. If the\nMarkupLabelFormat doesn't contain %N, return MarkupLabelFormat\n"},
  {"GetModifiedSinceRead", PyvtkMRMLMarkupsNode_GetModifiedSinceRead, METH_VARARGS,
   "V.GetModifiedSinceRead() -> bool\nC++: bool GetModifiedSinceRead() override;\n\nReimplemented to take into account the modified time of the\nmarkups Returns true if the node (default behavior) or the\nmarkups are modified since read/written. Note: The MTime of the\nmarkups node is used to know if it has been modified. So if you\ninvoke class specific modified events without calling Modified()\non the markups, GetModifiedSinceRead() won't return true.\n\\sa vtkMRMLStorableNode::GetModifiedSinceRead()\n"},
  {"ResetNthControlPointID", PyvtkMRMLMarkupsNode_ResetNthControlPointID, METH_VARARGS,
   "V.ResetNthControlPointID(int) -> bool\nC++: bool ResetNthControlPointID(int n)\n\nReset the id of the Nth control point according to the local\npolicy Called after an already initialised markup has been added\nto the scene. Returns false if n out of bounds, true on success.\n"},
  {"GetRequiredNumberOfControlPoints", PyvtkMRMLMarkupsNode_GetRequiredNumberOfControlPoints, METH_VARARGS,
   "V.GetRequiredNumberOfControlPoints() -> int\nC++: virtual int GetRequiredNumberOfControlPoints()\n\nReturn the number of control points that are required for\ndefining this widget. Interaction mode remains in \"place\" mode\nuntil this number is reached. If the number is set to 0 then no\nit means there is no preference (this is the default value).\n"},
  {"GetMaximumNumberOfControlPoints", PyvtkMRMLMarkupsNode_GetMaximumNumberOfControlPoints, METH_VARARGS,
   "V.GetMaximumNumberOfControlPoints() -> int\nC++: virtual int GetMaximumNumberOfControlPoints()\n\nMaximum number of control points limits the number of markups\nallowed in the node. If maximum number of control points is set\nto 0 then no it means there is no limit (this is the default\nvalue). The value is an indication to the user interface and does\nnot affect prevent adding markups to a node programmatically. If\nvalue is set to lower value than the number of markups in the\nnode, then existing markups are not deleted. 2 for line, and 3\nfor angle Markups\n"},
  {"ConvertOrientationMatrixToWXYZ", PyvtkMRMLMarkupsNode_ConvertOrientationMatrixToWXYZ, METH_VARARGS,
   "V.ConvertOrientationMatrixToWXYZ((float, float, float, float,\n    float, float, float, float, float), [float, float, float,\n    float])\nC++: static void ConvertOrientationMatrixToWXYZ(\n    const double orientationMatrix[9], double orientationWXYZ[4])\n\n"},
  {"ConvertOrientationWXYZToMatrix", PyvtkMRMLMarkupsNode_ConvertOrientationWXYZToMatrix, METH_VARARGS,
   "V.ConvertOrientationWXYZToMatrix([float, float, float, float],\n    [float, float, float, float, float, float, float, float,\n    float])\nC++: static void ConvertOrientationWXYZToMatrix(\n    double orientationWXYZ[4], double orientationMatrix[9])\n\n"},
  {"GetControlPointLabels", PyvtkMRMLMarkupsNode_GetControlPointLabels, METH_VARARGS,
   "V.GetControlPointLabels(vtkStringArray)\nC++: void GetControlPointLabels(vtkStringArray *labels)\n\n"},
  {"GetCurvePoints", PyvtkMRMLMarkupsNode_GetCurvePoints, METH_VARARGS,
   "V.GetCurvePoints() -> vtkPoints\nC++: vtkPoints *GetCurvePoints()\n\n"},
  {"GetCurvePointsWorld", PyvtkMRMLMarkupsNode_GetCurvePointsWorld, METH_VARARGS,
   "V.GetCurvePointsWorld() -> vtkPoints\nC++: vtkPoints *GetCurvePointsWorld()\n\n"},
  {"GetCurve", PyvtkMRMLMarkupsNode_GetCurve, METH_VARARGS,
   "V.GetCurve() -> vtkPolyData\nC++: vtkPolyData *GetCurve()\n\n"},
  {"GetCurveWorld", PyvtkMRMLMarkupsNode_GetCurveWorld, METH_VARARGS,
   "V.GetCurveWorld() -> vtkPolyData\nC++: vtkPolyData *GetCurveWorld()\n\n"},
  {"GetCurveWorldConnection", PyvtkMRMLMarkupsNode_GetCurveWorldConnection, METH_VARARGS,
   "V.GetCurveWorldConnection() -> vtkAlgorithmOutput\nC++: vtkAlgorithmOutput *GetCurveWorldConnection()\n\n"},
  {"GetCurveClosed", PyvtkMRMLMarkupsNode_GetCurveClosed, METH_VARARGS,
   "V.GetCurveClosed() -> bool\nC++: virtual bool GetCurveClosed()\n\n"},
  {"GetControlPointIndexFromInterpolatedPointIndex", PyvtkMRMLMarkupsNode_GetControlPointIndexFromInterpolatedPointIndex, METH_VARARGS,
   "V.GetControlPointIndexFromInterpolatedPointIndex(int) -> int\nC++: int GetControlPointIndexFromInterpolatedPointIndex(\n    vtkIdType interpolatedPointIndex)\n\n"},
  {"GetCurveGenerator", PyvtkMRMLMarkupsNode_GetCurveGenerator, METH_VARARGS,
   "V.GetCurveGenerator() -> vtkCurveGenerator\nC++: vtkCurveGenerator *GetCurveGenerator()\n\nThe internal instance of the curve generator to allow use of the\ncurve for other computations. Any custom overrides of the\ninterpolation modes are not persisted in MRML.\n"},
  {"GetRASBounds", PyvtkMRMLMarkupsNode_GetRASBounds, METH_VARARGS,
   "V.GetRASBounds([float, float, float, float, float, float])\nC++: void GetRASBounds(double bounds[6]) override;\n\nGet bounding box in global RAS form (xmin,xmax, ymin,ymax,\nzmin,zmax). This method returns the bounds of the object with any\ntransforms that may be applied to it.\n\\sa GetBounds()\n"},
  {"GetBounds", PyvtkMRMLMarkupsNode_GetBounds, METH_VARARGS,
   "V.GetBounds([float, float, float, float, float, float])\nC++: void GetBounds(double bounds[6]) override;\n\nGet bounding box in global RAS form (xmin,xmax, ymin,ymax,\nzmin,zmax). This method always returns the bounds of the\nuntransformed object.\n\\sa GetRASBounds()\n"},
  {"GetClosestControlPointIndexToPositionWorld", PyvtkMRMLMarkupsNode_GetClosestControlPointIndexToPositionWorld, METH_VARARGS,
   "V.GetClosestControlPointIndexToPositionWorld([float, float,\n    float]) -> int\nC++: int GetClosestControlPointIndexToPositionWorld(double pos[3])\n\nGet the index of the closest control point to the world\ncoordinates\n"},
  {"SetControlPointPositionsWorld", PyvtkMRMLMarkupsNode_SetControlPointPositionsWorld, METH_VARARGS,
   "V.SetControlPointPositionsWorld(vtkPoints)\nC++: void SetControlPointPositionsWorld(vtkPoints *points)\n\nSet all control point positions from a point list. If points is\nnullptr then all control points are removed. New control points\nare added if needed. Existing control points are updated with the\nnew positions. Any extra existing control points are removed.\n"},
  {"GetControlPointPositionsWorld", PyvtkMRMLMarkupsNode_GetControlPointPositionsWorld, METH_VARARGS,
   "V.GetControlPointPositionsWorld(vtkPoints)\nC++: void GetControlPointPositionsWorld(vtkPoints *points)\n\nGet a copy of all control point positions in world coordinate\nsystem\n"},
  {"GetInteractionHandleToWorldMatrix", PyvtkMRMLMarkupsNode_GetInteractionHandleToWorldMatrix, METH_VARARGS,
   "V.GetInteractionHandleToWorldMatrix() -> vtkMatrix4x4\nC++: virtual vtkMatrix4x4 *GetInteractionHandleToWorldMatrix()\n\n4x4 matrix detailing the orientation and position in world\ncoordinates of the interaction handles.\n"},
  {"GetPropertiesLabelText", PyvtkMRMLMarkupsNode_GetPropertiesLabelText, METH_VARARGS,
   "V.GetPropertiesLabelText() -> string\nC++: virtual std::string GetPropertiesLabelText()\n\n"},
  {"GetUnitNode", PyvtkMRMLMarkupsNode_GetUnitNode, METH_VARARGS,
   "V.GetUnitNode(string) -> vtkMRMLUnitNode\nC++: vtkMRMLUnitNode *GetUnitNode(const char *quantity)\n\nUtility function to get unit node from scene\n"},
  {"UpdateAssignedAttribute", PyvtkMRMLMarkupsNode_UpdateAssignedAttribute, METH_VARARGS,
   "V.UpdateAssignedAttribute()\nC++: virtual void UpdateAssignedAttribute()\n\nUpdate the AssignAttribute filter based on its ActiveScalarName\nand its ActiveAttributeLocation To be re-implemented in\nsubclasses\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLMarkupsNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerMarkupsModuleMRML.vtkMRMLMarkupsNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLMarkupsNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLMarkupsNode_StaticNew()
{
  return vtkMRMLMarkupsNode::New();
}

PyObject *PyvtkMRMLMarkupsNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLMarkupsNode_Type, PyvtkMRMLMarkupsNode_Methods,
    "vtkMRMLMarkupsNode",
 &PyvtkMRMLMarkupsNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkMRMLDisplayableNode");

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 14; c++)
  {
    static const struct { const char *name; int value; }
      constants[14] = {
        { "LockModifiedEvent", vtkMRMLMarkupsNode::LockModifiedEvent },
        { "LabelFormatModifiedEvent", vtkMRMLMarkupsNode::LabelFormatModifiedEvent },
        { "PointAddedEvent", vtkMRMLMarkupsNode::PointAddedEvent },
        { "PointRemovedEvent", vtkMRMLMarkupsNode::PointRemovedEvent },
        { "PointPositionDefinedEvent", vtkMRMLMarkupsNode::PointPositionDefinedEvent },
        { "PointPositionUndefinedEvent", vtkMRMLMarkupsNode::PointPositionUndefinedEvent },
        { "PointModifiedEvent", vtkMRMLMarkupsNode::PointModifiedEvent },
        { "PointStartInteractionEvent", vtkMRMLMarkupsNode::PointStartInteractionEvent },
        { "PointEndInteractionEvent", vtkMRMLMarkupsNode::PointEndInteractionEvent },
        { "CenterPointModifiedEvent", vtkMRMLMarkupsNode::CenterPointModifiedEvent },
        { "PositionUndefined", vtkMRMLMarkupsNode::PositionUndefined },
        { "PositionPreview", vtkMRMLMarkupsNode::PositionPreview },
        { "PositionDefined", vtkMRMLMarkupsNode::PositionDefined },
        { "PositionStatus_Last", vtkMRMLMarkupsNode::PositionStatus_Last },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLMarkupsNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLMarkupsNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLMarkupsNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

