// python wrapper for vtkMRMLMarkupsPlaneNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMRMLMarkupsPlaneNode.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMRMLMarkupsPlaneNode(PyObject *dict); }
extern "C" { PyObject *PyvtkMRMLMarkupsPlaneNode_ClassNew(); }

#ifndef DECLARED_PyvtkMRMLMarkupsNode_ClassNew
extern "C" { PyObject *PyvtkMRMLMarkupsNode_ClassNew(); }
#define DECLARED_PyvtkMRMLMarkupsNode_ClassNew
#endif

static const char *PyvtkMRMLMarkupsPlaneNode_Doc =
  "vtkMRMLMarkupsPlaneNode - MRML node to represent a plane markup\n\n"
  "Superclass: vtkMRMLMarkupsNode\n\n"
  "Plane Markups nodes contain three control points. Visualization\n"
  "parameters are set in the vtkMRMLMarkupsDisplayNode class.\n\n"
  "Markups is intended to be used for manual marking/editing of point\n"
  "positions.\n\n"
  "Coordinate systems used:\n"
  "- Local: Local coordinates\n"
  "- World: All parent transforms on node applied to local.\n"
  "- Plane: Plane coordinate space (Origin of plane at 0,0,0, XYZ axis\n"
  "  aligned to XYZ unit vectors). Can have additional offset/rotation\n"
  "  compared to local.\\ingroup Slicer_QtModules_Markups\n\n";


static PyObject *
PyvtkMRMLMarkupsPlaneNode_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLMarkupsPlaneNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMRMLMarkupsPlaneNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMRMLMarkupsPlaneNode *tempr = vtkMRMLMarkupsPlaneNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLMarkupsPlaneNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMRMLMarkupsPlaneNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMRMLMarkupsPlaneNode::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMRMLMarkupsPlaneNode::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetIcon(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIcon");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetIcon() :
      op->vtkMRMLMarkupsPlaneNode::GetIcon());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_CreateNodeInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateNodeInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLNode *tempr = (ap.IsBound() ?
      op->CreateNodeInstance() :
      op->vtkMRMLMarkupsPlaneNode::CreateNodeInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetNodeTagName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeTagName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetNodeTagName() :
      op->vtkMRMLMarkupsPlaneNode::GetNodeTagName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_CopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  vtkMRMLNode *temp0 = nullptr;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkMRMLNode") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->CopyContent(temp0, temp1);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::CopyContent(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_HasCopyContent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasCopyContent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasCopyContent() :
      op->vtkMRMLMarkupsPlaneNode::HasCopyContent());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetSizeMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSizeMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSizeMode(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetSizeMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetSizeMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSizeMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSizeMode() :
      op->vtkMRMLMarkupsPlaneNode::GetSizeMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetSizeModeAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSizeModeAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetSizeModeAsString(temp0) :
      op->vtkMRMLMarkupsPlaneNode::GetSizeModeAsString(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetSizeModeFromString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSizeModeFromString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSizeModeFromString(temp0) :
      op->vtkMRMLMarkupsPlaneNode::GetSizeModeFromString(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetAutoSizeScalingFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoSizeScalingFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetAutoSizeScalingFactor() :
      op->vtkMRMLMarkupsPlaneNode::GetAutoSizeScalingFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetAutoSizeScalingFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoSizeScalingFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoSizeScalingFactor(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetAutoSizeScalingFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetPlaneBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPlaneBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 6;
  double temp0[6];
  double save0[6];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetPlaneBounds(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::GetPlaneBounds(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetPlaneBounds_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPlaneBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  double temp4;
  double temp5;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5))
  {
    if (ap.IsBound())
    {
      op->SetPlaneBounds(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetPlaneBounds(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetPlaneBounds_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPlaneBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 6;
  double temp0[6];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetPlaneBounds(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetPlaneBounds(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetPlaneBounds(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 6:
      return PyvtkMRMLMarkupsPlaneNode_SetPlaneBounds_s1(self, args);
    case 1:
      return PyvtkMRMLMarkupsPlaneNode_SetPlaneBounds_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetPlaneBounds");
  return nullptr;
}



static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetNormal(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNormal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetNormal(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::GetNormal(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetNormal(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNormal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetNormal(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetNormal(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetNormalWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNormalWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetNormalWorld(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::GetNormalWorld(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetNormalWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNormalWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetNormalWorld(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetNormalWorld(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetOrigin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOrigin");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetOrigin(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::GetOrigin(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetOrigin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOrigin");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetOrigin(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetOrigin(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetOriginWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOriginWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetOriginWorld(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::GetOriginWorld(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetOriginWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOriginWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetOriginWorld(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetOriginWorld(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetAxes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAxes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  const size_t size1 = 3;
  double temp1[3];
  double save1[3];
  const size_t size2 = 3;
  double temp2[3];
  double save2[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2))
  {
    vtkPythonArgs::Save(temp0, save0, size0);
    vtkPythonArgs::Save(temp1, save1, size1);
    vtkPythonArgs::Save(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->GetAxes(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::GetAxes(temp0, temp1, temp2);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (vtkPythonArgs::HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetAxes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAxes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  const size_t size1 = 3;
  double temp1[3];
  const size_t size2 = 3;
  double temp2[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2))
  {
    if (ap.IsBound())
    {
      op->SetAxes(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetAxes(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetAxesWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAxesWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  const size_t size1 = 3;
  double temp1[3];
  double save1[3];
  const size_t size2 = 3;
  double temp2[3];
  double save2[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2))
  {
    vtkPythonArgs::Save(temp0, save0, size0);
    vtkPythonArgs::Save(temp1, save1, size1);
    vtkPythonArgs::Save(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->GetAxesWorld(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::GetAxesWorld(temp0, temp1, temp2);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (vtkPythonArgs::HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_SetAxesWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAxesWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  const size_t size1 = 3;
  double temp1[3];
  const size_t size2 = 3;
  double temp2[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2))
  {
    if (ap.IsBound())
    {
      op->SetAxesWorld(temp0, temp1, temp2);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::SetAxesWorld(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetPlaneToLocalMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPlaneToLocalMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->GetPlaneToLocalMatrix(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::GetPlaneToLocalMatrix(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetPlaneToWorldMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPlaneToWorldMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->GetPlaneToWorldMatrix(temp0);
    }
    else
    {
      op->vtkMRMLMarkupsPlaneNode::GetPlaneToWorldMatrix(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetPlaneToPlaneOffsetMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPlaneToPlaneOffsetMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetPlaneToPlaneOffsetMatrix() :
      op->vtkMRMLMarkupsPlaneNode::GetPlaneToPlaneOffsetMatrix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMRMLMarkupsPlaneNode_GetClosestPointOnPlaneWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClosestPointOnPlaneWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMRMLMarkupsPlaneNode *op = static_cast<vtkMRMLMarkupsPlaneNode *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  const size_t size1 = 3;
  double temp1[3];
  double save1[3];
  bool temp2 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    double tempr = (ap.IsBound() ?
      op->GetClosestPointOnPlaneWorld(temp0, temp1, temp2) :
      op->vtkMRMLMarkupsPlaneNode::GetClosestPointOnPlaneWorld(temp0, temp1, temp2));

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMRMLMarkupsPlaneNode_Methods[] = {
  {"IsTypeOf", PyvtkMRMLMarkupsPlaneNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMRMLMarkupsPlaneNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMRMLMarkupsPlaneNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMRMLMarkupsPlaneNode\nC++: static vtkMRMLMarkupsPlaneNode *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMRMLMarkupsPlaneNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMRMLMarkupsPlaneNode\nC++: vtkMRMLMarkupsPlaneNode *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMRMLMarkupsPlaneNode_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMRMLMarkupsPlaneNode_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetIcon", PyvtkMRMLMarkupsPlaneNode_GetIcon, METH_VARARGS,
   "V.GetIcon() -> string\nC++: const char *GetIcon() override;\n\n"},
  {"CreateNodeInstance", PyvtkMRMLMarkupsPlaneNode_CreateNodeInstance, METH_VARARGS,
   "V.CreateNodeInstance() -> vtkMRMLNode\nC++: vtkMRMLNode *CreateNodeInstance() override;\n\nMRMLNode methods\n"},
  {"GetNodeTagName", PyvtkMRMLMarkupsPlaneNode_GetNodeTagName, METH_VARARGS,
   "V.GetNodeTagName() -> string\nC++: const char *GetNodeTagName() override;\n\nGet node XML tag name (like Volume, Model)\n"},
  {"CopyContent", PyvtkMRMLMarkupsPlaneNode_CopyContent, METH_VARARGS,
   "V.CopyContent(vtkMRMLNode, bool)\nC++: void CopyContent(vtkMRMLNode *node, bool deepCopy=true)\n    override;\n\nCopy node content (excludes basic data, such as name and node\nreferences).\n\\sa vtkMRMLNode::CopyContent\n"},
  {"HasCopyContent", PyvtkMRMLMarkupsPlaneNode_HasCopyContent, METH_VARARGS,
   "V.HasCopyContent() -> bool\nC++: bool HasCopyContent() override;\n\nReturns true if the class supports deep and shallow copying node\n    content.\n"},
  {"SetSizeMode", PyvtkMRMLMarkupsPlaneNode_SetSizeMode, METH_VARARGS,
   "V.SetSizeMode(int)\nC++: virtual void SetSizeMode(int _arg)\n\nMethod for calculating the size of the plane along the direction\nvectors. With size mode auto, the size of the plane is\nautomatically calculated so that it ecompasses all of the points.\nSize mode absolute will never be recalculated. Default is\nSizeModeAuto.\n"},
  {"GetSizeMode", PyvtkMRMLMarkupsPlaneNode_GetSizeMode, METH_VARARGS,
   "V.GetSizeMode() -> int\nC++: virtual int GetSizeMode()\n\n"},
  {"GetSizeModeAsString", PyvtkMRMLMarkupsPlaneNode_GetSizeModeAsString, METH_VARARGS,
   "V.GetSizeModeAsString(int) -> string\nC++: const char *GetSizeModeAsString(int sizeMode)\n\n"},
  {"GetSizeModeFromString", PyvtkMRMLMarkupsPlaneNode_GetSizeModeFromString, METH_VARARGS,
   "V.GetSizeModeFromString(string) -> int\nC++: int GetSizeModeFromString(const char *sizeMode)\n\n"},
  {"GetAutoSizeScalingFactor", PyvtkMRMLMarkupsPlaneNode_GetAutoSizeScalingFactor, METH_VARARGS,
   "V.GetAutoSizeScalingFactor() -> float\nC++: virtual double GetAutoSizeScalingFactor()\n\nThe plane size multiplier used to calculate the size of the\nplane. This is only used when the size mode is auto. Default is\n1.0.\n"},
  {"SetAutoSizeScalingFactor", PyvtkMRMLMarkupsPlaneNode_SetAutoSizeScalingFactor, METH_VARARGS,
   "V.SetAutoSizeScalingFactor(float)\nC++: virtual void SetAutoSizeScalingFactor(double _arg)\n\n"},
  {"GetPlaneBounds", PyvtkMRMLMarkupsPlaneNode_GetPlaneBounds, METH_VARARGS,
   "V.GetPlaneBounds([float, float, float, float, float, float])\nC++: void GetPlaneBounds(double bounds[6])\n\nThe bounds of the plane in the plane coordinate system. When the\nsize mode is absolute, SetPlaneBounds can be used to specify the\nsize of the plane. This is only used when the size mode is\nabsolute.\n"},
  {"SetPlaneBounds", PyvtkMRMLMarkupsPlaneNode_SetPlaneBounds, METH_VARARGS,
   "V.SetPlaneBounds(float, float, float, float, float, float)\nC++: virtual void SetPlaneBounds(double _arg1, double _arg2,\n    double _arg3, double _arg4, double _arg5, double _arg6)\nV.SetPlaneBounds((float, float, float, float, float, float))\nC++: virtual void SetPlaneBounds(const double _arg[6])\n\n"},
  {"GetNormal", PyvtkMRMLMarkupsPlaneNode_GetNormal, METH_VARARGS,
   "V.GetNormal([float, float, float])\nC++: void GetNormal(double normal[3])\n\nThe normal vector for the plane. Calculated as the vector\nperpendicular to the plane containing the 3 markup points, and\ntransformed by the PlaneToPlaneOffsetMatrix.\n"},
  {"SetNormal", PyvtkMRMLMarkupsPlaneNode_SetNormal, METH_VARARGS,
   "V.SetNormal((float, float, float))\nC++: void SetNormal(const double normal[3])\n\n"},
  {"GetNormalWorld", PyvtkMRMLMarkupsPlaneNode_GetNormalWorld, METH_VARARGS,
   "V.GetNormalWorld([float, float, float])\nC++: void GetNormalWorld(double normal[3])\n\n"},
  {"SetNormalWorld", PyvtkMRMLMarkupsPlaneNode_SetNormalWorld, METH_VARARGS,
   "V.SetNormalWorld((float, float, float))\nC++: void SetNormalWorld(const double normal[3])\n\n"},
  {"GetOrigin", PyvtkMRMLMarkupsPlaneNode_GetOrigin, METH_VARARGS,
   "V.GetOrigin([float, float, float])\nC++: void GetOrigin(double origin[3])\n\nThe origin of the plane. Calculated as the location of the 0th\nmarkup point, and translated by the PlaneToPlaneOffsetMatrix.\n"},
  {"SetOrigin", PyvtkMRMLMarkupsPlaneNode_SetOrigin, METH_VARARGS,
   "V.SetOrigin((float, float, float))\nC++: void SetOrigin(const double origin[3])\n\n"},
  {"GetOriginWorld", PyvtkMRMLMarkupsPlaneNode_GetOriginWorld, METH_VARARGS,
   "V.GetOriginWorld([float, float, float])\nC++: void GetOriginWorld(double origin[3])\n\n"},
  {"SetOriginWorld", PyvtkMRMLMarkupsPlaneNode_SetOriginWorld, METH_VARARGS,
   "V.SetOriginWorld((float, float, float))\nC++: void SetOriginWorld(const double origin[3])\n\n"},
  {"GetAxes", PyvtkMRMLMarkupsPlaneNode_GetAxes, METH_VARARGS,
   "V.GetAxes([float, float, float], [float, float, float], [float,\n    float, float])\nC++: void GetAxes(double x[3], double y[3], double z[3])\n\nThe direction vectors defined by the markup points. Calculated as\nfollows and then transformed by the offset matrix: X: Vector from\n1st to 0th point. Y: Cross product of the Z vector and X vectors.\nZ: Cross product of the X vector and the vector from the 2nd to\n0th point.\n"},
  {"SetAxes", PyvtkMRMLMarkupsPlaneNode_SetAxes, METH_VARARGS,
   "V.SetAxes((float, float, float), (float, float, float), (float,\n    float, float))\nC++: void SetAxes(const double x[3], const double y[3],\n    const double z[3])\n\n"},
  {"GetAxesWorld", PyvtkMRMLMarkupsPlaneNode_GetAxesWorld, METH_VARARGS,
   "V.GetAxesWorld([float, float, float], [float, float, float],\n    [float, float, float])\nC++: void GetAxesWorld(double x[3], double y[3], double z[3])\n\n"},
  {"SetAxesWorld", PyvtkMRMLMarkupsPlaneNode_SetAxesWorld, METH_VARARGS,
   "V.SetAxesWorld((float, float, float), (float, float, float), (\n    float, float, float))\nC++: void SetAxesWorld(const double x[3], const double y[3],\n    const double z[3])\n\n"},
  {"GetPlaneToLocalMatrix", PyvtkMRMLMarkupsPlaneNode_GetPlaneToLocalMatrix, METH_VARARGS,
   "V.GetPlaneToLocalMatrix(vtkMatrix4x4)\nC++: virtual void GetPlaneToLocalMatrix(\n    vtkMatrix4x4 *planeToLocalMatrix)\n\n"},
  {"GetPlaneToWorldMatrix", PyvtkMRMLMarkupsPlaneNode_GetPlaneToWorldMatrix, METH_VARARGS,
   "V.GetPlaneToWorldMatrix(vtkMatrix4x4)\nC++: virtual void GetPlaneToWorldMatrix(\n    vtkMatrix4x4 *planeToWorldMatrix)\n\n"},
  {"GetPlaneToPlaneOffsetMatrix", PyvtkMRMLMarkupsPlaneNode_GetPlaneToPlaneOffsetMatrix, METH_VARARGS,
   "V.GetPlaneToPlaneOffsetMatrix() -> vtkMatrix4x4\nC++: virtual vtkMatrix4x4 *GetPlaneToPlaneOffsetMatrix()\n\n4x4 matrix detailing the offset (rotation/translation) of the\nplane from the plane defined by the markup points. Default is the\nidentity matrix.\n"},
  {"GetClosestPointOnPlaneWorld", PyvtkMRMLMarkupsPlaneNode_GetClosestPointOnPlaneWorld, METH_VARARGS,
   "V.GetClosestPointOnPlaneWorld((float, float, float), [float,\n    float, float], bool) -> float\nC++: double GetClosestPointOnPlaneWorld(const double posWorld[3],\n    double closestPosWorld[3], bool infinitePlane=true)\n\nGet the closest position on the plane in world coordinates.\nReturns the signed distance from the input point to the plane.\nPositive distance is in the direction of the plane normal, and\nnegative distance is in the opposite direction.\n\\param posWorld input position\n\\param closestPosWorld: output found closest position\n\\param infinitePlane if false, the closest position will be\n    restricted to the plane bounds\n\\return Signed distance from the point to the plane. Positive\n    distance is in the direction of the plane normal\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkMRMLMarkupsPlaneNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerMarkupsModuleMRML.vtkMRMLMarkupsPlaneNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMRMLMarkupsPlaneNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMRMLMarkupsPlaneNode_StaticNew()
{
  return vtkMRMLMarkupsPlaneNode::New();
}

PyObject *PyvtkMRMLMarkupsPlaneNode_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMRMLMarkupsPlaneNode_Type, PyvtkMRMLMarkupsPlaneNode_Methods,
    "vtkMRMLMarkupsPlaneNode",
 &PyvtkMRMLMarkupsPlaneNode_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMRMLMarkupsNode_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 3; c++)
  {
    static const struct { const char *name; int value; }
      constants[3] = {
        { "SizeModeAuto", vtkMRMLMarkupsPlaneNode::SizeModeAuto },
        { "SizeModeAbsolute", vtkMRMLMarkupsPlaneNode::SizeModeAbsolute },
        { "SizeMode_Last", vtkMRMLMarkupsPlaneNode::SizeMode_Last },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMRMLMarkupsPlaneNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMRMLMarkupsPlaneNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMRMLMarkupsPlaneNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

