// python wrapper for vtkSlicerSceneViewsModuleLogic
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkSlicerSceneViewsModuleLogic.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSlicerSceneViewsModuleLogic(PyObject *dict); }
extern "C" { PyObject *PyvtkSlicerSceneViewsModuleLogic_ClassNew(); }

#ifndef DECLARED_PyvtkSlicerModuleLogic_ClassNew
extern "C" { PyObject *PyvtkSlicerModuleLogic_ClassNew(); }
#define DECLARED_PyvtkSlicerModuleLogic_ClassNew
#endif

static const char *PyvtkSlicerSceneViewsModuleLogic_Doc =
  "vtkSlicerSceneViewsModuleLogic - \\ingroup Slicer_QtModules_SceneViews\n\n"
  "Superclass: vtkSlicerModuleLogic\n\n"
;


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerSceneViewsModuleLogic::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSlicerSceneViewsModuleLogic::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSlicerSceneViewsModuleLogic *tempr = vtkSlicerSceneViewsModuleLogic::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkSlicerSceneViewsModuleLogic *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSlicerSceneViewsModuleLogic::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerSceneViewsModuleLogic::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkSlicerSceneViewsModuleLogic::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_SetMRMLSceneInternal(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMRMLSceneInternal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  vtkMRMLScene *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLScene"))
  {
    if (ap.IsBound())
    {
      op->SetMRMLSceneInternal(temp0);
    }
    else
    {
      op->vtkSlicerSceneViewsModuleLogic::SetMRMLSceneInternal(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_RegisterNodes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RegisterNodes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RegisterNodes();
    }
    else
    {
      op->vtkSlicerSceneViewsModuleLogic::RegisterNodes();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_CreateSceneView(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateSceneView");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  int temp2;
  vtkImageData *temp3 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetVTKObject(temp3, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->CreateSceneView(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkSlicerSceneViewsModuleLogic::CreateSceneView(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_ModifySceneView(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ModifySceneView");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  vtkStdString temp0;
  const char *temp1 = nullptr;
  const char *temp2 = nullptr;
  int temp3;
  vtkImageData *temp4 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetVTKObject(temp4, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->ModifySceneView(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkSlicerSceneViewsModuleLogic::ModifySceneView(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_GetSceneViewName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSceneViewName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetSceneViewName(temp0) :
      op->vtkSlicerSceneViewsModuleLogic::GetSceneViewName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_GetSceneViewDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSceneViewDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetSceneViewDescription(temp0) :
      op->vtkSlicerSceneViewsModuleLogic::GetSceneViewDescription(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_GetSceneViewScreenshotType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSceneViewScreenshotType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSceneViewScreenshotType(temp0) :
      op->vtkSlicerSceneViewsModuleLogic::GetSceneViewScreenshotType(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_GetSceneViewScreenshot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSceneViewScreenshot");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetSceneViewScreenshot(temp0) :
      op->vtkSlicerSceneViewsModuleLogic::GetSceneViewScreenshot(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_RestoreSceneView(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RestoreSceneView");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  bool temp1 = true;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->RestoreSceneView(temp0, temp1);
    }
    else
    {
      op->vtkSlicerSceneViewsModuleLogic::RestoreSceneView(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_MoveSceneViewUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MoveSceneViewUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->MoveSceneViewUp(temp0) :
      op->vtkSlicerSceneViewsModuleLogic::MoveSceneViewUp(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_MoveSceneViewDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MoveSceneViewDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->MoveSceneViewDown(temp0) :
      op->vtkSlicerSceneViewsModuleLogic::MoveSceneViewDown(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerSceneViewsModuleLogic_RemoveSceneViewNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveSceneViewNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerSceneViewsModuleLogic *op = static_cast<vtkSlicerSceneViewsModuleLogic *>(vp);

  vtkMRMLSceneViewNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMRMLSceneViewNode"))
  {
    if (ap.IsBound())
    {
      op->RemoveSceneViewNode(temp0);
    }
    else
    {
      op->vtkSlicerSceneViewsModuleLogic::RemoveSceneViewNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSlicerSceneViewsModuleLogic_Methods[] = {
  {"IsTypeOf", PyvtkSlicerSceneViewsModuleLogic_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkSlicerSceneViewsModuleLogic_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkSlicerSceneViewsModuleLogic_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSlicerSceneViewsModuleLogic\nC++: static vtkSlicerSceneViewsModuleLogic *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSlicerSceneViewsModuleLogic_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSlicerSceneViewsModuleLogic\nC++: vtkSlicerSceneViewsModuleLogic *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkSlicerSceneViewsModuleLogic_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkSlicerSceneViewsModuleLogic_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetMRMLSceneInternal", PyvtkSlicerSceneViewsModuleLogic_SetMRMLSceneInternal, METH_VARARGS,
   "V.SetMRMLSceneInternal(vtkMRMLScene)\nC++: void SetMRMLSceneInternal(vtkMRMLScene *newScene) override;\n\nInitialize listening to MRML events\n"},
  {"RegisterNodes", PyvtkSlicerSceneViewsModuleLogic_RegisterNodes, METH_VARARGS,
   "V.RegisterNodes()\nC++: void RegisterNodes() override;\n\nRegister MRML Node classes to Scene. Gets called automatically\nwhen the MRMLScene is attached to this logic class.\n"},
  {"CreateSceneView", PyvtkSlicerSceneViewsModuleLogic_CreateSceneView, METH_VARARGS,
   "V.CreateSceneView(string, string, int, vtkImageData)\nC++: void CreateSceneView(const char *name,\n    const char *description, int screenshotType,\n    vtkImageData *screenshot)\n\nCreate a sceneView..\n"},
  {"ModifySceneView", PyvtkSlicerSceneViewsModuleLogic_ModifySceneView, METH_VARARGS,
   "V.ModifySceneView(string, string, string, int, vtkImageData)\nC++: void ModifySceneView(vtkStdString id, const char *name,\n    const char *description, int screenshotType,\n    vtkImageData *screenshot)\n\nModify an existing sceneView.\n"},
  {"GetSceneViewName", PyvtkSlicerSceneViewsModuleLogic_GetSceneViewName, METH_VARARGS,
   "V.GetSceneViewName(string) -> string\nC++: vtkStdString GetSceneViewName(const char *id)\n\nReturn the name of an existing sceneView.\n"},
  {"GetSceneViewDescription", PyvtkSlicerSceneViewsModuleLogic_GetSceneViewDescription, METH_VARARGS,
   "V.GetSceneViewDescription(string) -> string\nC++: vtkStdString GetSceneViewDescription(const char *id)\n\nReturn the description of an existing sceneView.\n"},
  {"GetSceneViewScreenshotType", PyvtkSlicerSceneViewsModuleLogic_GetSceneViewScreenshotType, METH_VARARGS,
   "V.GetSceneViewScreenshotType(string) -> int\nC++: int GetSceneViewScreenshotType(const char *id)\n\nReturn the screenshotType of an existing sceneView.\n"},
  {"GetSceneViewScreenshot", PyvtkSlicerSceneViewsModuleLogic_GetSceneViewScreenshot, METH_VARARGS,
   "V.GetSceneViewScreenshot(string) -> vtkImageData\nC++: vtkImageData *GetSceneViewScreenshot(const char *id)\n\nReturn the screenshot of an existing sceneView.\n"},
  {"RestoreSceneView", PyvtkSlicerSceneViewsModuleLogic_RestoreSceneView, METH_VARARGS,
   "V.RestoreSceneView(string, bool)\nC++: void RestoreSceneView(const char *id, bool removeNodes=true)\n\nRestore a sceneView. If removeNodes flag is false, don't restore\nthe scene if it will remove data. removeNodes defaults to true\nfor backward compatibility.\n"},
  {"MoveSceneViewUp", PyvtkSlicerSceneViewsModuleLogic_MoveSceneViewUp, METH_VARARGS,
   "V.MoveSceneViewUp(string) -> string\nC++: const char *MoveSceneViewUp(const char *id)\n\nMove sceneView up\n"},
  {"MoveSceneViewDown", PyvtkSlicerSceneViewsModuleLogic_MoveSceneViewDown, METH_VARARGS,
   "V.MoveSceneViewDown(string) -> string\nC++: const char *MoveSceneViewDown(const char *id)\n\nMove sceneView up\n"},
  {"RemoveSceneViewNode", PyvtkSlicerSceneViewsModuleLogic_RemoveSceneViewNode, METH_VARARGS,
   "V.RemoveSceneViewNode(vtkMRMLSceneViewNode)\nC++: void RemoveSceneViewNode(vtkMRMLSceneViewNode *sceneViewNode)\n\nRemove a scene view node\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkSlicerSceneViewsModuleLogic_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerSceneViewsModuleLogic.vtkSlicerSceneViewsModuleLogic", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkSlicerSceneViewsModuleLogic_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSlicerSceneViewsModuleLogic_StaticNew()
{
  return vtkSlicerSceneViewsModuleLogic::New();
}

PyObject *PyvtkSlicerSceneViewsModuleLogic_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkSlicerSceneViewsModuleLogic_Type, PyvtkSlicerSceneViewsModuleLogic_Methods,
    "vtkSlicerSceneViewsModuleLogic",
 &PyvtkSlicerSceneViewsModuleLogic_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkSlicerModuleLogic");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkSlicerSceneViewsModuleLogic(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSlicerSceneViewsModuleLogic_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSlicerSceneViewsModuleLogic", o) != 0)
  {
    Py_DECREF(o);
  }

}

