// python wrapper for vtkSlicerViewControllersLogic
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSlicerViewControllersLogic.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSlicerViewControllersLogic(PyObject *dict); }
extern "C" { PyObject *PyvtkSlicerViewControllersLogic_ClassNew(); }

#ifndef DECLARED_PyvtkSlicerModuleLogic_ClassNew
extern "C" { PyObject *PyvtkSlicerModuleLogic_ClassNew(); }
#define DECLARED_PyvtkSlicerModuleLogic_ClassNew
#endif

static const char *PyvtkSlicerViewControllersLogic_Doc =
  "vtkSlicerViewControllersLogic - slicer logic class for\nSliceViewControllers module\n\n"
  "Superclass: vtkSlicerModuleLogic\n\n"
;


static PyObject *
PyvtkSlicerViewControllersLogic_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerViewControllersLogic::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerViewControllersLogic_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerViewControllersLogic *op = static_cast<vtkSlicerViewControllersLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSlicerViewControllersLogic::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerViewControllersLogic_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSlicerViewControllersLogic *tempr = vtkSlicerViewControllersLogic::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerViewControllersLogic_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerViewControllersLogic *op = static_cast<vtkSlicerViewControllersLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkSlicerViewControllersLogic *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSlicerViewControllersLogic::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerViewControllersLogic_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSlicerViewControllersLogic::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerViewControllersLogic_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerViewControllersLogic *op = static_cast<vtkSlicerViewControllersLogic *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkSlicerViewControllersLogic::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerViewControllersLogic_GetDefaultSliceViewNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultSliceViewNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerViewControllersLogic *op = static_cast<vtkSlicerViewControllersLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLSliceNode *tempr = (ap.IsBound() ?
      op->GetDefaultSliceViewNode() :
      op->vtkSlicerViewControllersLogic::GetDefaultSliceViewNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerViewControllersLogic_GetDefaultThreeDViewNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultThreeDViewNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerViewControllersLogic *op = static_cast<vtkSlicerViewControllersLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLViewNode *tempr = (ap.IsBound() ?
      op->GetDefaultThreeDViewNode() :
      op->vtkSlicerViewControllersLogic::GetDefaultThreeDViewNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerViewControllersLogic_GetDefaultPlotViewNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultPlotViewNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerViewControllersLogic *op = static_cast<vtkSlicerViewControllersLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMRMLPlotViewNode *tempr = (ap.IsBound() ?
      op->GetDefaultPlotViewNode() :
      op->vtkSlicerViewControllersLogic::GetDefaultPlotViewNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSlicerViewControllersLogic_ResetAllViewNodesToDefault(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResetAllViewNodesToDefault");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSlicerViewControllersLogic *op = static_cast<vtkSlicerViewControllersLogic *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ResetAllViewNodesToDefault();
    }
    else
    {
      op->vtkSlicerViewControllersLogic::ResetAllViewNodesToDefault();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSlicerViewControllersLogic_Methods[] = {
  {"IsTypeOf", PyvtkSlicerViewControllersLogic_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkSlicerViewControllersLogic_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkSlicerViewControllersLogic_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSlicerViewControllersLogic\nC++: static vtkSlicerViewControllersLogic *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSlicerViewControllersLogic_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSlicerViewControllersLogic\nC++: vtkSlicerViewControllersLogic *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkSlicerViewControllersLogic_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkSlicerViewControllersLogic_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetDefaultSliceViewNode", PyvtkSlicerViewControllersLogic_GetDefaultSliceViewNode, METH_VARARGS,
   "V.GetDefaultSliceViewNode() -> vtkMRMLSliceNode\nC++: vtkMRMLSliceNode *GetDefaultSliceViewNode()\n\nRetrieves the default slice view node from the scene. The\nreturned node can be changed to customize the contents of new\nview nodes. ResetAllViewNodesToDefault() can be called to update\nall existing view nodes to the new default settings immediately.\n"},
  {"GetDefaultThreeDViewNode", PyvtkSlicerViewControllersLogic_GetDefaultThreeDViewNode, METH_VARARGS,
   "V.GetDefaultThreeDViewNode() -> vtkMRMLViewNode\nC++: vtkMRMLViewNode *GetDefaultThreeDViewNode()\n\nRetrieves the default 3D view node from the scene. The returned\nnode can be changed to customize the contents of new view nodes.\nResetAllViewNodesToDefault() can be called to update all existing\nview nodes to the new default settings immediately.\n"},
  {"GetDefaultPlotViewNode", PyvtkSlicerViewControllersLogic_GetDefaultPlotViewNode, METH_VARARGS,
   "V.GetDefaultPlotViewNode() -> vtkMRMLPlotViewNode\nC++: vtkMRMLPlotViewNode *GetDefaultPlotViewNode()\n\nRetrieves the default plot view node from the scene. The returned\nnode can be changed to customize the contents of new view nodes.\nResetAllViewNodesToDefault() can be called to update all existing\nview nodes to the new default settings immediately.\n"},
  {"ResetAllViewNodesToDefault", PyvtkSlicerViewControllersLogic_ResetAllViewNodesToDefault, METH_VARARGS,
   "V.ResetAllViewNodesToDefault()\nC++: void ResetAllViewNodesToDefault()\n\nReset all existing slice and 3D view nodes to default settings.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkSlicerViewControllersLogic_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerViewControllersModuleLogic.vtkSlicerViewControllersLogic", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkSlicerViewControllersLogic_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSlicerViewControllersLogic_StaticNew()
{
  return vtkSlicerViewControllersLogic::New();
}

PyObject *PyvtkSlicerViewControllersLogic_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkSlicerViewControllersLogic_Type, PyvtkSlicerViewControllersLogic_Methods,
    "vtkSlicerViewControllersLogic",
 &PyvtkSlicerViewControllersLogic_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkSlicerModuleLogic");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkSlicerViewControllersLogic(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSlicerViewControllersLogic_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSlicerViewControllersLogic", o) != 0)
  {
    Py_DECREF(o);
  }

}

