// python wrapper for vtkImageConnectivity
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkImageConnectivity.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageConnectivity(PyObject *dict); }
extern "C" { PyObject *PyvtkImageConnectivity_ClassNew(); }

#ifndef DECLARED_PyvtkImageAlgorithm_ClassNew
extern "C" { PyObject *PyvtkImageAlgorithm_ClassNew(); }
#define DECLARED_PyvtkImageAlgorithm_ClassNew
#endif

static const char *PyvtkImageConnectivity_Doc =
  "vtkImageConnectivity - no description provided.\n\n"
  "Superclass: vtkImageAlgorithm\n\n"
;


static PyObject *
PyvtkImageConnectivity_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkImageConnectivity::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageConnectivity::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkImageConnectivity *tempr = vtkImageConnectivity::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageConnectivity *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageConnectivity::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkImageConnectivity::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkImageConnectivity::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetFunction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFunction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFunction(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetFunction(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetFunctionToIdentifyIslands(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFunctionToIdentifyIslands");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFunctionToIdentifyIslands();
    }
    else
    {
      op->vtkImageConnectivity::SetFunctionToIdentifyIslands();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetFunctionToRemoveIslands(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFunctionToRemoveIslands");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFunctionToRemoveIslands();
    }
    else
    {
      op->vtkImageConnectivity::SetFunctionToRemoveIslands();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetFunctionToChangeIsland(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFunctionToChangeIsland");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFunctionToChangeIsland();
    }
    else
    {
      op->vtkImageConnectivity::SetFunctionToChangeIsland();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetFunctionToMeasureIsland(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFunctionToMeasureIsland");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFunctionToMeasureIsland();
    }
    else
    {
      op->vtkImageConnectivity::SetFunctionToMeasureIsland();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetFunctionToSaveIsland(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFunctionToSaveIsland");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFunctionToSaveIsland();
    }
    else
    {
      op->vtkImageConnectivity::SetFunctionToSaveIsland();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetFunction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFunction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFunction() :
      op->vtkImageConnectivity::GetFunction());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetFunctionString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFunctionString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFunctionString() :
      op->vtkImageConnectivity::GetFunctionString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetIslandSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIslandSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetIslandSize() :
      op->vtkImageConnectivity::GetIslandSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetIslandSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIslandSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIslandSize(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetIslandSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetLargestIslandSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLargestIslandSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLargestIslandSize() :
      op->vtkImageConnectivity::GetLargestIslandSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetLargestIslandSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLargestIslandSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLargestIslandSize(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetLargestIslandSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetSliceBySlice(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceBySlice");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSliceBySlice() :
      op->vtkImageConnectivity::GetSliceBySlice());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetSliceBySlice(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSliceBySlice");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSliceBySlice(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetSliceBySlice(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SliceBySliceOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SliceBySliceOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SliceBySliceOn();
    }
    else
    {
      op->vtkImageConnectivity::SliceBySliceOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SliceBySliceOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SliceBySliceOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SliceBySliceOff();
    }
    else
    {
      op->vtkImageConnectivity::SliceBySliceOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetSeed_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetSeed(temp0, temp1, temp2);
    }
    else
    {
      op->vtkImageConnectivity::SetSeed(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageConnectivity_SetSeed_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  const size_t size0 = 3;
  int temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetSeed(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetSeed(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageConnectivity_SetSeed(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkImageConnectivity_SetSeed_s1(self, args);
    case 1:
      return PyvtkImageConnectivity_SetSeed_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetSeed");
  return nullptr;
}



static PyObject *
PyvtkImageConnectivity_GetSeed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetSeed() :
      op->vtkImageConnectivity::GetSeed());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetOutputLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOutputLabel(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetOutputLabel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetOutputLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOutputLabel() :
      op->vtkImageConnectivity::GetOutputLabel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetMinSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMinSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMinSize(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetMinSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetMinSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMinSize() :
      op->vtkImageConnectivity::GetMinSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetBackground(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBackground");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  short temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetBackground(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetBackground(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetBackground(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBackground");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    short tempr = (ap.IsBound() ?
      op->GetBackground() :
      op->vtkImageConnectivity::GetBackground());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetMinForeground(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMinForeground");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  short temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMinForeground(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetMinForeground(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetMinForeground(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinForeground");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    short tempr = (ap.IsBound() ?
      op->GetMinForeground() :
      op->vtkImageConnectivity::GetMinForeground());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_SetMaxForeground(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaxForeground");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  short temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaxForeground(temp0);
    }
    else
    {
      op->vtkImageConnectivity::SetMaxForeground(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageConnectivity_GetMaxForeground(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaxForeground");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageConnectivity *op = static_cast<vtkImageConnectivity *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    short tempr = (ap.IsBound() ?
      op->GetMaxForeground() :
      op->vtkImageConnectivity::GetMaxForeground());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkImageConnectivity_Methods[] = {
  {"IsTypeOf", PyvtkImageConnectivity_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkImageConnectivity_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkImageConnectivity_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkImageConnectivity\nC++: static vtkImageConnectivity *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkImageConnectivity_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageConnectivity\nC++: vtkImageConnectivity *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkImageConnectivity_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkImageConnectivity_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetFunction", PyvtkImageConnectivity_SetFunction, METH_VARARGS,
   "V.SetFunction(int)\nC++: void SetFunction(int func)\n\nFunction\n"},
  {"SetFunctionToIdentifyIslands", PyvtkImageConnectivity_SetFunctionToIdentifyIslands, METH_VARARGS,
   "V.SetFunctionToIdentifyIslands()\nC++: void SetFunctionToIdentifyIslands()\n\n"},
  {"SetFunctionToRemoveIslands", PyvtkImageConnectivity_SetFunctionToRemoveIslands, METH_VARARGS,
   "V.SetFunctionToRemoveIslands()\nC++: void SetFunctionToRemoveIslands()\n\n"},
  {"SetFunctionToChangeIsland", PyvtkImageConnectivity_SetFunctionToChangeIsland, METH_VARARGS,
   "V.SetFunctionToChangeIsland()\nC++: void SetFunctionToChangeIsland()\n\n"},
  {"SetFunctionToMeasureIsland", PyvtkImageConnectivity_SetFunctionToMeasureIsland, METH_VARARGS,
   "V.SetFunctionToMeasureIsland()\nC++: void SetFunctionToMeasureIsland()\n\n"},
  {"SetFunctionToSaveIsland", PyvtkImageConnectivity_SetFunctionToSaveIsland, METH_VARARGS,
   "V.SetFunctionToSaveIsland()\nC++: void SetFunctionToSaveIsland()\n\n"},
  {"GetFunction", PyvtkImageConnectivity_GetFunction, METH_VARARGS,
   "V.GetFunction() -> int\nC++: int GetFunction()\n\n"},
  {"GetFunctionString", PyvtkImageConnectivity_GetFunctionString, METH_VARARGS,
   "V.GetFunctionString() -> string\nC++: const char *GetFunctionString()\n\n"},
  {"GetIslandSize", PyvtkImageConnectivity_GetIslandSize, METH_VARARGS,
   "V.GetIslandSize() -> int\nC++: virtual int GetIslandSize()\n\noutputs of MeasureIsland\n"},
  {"SetIslandSize", PyvtkImageConnectivity_SetIslandSize, METH_VARARGS,
   "V.SetIslandSize(int)\nC++: virtual void SetIslandSize(int _arg)\n\n"},
  {"GetLargestIslandSize", PyvtkImageConnectivity_GetLargestIslandSize, METH_VARARGS,
   "V.GetLargestIslandSize() -> int\nC++: virtual int GetLargestIslandSize()\n\n"},
  {"SetLargestIslandSize", PyvtkImageConnectivity_SetLargestIslandSize, METH_VARARGS,
   "V.SetLargestIslandSize(int)\nC++: virtual void SetLargestIslandSize(int _arg)\n\n"},
  {"GetSliceBySlice", PyvtkImageConnectivity_GetSliceBySlice, METH_VARARGS,
   "V.GetSliceBySlice() -> int\nC++: virtual int GetSliceBySlice()\n\n\n"},
  {"SetSliceBySlice", PyvtkImageConnectivity_SetSliceBySlice, METH_VARARGS,
   "V.SetSliceBySlice(int)\nC++: virtual void SetSliceBySlice(int _arg)\n\n"},
  {"SliceBySliceOn", PyvtkImageConnectivity_SliceBySliceOn, METH_VARARGS,
   "V.SliceBySliceOn()\nC++: virtual void SliceBySliceOn()\n\n"},
  {"SliceBySliceOff", PyvtkImageConnectivity_SliceBySliceOff, METH_VARARGS,
   "V.SliceBySliceOff()\nC++: virtual void SliceBySliceOff()\n\n"},
  {"SetSeed", PyvtkImageConnectivity_SetSeed, METH_VARARGS,
   "V.SetSeed(int, int, int)\nC++: virtual void SetSeed(int _arg1, int _arg2, int _arg3)\nV.SetSeed((int, int, int))\nC++: virtual void SetSeed(const int _arg[3])\n\n"},
  {"GetSeed", PyvtkImageConnectivity_GetSeed, METH_VARARGS,
   "V.GetSeed() -> (int, int, int)\nC++: virtual int *GetSeed()\n\n"},
  {"SetOutputLabel", PyvtkImageConnectivity_SetOutputLabel, METH_VARARGS,
   "V.SetOutputLabel(int)\nC++: virtual void SetOutputLabel(int _arg)\n\n"},
  {"GetOutputLabel", PyvtkImageConnectivity_GetOutputLabel, METH_VARARGS,
   "V.GetOutputLabel() -> int\nC++: virtual int GetOutputLabel()\n\n"},
  {"SetMinSize", PyvtkImageConnectivity_SetMinSize, METH_VARARGS,
   "V.SetMinSize(int)\nC++: virtual void SetMinSize(int _arg)\n\n"},
  {"GetMinSize", PyvtkImageConnectivity_GetMinSize, METH_VARARGS,
   "V.GetMinSize() -> int\nC++: virtual int GetMinSize()\n\n"},
  {"SetBackground", PyvtkImageConnectivity_SetBackground, METH_VARARGS,
   "V.SetBackground(int)\nC++: virtual void SetBackground(short _arg)\n\n"},
  {"GetBackground", PyvtkImageConnectivity_GetBackground, METH_VARARGS,
   "V.GetBackground() -> int\nC++: virtual short GetBackground()\n\n"},
  {"SetMinForeground", PyvtkImageConnectivity_SetMinForeground, METH_VARARGS,
   "V.SetMinForeground(int)\nC++: virtual void SetMinForeground(short _arg)\n\n"},
  {"GetMinForeground", PyvtkImageConnectivity_GetMinForeground, METH_VARARGS,
   "V.GetMinForeground() -> int\nC++: virtual short GetMinForeground()\n\n"},
  {"SetMaxForeground", PyvtkImageConnectivity_SetMaxForeground, METH_VARARGS,
   "V.SetMaxForeground(int)\nC++: virtual void SetMaxForeground(short _arg)\n\n"},
  {"GetMaxForeground", PyvtkImageConnectivity_GetMaxForeground, METH_VARARGS,
   "V.GetMaxForeground() -> int\nC++: virtual short GetMaxForeground()\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkImageConnectivity_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerEditorLibModuleLogic.vtkImageConnectivity", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkImageConnectivity_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageConnectivity_StaticNew()
{
  return vtkImageConnectivity::New();
}

PyObject *PyvtkImageConnectivity_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkImageConnectivity_Type, PyvtkImageConnectivity_Methods,
    "vtkImageConnectivity",
 &PyvtkImageConnectivity_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkImageAlgorithm");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkImageConnectivity(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageConnectivity_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageConnectivity", o) != 0)
  {
    Py_DECREF(o);
  }

}

