// python wrapper for vtkImageSlicePaint
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkImageSlicePaint.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageSlicePaint(PyObject *dict); }
extern "C" { PyObject *PyvtkImageSlicePaint_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char *PyvtkImageSlicePaint_Doc =
  "vtkImageSlicePaint - no description provided.\n\n"
  "Superclass: vtkObject\n\n"
;


static PyObject *
PyvtkImageSlicePaint_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkImageSlicePaint::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageSlicePaint::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkImageSlicePaint *tempr = vtkImageSlicePaint::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageSlicePaint *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageSlicePaint::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkImageSlicePaint::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkImageSlicePaint::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetTopLeft_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTopLeft");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetTopLeft(temp0, temp1, temp2);
    }
    else
    {
      op->vtkImageSlicePaint::SetTopLeft(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetTopLeft_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTopLeft");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  const size_t size0 = 3;
  int temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetTopLeft(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetTopLeft(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetTopLeft(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkImageSlicePaint_SetTopLeft_s1(self, args);
    case 1:
      return PyvtkImageSlicePaint_SetTopLeft_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetTopLeft");
  return nullptr;
}



static PyObject *
PyvtkImageSlicePaint_GetTopLeft(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTopLeft");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetTopLeft() :
      op->vtkImageSlicePaint::GetTopLeft());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetTopRight_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTopRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetTopRight(temp0, temp1, temp2);
    }
    else
    {
      op->vtkImageSlicePaint::SetTopRight(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetTopRight_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTopRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  const size_t size0 = 3;
  int temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetTopRight(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetTopRight(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetTopRight(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkImageSlicePaint_SetTopRight_s1(self, args);
    case 1:
      return PyvtkImageSlicePaint_SetTopRight_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetTopRight");
  return nullptr;
}



static PyObject *
PyvtkImageSlicePaint_GetTopRight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTopRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetTopRight() :
      op->vtkImageSlicePaint::GetTopRight());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetBottomLeft_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBottomLeft");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetBottomLeft(temp0, temp1, temp2);
    }
    else
    {
      op->vtkImageSlicePaint::SetBottomLeft(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetBottomLeft_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBottomLeft");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  const size_t size0 = 3;
  int temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetBottomLeft(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetBottomLeft(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetBottomLeft(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkImageSlicePaint_SetBottomLeft_s1(self, args);
    case 1:
      return PyvtkImageSlicePaint_SetBottomLeft_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetBottomLeft");
  return nullptr;
}



static PyObject *
PyvtkImageSlicePaint_GetBottomLeft(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBottomLeft");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetBottomLeft() :
      op->vtkImageSlicePaint::GetBottomLeft());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetBottomRight_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBottomRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetBottomRight(temp0, temp1, temp2);
    }
    else
    {
      op->vtkImageSlicePaint::SetBottomRight(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetBottomRight_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBottomRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  const size_t size0 = 3;
  int temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetBottomRight(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetBottomRight(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetBottomRight(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkImageSlicePaint_SetBottomRight_s1(self, args);
    case 1:
      return PyvtkImageSlicePaint_SetBottomRight_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetBottomRight");
  return nullptr;
}



static PyObject *
PyvtkImageSlicePaint_GetBottomRight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBottomRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetBottomRight() :
      op->vtkImageSlicePaint::GetBottomRight());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetBrushCenter_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetBrushCenter(temp0, temp1, temp2);
    }
    else
    {
      op->vtkImageSlicePaint::SetBrushCenter(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetBrushCenter_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetBrushCenter(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetBrushCenter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetBrushCenter(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkImageSlicePaint_SetBrushCenter_s1(self, args);
    case 1:
      return PyvtkImageSlicePaint_SetBrushCenter_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetBrushCenter");
  return nullptr;
}



static PyObject *
PyvtkImageSlicePaint_GetBrushCenter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBrushCenter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetBrushCenter() :
      op->vtkImageSlicePaint::GetBrushCenter());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetBrushRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBrushRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetBrushRadius(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetBrushRadius(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetBrushRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBrushRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetBrushRadius() :
      op->vtkImageSlicePaint::GetBrushRadius());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetMaskImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaskImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  vtkImageData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetMaskImage(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetMaskImage(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetMaskImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaskImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetMaskImage() :
      op->vtkImageSlicePaint::GetMaskImage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetBackgroundImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBackgroundImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  vtkImageData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetBackgroundImage(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetBackgroundImage(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetBackgroundImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBackgroundImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetBackgroundImage() :
      op->vtkImageSlicePaint::GetBackgroundImage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetWorkingImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWorkingImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  vtkImageData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetWorkingImage(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetWorkingImage(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetWorkingImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWorkingImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetWorkingImage() :
      op->vtkImageSlicePaint::GetWorkingImage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetExtractImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetExtractImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  vtkImageData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetExtractImage(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetExtractImage(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetExtractImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetExtractImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetExtractImage() :
      op->vtkImageSlicePaint::GetExtractImage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetReplaceImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReplaceImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  vtkImageData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetReplaceImage(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetReplaceImage(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetReplaceImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReplaceImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetReplaceImage() :
      op->vtkImageSlicePaint::GetReplaceImage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetBackgroundIJKToWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBackgroundIJKToWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetBackgroundIJKToWorld(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetBackgroundIJKToWorld(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetBackgroundIJKToWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBackgroundIJKToWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetBackgroundIJKToWorld() :
      op->vtkImageSlicePaint::GetBackgroundIJKToWorld());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetWorkingIJKToWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWorkingIJKToWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetWorkingIJKToWorld(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetWorkingIJKToWorld(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetWorkingIJKToWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWorkingIJKToWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetWorkingIJKToWorld() :
      op->vtkImageSlicePaint::GetWorkingIJKToWorld());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetMaskIJKToWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaskIJKToWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetMaskIJKToWorld(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetMaskIJKToWorld(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetMaskIJKToWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaskIJKToWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetMaskIJKToWorld() :
      op->vtkImageSlicePaint::GetMaskIJKToWorld());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetPaintLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPaintLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPaintLabel(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetPaintLabel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetPaintLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPaintLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetPaintLabel() :
      op->vtkImageSlicePaint::GetPaintLabel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetPaintOver(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPaintOver");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPaintOver(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetPaintOver(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetPaintOver(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPaintOver");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPaintOver() :
      op->vtkImageSlicePaint::GetPaintOver());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetThresholdPaint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetThresholdPaint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetThresholdPaint(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetThresholdPaint(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_GetThresholdPaint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetThresholdPaint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetThresholdPaint() :
      op->vtkImageSlicePaint::GetThresholdPaint());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_SetThresholdPaintRange_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetThresholdPaintRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  double temp0;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetThresholdPaintRange(temp0, temp1);
    }
    else
    {
      op->vtkImageSlicePaint::SetThresholdPaintRange(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetThresholdPaintRange_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetThresholdPaintRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  const size_t size0 = 2;
  double temp0[2];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetThresholdPaintRange(temp0);
    }
    else
    {
      op->vtkImageSlicePaint::SetThresholdPaintRange(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageSlicePaint_SetThresholdPaintRange(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkImageSlicePaint_SetThresholdPaintRange_s1(self, args);
    case 1:
      return PyvtkImageSlicePaint_SetThresholdPaintRange_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetThresholdPaintRange");
  return nullptr;
}



static PyObject *
PyvtkImageSlicePaint_GetThresholdPaintRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetThresholdPaintRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  size_t sizer = 2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetThresholdPaintRange() :
      op->vtkImageSlicePaint::GetThresholdPaintRange());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkImageSlicePaint_Paint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Paint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageSlicePaint *op = static_cast<vtkImageSlicePaint *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Paint();
    }
    else
    {
      op->vtkImageSlicePaint::Paint();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkImageSlicePaint_Methods[] = {
  {"IsTypeOf", PyvtkImageSlicePaint_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkImageSlicePaint_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkImageSlicePaint_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkImageSlicePaint\nC++: static vtkImageSlicePaint *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkImageSlicePaint_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageSlicePaint\nC++: vtkImageSlicePaint *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkImageSlicePaint_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkImageSlicePaint_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetTopLeft", PyvtkImageSlicePaint_SetTopLeft, METH_VARARGS,
   "V.SetTopLeft(int, int, int)\nC++: virtual void SetTopLeft(int _arg1, int _arg2, int _arg3)\nV.SetTopLeft((int, int, int))\nC++: virtual void SetTopLeft(const int _arg[3])\n\nSets/Gets the PaintRegion in IJK (pixel) coordinates of the\nWorking image\n"},
  {"GetTopLeft", PyvtkImageSlicePaint_GetTopLeft, METH_VARARGS,
   "V.GetTopLeft() -> (int, int, int)\nC++: virtual int *GetTopLeft()\n\n"},
  {"SetTopRight", PyvtkImageSlicePaint_SetTopRight, METH_VARARGS,
   "V.SetTopRight(int, int, int)\nC++: virtual void SetTopRight(int _arg1, int _arg2, int _arg3)\nV.SetTopRight((int, int, int))\nC++: virtual void SetTopRight(const int _arg[3])\n\n"},
  {"GetTopRight", PyvtkImageSlicePaint_GetTopRight, METH_VARARGS,
   "V.GetTopRight() -> (int, int, int)\nC++: virtual int *GetTopRight()\n\n"},
  {"SetBottomLeft", PyvtkImageSlicePaint_SetBottomLeft, METH_VARARGS,
   "V.SetBottomLeft(int, int, int)\nC++: virtual void SetBottomLeft(int _arg1, int _arg2, int _arg3)\nV.SetBottomLeft((int, int, int))\nC++: virtual void SetBottomLeft(const int _arg[3])\n\n"},
  {"GetBottomLeft", PyvtkImageSlicePaint_GetBottomLeft, METH_VARARGS,
   "V.GetBottomLeft() -> (int, int, int)\nC++: virtual int *GetBottomLeft()\n\n"},
  {"SetBottomRight", PyvtkImageSlicePaint_SetBottomRight, METH_VARARGS,
   "V.SetBottomRight(int, int, int)\nC++: virtual void SetBottomRight(int _arg1, int _arg2, int _arg3)\nV.SetBottomRight((int, int, int))\nC++: virtual void SetBottomRight(const int _arg[3])\n\n"},
  {"GetBottomRight", PyvtkImageSlicePaint_GetBottomRight, METH_VARARGS,
   "V.GetBottomRight() -> (int, int, int)\nC++: virtual int *GetBottomRight()\n\n"},
  {"SetBrushCenter", PyvtkImageSlicePaint_SetBrushCenter, METH_VARARGS,
   "V.SetBrushCenter(float, float, float)\nC++: virtual void SetBrushCenter(double _arg1, double _arg2,\n    double _arg3)\nV.SetBrushCenter((float, float, float))\nC++: virtual void SetBrushCenter(const double _arg[3])\n\nThe center and radius of the brush are in world space\n- ijk coordinates are mapped to work to see of pixels are within\n  the brush before applying the threshold/paint operation\n"},
  {"GetBrushCenter", PyvtkImageSlicePaint_GetBrushCenter, METH_VARARGS,
   "V.GetBrushCenter() -> (float, float, float)\nC++: virtual double *GetBrushCenter()\n\n"},
  {"SetBrushRadius", PyvtkImageSlicePaint_SetBrushRadius, METH_VARARGS,
   "V.SetBrushRadius(float)\nC++: virtual void SetBrushRadius(double _arg)\n\n"},
  {"GetBrushRadius", PyvtkImageSlicePaint_GetBrushRadius, METH_VARARGS,
   "V.GetBrushRadius() -> float\nC++: virtual double GetBrushRadius()\n\n"},
  {"SetMaskImage", PyvtkImageSlicePaint_SetMaskImage, METH_VARARGS,
   "V.SetMaskImage(vtkImageData)\nC++: virtual void SetMaskImage(vtkImageData *_arg)\n\nThe mask image: used instead of brush if non nullptr\n- image corresponds to the PaintRegion but is in World\n  coordinates.\n"},
  {"GetMaskImage", PyvtkImageSlicePaint_GetMaskImage, METH_VARARGS,
   "V.GetMaskImage() -> vtkImageData\nC++: virtual vtkImageData *GetMaskImage()\n\n"},
  {"SetBackgroundImage", PyvtkImageSlicePaint_SetBackgroundImage, METH_VARARGS,
   "V.SetBackgroundImage(vtkImageData)\nC++: virtual void SetBackgroundImage(vtkImageData *_arg)\n\nThe reference image for threshold calculations\n"},
  {"GetBackgroundImage", PyvtkImageSlicePaint_GetBackgroundImage, METH_VARARGS,
   "V.GetBackgroundImage() -> vtkImageData\nC++: virtual vtkImageData *GetBackgroundImage()\n\n"},
  {"SetWorkingImage", PyvtkImageSlicePaint_SetWorkingImage, METH_VARARGS,
   "V.SetWorkingImage(vtkImageData)\nC++: virtual void SetWorkingImage(vtkImageData *_arg)\n\nImage data to be painted into\n"},
  {"GetWorkingImage", PyvtkImageSlicePaint_GetWorkingImage, METH_VARARGS,
   "V.GetWorkingImage() -> vtkImageData\nC++: virtual vtkImageData *GetWorkingImage()\n\n"},
  {"SetExtractImage", PyvtkImageSlicePaint_SetExtractImage, METH_VARARGS,
   "V.SetExtractImage(vtkImageData)\nC++: virtual void SetExtractImage(vtkImageData *_arg)\n\nThe place to store data pulled out\n"},
  {"GetExtractImage", PyvtkImageSlicePaint_GetExtractImage, METH_VARARGS,
   "V.GetExtractImage() -> vtkImageData\nC++: virtual vtkImageData *GetExtractImage()\n\n"},
  {"SetReplaceImage", PyvtkImageSlicePaint_SetReplaceImage, METH_VARARGS,
   "V.SetReplaceImage(vtkImageData)\nC++: virtual void SetReplaceImage(vtkImageData *_arg)\n\nThe place to get data to be replaced\n"},
  {"GetReplaceImage", PyvtkImageSlicePaint_GetReplaceImage, METH_VARARGS,
   "V.GetReplaceImage() -> vtkImageData\nC++: virtual vtkImageData *GetReplaceImage()\n\n"},
  {"SetBackgroundIJKToWorld", PyvtkImageSlicePaint_SetBackgroundIJKToWorld, METH_VARARGS,
   "V.SetBackgroundIJKToWorld(vtkMatrix4x4)\nC++: virtual void SetBackgroundIJKToWorld(vtkMatrix4x4 *_arg)\n\nmatrices to map from voxel coordinates (IJK) to world\n"},
  {"GetBackgroundIJKToWorld", PyvtkImageSlicePaint_GetBackgroundIJKToWorld, METH_VARARGS,
   "V.GetBackgroundIJKToWorld() -> vtkMatrix4x4\nC++: virtual vtkMatrix4x4 *GetBackgroundIJKToWorld()\n\n"},
  {"SetWorkingIJKToWorld", PyvtkImageSlicePaint_SetWorkingIJKToWorld, METH_VARARGS,
   "V.SetWorkingIJKToWorld(vtkMatrix4x4)\nC++: virtual void SetWorkingIJKToWorld(vtkMatrix4x4 *_arg)\n\n"},
  {"GetWorkingIJKToWorld", PyvtkImageSlicePaint_GetWorkingIJKToWorld, METH_VARARGS,
   "V.GetWorkingIJKToWorld() -> vtkMatrix4x4\nC++: virtual vtkMatrix4x4 *GetWorkingIJKToWorld()\n\n"},
  {"SetMaskIJKToWorld", PyvtkImageSlicePaint_SetMaskIJKToWorld, METH_VARARGS,
   "V.SetMaskIJKToWorld(vtkMatrix4x4)\nC++: virtual void SetMaskIJKToWorld(vtkMatrix4x4 *_arg)\n\n"},
  {"GetMaskIJKToWorld", PyvtkImageSlicePaint_GetMaskIJKToWorld, METH_VARARGS,
   "V.GetMaskIJKToWorld() -> vtkMatrix4x4\nC++: virtual vtkMatrix4x4 *GetMaskIJKToWorld()\n\n"},
  {"SetPaintLabel", PyvtkImageSlicePaint_SetPaintLabel, METH_VARARGS,
   "V.SetPaintLabel(float)\nC++: virtual void SetPaintLabel(double _arg)\n\nPaintLabel is the value that gets painted into the Working Image\n"},
  {"GetPaintLabel", PyvtkImageSlicePaint_GetPaintLabel, METH_VARARGS,
   "V.GetPaintLabel() -> float\nC++: virtual double GetPaintLabel()\n\n"},
  {"SetPaintOver", PyvtkImageSlicePaint_SetPaintOver, METH_VARARGS,
   "V.SetPaintOver(int)\nC++: virtual void SetPaintOver(int _arg)\n\nPaintOver mode on means that the pixel value should be set in the\nworking image even if it is non-zero.\n"},
  {"GetPaintOver", PyvtkImageSlicePaint_GetPaintOver, METH_VARARGS,
   "V.GetPaintOver() -> int\nC++: virtual int GetPaintOver()\n\n"},
  {"SetThresholdPaint", PyvtkImageSlicePaint_SetThresholdPaint, METH_VARARGS,
   "V.SetThresholdPaint(int)\nC++: virtual void SetThresholdPaint(int _arg)\n\nThresholdPaint mode on means check the background value and only\nset the label map if the background is inside the range (also\nobeys the PaintOver flag)\n"},
  {"GetThresholdPaint", PyvtkImageSlicePaint_GetThresholdPaint, METH_VARARGS,
   "V.GetThresholdPaint() -> int\nC++: virtual int GetThresholdPaint()\n\n"},
  {"SetThresholdPaintRange", PyvtkImageSlicePaint_SetThresholdPaintRange, METH_VARARGS,
   "V.SetThresholdPaintRange(float, float)\nC++: virtual void SetThresholdPaintRange(double _arg1,\n    double _arg2)\nV.SetThresholdPaintRange((float, float))\nC++: void SetThresholdPaintRange(const double _arg[2])\n\nMin/Max for the ThresholdPaint mode\n"},
  {"GetThresholdPaintRange", PyvtkImageSlicePaint_GetThresholdPaintRange, METH_VARARGS,
   "V.GetThresholdPaintRange() -> (float, float)\nC++: virtual double *GetThresholdPaintRange()\n\n"},
  {"Paint", PyvtkImageSlicePaint_Paint, METH_VARARGS,
   "V.Paint()\nC++: void Paint()\n\nApply the paint operation\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkImageSlicePaint_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerEditorLibModuleLogic.vtkImageSlicePaint", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkImageSlicePaint_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageSlicePaint_StaticNew()
{
  return vtkImageSlicePaint::New();
}

PyObject *PyvtkImageSlicePaint_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkImageSlicePaint_Type, PyvtkImageSlicePaint_Methods,
    "vtkImageSlicePaint",
 &PyvtkImageSlicePaint_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkImageSlicePaint(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageSlicePaint_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageSlicePaint", o) != 0)
  {
    Py_DECREF(o);
  }

}

