// python wrapper for vtkImageStash
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkImageStash.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageStash(PyObject *dict); }
extern "C" { PyObject *PyvtkImageStash_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char *PyvtkImageStash_Doc =
  "vtkImageStash - no description provided.\n\n"
  "Superclass: vtkObject\n\n"
;


static PyObject *
PyvtkImageStash_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkImageStash::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageStash::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkImageStash *tempr = vtkImageStash::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageStash *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageStash::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkImageStash::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkImageStash::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_SetStashImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStashImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  vtkImageData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetStashImage(temp0);
    }
    else
    {
      op->vtkImageStash::SetStashImage(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetStashImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStashImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetStashImage() :
      op->vtkImageStash::GetStashImage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_SetStashedScalars(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStashedScalars");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  vtkUnsignedCharArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkUnsignedCharArray"))
  {
    if (ap.IsBound())
    {
      op->SetStashedScalars(temp0);
    }
    else
    {
      op->vtkImageStash::SetStashedScalars(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetStashedScalars(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStashedScalars");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkUnsignedCharArray *tempr = (ap.IsBound() ?
      op->GetStashedScalars() :
      op->vtkImageStash::GetStashedScalars());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_SetNumberOfTuples(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfTuples");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfTuples(temp0);
    }
    else
    {
      op->vtkImageStash::SetNumberOfTuples(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetNumberOfTuples(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfTuples");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfTuples() :
      op->vtkImageStash::GetNumberOfTuples());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_SetMultiThreader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMultiThreader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  vtkMultiThreader *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiThreader"))
  {
    if (ap.IsBound())
    {
      op->SetMultiThreader(temp0);
    }
    else
    {
      op->vtkImageStash::SetMultiThreader(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetMultiThreader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMultiThreader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiThreader *tempr = (ap.IsBound() ?
      op->GetMultiThreader() :
      op->vtkImageStash::GetMultiThreader());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_Stash(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Stash");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Stash();
    }
    else
    {
      op->vtkImageStash::Stash();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_ThreadedStash(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ThreadedStash");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ThreadedStash();
    }
    else
    {
      op->vtkImageStash::ThreadedStash();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_Unstash(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Unstash");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Unstash();
    }
    else
    {
      op->vtkImageStash::Unstash();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_SetCompressionLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompressionLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCompressionLevel(temp0);
    }
    else
    {
      op->vtkImageStash::SetCompressionLevel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetCompressionLevelMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompressionLevelMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCompressionLevelMinValue() :
      op->vtkImageStash::GetCompressionLevelMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetCompressionLevelMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompressionLevelMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCompressionLevelMaxValue() :
      op->vtkImageStash::GetCompressionLevelMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetCompressionLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompressionLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCompressionLevel() :
      op->vtkImageStash::GetCompressionLevel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_SetCompressor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompressor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  vtkZLibDataCompressor *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkZLibDataCompressor"))
  {
    if (ap.IsBound())
    {
      op->SetCompressor(temp0);
    }
    else
    {
      op->vtkImageStash::SetCompressor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetCompressor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompressor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkZLibDataCompressor *tempr = (ap.IsBound() ?
      op->GetCompressor() :
      op->vtkImageStash::GetCompressor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_SetStashing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStashing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStashing(temp0);
    }
    else
    {
      op->vtkImageStash::SetStashing(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetStashing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStashing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetStashing() :
      op->vtkImageStash::GetStashing());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_SetStashingSucceeded(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStashingSucceeded");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStashingSucceeded(temp0);
    }
    else
    {
      op->vtkImageStash::SetStashingSucceeded(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageStash_GetStashingSucceeded(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStashingSucceeded");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageStash *op = static_cast<vtkImageStash *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetStashingSucceeded() :
      op->vtkImageStash::GetStashingSucceeded());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkImageStash_Methods[] = {
  {"IsTypeOf", PyvtkImageStash_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkImageStash_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkImageStash_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkImageStash\nC++: static vtkImageStash *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkImageStash_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageStash\nC++: vtkImageStash *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkImageStash_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBaseType(string) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkImageStash_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "V.GetNumberOfGenerationsFromBase(string) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetStashImage", PyvtkImageStash_SetStashImage, METH_VARARGS,
   "V.SetStashImage(vtkImageData)\nC++: virtual void SetStashImage(vtkImageData *_arg)\n\nThe stash image: This image data will have the Scalars removed\nand they will be stored in a local compressed data array inside\nthis class when the Stash method is called. You must call Unstash\nto have the scalars put back into this image data.\n"},
  {"GetStashImage", PyvtkImageStash_GetStashImage, METH_VARARGS,
   "V.GetStashImage() -> vtkImageData\nC++: virtual vtkImageData *GetStashImage()\n\n"},
  {"SetStashedScalars", PyvtkImageStash_SetStashedScalars, METH_VARARGS,
   "V.SetStashedScalars(vtkUnsignedCharArray)\nC++: virtual void SetStashedScalars(vtkUnsignedCharArray *_arg)\n\nThe stashed scalars: this is the zlib compressed image scalar\ndata\n"},
  {"GetStashedScalars", PyvtkImageStash_GetStashedScalars, METH_VARARGS,
   "V.GetStashedScalars() -> vtkUnsignedCharArray\nC++: virtual vtkUnsignedCharArray *GetStashedScalars()\n\n"},
  {"SetNumberOfTuples", PyvtkImageStash_SetNumberOfTuples, METH_VARARGS,
   "V.SetNumberOfTuples(int)\nC++: virtual void SetNumberOfTuples(vtkIdType _arg)\n\nTo keep track of original number of tuples in scalar data\n"},
  {"GetNumberOfTuples", PyvtkImageStash_GetNumberOfTuples, METH_VARARGS,
   "V.GetNumberOfTuples() -> int\nC++: virtual vtkIdType GetNumberOfTuples()\n\nTo keep track of original number of tuples in scalar data\n"},
  {"SetMultiThreader", PyvtkImageStash_SetMultiThreader, METH_VARARGS,
   "V.SetMultiThreader(vtkMultiThreader)\nC++: virtual void SetMultiThreader(vtkMultiThreader *_arg)\n\nThe multi-threader used when TreadedStash is called\n"},
  {"GetMultiThreader", PyvtkImageStash_GetMultiThreader, METH_VARARGS,
   "V.GetMultiThreader() -> vtkMultiThreader\nC++: virtual vtkMultiThreader *GetMultiThreader()\n\n"},
  {"Stash", PyvtkImageStash_Stash, METH_VARARGS,
   "V.Stash()\nC++: void Stash()\n\ncompress and strip the scalars\n"},
  {"ThreadedStash", PyvtkImageStash_ThreadedStash, METH_VARARGS,
   "V.ThreadedStash()\nC++: void ThreadedStash()\n\ncompress and strip the scalars in a separate thread\n"},
  {"Unstash", PyvtkImageStash_Unstash, METH_VARARGS,
   "V.Unstash()\nC++: void Unstash()\n\ndecompress and restore the scalars\n"},
  {"SetCompressionLevel", PyvtkImageStash_SetCompressionLevel, METH_VARARGS,
   "V.SetCompressionLevel(int)\nC++: virtual void SetCompressionLevel(int _arg)\n\nGet/Set the compression level.\n"},
  {"GetCompressionLevelMinValue", PyvtkImageStash_GetCompressionLevelMinValue, METH_VARARGS,
   "V.GetCompressionLevelMinValue() -> int\nC++: virtual int GetCompressionLevelMinValue()\n\nGet/Set the compression level.\n"},
  {"GetCompressionLevelMaxValue", PyvtkImageStash_GetCompressionLevelMaxValue, METH_VARARGS,
   "V.GetCompressionLevelMaxValue() -> int\nC++: virtual int GetCompressionLevelMaxValue()\n\nGet/Set the compression level.\n"},
  {"GetCompressionLevel", PyvtkImageStash_GetCompressionLevel, METH_VARARGS,
   "V.GetCompressionLevel() -> int\nC++: virtual int GetCompressionLevel()\n\nGet/Set the compression level.\n"},
  {"SetCompressor", PyvtkImageStash_SetCompressor, METH_VARARGS,
   "V.SetCompressor(vtkZLibDataCompressor)\nC++: virtual void SetCompressor(vtkZLibDataCompressor *_arg)\n\nGet/Set the compressor if needed\n"},
  {"GetCompressor", PyvtkImageStash_GetCompressor, METH_VARARGS,
   "V.GetCompressor() -> vtkZLibDataCompressor\nC++: virtual vtkZLibDataCompressor *GetCompressor()\n\nGet/Set the compressor if needed\n"},
  {"SetStashing", PyvtkImageStash_SetStashing, METH_VARARGS,
   "V.SetStashing(int)\nC++: virtual void SetStashing(int _arg)\n\nCheck if compression thread is finished\n"},
  {"GetStashing", PyvtkImageStash_GetStashing, METH_VARARGS,
   "V.GetStashing() -> int\nC++: virtual int GetStashing()\n\nCheck if compression thread is finished\n"},
  {"SetStashingSucceeded", PyvtkImageStash_SetStashingSucceeded, METH_VARARGS,
   "V.SetStashingSucceeded(int)\nC++: virtual void SetStashingSucceeded(int _arg)\n\n1 if the last call to Stash worked correctly, 0 otherwise\n"},
  {"GetStashingSucceeded", PyvtkImageStash_GetStashingSucceeded, METH_VARARGS,
   "V.GetStashingSucceeded() -> int\nC++: virtual int GetStashingSucceeded()\n\n1 if the last call to Stash worked correctly, 0 otherwise\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkImageStash_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkSlicerEditorLibModuleLogic.vtkImageStash", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkImageStash_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageStash_StaticNew()
{
  return vtkImageStash::New();
}

PyObject *PyvtkImageStash_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkImageStash_Type, PyvtkImageStash_Methods,
    "vtkImageStash",
 &PyvtkImageStash_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkImageStash(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageStash_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageStash", o) != 0)
  {
    Py_DECREF(o);
  }

}

